#include "TrialEndNormal.h"

TrialEndNormal::TrialEndNormal()
{
  type="Normal";  // Normal type data
  order=1;      // The first or the second endpoint
  num_look=1;
  look_order=1;
  num_simul=1;
  looksimul=1;  // the same meanings as in previous code
  sample_size1=1; // the same for two endpoints;
  sample_size2=1;
  spending_number = 1;
	
  rule_decision = 2;

  BiSpending=1;
  meanNull=0.0;
  meanAlter=0.0;

  mean = new double[LIMIT_N_LOOK];
  var = new double[LIMIT_N_LOOK];
  coVar = new double[LIMIT_N_LOOK*LIMIT_N_LOOK];

  upperbound=new double[LIMIT_N_LOOK];
  lowerbound=new double[LIMIT_N_LOOK];
  UpperAdjust = new double[LIMIT_N_LOOK];
  LowerAdjust = new double[LIMIT_N_LOOK];

  boundary=new double[LIMIT_N_LOOK*2];
  testZ = new double[LIMIT_N_LOOK];
  event_look = new double[LIMIT_N_LOOK];
  inform_time = new double[LIMIT_N_LOOK];
  alpha = new double[LIMIT_N_LOOK];
  beta = new double[LIMIT_N_LOOK];

  UpperTrial=new double[LIMIT_N_LOOK];
  LowerTrial=new double[LIMIT_N_LOOK];
  BoundTrial=new double[LIMIT_N_LOOK*2];

  decision='s';   // 's' or 'h': soft or hard

  AlphaEnd=new double[LIMIT_N_LOOK];
  BetaEnd=new double[LIMIT_N_LOOK];
  AlphaGlobal=new double[LIMIT_N_LOOK];
  
}

void TrialEndNormal::clone(TrialEndNormal* normalend)
{  
  type = normalend->type;  // Normal type data
  order = normalend->order;      // The first or the second endpoint
  num_look = normalend->num_look;
  look_order = normalend->look_order;
  num_simul = normalend->num_simul;
  looksimul = normalend->looksimul;  // the same meanings as in previous code
  sample_size1 = normalend->sample_size1; // the same for two endpoints;
  sample_size2 = normalend->sample_size2;
  spending_number = normalend->spending_number;
	
  rule_decision = normalend->rule_decision;

  BiSpending = normalend->BiSpending;
  meanNull = normalend->meanNull;
  meanAlter = normalend->meanAlter;

  mean = normalend->mean;
  var = normalend->var;
  coVar = normalend->coVar;

  upperbound = normalend->upperbound;
  lowerbound = normalend->lowerbound;
  UpperAdjust = normalend->UpperAdjust;
  LowerAdjust = normalend->LowerAdjust;

  boundary = normalend->boundary;
  testZ = normalend->testZ;
  event_look = normalend->event_look;
  inform_time = normalend->inform_time;
  alpha = normalend->alpha;
  beta = normalend->beta;

  UpperTrial = normalend->UpperTrial;
  LowerTrial = normalend->LowerTrial;
  BoundTrial = normalend->BoundTrial;

  decision = normalend->decision;   // 's' or 'h': soft or hard

  AlphaEnd = normalend->AlphaEnd;
  BetaEnd = normalend->BetaEnd;
  AlphaGlobal = normalend->AlphaGlobal;

}


void TrialEndNormal::getLookSimul()
{
	if(num_look!=0){
		looksimul = num_simul/num_look;
	}
}

int TrialEndNormal::Loadfile1(char* filename)
{
	char* buffer=new char[512];
	char* parm=new char[50];
	float value;
	ifstream fin(filename,ios::nocreate);

	if(!fin){
		cerr << "Unable to open file: "<< filename << endl;
		fin.close();
		return 0;
	}
	
	while (fin.getline(buffer, 512)){
		if (buffer[0] == '#'){}			// Strip comments and blank lines
		else if (buffer[0] == '\0'){}
		else{
			sscanf(buffer, "%s : %f", parm, &value);
			if (strcmp(parm,"order") == 0)
				order = (int) value;
			if (strcmp(parm,"num_look") == 0)
				num_look = (int) value;
			if (strcmp(parm,"num_simul") == 0)
				num_simul = (int) value;
			if (strcmp(parm,"overall_alpha") == 0)
				overall_alpha = value;
			if (strcmp(parm,"overall_beta") == 0)
				overall_beta = value;
			if (strcmp(parm,"Bi_Alpha") == 0)
				Bi_Alpha = value;
			if (strcmp(parm,"Bi_Beta") == 0)
				Bi_Beta = value;
			if (strcmp(parm,"spending_time") == 0)
				spending_number = (int)value;
			if (strcmp(parm,"sample_size1") == 0)
				sample_size1 = (int)value;
			if (strcmp(parm,"sample_size2") == 0)
				sample_size2 = (int)value;
			if (strcmp(parm,"meanNull") == 0)
				meanNull = value;
			if (strcmp(parm,"meanAlter") == 0)
				meanAlter = value;
		}
	}
	fin.close();
	return 1;

}


int TrialEndNormal::Loadfile2(char* filename)
{
	char* buffer=new char[512];
	float value1, value2, value3, value4, value5, value6, value7;
	ifstream fin(filename,ios::nocreate);

	if(!fin){
		cerr << "Unable to open file: "<< filename << endl;
		fin.close();
		return 0;
	}

	fin.getline(buffer, 512);
	int row =2;
	while (fin.getline(buffer, 512) && row-2<num_look){
	if (buffer[0] == '#'){}			// Strip comments and blank lines
		else if (buffer[0] == '\0'){}
		else{
			sscanf(buffer, "%f %f %f %f %f %f %f", &value1, &value2, &value3, &value4, &value5, &value6, &value7);
			event_look[row-2]=value1;
			inform_time[row-2]=value2;
			alpha[row-2]=value3;
			beta[row-2]=value4;
			upperbound[row-2]=value5;
			lowerbound[row-2]=value6;
			boundary[row-2]=value7;
			row++;
		}
	}
	fin.close();
	return 1;
}

        
