#include "TrialEndSurvival.h"
#include "TrialEndNormal.h"

TrialEndSurvival::TrialEndSurvival()
{
	data_type = 'S';
	order=0;
	num_look = 0;
	num_simul = 0;
	look_order = 0;

	rule_decision = 2;

	alpha=0.0;
	beta=0.0;

	global_alpha=0.0;
	global_beta =0.0;

	lambdaNull=0.0;
	lambdaAlter=0.0;
	lambdadrop=0.0;

	alpha_spending=new double[LIMIT_N_LOOK];
	beta_spending=new double[LIMIT_N_LOOK];

	BiAlphaSpending=new double[LIMIT_N_LOOK];
	
	inform_time=new double[LIMIT_N_LOOK];
	look_time = new double[LIMIT_N_LOOK];

	alphaSpend=0;
	betaSpend=0;

	entry=0.0;
	followup=0.0;

	sample_size1=0;
	sample_size2=0;
	
	upperbound=new double[LIMIT_N_LOOK];
	lowerbound=new double[LIMIT_N_LOOK];
	boundary=new double[2*LIMIT_N_LOOK];
	
	UpperAdjust = new double[LIMIT_N_LOOK];
	LowerAdjust = new double[LIMIT_N_LOOK];
	
	testZ = new double[LIMIT_N_LOOK];

}

void TrialEndSurvival::clone(TrialEndSurvival* survivalend)
{
	data_type = survivalend->data_type;
	order = survivalend->order;
	num_look = survivalend->num_look;
	num_simul = survivalend->num_simul;
	look_order = survivalend->look_order;

	rule_decision = survivalend->rule_decision;

	alpha = survivalend->alpha;
	beta = survivalend->beta;

	global_alpha = survivalend->global_alpha;
	global_beta = survivalend->global_beta;

	lambdaNull = survivalend->lambdaNull;
	lambdaAlter = survivalend->lambdaAlter;
	lambdadrop = survivalend->lambdadrop;

	alpha_spending = survivalend->alpha_spending;
	beta_spending = survivalend->beta_spending;

	BiAlphaSpending = survivalend->BiAlphaSpending;
	
	inform_time = survivalend->inform_time;
	look_time = survivalend->look_time;

	alphaSpend = survivalend->alphaSpend;
	betaSpend = survivalend->betaSpend;

	entry = survivalend->entry;
	followup = survivalend->followup;

	sample_size1 = survivalend->sample_size1;
	sample_size2 = survivalend->sample_size2;
	
	upperbound = survivalend->upperbound;
	lowerbound = survivalend->lowerbound;
	boundary = survivalend->boundary;
	
	UpperAdjust = survivalend->UpperAdjust;
	LowerAdjust = survivalend->LowerAdjust;
	
	testZ = survivalend->testZ;

}


int TrialEndSurvival::getLookSimul()
{
	looksimul = (int) num_simul/num_look;
	return looksimul;
}

int TrialEndSurvival::Loadfile1(char* filename)
{
	char* buffer = new char[512];
	char* parm = new char[50];
	float value;
	ifstream fin(filename,ios::nocreate);

	if(!fin){
		cerr << "Unable to open file: "<< filename << endl;
		fin.close();
		return 0;
	}
	
	while (fin.getline(buffer, 512)){
		if (buffer[0] == '#'){}			// Strip comments and blank lines
		else if (buffer[0] == '\0'){}
		else{
			sscanf(buffer, "%s : %f", parm, &value);
			if (strcmp(parm,"order") == 0)
				order = (int) value;
			if (strcmp(parm,"num_look") ==0)
				num_look = (int) value;
			if (strcmp(parm,"num_simul") ==0)
				num_simul = (int) value;
			if (strcmp(parm,"lambdaNull") ==0)
				lambdaNull = value;
			if (strcmp(parm,"lambdaAlter") ==0)
				lambdaAlter = value;
			if (strcmp(parm,"lambdadrop") ==0)
				lambdadrop = value;
			if (strcmp(parm,"alpha") ==0)
				alpha = value;
			if (strcmp(parm,"beta") ==0)
				beta = value;
 			if (strcmp(parm,"global_alpha") ==0)
				global_alpha = value;
 			if (strcmp(parm,"global_beta") ==0)
				global_beta = value;
			if (strcmp(parm,"sample_size1") ==0)
				sample_size1 = (int)value;
			if (strcmp(parm,"sample_size2") ==0)
				sample_size2 = (int)value;
		}
	}
	fin.close();
	return 1;
}

int TrialEndSurvival::Loadfile2(char* filename)
{
	char* buffer = new char[512];
	float value1, value2, value3, value4, value5;
	ifstream fin(filename,ios::nocreate);

	if(!fin){
		cerr << "Unable to open file: "<< filename << endl;
		fin.close();
		return 0;
	}

	fin.getline(buffer, 512);
	int row =2;
	while (fin.getline(buffer, 512) && row-2<num_look){
	if (buffer[0] == '#'){}			// Strip comments and blank lines
		else if (buffer[0] == '\0'){}
		else{
			sscanf(buffer, "%f %f %f %f %f", &value1, &value2, &value3, &value4, &value5);
			BiAlphaSpending[row-2]=value1;
			inform_time[row-2]=value2;
			alpha_spending[row-2]=value3;
			beta_spending[row-2]=value4;
			look_time[row-2]=value5;
			row++;
		}
	}
	fin.close();
	return 1;
}
/*
int TrialEndSurvival::Loadfile3(char* filename)
{
	char* buffer = new char[512];
	float entry, event;
	char type;
	int end, ID, Indicator;

	ifstream fin(filename,ios::nocreate);

	if(!fin){
		cerr << "Unable to open file: "<< filename << endl;
		fin.close();
		return 0;
	}

	fin.getline(buffer, 512);
	int row =2;
	while (fin.getline(buffer, 512) && row-2<sample_size){
	if (buffer[0] == '#'){}			// Strip comments and blank lines
		else if (buffer[0] == '\0'){}
		else{
			sscanf(buffer, "%d %c %d %f %f %d", &end, &type, &ID, &entry, &event, &Indicator);
			row++;
		}
	}
	fin.close();

	return 1;
}
*/
int TrialEndSurvival::Loadfile4(char* filename)
{
	return 1;
}
