#include "Interface.h"

TrialEndNormal *NormalEnd1, *NormalEnd2;
TrialEndSurvival *SurvivalEnd1, *SurvivalEnd2;

int num_endpoint = 0;
int caseIndex = 0;

int count_up_bound = 0;
int count_low_bound = 0;
int count_alpha = 0;
int count_beta = 0;
int count_global_alpha = 0;

double temp;

double End1_p1[2], End1_p2[2], End1_p3[2], End1_p4[2], End1_p5[2];
double End1_p6[2], End1_p7[2], End1_p8[2], End1_p9[2], End1_p10[2];
double End2_p1[2], End2_p2[2], End2_p3[2], End2_p4[2], End2_p5[2];
double End2_p6[2], End2_p7[2], End2_p8[2], End2_p9[2], End2_p10[2];
// The prob used in the calculation of maginal critical boundaries


double *dataEnd11, *dataEnd21;
double *dataEnd12, *dataEnd22;
double *dataEnd13, *dataEnd23;
double *dataEnd14, *dataEnd24;
double *dataEnd15, *dataEnd25;
double *dataEnd16, *dataEnd26;
double *dataEnd17, *dataEnd27;
double *dataEnd18, *dataEnd28;
double *dataEnd19, *dataEnd29;
double *dataEnd10, *dataEnd20;  // The arrays to store the data of real clinical trials.


double *dataS1, *dataS2;

double CorrEstimate[2*MAXLOOK][2*MAXLOOK];
// The correlation of the data of two endpoints.
double MeanEstimate[2][MAXLOOK];
// The estimate mean for each endpoint, each look;

// GLOBALS
int NextActive = FALSE;
int ReturnActive = FALSE;
int CalculateActive = FALSE;
int ExitActive = FALSE;

int  ActiveType = FALSE;
int  BroadcastOption = 0;
int  stringcounter = 0;
char *BroadcastString=new char[256];
char *BroadcastValueString=new char[256];

int InputAllowed = FALSE;
int ActiveQsnIndex = 0;

// Window Parameters
extern int CreditInterface;
extern int MainInterface;

extern int main_w,  control_w, broadcast_w, temp_w;
extern double mean, variance, result;

//
// bitmap_output: Function to draw characters in
//        opengl using the glut toolkit
//
void bitmap_output(int x, int y, char *string, void *font)
{
  int len, i;

  glRasterPos2f(x, y);
  len = (int) strlen(string);
  for (i = 0; i < len; i++) {
    glutBitmapCharacter(font, string[i]);
  }
}

//
// clearString: clears the contents of a string
//
void clearString(char * string)
{
	int len, i;
	len = (int) strlen(string);
	for (i=0;i< len; i++){
		string[i] = ' ';
	}
}

char* trimString(char* string)
{
	int i=0;
	char *temp_str = new char[500];
	while(string[i]==' '){
		i++;
	}
	int j=0;
	while(string[j+i]!='\0'){
		temp_str[j]=string[j+i];
		j++;
	}
	temp_str[j]='\0';
	return temp_str;
}
	

//
// Exit Function for the 3D and credit windows
//
void ExitKey(unsigned char key, int x, int y)
{
	if (CreditInterface == TRUE){	// Only do something if we are supposed to!

		if (key == '\r'){			// Wait for a carrige return
			glutDestroyWindow(temp_w);
			CreditInterface = FALSE;

			if(MainInterface == FALSE){
				BuildInterface();
				MainInterface = TRUE;
			}
		}
	}

}

//
// CreditMouse: Function to handle the click to begin the program
//
void CreditMouse(int b, int s, int x, int y)
{
  if (s == GLUT_DOWN){
    switch (b) {
    case GLUT_LEFT_BUTTON:
		if(CreditInterface == TRUE){
			glutDestroyWindow(temp_w);
			CreditInterface = FALSE;
		}

		if(MainInterface == FALSE){
			BuildInterface();
			MainInterface = TRUE;
		}

      break;
    case GLUT_MIDDLE_BUTTON:
      break;
    }
  }

  else {
    switch (b) {
    case GLUT_LEFT_BUTTON:
      break;
    case GLUT_MIDDLE_BUTTON:
      break;
    }
  }
}

//
// Generic IsVisable callback
//
void vis(int visState)
{
  // Nothing needed here for now.
}

//
// Generic IsVisable callback
//
void visCredit(int visState)
{
  // Nothing needed here for now.
}

//
// reshapeCredits: This is needed because the credits window is a
//          root level window.
//
void reshapeCredits(int w, int h)
{
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0, w, 0, h);
  glScalef(1, -1, 1);
  glTranslatef(0, -h, 0);
  glMatrixMode(GL_MODELVIEW);

}

//
// General reshape function to handle creation
// and managment of the root interface window.
//
void reshape(int w, int h)
{
  int width = 50;
  int height = 50;

  //////////////////////////////////////
  // Setup the broadcast sub-window
  glutSetWindow(broadcast_w);
  glutPositionWindow(GAP, GAP);
  glutReshapeWindow(MainWidth-2*GAP, UpperHeight-2*GAP);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0, w, 0, h);
  glScalef(1, -1, 1);
  glTranslatef(0, -h, 0);
  glMatrixMode(GL_MODELVIEW);

  //////////////////////////////////////
  // Setup the control sub-window
  glutSetWindow(control_w);
  glutPositionWindow(GAP, UpperHeight);
  glutReshapeWindow(MainWidth-2*GAP, LowerHeight-GAP);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0, w, 0, h);
  glScalef(1, -1, 1);
  glTranslatef(0, -h, 0);
  glMatrixMode(GL_MODELVIEW);

}



///////////////////////////////////////////////////////////////////////////////
//																			 //
//                         Credits Window Functions							 //
//																			 //
///////////////////////////////////////////////////////////////////////////////
//
// displayCredits: Function to handle the display of the credits
//            window presented when the program is started.
//

void displayCredits(void)
{
  glClear(GL_COLOR_BUFFER_BIT);
  glColor3f(1,0,0);

  //////////////////////////////////////
  // The Credits!
  bitmap_output(60, 50, "Data Analysis of",
    GLUT_BITMAP_HELVETICA_18);
  bitmap_output(60, 80, "Group Sequential Clinical Trials with Multiple Endpoints",
    GLUT_BITMAP_HELVETICA_18);

  bitmap_output(60, 250, "Windows Version 1.0",
	  GLUT_BITMAP_HELVETICA_18);
  bitmap_output(60, 280, "CopyRight(R) Shuangge Ma and Micheal Kosorok 2002",
	  GLUT_BITMAP_HELVETICA_18);
  bitmap_output(60, 310, "Department of Biostatistics and Medical Informatics",
    GLUT_BITMAP_HELVETICA_18);
  bitmap_output(60, 340, "University of Wisconsin--Madison",
    GLUT_BITMAP_HELVETICA_18);

  glFlush();
  glutSwapBuffers();		// Swap Buffers
}

//
// Function to initialize and pop the main
// interface window.
//
void BuildInterface(void)
{
	NormalEnd1 = new TrialEndNormal;
	NormalEnd2 = new TrialEndNormal;
	SurvivalEnd1 = new TrialEndSurvival;
	SurvivalEnd2 = new TrialEndSurvival;

  glutInitWindowPosition(50,50);
  glutInitWindowSize(MainWidth, MainHeight);

  ///////////////////////////////////////////
  // Initialize the main window
  main_w = glutCreateWindow("Software Name (Version 1.0)");
  glutDisplayFunc(display);
  glutVisibilityFunc(vis);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(BroadcastKey);
  glClearColor(0.0, 0.0, (float)0.4, 1.0);

  ///////////////////////////////////////////
  // Initialize the broadcast sub-window
  broadcast_w = glutCreateSubWindow(main_w, GAP, GAP, MainWidth-2*GAP, UpperHeight-2*GAP);
  glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);
  glutDisplayFunc(displayBroadcast);
  glutKeyboardFunc(BroadcastKey);
  glutVisibilityFunc(vis);
  glClearColor(0.0, 0.0, 0.0, 0.0);

  ///////////////////////////////////////////
  // Initialize the control sub-window
  control_w = glutCreateSubWindow(main_w, GAP, UpperHeight, MainWidth-2*GAP, LowerHeight-GAP);
  glutDisplayFunc(displayControls);
  glutVisibilityFunc(vis);
  glutPassiveMotionFunc(ControlMousePassive);
  glutMouseFunc(ControlMouse);
  glClearColor(0.0, 0.0, 0.0, 0.0);

}

///////////////////////////////////////////////////////////////////////////////
//																			 //
//                         Shared Window Functions							 //
//																			 //
///////////////////////////////////////////////////////////////////////////////


//
// Generic display callback
//
void display(void)
{
  //cerr << "Display Callback!" << endl;
  glClear(GL_COLOR_BUFFER_BIT);
  glFlush();
  glutSwapBuffers();
  displayBroadcast();
  displayControls();
}


void displayBroadcast(void)
{

  glutSetWindow(broadcast_w);	// Make sure we are dealing with the right window
  glClear(GL_COLOR_BUFFER_BIT);

  glColor3f(0,1,0);						// highlight it, otherwise don't!

  switch(BroadcastOption){

  case 0:
	  ActiveQsnIndex = 0;
	  bitmap_output(200, Y_Line2, "Section II -- Data Analysis of Group Sequential Clinical Trials",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(50, Y_Line4+20, "Step 1: Calculatiosn of Marginal Critical Boundaries Satisfying Certain Alpha(beta) Spending Functions",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(50, Y_Line5+40, "Step 2: Use Global Alpha Spending Function to Control Overall Type I Error",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(50, Y_Line6+60, "Step 3: Compare Test Statistics  with Critical Boundaries",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(50, Y_Line8+80, "Software Homepage: http://www.biostat.wisc.edu/~kosorok/",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(550, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
  	  break;

  case 100:
	  ActiveQsnIndex = 10;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "How many endpionts does this trial have (1 or 2) ?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please input the number of endpoints :",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 101:
	  ActiveQsnIndex = 10;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Unrecognized number of endpoint!!!",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Try to choose from 1 or 2 agian :",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 200:
	  ActiveQsnIndex = 20;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Response Type: Normal or Survival (N or S) :",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 201:
	  ActiveQsnIndex = 20;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Unrecognized type of response !!!",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Try to choose from N or S agian :",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 250:
	  ActiveQsnIndex = 25;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Case Selection ?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line6, "Case 1. Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line7, "Case 2. Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line8, "Case 3. A Normal Endpoint(first) and a Survival Endpoint(second).",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line9, "Case 4. A Survival Endpoint(first) and a Normal Endpoint(second).",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Please select (1, 2, 3 or 4):",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 260:
	  ActiveQsnIndex = 26;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Choose decision rule: hard or soft ?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Choose  \"h\" or \"s\":",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

//////////////////////////////////////////////////////////////////////////////////////////////
//  One Normal Endpoint
//////////////////////////////////////////////////////////////////////////////////////////////
  case 110100:
	  ActiveQsnIndex = 11010;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please load information file, two files needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Sample information files available at: http://www.biostat.wisc.edu/~kosorok/",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the name of the first file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(440, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 110101:
	  ActiveQsnIndex = 11010;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Two information files needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the name of the first file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(440, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
//////////////////////////////////////////////////////////////////////////////////////////////
  case 111000:
	  ActiveQsnIndex = 11100;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Following information received.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Order =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->order);
	  bitmap_output(270, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Number of Looks =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(270, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Number of Monto Carlo Replications =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Alpha (Beta) Spending Function =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->spending_number);
	  bitmap_output(380, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Sample size control =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->sample_size1);
	  bitmap_output(270, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "Sample size treat =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->sample_size2);
	  bitmap_output(270, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);

	  bitmap_output(X_Column10, Y_Line6, "Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->overall_alpha);
	  bitmap_output(X_Column10+150, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line7, "Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->overall_beta);
	  bitmap_output(X_Column10+150, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line8, "Global Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->Bi_Alpha);
	  bitmap_output(X_Column10+150, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line9, "Global Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->Bi_Beta);
	  bitmap_output(X_Column10+150, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line10, "mean (Null) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->meanNull);
	  bitmap_output(X_Column10+150, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line11, "mean (Alter) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->meanAlter);
	  bitmap_output(X_Column10+150, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);

	  bitmap_output(X_Column1, Y_Line15, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
//////////////////////////////////////////////////////////////////////////////////////////////
  case 111100:
	  ActiveQsnIndex = 11110;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please input the name of the second information file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(560, Y_Line5, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 111101:
	  ActiveQsnIndex = 11110;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Two Information Files Needed",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the name of the second information file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(560, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 112000:
	  {
	  ActiveQsnIndex = 11200;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(300, Y_Line5, "Information", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(520, Y_Line5, "Alpha", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(720, Y_Line5, "Beta", GLUT_BITMAP_HELVETICA_18);
	  for(int i=0; i<NormalEnd1->num_look; i++){
		  bitmap_output(X_Column3, Y_Line6+i*Y_GAP, "Look", GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(150, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(170, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->inform_time[i]);
		  bitmap_output(300, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->alpha[i]);
		  bitmap_output(500, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->beta[i]);
		  bitmap_output(700, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column15, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 113000:
	  ActiveQsnIndex = 11300;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Current Look Number:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 113001:
	  ActiveQsnIndex = 11300;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Your input is out of range, please try again",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the current look number",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of look is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 113100:
	  ActiveQsnIndex = 11310;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please Load Data File:", 
	      GLUT_BITMAP_HELVETICA_18);
//	  bitmap_output(X_Column1, Y_Line6, "the first          columns corresponde to the data needed for this look.", 
//	      GLUT_BITMAP_HELVETICA_18);
//	  itoa(NormalEnd1->look_order);	  
//	  bitmap_output(135, Y_Line6, BroadcastString, 
//	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the data file name:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 113101:
	  ActiveQsnIndex = 11310;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line5, "File not found, please try again.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the data file name:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 113200:
	  ActiveQsnIndex = 11320;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line5, "Data loaded successfully.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line16, "Click \"Next\" to run the program.",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

/*  case 113300:
	  {
	  ActiveQsnIndex = 11330;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "The data summary:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(310, Y_Line5, "mean", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(500, Y_Line5, "variance", GLUT_BITMAP_HELVETICA_18);
	  for(int i=0; i<NormalEnd1->look_order; i++){
		  bitmap_output(X_Column3, Y_Line6+i*Y_GAP, "Look", GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(150, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(170, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->mean[i]);
		  bitmap_output(300, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->var[i]);
		  bitmap_output(500, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column10, Y_Line16, "Click \"Next\" to check the covariancies",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 113400:
	  {
	  ActiveQsnIndex = 11340;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "The covariance structure",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(50, Y_Line5, "Look", GLUT_BITMAP_HELVETICA_18);
	  for(int j=0; j<NormalEnd1->look_order; j++){
		  itoa(j+1);
		  bitmap_output(150+j*80, Y_Line5, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  for(int i=0; i<NormalEnd1->look_order; i++){
		  itoa(i+1);
		  bitmap_output(50, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(75, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  for(j=0; j<NormalEnd1->look_order; j++){
			  ftoa_3(NormalEnd1->coVar[i*LIMIT_N_LOOK+j]);
			  if(NormalEnd1->coVar[i*LIMIT_N_LOOK+j]>=0){
				  bitmap_output(100+j*80, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
			  }
			  else{
				  bitmap_output(95+j*80, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
			  }
		  }
	  }
	  bitmap_output(X_Column10, Y_Line16, "Click \"Next\" to run UniNormalDecision()",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }
*/
  case 115100:
	  {
	  ActiveQsnIndex = 11510;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "Critical boundaries:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(410, Y_Line5, "Lower", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(510, Y_Line5, "Upper", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(590, Y_Line5, "Test statistic", GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<NormalEnd1->look_order;i++){
		  bitmap_output(X_Column4, Y_Line6+(i)*Y_GAP, "Look",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column4+50, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column4+60, Y_Line6+(i)*Y_GAP, ":",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->boundary[2*i]);
		  bitmap_output(400, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->boundary[2*i+1]);
		  bitmap_output(500, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->testZ[i]);
		  bitmap_output(600, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);

	  }
	  bitmap_output(500, Y_Line16, "Click \"Next\" to view the boudaries.",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 115200:
	  {
	  ActiveQsnIndex = 11520;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "Visual Display of Critical Boundaries",
	      GLUT_BITMAP_HELVETICA_18);

	    int offsetx = 200;
		int offsety = 600;
		int minTestZ = 0;
		for(int i=1; i<NormalEnd1->look_order; i++){
			if(NormalEnd1->testZ[i] < 0 && NormalEnd1->testZ[i] < NormalEnd1->testZ[i-1])
				minTestZ = NormalEnd1->testZ[i];
		}
		int factor = minInt((MainWidth-400)/(NormalEnd1->look_order+1), (MainHeight-350)/(NormalEnd1->boundary[1] - minTestZ +1));
 
		if (minTestZ < 0) {
			offsety = 650 - factor * (-minTestZ+1);
		}

		glColor3f(1,1,1);
		glLineWidth(2);
	
		glBegin(GL_LINES);
		glVertex3f(0+offsetx,0+offsety,0);
		glVertex3f((NormalEnd1->look_order+1)*factor+offsetx,0+offsety,0);
		glEnd();

		glBegin(GL_LINES);
		glVertex3f(0+offsetx,0+offsety,0);
		glVertex3f(0+offsetx,-factor*(NormalEnd1->boundary[1]+1)+offsety,0);
		glEnd();

		for (i=0; i<NormalEnd1->look_order+1; i++){
			itoa(i);
			bitmap_output(i*factor+offsetx, offsety+30, BroadcastString,
				GLUT_BITMAP_HELVETICA_18);
		}
		for (i=0; i<NormalEnd1->boundary[1]+1; i++){
			itoa(i);
			bitmap_output(-20+offsetx, offsety-factor*i, BroadcastString,
		        GLUT_BITMAP_HELVETICA_18);
		}

	  	glColor3f(1,1,0); 
		glLineWidth(2);
		glBegin(GL_LINE_STRIP);
		for (i=0; i<NormalEnd1->look_order; i++){
			glVertex3f(factor*(i+1)+offsetx, offsety-factor*NormalEnd1->boundary[2*i],0);
		}
		glEnd();

	  	glColor3f(1,1,0); 
		glLineWidth(2);
		glBegin(GL_LINE_STRIP);
		for (i=0; i<NormalEnd1->look_order; i++){
			glVertex3f(factor*(i+1)+offsetx, offsety-factor*NormalEnd1->boundary[2*i+1],0);
		}
		glEnd();

	  	glColor3f(1,0,0); 
		glLineWidth(2);
		glBegin(GL_LINE_STRIP);
		for (i=0; i<NormalEnd1->look_order; i++){
			glVertex3f(factor*(i+1)+offsetx, offsety-factor*NormalEnd1->testZ[i],0);
		}

		glEnd();
		break;
	  }


//////////////////////////////////////////////////////////////////////////////////////////////
//  One Survival Endpoint
//////////////////////////////////////////////////////////////////////////////////////////////
  case 120100:
	  ActiveQsnIndex = 12010;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Survival Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please load information files. Two files needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Sample information files available at: http://www.biostat.wisc.edu/~kosorok/.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the name of the first file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120101:
	  ActiveQsnIndex = 12010;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Survival Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Two information files needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the name of the first file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 121000:
	  ActiveQsnIndex = 12100;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Survival Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Following information received.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Order =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->order);
	  bitmap_output(270, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Number of Looks =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);
	  bitmap_output(270, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Number of Monto Carlo replications =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_simul);
	  bitmap_output(380, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Lambda Null =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->lambdaNull);
	  bitmap_output(260, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Lambda Alter =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->lambdaAlter);
	  bitmap_output(260, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "Lambda drop =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->lambdadrop);
	  bitmap_output(260, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line12, "Sample Size COntrol =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->sample_size1);
	  bitmap_output(270, Y_Line12, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line13, "Sample Size Treat =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->sample_size2);
	  bitmap_output(270, Y_Line13, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line6, "Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->alpha);
	  bitmap_output(X_Column10+150, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line7, "Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->beta);
	  bitmap_output(X_Column10+150, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line8, "Global Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->global_alpha);
	  bitmap_output(X_Column10+150, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line9, "Global Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->global_beta);
	  bitmap_output(X_Column10+150, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column15, Y_Line15, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 121100:
	  ActiveQsnIndex = 12110;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Survival Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please input the name of the second information file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(700, Y_Line5, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 121101:
	  ActiveQsnIndex = 12110;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Survival Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Two Information Files Needed",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the name of the second information file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(700, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 122000:
	  {
	  ActiveQsnIndex = 12200;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Survival Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(300, Y_Line5, "Information", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line5, "Alpha ", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line5, "Beta", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line5, "look time", GLUT_BITMAP_HELVETICA_18);
	  for(int i=0; i<SurvivalEnd1->num_look; i++){
		  bitmap_output(X_Column3, Y_Line6+i*Y_GAP, "Look", GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(150, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(170, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->inform_time[i]);
		  bitmap_output(300, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->alpha_spending[i]);
		  bitmap_output(450, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->beta_spending[i]);
		  bitmap_output(600, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->look_time[i]);
		  bitmap_output(750, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column15, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 123000:
	  ActiveQsnIndex = 12300;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Survival Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Current Look Number:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 123001:
	  ActiveQsnIndex = 12300;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Survival Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Your input is out of range, please try again",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the order of this look:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 123100:
	  ActiveQsnIndex = 12310;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Survival Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line5, "Please Load Data File.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the data file name:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 123101:
	  ActiveQsnIndex = 12310;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Survival Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line5, "File not found, please try again.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the data file name:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 123200:
	  ActiveQsnIndex = 12320;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Survival Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line5, "Data loaded successfully.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line16, "Click \"Next\" to run the program.",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 125100:
	  {
	  ActiveQsnIndex = 12510;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: One Survival Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(410, Y_Line5, "Lower", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(510, Y_Line5, "Upper", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(590, Y_Line5, "Test statistic", GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<SurvivalEnd1->look_order;i++){
		  bitmap_output(X_Column4, Y_Line6+(i)*Y_GAP, "Look",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column4+50, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column4+60, Y_Line6+(i)*Y_GAP, ":",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->lowerbound[i]);
		  bitmap_output(400, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->upperbound[i]);
		  bitmap_output(500, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->testZ[i]);
		  bitmap_output(600, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);

	  }
	  bitmap_output(500, Y_Line16, "Click \"Next\" to view the boudaries.",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 125200:
	  {
	  ActiveQsnIndex = 12520;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "Visual Display of Critical Boundaries",
	      GLUT_BITMAP_HELVETICA_18);

	    int offsetx = 200;
		int offsety = 600;
		int minTestZ = 0;
		for(int i=1; i<SurvivalEnd1->look_order; i++){
			if(SurvivalEnd1->testZ[i] < 0 && SurvivalEnd1->testZ[i] < SurvivalEnd1->testZ[i-1])
				minTestZ = SurvivalEnd1->testZ[i];
		}
		int factor = minInt((MainWidth-400)/(SurvivalEnd1->look_order+1), (MainHeight-350)/(SurvivalEnd1->upperbound[1] - minTestZ +1));
 
		if (minTestZ < 0) {
			offsety = 650 - factor * (-minTestZ+1);
		}

		glColor3f(1,1,1);
		glLineWidth(2);
	
		glBegin(GL_LINES);
		glVertex3f(0+offsetx,0+offsety,0);
		glVertex3f((SurvivalEnd1->look_order+1)*factor+offsetx,0+offsety,0);
		glEnd();

		glBegin(GL_LINES);
		glVertex3f(0+offsetx,0+offsety,0);
		glVertex3f(0+offsetx,-factor*(SurvivalEnd1->upperbound[1]+1)+offsety,0);
		glEnd();

		for (i=0; i<SurvivalEnd1->look_order+1; i++){
			itoa(i);
			bitmap_output(i*factor+offsetx, offsety+30, BroadcastString,
				GLUT_BITMAP_HELVETICA_18);
		}
		for (i=0; i<SurvivalEnd1->upperbound[1]+1; i++){
			itoa(i);
			bitmap_output(-20+offsetx, offsety-factor*i, BroadcastString,
		        GLUT_BITMAP_HELVETICA_18);
		}

	  	glColor3f(1,1,0); 
		glLineWidth(2);
		glBegin(GL_LINE_STRIP);
		for (i=0; i<SurvivalEnd1->look_order; i++){
			glVertex3f(factor*(i+1)+offsetx, offsety-factor*SurvivalEnd1->lowerbound[i],0);
		}
		glEnd();

	  	glColor3f(1,1,0); 
		glLineWidth(2);
		glBegin(GL_LINE_STRIP);
		for (i=0; i<SurvivalEnd1->look_order; i++){
			glVertex3f(factor*(i+1)+offsetx, offsety-factor*SurvivalEnd1->upperbound[i],0);
		}
		glEnd();

	  	glColor3f(1,0,0); 
		glLineWidth(2);
		glBegin(GL_LINE_STRIP);
		for (i=0; i<SurvivalEnd1->look_order; i++){
			glVertex3f(factor*(i+1)+offsetx, offsety-factor*SurvivalEnd1->testZ[i],0);
		}

		glEnd();
		break;
	  }



/////////////////////////////////////////////////////////////////////////////////////////
//  Case 21, two normal
//////////////////////////////////////////////////////////////////////////////////////////////
  case 210100:
	  ActiveQsnIndex = 21010;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please Load Information Files. Two Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Sample files available at: http://www.biostat.wisc.edu/~kosorok/",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Please input the name of first file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line9, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 210101:
	  ActiveQsnIndex = 21010;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Two Information Files Needed",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Please input the name of the first file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line9, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 211000:
	  ActiveQsnIndex = 21100;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: Two Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The following information received.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+2, "________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Order =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->order);
	  bitmap_output(270, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Number of Looks =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(270, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Number of Monto Carlo replications =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Spending Function =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->spending_number);
	  bitmap_output(270, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Sample size control =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->sample_size1);
	  bitmap_output(270, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "Sample size treat =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->sample_size2);
	  bitmap_output(270, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);

	  bitmap_output(X_Column10, Y_Line6, "Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->overall_alpha);
	  bitmap_output(X_Column10+150, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line7, "Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->overall_beta);
	  bitmap_output(X_Column10+150, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line8, "Global Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->Bi_Alpha);
	  bitmap_output(X_Column10+150, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line9, "Global Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->Bi_Beta);
	  bitmap_output(X_Column10+150, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line10, "mean (Null) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->meanNull);
	  bitmap_output(X_Column10+150, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line11, "mean (Alter) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->meanAlter);
	  bitmap_output(X_Column10+150, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);

	  bitmap_output(X_Column1, Y_Line15, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

//////////////////////////////////////////////////////////////////////////////////////////////
  case 211100:
	  ActiveQsnIndex = 21110;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input name of the second information file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 211101:
	  ActiveQsnIndex = 21110;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Two Information Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line9, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 212000:
	  {
	  ActiveQsnIndex = 21200;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: Two Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(300, Y_Line5, "Information", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(520, Y_Line5, "Alpha", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(720, Y_Line5, "Beta", GLUT_BITMAP_HELVETICA_18);
	  for(int i=0; i<NormalEnd1->num_look; i++){
		  bitmap_output(X_Column3, Y_Line6+i*Y_GAP, "Look", GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(150, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(170, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->inform_time[i]);
		  bitmap_output(300, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->alpha[i]);
		  bitmap_output(500, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->beta[i]);
		  bitmap_output(700, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column15, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

//////////////////////////////////////////////////////////////////////////////////////////////
  case 213000:
	  ActiveQsnIndex = 21300;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "What look is this one?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 213001:
	  ActiveQsnIndex = 21300;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Your input is out of range, please try again",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the order of this look:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 213100:
	  ActiveQsnIndex = 21310;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line7, "Please Load Data File", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Please input the data file name:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line10, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 213101:
	  ActiveQsnIndex = 21310;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line7, "File not found, please try again.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Please input the data file name:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 213200:
	  ActiveQsnIndex = 21320;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line7, "Data loaded successfully.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

//////////////////////////////////////////////////////////////////////////////////////////////
  case 214100:
	  ActiveQsnIndex = 21410;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please load information files. Two files needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Sample information files available at: http://www.biostat.wisc.edu/~kosorok/",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Please input the name of the first file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line9, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 214101:
	  ActiveQsnIndex = 21410;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Two Information Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Please input the name of the first information file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line9, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

//////////////////////////////////////////////////////////////////////////////////////////////
  case 215000:
	  ActiveQsnIndex = 21500;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case: Two Normal Endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The following information received.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+2, "________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Order =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->order);
	  bitmap_output(270, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Number of Looks =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(270, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Number of Monto Carlo replications =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Spending Function =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->spending_number);
	  bitmap_output(270, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Sample size control =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->sample_size1);
	  bitmap_output(270, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "Sample size treat =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->sample_size2);
	  bitmap_output(270, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);

	  bitmap_output(X_Column10, Y_Line6, "Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd2->overall_alpha);
	  bitmap_output(X_Column10+150, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line7, "Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd2->overall_beta);
	  bitmap_output(X_Column10+150, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line8, "Global Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd2->Bi_Alpha);
	  bitmap_output(X_Column10+150, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line9, "Global Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd2->Bi_Beta);
	  bitmap_output(X_Column10+150, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line10, "mean (Null) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd2->meanNull);
	  bitmap_output(X_Column10+150, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line11, "mean (Alter) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd2->meanAlter);
	  bitmap_output(X_Column10+150, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);

	  bitmap_output(X_Column1, Y_Line15, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 215100:
	  ActiveQsnIndex = 21510;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the Second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the second file's name:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 215101:
	  ActiveQsnIndex = 21510;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Two Information Files Needed",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Please input the name of the information file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line9, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 216000:
	  {
	  ActiveQsnIndex = 21600;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(300, Y_Line5, "Information", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(520, Y_Line5, "Alpha", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(720, Y_Line5, "Beta", GLUT_BITMAP_HELVETICA_18);
	  for(int i=0; i<NormalEnd1->num_look; i++){
		  bitmap_output(X_Column3, Y_Line6+i*Y_GAP, "Look", GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(150, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(170, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->inform_time[i]);
		  bitmap_output(300, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->alpha[i]);
		  bitmap_output(500, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->beta[i]);
		  bitmap_output(700, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column15, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 217000:
	  ActiveQsnIndex = 21700;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Current Look Number:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 217001:
	  ActiveQsnIndex = 21700;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Input out of range, please try again",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the order of this look:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 217100:
	  ActiveQsnIndex = 21710;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line7, "Please Load Data File:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Please input the data file name:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line10, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 217101:
	  ActiveQsnIndex = 21710;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line7, "File not found, please try again.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Please input the data file name:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 217200:
	  ActiveQsnIndex = 21720;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line7, "Data loaded successfully.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line16, "Click \"Next\" to run the program.",
	      GLUT_BITMAP_HELVETICA_18);
	  break;

//////////////////////////////////////////////////////////////////////////////////////////////
  case 218100:
	  {
	  ActiveQsnIndex = 21810;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 1: Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "Critical Boundaries:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(320, Y_Line4, "first endpoint", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(650, Y_Line4, "second endpoint", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(260, Y_Line4+5, "________________________", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(580, Y_Line4+5, "________________________", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(260, Y_Line5, "lower", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(360, Y_Line5, "upper", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(460, Y_Line5, "testZ", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(580, Y_Line5, "lower", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(680, Y_Line5, "upper", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(780, Y_Line5, "testZ", GLUT_BITMAP_HELVETICA_18);
	  for(int i=0; i<NormalEnd1->look_order; i++){
		  bitmap_output(100, Y_Line6+i*Y_GAP, "Look", GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(150, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(170, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->LowerAdjust[i]);
		  bitmap_output(250, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->UpperAdjust[i]);
		  bitmap_output(350, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->testZ[i]);
		  bitmap_output(450, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(540, Y_Line6+i*Y_GAP, "|", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd2->LowerAdjust[i]);
		  bitmap_output(570, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd2->UpperAdjust[i]);
		  bitmap_output(670, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd2->testZ[i]);
		  bitmap_output(770, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column10, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 218200:
	  {
	  ActiveQsnIndex = 21820;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line2, "Case 1: Two Normal Endpoints--Visual Display of Critical Boundaries.",
	      GLUT_BITMAP_HELVETICA_18);

	    int offsetx = 500;
		int offsety = 400;		
		int factor = min(300/(max(NormalEnd1->testZ[NormalEnd1->look_order-1], NormalEnd1->UpperAdjust[NormalEnd1->look_order-1])+1), 250/(max(NormalEnd2->testZ[NormalEnd2->look_order-1],NormalEnd2->UpperAdjust[NormalEnd2->look_order-1])+1));

		cout<<"factor="<<factor<<endl;

		glColor3f(1,1,1);
		glLineWidth(2);
	
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,0+offsety,0);
		glVertex3f(-300+offsetx, 0+offsety,0);
		glEnd();
		bitmap_output(310+offsetx, offsety+8, "end 1",
				GLUT_BITMAP_HELVETICA_18);

		glBegin(GL_LINES);
		glVertex3f(0+offsetx,250+offsety,0);
		glVertex3f(0+offsetx,-250+offsety,0);
		glEnd();
		bitmap_output(-18+offsetx, -260+offsety, "end 2",
				GLUT_BITMAP_HELVETICA_18);


		bitmap_output(-20+offsetx, offsety+30, "0",
				GLUT_BITMAP_HELVETICA_18);
		for (int i=1; i<min(NormalEnd1->UpperAdjust[NormalEnd1->look_order-1]+1, 300.0/factor); i++){
			itoa(i);
			bitmap_output(i*factor+offsetx, offsety+30, BroadcastString,
				GLUT_BITMAP_HELVETICA_18);
			itoa(-i);
			bitmap_output(-i*factor-5+offsetx, offsety+30, BroadcastString,
				GLUT_BITMAP_HELVETICA_18);
		}
		for (i=1; i<min(NormalEnd2->UpperAdjust[NormalEnd2->look_order-1]+1, 250.0/factor) ; i++){
			itoa(i);
			bitmap_output(-20+offsetx, offsety-factor*i, BroadcastString,
		        GLUT_BITMAP_HELVETICA_18);
			itoa(-i);
			bitmap_output(-25+offsetx, offsety+factor*i, BroadcastString,
		        GLUT_BITMAP_HELVETICA_18);
		}

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(factor*NormalEnd2->UpperAdjust[NormalEnd2->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(factor*NormalEnd2->UpperAdjust[NormalEnd2->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(-factor*NormalEnd2->UpperAdjust[NormalEnd2->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(-factor*NormalEnd2->UpperAdjust[NormalEnd2->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(factor*NormalEnd2->LowerAdjust[NormalEnd2->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(factor*NormalEnd2->LowerAdjust[NormalEnd2->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(-factor*NormalEnd2->LowerAdjust[NormalEnd2->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(-factor*NormalEnd2->LowerAdjust[NormalEnd2->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,factor*NormalEnd1->UpperAdjust[NormalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, factor*NormalEnd1->UpperAdjust[NormalEnd1->look_order-1]+offsety,0);
		glEnd();

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,-factor*NormalEnd1->UpperAdjust[NormalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, -factor*NormalEnd1->UpperAdjust[NormalEnd1->look_order-1]+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,factor*NormalEnd1->LowerAdjust[NormalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, factor*NormalEnd1->LowerAdjust[NormalEnd1->look_order-1]+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,-factor*NormalEnd1->LowerAdjust[NormalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, -factor*NormalEnd1->LowerAdjust[NormalEnd1->look_order-1]+offsety,0);
		glEnd();

		// testZ
		glColor3f(0,1,1);
		bitmap_output(factor*NormalEnd1->testZ[NormalEnd1->look_order-1]+offsetx, -factor*NormalEnd2->testZ[NormalEnd2->look_order-1]+offsety, "*",
			GLUT_BITMAP_HELVETICA_18);
		glEnd();

		glEnd();
		break;
	  }


/////////////////////////////////////////////////////////////////////////////////////////
//  Case 22, two survival
//////////////////////////////////////////////////////////////////////////////////////////////
  case 220100:
	  ActiveQsnIndex = 22010;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please load information files. Two files needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Sample information files available at: http://www.biostat.wisc.edu/~kosorok/.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the name of the first file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(500, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220101:
	  ActiveQsnIndex = 22010;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Two information files needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 221000:
	  ActiveQsnIndex = 22100;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The following information received.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Order =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->order);
	  bitmap_output(270, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Number of Looks =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);
	  bitmap_output(270, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Number of Monto Carlo replications =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_simul);
	  bitmap_output(380, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Lambda (Null) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->lambdaNull);
	  bitmap_output(260, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Lambda (Alter) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->lambdaAlter);
	  bitmap_output(260, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "Lambda (drop) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->lambdadrop);
	  bitmap_output(260, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line12, "Sample size control =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->sample_size1);
	  bitmap_output(270, Y_Line12, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line13, "Sample size treat =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->sample_size2);
	  bitmap_output(270, Y_Line13, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line6, "Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->alpha);
	  bitmap_output(X_Column10+150, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line7, "Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->beta);
	  bitmap_output(X_Column10+150, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line8, "Global Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->global_alpha);
	  bitmap_output(X_Column10+150, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line9, "Global Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->global_beta);
	  bitmap_output(X_Column10+150, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column15, Y_Line15, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 221100:
	  ActiveQsnIndex = 22110;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please input the name of the second information file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line5, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 221101:
	  ActiveQsnIndex = 22110;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Two Information Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 222000:
	  {
	  ActiveQsnIndex = 22200;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(240, Y_Line5, "Global alpha", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line5, "Alpha", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line5, "Beta", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line5, "Look time", GLUT_BITMAP_HELVETICA_18);
	  for(int i=0; i<SurvivalEnd1->num_look; i++){
		  bitmap_output(X_Column3, Y_Line6+i*Y_GAP, "Look", GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(150, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(170, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->BiAlphaSpending[i]);
		  bitmap_output(300, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->alpha_spending[i]);
		  bitmap_output(450, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->beta_spending[i]);
		  bitmap_output(600, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->look_time[i]);
		  bitmap_output(750, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column15, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 223000:
	  ActiveQsnIndex = 22300;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Current Look Number:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 223001:
	  ActiveQsnIndex = 22300;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Your input is out of range, please try again",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the order of current look:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 223100:
	  ActiveQsnIndex = 22310;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line5, "Please Load Data File.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the name of the data file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(500, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 223101:
	  ActiveQsnIndex = 22310;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line5, "File not found, please try again.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 223200:
	  ActiveQsnIndex = 22320;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line5, "Data loaded successfully.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column4, Y_Line12, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 224100:
	  ActiveQsnIndex = 22410;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please Load Information Files. Two Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Sample Information Files Available at: http://www.biostat.wisc.edu/~kosorok/.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the name of the first file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(500, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 224101:
	  ActiveQsnIndex = 22410;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Two Information Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 225000:
	  ActiveQsnIndex = 22500;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The following information received.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Order =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->order);
	  bitmap_output(270, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Number of Looks =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_look);
	  bitmap_output(270, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Number of Monto Carlo replications =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_simul);
	  bitmap_output(380, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Lambda (Null) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd2->lambdaNull);
	  bitmap_output(260, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Lambda (Alter) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd2->lambdaAlter);
	  bitmap_output(260, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "Lambda (drop) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd2->lambdadrop);
	  bitmap_output(260, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line12, "Sample size control =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->sample_size1);
	  bitmap_output(270, Y_Line12, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line13, "Sample size treat =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->sample_size2);
	  bitmap_output(270, Y_Line13, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line6, "Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd2->alpha);
	  bitmap_output(X_Column10+150, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line7, "Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd2->beta);
	  bitmap_output(X_Column10+150, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line8, "Global Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd2->global_alpha);
	  bitmap_output(X_Column10+150, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line9, "Global Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd2->global_beta);
	  bitmap_output(X_Column10+150, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column15, Y_Line15, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 225100:
	  ActiveQsnIndex = 22510;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please input the name of the second information file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(500, Y_Line5, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 225101:
	  ActiveQsnIndex = 22510;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Two Information Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 226000:
	  {
	  ActiveQsnIndex = 22600;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(240, Y_Line5, "Global alpha", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line5, "Alpha", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line5, "Beta", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line5, "Look time", GLUT_BITMAP_HELVETICA_18);
	  for(int i=0; i<SurvivalEnd2->num_look; i++){
		  bitmap_output(X_Column3, Y_Line6+i*Y_GAP, "Look", GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(150, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(170, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd2->BiAlphaSpending[i]);
		  bitmap_output(300, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd2->alpha_spending[i]);
		  bitmap_output(450, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd2->beta_spending[i]);
		  bitmap_output(600, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd2->look_time[i]);
		  bitmap_output(750, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column15, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 227000:
	  ActiveQsnIndex = 22700;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Current Look Number:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 227001:
	  ActiveQsnIndex = 22700;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Input out of range, please try again",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the order of this look:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 227100:
	  ActiveQsnIndex = 22710;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line5, "Please Load Data File.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 227101:
	  ActiveQsnIndex = 22710;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line5, "File not found, please try again.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 227200:
	  ActiveQsnIndex = 22720;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line5, "Data loaded successfully.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column4, Y_Line12, "Click \"Next\" to run the program.",
	      GLUT_BITMAP_HELVETICA_18);
	  break;

//////////////////////////////////////////////////////////////////////////////////////////////
  case 228100:
	  {
	  ActiveQsnIndex = 22810;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 2: Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "Critical Boundaries:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(320, Y_Line4, "First endpoint", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(650, Y_Line4, "Second endpoint", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(260, Y_Line4+5, "________________________", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(580, Y_Line4+5, "________________________", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(260, Y_Line5, "lower", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(360, Y_Line5, "upper", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(460, Y_Line5, "testZ", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(580, Y_Line5, "lower", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(680, Y_Line5, "upper", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(780, Y_Line5, "testZ", GLUT_BITMAP_HELVETICA_18);
	  for(int i=0; i<SurvivalEnd1->look_order; i++){
		  bitmap_output(100, Y_Line6+i*Y_GAP, "Look", GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(150, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(170, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->LowerAdjust[i]);
		  bitmap_output(250, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->UpperAdjust[i]);
		  bitmap_output(350, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->testZ[i]);
		  bitmap_output(450, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(540, Y_Line6+i*Y_GAP, "|", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd2->LowerAdjust[i]);
		  bitmap_output(570, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd2->UpperAdjust[i]);
		  bitmap_output(670, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd2->testZ[i]);
		  bitmap_output(770, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column10, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }
	  

  case 228200:
	  {
	  ActiveQsnIndex = 22820;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line2, "Case 2: Two Survival Endpoints--Visual Display of Critical Boundaries.",
	      GLUT_BITMAP_HELVETICA_18);

	    int offsetx = 500;
		int offsety = 400;		
		int factor = min(300/(max(SurvivalEnd1->testZ[SurvivalEnd1->look_order-1], SurvivalEnd1->UpperAdjust[SurvivalEnd1->look_order-1])+1), 250/(max(SurvivalEnd2->testZ[SurvivalEnd1->look_order-1],SurvivalEnd2->UpperAdjust[SurvivalEnd1->look_order-1])+1));

		cout<<"factor="<<factor<<endl;

		glColor3f(1,1,1);
		glLineWidth(2);
	
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,0+offsety,0);
		glVertex3f(-300+offsetx, 0+offsety,0);
		glEnd();
		bitmap_output(310+offsetx, offsety+8, "End 1",
				GLUT_BITMAP_HELVETICA_18);

		glBegin(GL_LINES);
		glVertex3f(0+offsetx,250+offsety,0);
		glVertex3f(0+offsetx,-250+offsety,0);
		glEnd();
		bitmap_output(-18+offsetx, -260+offsety, "End 2",
				GLUT_BITMAP_HELVETICA_18);


		bitmap_output(-20+offsetx, offsety+30, "0",
				GLUT_BITMAP_HELVETICA_18);
		for (int i=1; i<min(SurvivalEnd1->UpperAdjust[SurvivalEnd1->look_order-1]+1, 300.0/factor); i++){
			itoa(i);
			bitmap_output(i*factor+offsetx, offsety+30, BroadcastString,
				GLUT_BITMAP_HELVETICA_18);
			itoa(-i);
			bitmap_output(-i*factor-5+offsetx, offsety+30, BroadcastString,
				GLUT_BITMAP_HELVETICA_18);
		}
		for (i=1; i<min(SurvivalEnd2->UpperAdjust[SurvivalEnd1->look_order-1]+1, 250.0/factor) ; i++){
			itoa(i);
			bitmap_output(-20+offsetx, offsety-factor*i, BroadcastString,
		        GLUT_BITMAP_HELVETICA_18);
			itoa(-i);
			bitmap_output(-25+offsetx, offsety+factor*i, BroadcastString,
		        GLUT_BITMAP_HELVETICA_18);
		}

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(factor*SurvivalEnd2->UpperAdjust[SurvivalEnd1->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(factor*SurvivalEnd2->UpperAdjust[SurvivalEnd1->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(-factor*SurvivalEnd2->UpperAdjust[SurvivalEnd1->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(-factor*SurvivalEnd2->UpperAdjust[SurvivalEnd1->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(factor*SurvivalEnd2->LowerAdjust[SurvivalEnd1->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(factor*SurvivalEnd2->LowerAdjust[SurvivalEnd1->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(-factor*SurvivalEnd2->LowerAdjust[SurvivalEnd1->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(-factor*SurvivalEnd2->LowerAdjust[SurvivalEnd1->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,factor*SurvivalEnd1->UpperAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, factor*SurvivalEnd1->UpperAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glEnd();

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,-factor*SurvivalEnd1->UpperAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, -factor*SurvivalEnd1->UpperAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,factor*SurvivalEnd1->LowerAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, factor*SurvivalEnd1->LowerAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,-factor*SurvivalEnd1->LowerAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, -factor*SurvivalEnd1->LowerAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glEnd();

		// testZ
		glColor3f(0,1,1);
		bitmap_output(factor*SurvivalEnd1->testZ[SurvivalEnd1->look_order-1]+offsetx, -factor*SurvivalEnd2->testZ[SurvivalEnd1->look_order-1]+offsety, "*",
			GLUT_BITMAP_HELVETICA_18);
		glEnd();

		glEnd();
		break;
	  }

//////////////////////////////////////////////////////////////////////////////////////////////
//  Case 23, first normal, second survival
//////////////////////////////////////////////////////////////////////////////////////////////
  case 230100:
	  ActiveQsnIndex = 23010;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please Load Information Files. Two Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Sample Information Files Available at: http://www.biostat.wisc.edu/~kosorok/",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the name of the first information file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(500, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 230101:
	  ActiveQsnIndex = 23010;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "__________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Two Information Files Needed",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 231000:
	  ActiveQsnIndex = 23100;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The following information received.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+2, "_______________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Order =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->order);
	  bitmap_output(270, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Number of Looks =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(270, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Number of Monto Carlo replications =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Spending Function =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->spending_number);
	  bitmap_output(270, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Sample size control =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->sample_size1);
	  bitmap_output(270, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "Sample size treat =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->sample_size2);
	  bitmap_output(270, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);

	  bitmap_output(X_Column10, Y_Line6, "Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->overall_alpha);
	  bitmap_output(X_Column10+150, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line7, "Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->overall_beta);
	  bitmap_output(X_Column10+150, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line8, "Global Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->Bi_Alpha);
	  bitmap_output(X_Column10+150, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line9, "Global Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->Bi_Beta);
	  bitmap_output(X_Column10+150, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line10, "mean (Null) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->meanNull);
	  bitmap_output(X_Column10+150, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line11, "mean (Alter) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd1->meanAlter);
	  bitmap_output(X_Column10+150, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);

	  bitmap_output(X_Column1, Y_Line15, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

//////////////////////////////////////////////////////////////////////////////////////////////
  case 231100:
	  ActiveQsnIndex = 23110;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input the name of the second file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(500, Y_Line6, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 231101:
	  ActiveQsnIndex = 23110;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Two Information Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 232000:
	  {
	  ActiveQsnIndex = 23200;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "__________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(300, Y_Line5, "Information", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(520, Y_Line5, "Aalpha", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(720, Y_Line5, "Beta", GLUT_BITMAP_HELVETICA_18);
	  for(int i=0; i<NormalEnd1->num_look; i++){
		  bitmap_output(X_Column3, Y_Line6+i*Y_GAP, "Look", GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(150, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(170, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->inform_time[i]);
		  bitmap_output(300, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->alpha[i]);
		  bitmap_output(500, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->beta[i]);
		  bitmap_output(700, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column15, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

//////////////////////////////////////////////////////////////////////////////////////////////
  case 233000:
	  ActiveQsnIndex = 23300;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Current Look Number:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 233001:
	  ActiveQsnIndex = 23300;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Input is out of range, please try again",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the order of this look:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line7, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 233100:
	  ActiveQsnIndex = 23310;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line6, "Please Load Data File.", 
	      GLUT_BITMAP_HELVETICA_18);
//	  bitmap_output(X_Column1, Y_Line7, "the first          columns corresponde to the data needed for this look.", 
//	      GLUT_BITMAP_HELVETICA_18);
//	  itoa(NormalEnd1->look_order);	  
//	  bitmap_output(135, Y_Line7, BroadcastString, 
//	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line9, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 233101:
	  ActiveQsnIndex = 23310;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line6, "File not found, please try again.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line9, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 233200:
	  ActiveQsnIndex = 23320;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line6, "Data loaded successfully.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 234100:
	  ActiveQsnIndex = 23410;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please Load Information Files. Two Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Sample Information Files Available at: http://www.biostat.wisc.edu/~kosorok.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the name of the first file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(500, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 234101:
	  ActiveQsnIndex = 23410;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Two Information Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 235000:
	  ActiveQsnIndex = 23500;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The following information received.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Order =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->order);
	  bitmap_output(270, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Number of Looks =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_look);
	  bitmap_output(270, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Number of Monto Carlo replications =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_simul);
	  bitmap_output(380, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Lambda (Null) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd2->lambdaNull);
	  bitmap_output(260, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Lambda (Alter) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd2->lambdaAlter);
	  bitmap_output(260, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "Lambda (drop) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd2->lambdadrop);
	  bitmap_output(260, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line12, "Sample size control =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->sample_size1);
	  bitmap_output(270, Y_Line12, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line13, "Sample size treat =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->sample_size2);
	  bitmap_output(270, Y_Line13, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line6, "Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd2->alpha);
	  bitmap_output(X_Column10+150, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line7, "Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd2->beta);
	  bitmap_output(X_Column10+150, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line8, "Global Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd2->global_alpha);
	  bitmap_output(X_Column10+150, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line9, "Global Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd2->global_beta);
	  bitmap_output(X_Column10+150, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column15, Y_Line15, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 235100:
	  ActiveQsnIndex = 23510;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input the name of the second information file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(500, Y_Line6, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 235101:
	  ActiveQsnIndex = 23510;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Two Information Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 236000:
	  {
	  ActiveQsnIndex = 23600;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(240, Y_Line5, "Global alpha", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line5, "Alpha", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line5, "Beta", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line5, "Look time", GLUT_BITMAP_HELVETICA_18);
	  for(int i=0; i<SurvivalEnd2->num_look; i++){
		  bitmap_output(X_Column3, Y_Line6+i*Y_GAP, "Look", GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(150, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(170, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd2->BiAlphaSpending[i]);
		  bitmap_output(300, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd2->alpha_spending[i]);
		  bitmap_output(450, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd2->beta_spending[i]);
		  bitmap_output(600, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd2->look_time[i]);
		  bitmap_output(750, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column15, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 237000:
	  ActiveQsnIndex = 23700;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Current Look Number:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 237001:
	  ActiveQsnIndex = 23700;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Input out of range, please try again",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the order of this look:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 237100:
	  ActiveQsnIndex = 23710;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line6, "Please Load Data File.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 237101:
	  ActiveQsnIndex = 23710;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line6, "File not found, please try again.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 237200:
	  ActiveQsnIndex = 23720;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "_________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line6, "Data loaded successfully.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column4, Y_Line12, "Click \"Next\" to run the program.",
	      GLUT_BITMAP_HELVETICA_18);
	  break;
//////////////////////////////////////////////////////////////////////////////////////////////
  case 238100:
	  {
	  ActiveQsnIndex = 23810;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 3: Two Endpoints: first Normal & second Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "Critical Boundaries:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(320, Y_Line4, "First endpoint", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(650, Y_Line4, "Second endpoint", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(260, Y_Line4+5, "________________________", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(580, Y_Line4+5, "________________________", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(260, Y_Line5, "lower", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(360, Y_Line5, "upper", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(460, Y_Line5, "testZ", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(580, Y_Line5, "lower", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(680, Y_Line5, "upper", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(780, Y_Line5, "testZ", GLUT_BITMAP_HELVETICA_18);
	  for(int i=0; i<NormalEnd1->look_order; i++){
		  bitmap_output(100, Y_Line6+i*Y_GAP, "Look", GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(150, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(170, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->LowerAdjust[i]);
		  bitmap_output(250, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->UpperAdjust[i]);
		  bitmap_output(350, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd1->testZ[i]);
		  bitmap_output(450, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(540, Y_Line6+i*Y_GAP, "|", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd2->LowerAdjust[i]);
		  bitmap_output(570, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd2->UpperAdjust[i]);
		  bitmap_output(670, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd2->testZ[i]);
		  bitmap_output(770, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column10, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 238200:
	  {
	  ActiveQsnIndex = 23820;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line2, "Case 3: first Normal & second Survival Endpoints -- Visual Display of Critical Boundaries.",
	      GLUT_BITMAP_HELVETICA_18);

	    int offsetx = 500;
		int offsety = 400;		
		int factor = min(300/(max(NormalEnd1->testZ[NormalEnd1->look_order-1], NormalEnd1->UpperAdjust[NormalEnd1->look_order-1])+1), 250/(max(SurvivalEnd2->testZ[SurvivalEnd2->look_order-1],SurvivalEnd2->UpperAdjust[SurvivalEnd2->look_order-1])+1));

		cout<<"factor="<<factor<<endl;

		glColor3f(1,1,1);
		glLineWidth(2);
	
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,0+offsety,0);
		glVertex3f(-300+offsetx, 0+offsety,0);
		glEnd();
		bitmap_output(310+offsetx, offsety+8, "end 1",
				GLUT_BITMAP_HELVETICA_18);

		glBegin(GL_LINES);
		glVertex3f(0+offsetx,250+offsety,0);
		glVertex3f(0+offsetx,-250+offsety,0);
		glEnd();
		bitmap_output(-18+offsetx, -260+offsety, "end 2",
				GLUT_BITMAP_HELVETICA_18);


		bitmap_output(-20+offsetx, offsety+30, "0",
				GLUT_BITMAP_HELVETICA_18);
		for (int i=1; i<min(NormalEnd1->UpperAdjust[NormalEnd1->look_order-1]+1, 300.0/factor); i++){
			itoa(i);
			bitmap_output(i*factor+offsetx, offsety+30, BroadcastString,
				GLUT_BITMAP_HELVETICA_18);
			itoa(-i);
			bitmap_output(-i*factor-5+offsetx, offsety+30, BroadcastString,
				GLUT_BITMAP_HELVETICA_18);
		}
		for (i=1; i<min(SurvivalEnd2->UpperAdjust[SurvivalEnd2->look_order-1]+1, 250.0/factor) ; i++){
			itoa(i);
			bitmap_output(-20+offsetx, offsety-factor*i, BroadcastString,
		        GLUT_BITMAP_HELVETICA_18);
			itoa(-i);
			bitmap_output(-25+offsetx, offsety+factor*i, BroadcastString,
		        GLUT_BITMAP_HELVETICA_18);
		}

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(factor*SurvivalEnd2->UpperAdjust[SurvivalEnd2->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(factor*SurvivalEnd2->UpperAdjust[SurvivalEnd2->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(-factor*SurvivalEnd2->UpperAdjust[SurvivalEnd2->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(-factor*SurvivalEnd2->UpperAdjust[SurvivalEnd2->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(factor*SurvivalEnd2->LowerAdjust[SurvivalEnd2->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(factor*SurvivalEnd2->LowerAdjust[SurvivalEnd2->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(-factor*SurvivalEnd2->LowerAdjust[SurvivalEnd2->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(-factor*SurvivalEnd2->LowerAdjust[SurvivalEnd2->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,factor*NormalEnd1->UpperAdjust[NormalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, factor*NormalEnd1->UpperAdjust[NormalEnd1->look_order-1]+offsety,0);
		glEnd();

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,-factor*NormalEnd1->UpperAdjust[NormalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, -factor*NormalEnd1->UpperAdjust[NormalEnd1->look_order-1]+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,factor*NormalEnd1->LowerAdjust[NormalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, factor*NormalEnd1->LowerAdjust[NormalEnd1->look_order-1]+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,-factor*NormalEnd1->LowerAdjust[NormalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, -factor*NormalEnd1->LowerAdjust[NormalEnd1->look_order-1]+offsety,0);
		glEnd();

		// testZ
		glColor3f(0,1,1);
		bitmap_output(factor*NormalEnd1->testZ[NormalEnd1->look_order-1]+offsetx, -factor*SurvivalEnd2->testZ[SurvivalEnd2->look_order-1]+offsety, "*",
			GLUT_BITMAP_HELVETICA_18);
		glEnd();

		glEnd();
		break;
	  }

//////////////////////////////////////////////////////////////////////////////////////////////
//  Case 24, first survival, second normal
//////////////////////////////////////////////////////////////////////////////////////////////
  case 240100:
	  ActiveQsnIndex = 24010;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please Load Information Files. Two Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Sample Information Files Available at: http://www.biostat.wisc.edu/~kosorok/.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the name of the first information file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(500, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240101:
	  ActiveQsnIndex = 24010;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Two Information Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 241000:
	  ActiveQsnIndex = 24100;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The following information received.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Order =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->order);
	  bitmap_output(270, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Number of Looks =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);
	  bitmap_output(270, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Number of Monto Carlo replications =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_simul);
	  bitmap_output(380, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Lambda (Null) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->lambdaNull);
	  bitmap_output(260, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Lambda (Alter) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->lambdaAlter);
	  bitmap_output(260, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "Lambda (drop) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->lambdadrop);
	  bitmap_output(260, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line12, "Sample size control =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->sample_size1);
	  bitmap_output(270, Y_Line12, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line13, "Sample size treat =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->sample_size2);
	  bitmap_output(270, Y_Line13, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line6, "Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->alpha);
	  bitmap_output(X_Column10+150, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line7, "Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->beta);
	  bitmap_output(X_Column10+150, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line8, "Global Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->global_alpha);
	  bitmap_output(X_Column10+150, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line9, "Global Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(SurvivalEnd1->global_beta);
	  bitmap_output(X_Column10+150, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column15, Y_Line15, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 241100:
	  ActiveQsnIndex = 24110;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input the name of the second information file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(500, Y_Line6, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 241101:
	  ActiveQsnIndex = 24110;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Two information files needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 242000:
	  {
	  ActiveQsnIndex = 24200;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(240, Y_Line5, "Global alpha", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line5, "Alpha", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line5, "Beta", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line5, "Look time", GLUT_BITMAP_HELVETICA_18);
	  for(int i=0; i<SurvivalEnd1->num_look; i++){
		  bitmap_output(X_Column3, Y_Line6+i*Y_GAP, "Look", GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(150, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(170, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->BiAlphaSpending[i]);
		  bitmap_output(300, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->alpha_spending[i]);
		  bitmap_output(450, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->beta_spending[i]);
		  bitmap_output(600, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->look_time[i]);
		  bitmap_output(750, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column15, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 243000:
	  ActiveQsnIndex = 24300;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Current Look Number:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 243001:
	  ActiveQsnIndex = 24300;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Input out of range, please try again",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the order of this look:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 243100:
	  ActiveQsnIndex = 24310;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line6, "Please Load Data File.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 243101:
	  ActiveQsnIndex = 24310;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line6, "File not found, please try again.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 243200:
	  ActiveQsnIndex = 24320;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the first Survival Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line6, "Data loaded successfully.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column4, Y_Line12, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  break;
/////////////////////////////////////////////////////////////////////////////
  case 244100:
	  ActiveQsnIndex = 24410;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please Load Information Files. Two Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Sample Information Files Available at: http://www.biostat.wisc.edu/~kosorok/",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the name of the first information file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(500, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 244101:
	  ActiveQsnIndex = 24410;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Two Information Files Needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

//////////////////////////////////////////////////////////////////////////////////////////////
  case 245000:
	  ActiveQsnIndex = 24500;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The following information received.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+2, "________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Order =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->order);
	  bitmap_output(270, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Number of Looks =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(270, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Number of Monto Carlo replications =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Spending Function =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->spending_number);
	  bitmap_output(270, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Sample size control =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->sample_size1);
	  bitmap_output(270, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "Sample size treat =",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->sample_size2);
	  bitmap_output(270, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);

	  bitmap_output(X_Column10, Y_Line6, "Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd2->overall_alpha);
	  bitmap_output(X_Column10+150, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line7, "Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd2->overall_beta);
	  bitmap_output(X_Column10+150, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line8, "Global Alpha =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd2->Bi_Alpha);
	  bitmap_output(X_Column10+150, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line9, "Global Beta =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd2->Bi_Beta);
	  bitmap_output(X_Column10+150, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line10, "mean (Null) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd2->meanNull);
	  bitmap_output(X_Column10+150, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line11, "mean (Alter) =",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_4(NormalEnd2->meanAlter);
	  bitmap_output(X_Column10+150, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);

	  bitmap_output(X_Column1, Y_Line15, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 245100:
	  ActiveQsnIndex = 24510;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input the name of the second information file:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(500, Y_Line6, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 245101:
	  ActiveQsnIndex = 24510;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "File Not found. Try again.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Two information files needed.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 246000:
	  {
	  ActiveQsnIndex = 24600;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "__________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(300, Y_Line5, "Information", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(520, Y_Line5, "Alpha", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(720, Y_Line5, "Beta", GLUT_BITMAP_HELVETICA_18);
	  for(int i=0; i<NormalEnd2->num_look; i++){
		  bitmap_output(X_Column3, Y_Line6+i*Y_GAP, "Look", GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(150, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(170, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd2->inform_time[i]);
		  bitmap_output(300, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd2->alpha[i]);
		  bitmap_output(500, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd2->beta[i]);
		  bitmap_output(700, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column15, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 247000:
	  ActiveQsnIndex = 24700;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Current Look Number:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 247001:
	  ActiveQsnIndex = 24700;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Input out of range, please try again",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the order of this look:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line15, "*Note, the endpoint's number of looks is:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);	  
	  bitmap_output(400, Y_Line15, BroadcastString, 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 247100:
	  ActiveQsnIndex = 24710;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line6, "Please Load Data File.", 
	      GLUT_BITMAP_HELVETICA_18);
//	  bitmap_output(X_Column1, Y_Line7, "the first          columns corresponde to the data needed for this look.", 
//	      GLUT_BITMAP_HELVETICA_18);
//	  itoa(NormalEnd2->look_order);	  
//	  bitmap_output(135, Y_Line7, BroadcastString, 
//	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line10, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 247101:
	  ActiveQsnIndex = 24710;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line6, "File not found, please try again.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Please input the file name here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line9, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  break;

  case 247200:
	  ActiveQsnIndex = 24720;
	  InputAllowed = TRUE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "For the second Normal Endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+5, "________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line6, "Data loaded successfully.", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column10, Y_Line16, "Click \"Next\" to run the program.",
	      GLUT_BITMAP_HELVETICA_18);
	  break;
/////////////////////////////////////////////////////////////////////////////
  case 248100:
	  {
	  ActiveQsnIndex = 24810;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Case 4: Two Endpoints: first Survival & second Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "Critical Boundaries:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(320, Y_Line4, "First endpoint", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(650, Y_Line4, "Second endpoint", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(260, Y_Line4+5, "________________________", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(580, Y_Line4+5, "________________________", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(260, Y_Line5, "lower", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(360, Y_Line5, "upper", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(460, Y_Line5, "testZ", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(580, Y_Line5, "lower", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(680, Y_Line5, "upper", GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(780, Y_Line5, "testZ", GLUT_BITMAP_HELVETICA_18);
	  for(int i=0; i<SurvivalEnd1->look_order; i++){
		  bitmap_output(100, Y_Line6+i*Y_GAP, "Look", GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(150, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(170, Y_Line6+i*Y_GAP, ":", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->LowerAdjust[i]);
		  bitmap_output(250, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->UpperAdjust[i]);
		  bitmap_output(350, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(SurvivalEnd1->testZ[i]);
		  bitmap_output(450, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(540, Y_Line6+i*Y_GAP, "|", GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd2->LowerAdjust[i]);
		  bitmap_output(570, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd2->UpperAdjust[i]);
		  bitmap_output(670, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
		  ftoa_4(NormalEnd2->testZ[i]);
		  bitmap_output(770, Y_Line6+i*Y_GAP, BroadcastString, GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column10, Y_Line16, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 248200:
	  {
	  ActiveQsnIndex = 24820;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line1, "Section II -- Data Analysis of Group Sequential Clinical Trials",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line2, "Case 4: first Survival & second Normal Endpoints -- Visual Display of Critical Boundaries.",
	      GLUT_BITMAP_HELVETICA_18);

	    int offsetx = 500;
		int offsety = 400;		
		int factor = min(300/(max(SurvivalEnd1->testZ[SurvivalEnd1->look_order-1], SurvivalEnd1->UpperAdjust[SurvivalEnd1->look_order-1])+1), 250/(max(NormalEnd2->testZ[NormalEnd2->look_order-1],NormalEnd2->UpperAdjust[NormalEnd2->look_order-1])+1));

		cout<<"factor="<<factor<<endl;

		glColor3f(1,1,1);
		glLineWidth(2);
	
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,0+offsety,0);
		glVertex3f(-300+offsetx, 0+offsety,0);
		glEnd();
		bitmap_output(310+offsetx, offsety+8, "End 1",
				GLUT_BITMAP_HELVETICA_18);

		glBegin(GL_LINES);
		glVertex3f(0+offsetx,250+offsety,0);
		glVertex3f(0+offsetx,-250+offsety,0);
		glEnd();
		bitmap_output(-18+offsetx, -260+offsety, "End 2",
				GLUT_BITMAP_HELVETICA_18);


		bitmap_output(-20+offsetx, offsety+30, "0",
				GLUT_BITMAP_HELVETICA_18);
		for (int i=1; i<min(SurvivalEnd1->UpperAdjust[SurvivalEnd1->look_order-1]+1, 300.0/factor); i++){
			itoa(i);
			bitmap_output(i*factor+offsetx, offsety+30, BroadcastString,
				GLUT_BITMAP_HELVETICA_18);
			itoa(-i);
			bitmap_output(-i*factor-5+offsetx, offsety+30, BroadcastString,
				GLUT_BITMAP_HELVETICA_18);
		}
		for (i=1; i<min(NormalEnd2->UpperAdjust[NormalEnd2->look_order-1]+1, 250.0/factor) ; i++){
			itoa(i);
			bitmap_output(-20+offsetx, offsety-factor*i, BroadcastString,
		        GLUT_BITMAP_HELVETICA_18);
			itoa(-i);
			bitmap_output(-25+offsetx, offsety+factor*i, BroadcastString,
		        GLUT_BITMAP_HELVETICA_18);
		}

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(factor*NormalEnd2->UpperAdjust[NormalEnd2->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(factor*NormalEnd2->UpperAdjust[NormalEnd2->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(-factor*NormalEnd2->UpperAdjust[NormalEnd2->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(-factor*NormalEnd2->UpperAdjust[NormalEnd2->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(factor*NormalEnd2->LowerAdjust[NormalEnd2->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(factor*NormalEnd2->LowerAdjust[NormalEnd2->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(-factor*NormalEnd2->LowerAdjust[NormalEnd2->look_order-1]+offsetx,250+offsety,0);
		glVertex3f(-factor*NormalEnd2->LowerAdjust[NormalEnd2->look_order-1]+offsetx,-250+offsety,0);
		glEnd();

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,factor*SurvivalEnd1->UpperAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, factor*SurvivalEnd1->UpperAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glEnd();

		glColor3f(1,0,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,-factor*SurvivalEnd1->UpperAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, -factor*SurvivalEnd1->UpperAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,factor*SurvivalEnd1->LowerAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, factor*SurvivalEnd1->LowerAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glEnd();

		glColor3f(1,1,0);
		glBegin(GL_LINES);
		glVertex3f(300+offsetx,-factor*SurvivalEnd1->LowerAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glVertex3f(-300+offsetx, -factor*SurvivalEnd1->LowerAdjust[SurvivalEnd1->look_order-1]+offsety,0);
		glEnd();

		// testZ
		glColor3f(0,1,1);
		bitmap_output(factor*SurvivalEnd1->testZ[SurvivalEnd1->look_order-1]+offsetx, -factor*NormalEnd2->testZ[NormalEnd2->look_order-1]+offsety, "*",
			GLUT_BITMAP_HELVETICA_18);
		glEnd();

		glEnd();
		break;
	  }

/////////////////////////////////////////////////////////////////////////////
  case 888888888:
	  bitmap_output(150, Y_Line4, "Not enough information is given. Please return to the first page.",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 999999999:
	  bitmap_output(150, Y_Line4, "Please wait for later version.......",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  }

  glFlush();								// Flush the graphics pipe
  glutSwapBuffers();						// Swap buffers
  //glutSetWindow(broadcast_w);
}


//
// BroadcastKey: Function to handle keyboard events for input
//        in to the program via the broadcast window.
//

void BroadcastKey(unsigned char key, int x, int y)
{
	if(InputAllowed==TRUE){
		switch (ActiveQsnIndex){
		case 10:
			if (key=='1'){
				num_endpoint = key-48;      // change from char to int (-48)
				BroadcastOption = 200;
			}
			else if(key=='2'){
				num_endpoint = key-48;      // change from char to int (-48)
				BroadcastOption = 250;
			}
			else {
				BroadcastOption = 100;
			}
			displayBroadcast();
			break;


		case 20:
			if(key=='N'||key=='n'){
				NormalEnd1->type = "Normal";
				NormalEnd1->order = 1;
				caseIndex = 11;
				BroadcastOption = 110100;
			}
			else if(key=='S'||key=='s'){
				SurvivalEnd1->type = "Survival";
				SurvivalEnd1->order = 1;
				caseIndex = 12;
				BroadcastOption = 120100;
			}
			else{
				BroadcastOption = 201;
			}
			displayBroadcast();
			break;

		case 25:	
			if(key=='1'){
				caseIndex = 21;
				NormalEnd1->type = "Normal";
				NormalEnd1->order = 1;
				NormalEnd2->type = "Normal";
				NormalEnd2->order = 2;
				BroadcastOption = 260;
			}
			else if (key=='2'){
				caseIndex = 22;
				SurvivalEnd1->type = "Survival";
				SurvivalEnd1->order = 1;
				SurvivalEnd2->type = "Survival";
				SurvivalEnd2->order = 2;
				BroadcastOption = 260;
			}
			else if (key=='3'){
				caseIndex = 23;
				NormalEnd1->type = "Normal";
				NormalEnd1->order = 1;
				SurvivalEnd2->type = "Survival";
				SurvivalEnd2->order = 2;
				BroadcastOption = 260;
			}
			else if (key=='4'){
				caseIndex = 24;
				SurvivalEnd1->type = "Survival";
				SurvivalEnd1->order = 1;
				NormalEnd2->type = "Normal";
				NormalEnd2->order = 2;
				BroadcastOption = 260;
			}
			else {
				BroadcastOption = 250;
			}
			displayBroadcast();
			break;

		case 26:
			if(key=='h'||key=='H'){
				if(caseIndex==21){
					NormalEnd1->rule_decision = 1;
					NormalEnd2->rule_decision = 1;
					BroadcastOption = 210100;
				}
				else if(caseIndex==22){
					SurvivalEnd1->rule_decision = 1;
					SurvivalEnd2->rule_decision = 1;
					BroadcastOption = 220100;
				}
				else if(caseIndex==23){
					NormalEnd1->rule_decision = 1;
					SurvivalEnd2->rule_decision = 1;
					BroadcastOption = 230100;
				}
				else if(caseIndex==24){
					SurvivalEnd1->rule_decision = 1;
					NormalEnd2->rule_decision = 1;
					BroadcastOption = 240100;
				}
				else{
				}
			}
			else if(key=='s' || key=='S'){
				if(caseIndex==21){
					NormalEnd1->rule_decision = 0;
					NormalEnd2->rule_decision = 0;
					BroadcastOption = 210100;
				}
				else if(caseIndex==22){
					SurvivalEnd1->rule_decision = 0;
					SurvivalEnd2->rule_decision = 0;
					BroadcastOption = 220100;
				}
				else if(caseIndex==23){
					NormalEnd1->rule_decision = 0;
					SurvivalEnd2->rule_decision = 0;
					BroadcastOption = 230100;
				}
				else if(caseIndex==24){
					SurvivalEnd1->rule_decision = 0;
					NormalEnd2->rule_decision = 0;
					BroadcastOption = 240100;
				}
				else{
				}
			}
			displayBroadcast();
			break;


		case 11010:
		case 11110:
		case 11300:
		case 11310:

		case 12010:
		case 12110:		//		case 12020:		case 12030:		case 12040:
		case 12300:
		case 12310:
		case 12510:

		case 21010:
		case 21110:
		case 21300:
		case 21310:
		case 21410:
		case 21510:
		case 21700:
		case 21710:

		case 22010:		//		case 22020:		case 22030:		case 22040:
		case 22110:
		case 22300:		//		case 22220:		case 22230:		case 22240:
		case 22310:
		case 22410:
		case 22510:
		case 22700:
		case 22710:

		case 23010:
		case 23110:
		case 23300:
		case 23310:
		case 23410:
		case 23510:
		case 23700:
		case 23710:

		case 24010:
		case 24110:
		case 24300:
		case 24310:
		case 24410:
		case 24510:
		case 24700:
		case 24710:

			if (key != '\r'){		// Wait for a carrige return
				if (key == '\b'){	// If Backspace
					if (stringcounter != 0){
						BroadcastValueString[stringcounter-1] = '\0';
						displayBroadcast();
						stringcounter--;
					}
				}
				else{					// Not a backspace
					if(key>='0'&&key<='9'||key>='a'&&key<='z'||key>='A'&&key<='Z'||key=='.'){
						BroadcastValueString[stringcounter] = key;	
						// store text in BroadcastValueString
						displayBroadcast();
						stringcounter++;
					}
				}
			}

			else {
				BroadcastValueString[stringcounter] = '\0';
				BroadcastString = trimString(BroadcastValueString);
				switch(ActiveQsnIndex)
				{
				///////////////////////////////////////////////////////
				// Case 11
				///////////////////////////////////////////////////////
				case 11010:
					if (NormalEnd1->Loadfile1(BroadcastString)==1){
						NormalEnd1->getLookSimul();
						BroadcastOption = 111000;
					}
					else
						BroadcastOption = 110101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 11110:
					if (NormalEnd1->Loadfile2(BroadcastString)==1){
						cout<<"num_look="<<NormalEnd1->num_look<<endl;
						cout<<"Now check the \"inform_time\" of the endpoint:"<<endl;
						for (int iii=0; iii<NormalEnd1->num_look; iii++){
							cout<<NormalEnd1->inform_time[iii]<<"\t";
						}
						cout<<endl<<"inform_time check completed"<<endl;
						BroadcastOption = 112000;
					}
					else
						BroadcastOption = 111101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 11300:
					temp=(int)atof(BroadcastValueString);
					if (temp<=NormalEnd1->num_look && temp>=0){
						NormalEnd1->look_order=temp;
						BroadcastOption = 113100;
					}
					else
						BroadcastOption = 113001;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 11310:{
					if (LoadDataN1(BroadcastString, NormalEnd1->look_order)==1){
						cout<<endl<<"num_look="<<NormalEnd1->num_look<<"\t";
						cout<<"num_simul="<<NormalEnd1->num_simul<<"\t";
						cout<<"=> looksimul="<<NormalEnd1->looksimul<<endl;
						cout<<"Now check the first column\"dataEnd11\" :"<<endl;
						for (int iii=0; iii<NormalEnd1->sample_size1+NormalEnd1->sample_size2; iii++){
						//	cout<<dataEnd11[iii]<<"\t";
						}
					//	cout<<endl<<"dataEnd11 check completed"<<endl;
						BroadcastOption = 113200;
					}
					else 
						BroadcastOption = 113101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;}

				///////////////////////////////////////////////////////
				// Case 12
				///////////////////////////////////////////////////////
				case 12010:
					if (SurvivalEnd1->Loadfile1(BroadcastString)==1){
						SurvivalEnd1->getLookSimul();
						BroadcastOption = 121000;
					}
					else
						BroadcastOption = 120101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 12110:
					if (SurvivalEnd1->Loadfile2(BroadcastString)==1)
						BroadcastOption = 122000;
					else
						BroadcastOption = 121101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 12300:
					temp=(int)atof(BroadcastValueString);
					if (temp<=SurvivalEnd1->num_look && temp>=0){
						SurvivalEnd1->look_order=temp;
						BroadcastOption = 123100;
					}
					else
						BroadcastOption = 123001;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 12310:{
					if (LoadDataS1(BroadcastString)==1){
						cout<<endl<<"MS num_look="<<SurvivalEnd1->num_look<<"\t";
						cout<<"num_simul="<<SurvivalEnd1->num_simul<<"\t";
						cout<<"=> looksimul="<<SurvivalEnd1->looksimul<<endl;
						cout<<"sample zie"<<SurvivalEnd1->sample_size1<<endl;
					//	cout<<"Now check the 4th column \"entry\" :"<<endl;
					//	for (int iii=0; iii<SurvivalEnd1->sample_size1; iii++){
					//		cout<<dataS1[6*iii+4]<<"\t";
					//	}
						cout<<endl<<"dataS1 check completed"<<endl;
						BroadcastOption = 123200;
					}
					else 
						BroadcastOption = 123101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;}
					
				///////////////////////////////////////////////////////
				// Case 21
				///////////////////////////////////////////////////////
				case 21010:
					if (NormalEnd1->Loadfile1(BroadcastString)==1){
						NormalEnd1->getLookSimul();
						BroadcastOption = 211000;
					}
					else
						BroadcastOption = 210101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 21110:
					if (NormalEnd1->Loadfile2(BroadcastString)==1){
						cout<<"num_look="<<NormalEnd1->num_look<<endl;
						cout<<"Now check the \"inform_time\" of the endpoint:"<<endl;
						for (int iii=0; iii<NormalEnd1->num_look; iii++){
							cout<<NormalEnd1->inform_time[iii]<<"\t";
						}
						cout<<endl<<"inform_time check completed"<<endl;
						BroadcastOption = 212000;
					}
					else
						BroadcastOption = 211101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 21300:
					temp=(int)atof(BroadcastValueString);
					if (temp<=NormalEnd1->num_look && temp>=0){
						NormalEnd1->look_order=temp;
						BroadcastOption = 213100;
					}
					else
						BroadcastOption = 213001;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 21310:{
					if (LoadDataN1(BroadcastString, NormalEnd1->look_order)==1){
						cout<<endl<<"num_look="<<NormalEnd1->num_look<<"\t";
						cout<<"num_simul="<<NormalEnd1->num_simul<<"\t";
						cout<<"=> looksimul="<<NormalEnd1->looksimul<<endl;
						cout<<"Now check the first column\"dataEnd11\" :"<<endl;
						for (int iii=0; iii<NormalEnd1->sample_size1+NormalEnd1->sample_size2; iii++){
//							cout<<dataEnd11[iii]<<"\t";
						}
						cout<<endl<<"dataEnd11 check completed"<<endl;
						BroadcastOption = 213200;
					}
					else 
						BroadcastOption = 213101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;}

				case 21410:
					if (NormalEnd2->Loadfile1(BroadcastString)==1){
						NormalEnd2->getLookSimul();
						BroadcastOption = 215000;
					}
					else
						BroadcastOption = 214101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 21510:
					if (NormalEnd2->Loadfile2(BroadcastString)==1){
						cout<<"num_look="<<NormalEnd2->num_look<<endl;
						cout<<"Now check the \"inform_time\" of the endpoint:"<<endl;
						for (int iii=0; iii<NormalEnd2->num_look; iii++){
							cout<<NormalEnd2->inform_time[iii]<<"\t";
						}
						cout<<endl<<"inform_time check completed"<<endl;
						BroadcastOption = 216000;
					}
					else
						BroadcastOption = 215101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 21700:
					temp=(int)atof(BroadcastValueString);
					if (temp<=NormalEnd2->num_look && temp>=0){
						NormalEnd2->look_order=temp;
						BroadcastOption = 217100;
					}
					else
						BroadcastOption = 217001;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 21710:{
					if (LoadDataN2(BroadcastString, NormalEnd2->look_order)==1){
						cout<<endl<<"num_look="<<NormalEnd2->num_look<<"\t";
						cout<<"num_simul="<<NormalEnd2->num_simul<<"\t";
						cout<<"=> looksimul="<<NormalEnd2->looksimul<<endl;
						cout<<"Now check the first column\"dataEnd21\" :"<<endl;
						for (int iii=0; iii<NormalEnd2->sample_size1+NormalEnd2->sample_size2; iii++){
							cout<<dataEnd21[iii]<<"\t";
						}
						cout<<endl<<"dataEnd21 check completed"<<endl;
						BroadcastOption = 217200;
					}
					else 
						BroadcastOption = 217101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;}
				///////////////////////////////////////////////////////
				// Case 22
				///////////////////////////////////////////////////////
				case 22010:
					if (SurvivalEnd1->Loadfile1(BroadcastString)==1){
						SurvivalEnd1->getLookSimul();
						BroadcastOption = 221000;
					}
					else
						BroadcastOption = 220101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 22110:
					if (SurvivalEnd1->Loadfile2(BroadcastString)==1)
						BroadcastOption = 222000;
					else
						BroadcastOption = 221101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 22300:
					temp=(int)atof(BroadcastValueString);
					if (temp<=SurvivalEnd1->num_look && temp>=0){
						SurvivalEnd1->look_order=temp;
						BroadcastOption = 223100;
					}
					else
						BroadcastOption = 223001;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 22310:{
					if (LoadDataS1(BroadcastString)==1){
						cout<<endl<<"num_look="<<SurvivalEnd1->num_look<<"\t";
						cout<<"num_simul="<<SurvivalEnd1->num_simul<<"\t";
						cout<<"=> looksimul="<<SurvivalEnd1->looksimul<<endl;
						cout<<"sample size 1 \t"<<SurvivalEnd1->sample_size1<<endl;
						cout<<"sample size 2 \t"<<SurvivalEnd1->sample_size2<<endl;

					//	cout<<"Now check the 4th column \"entry\" :"<<endl;
					//	for (int iii=0; iii<(SurvivalEnd1->sample_size1+SurvivalEnd1->sample_size2); iii++){
					//		cout<<dataS1[6*iii+4]<<"\t";
					//	}
						cout<<endl<<"dataS1 check completed"<<endl;
						BroadcastOption = 223200;
					}
					else 
						BroadcastOption = 223101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;}

				case 22410:
					if (SurvivalEnd2->Loadfile1(BroadcastString)==1){
						SurvivalEnd2->getLookSimul();
						BroadcastOption = 225000;
					}
					else
						BroadcastOption = 224101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 22510:
					if (SurvivalEnd2->Loadfile2(BroadcastString)==1)
						BroadcastOption = 226000;
					else
						BroadcastOption = 225101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 22700:
					temp=(int)atof(BroadcastValueString);
					if (temp<=SurvivalEnd2->num_look && temp>=0){
						SurvivalEnd2->look_order=temp;
						BroadcastOption = 227100;
					}
					else
						BroadcastOption = 227001;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 22710:{
					if (LoadDataS2(BroadcastString)==1){
						cout<<endl<<"num_look="<<SurvivalEnd2->num_look<<"\t";
						cout<<"num_simul="<<SurvivalEnd2->num_simul<<"\t";
						cout<<"=> looksimul="<<SurvivalEnd2->looksimul<<endl;
					//	cout<<"Now check the 4th column \"entry\" :"<<endl;
					//	for (int iii=0; iii<(SurvivalEnd2->sample_size1+SurvivalEnd2->sample_size2); iii++){
					//		cout<<dataS2[6*iii+4]<<"\t";
					//	}
					//	cout<<endl<<"dataS2 check completed"<<endl;
						BroadcastOption = 227200;
					}
					else 
						BroadcastOption = 227101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;}
				//////////////////////////////////////////////////////
				// Case 23
				///////////////////////////////////////////////////////
				case 23010:
					if (NormalEnd1->Loadfile1(BroadcastString)==1){
						NormalEnd1->getLookSimul();
						BroadcastOption = 231000;
					}
					else
						BroadcastOption = 230101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 23110:
					if (NormalEnd1->Loadfile2(BroadcastString)==1){
						cout<<"num_look="<<NormalEnd1->num_look<<endl;
						cout<<"Now check the \"inform_time\" of the endpoint:"<<endl;
						for (int iii=0; iii<NormalEnd1->num_look; iii++){
							cout<<NormalEnd1->inform_time[iii]<<"\t";
						}
						cout<<endl<<"inform_time check completed"<<endl;
						BroadcastOption = 232000;
					}
					else
						BroadcastOption = 231101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 23300:
					temp=(int)atof(BroadcastValueString);
					if (temp<=NormalEnd1->num_look && temp>=0){
						NormalEnd1->look_order=temp;
						BroadcastOption = 233100;
					}
					else
						BroadcastOption = 233001;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 23310:{
					if (LoadDataN1(BroadcastString, NormalEnd1->look_order)==1){
						cout<<endl<<"num_look="<<NormalEnd1->num_look<<"\t";
						cout<<"num_simul="<<NormalEnd1->num_simul<<"\t";
						cout<<"=> looksimul="<<NormalEnd1->looksimul<<endl;
						cout<<"Now check the first column\"dataEnd11\" :"<<endl;
						for (int iii=0; iii<NormalEnd1->sample_size1+NormalEnd1->sample_size2; iii++){
//							cout<<dataEnd11[iii]<<"\t";
						}
						cout<<endl<<"dataEnd11 check completed"<<endl;
						BroadcastOption = 233200;
					}
					else 
						BroadcastOption = 233101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;}

				case 23410:
					if (SurvivalEnd2->Loadfile1(BroadcastString)==1){
						SurvivalEnd2->getLookSimul();
						BroadcastOption = 235000;
					}
					else
						BroadcastOption = 234101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 23510:
					if (SurvivalEnd2->Loadfile2(BroadcastString)==1)
						BroadcastOption = 236000;
					else
						BroadcastOption = 235101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 23700:
					temp=(int)atof(BroadcastValueString);
					if (temp<=SurvivalEnd2->num_look && temp>=0){
						SurvivalEnd2->look_order=temp;
						BroadcastOption = 237100;
					}
					else
						BroadcastOption = 237001;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 23710:{
					if (LoadDataS2(BroadcastString)==1){
						cout<<endl<<"num_look="<<SurvivalEnd2->num_look<<"\t";
						cout<<"num_simul="<<SurvivalEnd2->num_simul<<"\t";
						cout<<"=> looksimul="<<SurvivalEnd2->looksimul<<endl;
					//	cout<<"Now check the 4th column \"entry\" :"<<endl;
					//	for (int iii=0; iii<(SurvivalEnd2->sample_size1+SurvivalEnd2->sample_size2); iii++){
					//		cout<<dataS2[6*iii+4]<<"\t";
					//	}
						cout<<endl<<"dataS2 check completed"<<endl;
						BroadcastOption = 237200;
					}
					else 
						BroadcastOption = 237101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;}
				///////////////////////////////////////////////////////
				// Case 24
				///////////////////////////////////////////////////////
				case 24010:
					if (SurvivalEnd1->Loadfile1(BroadcastString)==1){
						SurvivalEnd1->getLookSimul();
						BroadcastOption = 241000;
					}
					else
						BroadcastOption = 240101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 24110:
					if (SurvivalEnd1->Loadfile2(BroadcastString)==1)
						BroadcastOption = 242000;
					else
						BroadcastOption = 241101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 24300:
					temp=(int)atof(BroadcastValueString);
					if (temp<=SurvivalEnd1->num_look && temp>=0){
						SurvivalEnd1->look_order=temp;
						BroadcastOption = 243100;
					}
					else
						BroadcastOption = 243001;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 24310:{
					if (LoadDataS1(BroadcastString)==1){
						cout<<endl<<"num_look="<<SurvivalEnd1->num_look<<"\t";
						cout<<"num_simul="<<SurvivalEnd1->num_simul<<"\t";
						cout<<"=> looksimul="<<SurvivalEnd1->looksimul<<endl;
						cout<<"Now check the 4th column \"entry\" :"<<endl;
					//	for (int iii=0; iii<(SurvivalEnd1->sample_size1+SurvivalEnd1->sample_size2); iii++){
					//		cout<<dataS1[6*iii+4]<<"\t";
					//	}
						cout<<endl<<"dataS1 check completed"<<endl;
						BroadcastOption = 243200;
					}
					else 
						BroadcastOption = 243101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;}

				case 24410:
					if (NormalEnd2->Loadfile1(BroadcastString)==1){
						NormalEnd2->getLookSimul();
						BroadcastOption = 245000;
					}
					else
						BroadcastOption = 244101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 24510:
					if (NormalEnd2->Loadfile2(BroadcastString)==1){
						cout<<"num_look="<<NormalEnd2->num_look<<endl;
						cout<<"Now check the \"inform_time\" of the endpoint:"<<endl;
						for (int iii=0; iii<NormalEnd2->num_look; iii++){
							cout<<NormalEnd2->inform_time[iii]<<"\t";
						}
						cout<<endl<<"inform_time check completed"<<endl;
						BroadcastOption = 246000;
					}
					else
						BroadcastOption = 245101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 24700:
					temp=(int)atof(BroadcastValueString);
					if (temp<=NormalEnd2->num_look && temp>=0){
						NormalEnd2->look_order=temp;
						BroadcastOption = 247100;
					}
					else
						BroadcastOption = 247001;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;
				case 24710:{
					if (LoadDataN2(BroadcastString, NormalEnd2->look_order)==1){
						cout<<endl<<"num_look="<<NormalEnd2->num_look<<"\t";
						cout<<"num_simul="<<NormalEnd2->num_simul<<"\t";
						cout<<"=> looksimul="<<NormalEnd2->looksimul<<endl;
						cout<<"Now check the first column\"dataEnd24\" :"<<endl;
						for (int iii=0; iii<NormalEnd2->sample_size1+NormalEnd2->sample_size2; iii++){
							cout<<dataEnd24[iii]<<"\t";
						}
						cout<<endl<<"dataEnd24 check completed"<<endl;
						BroadcastOption = 247200;
					}
					else 
						BroadcastOption = 247101;
					clearString(BroadcastValueString);
					displayBroadcast();
					break;}
				}
			}	
			break;
		}
	}
}


void displayControls(void)
{

  glutSetWindow(control_w);	
  // Make sure we are dealing with the right window
  glClear(GL_COLOR_BUFFER_BIT);

  /////////////////////////
  // "Next" Button
  if (NextActive == TRUE)					// If the mouse is over "Next"
	   glColor3f(1,1,0);					// highlight it, otherwise don't!
  else glColor3f(0,1,0);

  bitmap_output(150, 180, "Next",	
	GLUT_BITMAP_HELVETICA_18);

  /////////////////////////
  // "Return" Button
  if (ReturnActive == TRUE)					// If the mouse is over "Return"
	   glColor3f(1,1,0);					// highlight it, otherwise don't!
  else glColor3f(0,1,0);

  bitmap_output(300, 180, "Return",		
	GLUT_BITMAP_HELVETICA_18);

  /////////////////////////
  // "Calculate" Button
  if (CalculateActive == TRUE)					// If the mouse is over "Calculate"
	   glColor3f(1,1,0);					// highlight it, otherwise don't!
  else glColor3f(0,1,0);

  bitmap_output(450, 180, "Calculate",		// Draw "Load File"
	GLUT_BITMAP_HELVETICA_18);


  /////////////////////////
  // "Exit" Button
  if (ExitActive == TRUE)					// If the mouse is over "Exit"
	  glColor3f(1,1,0);						// highlight it, otherwise don't!
  else glColor3f(0,1,0);

  bitmap_output(620, 180, "Exit",			// Draw "Exit"
    GLUT_BITMAP_HELVETICA_18);


  glFlush();								// Flush the graphics pipe
  glutSwapBuffers();						// Swap buffers
  //glutSetWindow(broadcast_w);
}
//
// ControlMouse: function to determine which choice is clicked,
//      and what to do about it.
//
void ControlMouse(int b, int s, int x, int y)
{

  ///////////////////////////////
  // When "Next" is clicked
  if ((b == GLUT_LEFT_BUTTON) && (NextActive == TRUE)){
	  if(ActiveQsnIndex == 0){
		  BroadcastOption = 100;
	  }
  ///////////////////////////////
	  else if (ActiveQsnIndex == 11100){
		  BroadcastOption = 111100;
	  }
	  else if (ActiveQsnIndex == 11200){
		  BroadcastOption = 113000;
	  }
	  else if (ActiveQsnIndex == 11320){
		  cout<<"Just above the UniNormalDecision"<<endl;
		  UniNormalDecision();
		  BroadcastOption = 115100;
	  }
	  else if (ActiveQsnIndex == 11510){
		  BroadcastOption = 115200;
	  }
  ///////////////////////////////
	  else if (ActiveQsnIndex == 12100){
		  BroadcastOption = 121100;
	  }
	  else if (ActiveQsnIndex == 12200){
		  BroadcastOption = 123000;
	  }
	  else if (ActiveQsnIndex == 12320){
			// run some function ???
		  UniSurvivalDecision();
		  BroadcastOption = 125100;
	  }
	  else if (ActiveQsnIndex == 12510){
		  BroadcastOption = 125200;
	  }
  ///////////////////////////////
	  else if (ActiveQsnIndex == 21100){
		  BroadcastOption = 211100;
	  }
	  else if (ActiveQsnIndex == 21200){
		  BroadcastOption = 213000;
	  }
	  else if (ActiveQsnIndex == 21320){
		  BroadcastOption = 214100;
	  }
	  else if (ActiveQsnIndex == 21500){
		  BroadcastOption = 215100;
	  }
	  else if (ActiveQsnIndex == 21600){
		  BroadcastOption = 217000;
	  }
	  else if (ActiveQsnIndex == 21720){
		  cout<<"Just above two Normal Decision"<<endl;
		  TwoNormalDecision();
		  BroadcastOption = 218100;
	  }
	  else if (ActiveQsnIndex == 21810){
		  BroadcastOption = 218200;
	  }
  ///////////////////////////////
	  else if (ActiveQsnIndex == 22100){
		  BroadcastOption = 221100;
	  }
	  else if (ActiveQsnIndex == 22200){
		  BroadcastOption = 223000;
	  }
	  else if (ActiveQsnIndex == 22320){
			// run some function ???
		  BroadcastOption = 224100;
	  }
	  else if (ActiveQsnIndex == 22500){
		  BroadcastOption = 225100;
	  }
	  else if (ActiveQsnIndex == 22600){
		  BroadcastOption = 227000;
	  }
	  else if (ActiveQsnIndex == 22720){
		
		  TwoSurvivalDecision();
			
			// run some function ???
		  BroadcastOption = 228100;
	  }
	  else if (ActiveQsnIndex == 22810){
		  BroadcastOption = 228200;
	  }
   ///////////////////////////////
	  else if (ActiveQsnIndex == 23100){
		  BroadcastOption = 231100;
	  }
	  else if (ActiveQsnIndex == 23200){
		  BroadcastOption = 233000;
	  }
	  else if (ActiveQsnIndex == 23320){
		  BroadcastOption = 234100;
	  }
	  else if (ActiveQsnIndex == 23500){
		  BroadcastOption = 235100;
	  }
	  else if (ActiveQsnIndex == 23600){
		  BroadcastOption = 237000;
	  }
	  else if (ActiveQsnIndex == 23720){
		  NormalSurvivalDecision();
		  BroadcastOption = 238100;
	  }
	  else if (ActiveQsnIndex == 23810){
		  BroadcastOption = 238200;
	  }
  ///////////////////////////////
	  else if (ActiveQsnIndex == 24100){
		  BroadcastOption = 241100;
	  }
	  else if (ActiveQsnIndex == 24200){
		  BroadcastOption = 243000;
	  }
	  else if (ActiveQsnIndex == 24320){
			// run some function ???
		  BroadcastOption = 244100;
	  }
	  else if (ActiveQsnIndex == 24500){
		  BroadcastOption = 245100;
	  }
	  else if (ActiveQsnIndex == 24600){
		  BroadcastOption = 247000;
	  }
	  else if (ActiveQsnIndex == 24720){
		  SurvivalNormalDecision();
		  BroadcastOption = 248100;
	  }
	  else if (ActiveQsnIndex == 24810){
		  BroadcastOption = 248200;
	  }
 ///////////////////////////////
	  else {
		  BroadcastOption = 888888888;
	  }
	  NextActive = FALSE;
	  displayBroadcast();
  }

  ///////////////////////////////////////////////
  // When "Return" is clicked
  if ((b == GLUT_LEFT_BUTTON) && (ReturnActive == TRUE)){
	  clearString(BroadcastValueString);
	  switch(BroadcastOption){
	  case 999999999:
	  case 888888888:
		  BroadcastOption = 0;
		  break;
	  case 0:
		  break;
	  case 100:
	  case 101:
		  BroadcastOption = 0;
		  break;
	  case 200:
	  case 201:
	  case 250:
		  BroadcastOption = 100;
		  break;
	  case 260:
		  BroadcastOption = 250;
		  break;

//////////////////////////////////////////////////
//  Case 11
//////////////////////////////////////////////////
	  case 110100:
	  case 110101:
		  BroadcastOption = 200;
		  break;
	  case 111000:
		  BroadcastOption = 110100;
		  break;
	  case 111100:
	  case 111101:
		  BroadcastOption = 111000;
		  break;
	  case 112000:
		  BroadcastOption = 111100;
		  break;
	  case 113000:
	  case 113001:
		  BroadcastOption = 112000;
		  break;
	  case 113100:
	  case 113101:
		  BroadcastOption = 113000;
		  break;
	  case 113200:
		  BroadcastOption = 113100;
		  break;
	  case 115100:
		  BroadcastOption = 113200;
		  break;
	  case 115200:
		  BroadcastOption = 115100;
		  break;
//////////////////////////////////////////////////
//  Case 12
//////////////////////////////////////////////////
	  case 120100:
	  case 120101:
		  BroadcastOption = 200;
		  break;
	  case 121000:
		  BroadcastOption = 120100;
		  break;
	  case 121100:
	  case 121101:
		  BroadcastOption = 121000;
		  break;
	  case 122000:
		  BroadcastOption = 121100;
		  break;
	  case 123000:
	  case 123001:
		  BroadcastOption = 122000;
		  break;
	  case 123100:
	  case 123101:
		  BroadcastOption = 123000;
		  break;
	  case 123200:
		  BroadcastOption = 123100;
		  break;
	  case 125100:
		  BroadcastOption = 123200;
		  break;
	  case 125200:
		  BroadcastOption = 125100;
		  break;
//////////////////////////////////////////////////
//  Case 21
//////////////////////////////////////////////////
	  case 210100:
	  case 210101:
		  BroadcastOption = 250;
		  break;
	  case 211000:
		  BroadcastOption = 210100;
		  break;
	  case 211100:
	  case 211101:
		  BroadcastOption = 211000;
		  break;
	  case 212000:
		  BroadcastOption = 211100;
		  break;
	  case 213000:
	  case 213001:
		  BroadcastOption = 212000;
		  break;
	  case 213100:
	  case 213101:
		  BroadcastOption = 213000;
		  break;
	  case 213200:
		  BroadcastOption = 213100;
		  break;
	  case 214100:
	  case 214101:
		  BroadcastOption = 213200;
		  break;
	  case 215000:
		  BroadcastOption = 214100;
		  break;
	  case 215100:
	  case 215101:
		  BroadcastOption = 215000;
		  break;
	  case 216000:
		  BroadcastOption = 215100;
		  break;
	  case 217000:
	  case 217001:
		  BroadcastOption = 216000;
		  break;
	  case 217100:
	  case 217101:
		  BroadcastOption = 217000;
		  break;
	  case 217200:
		  BroadcastOption = 217100;
		  break;
	  case 218100:
		  BroadcastOption = 217200;
		  break;
	  case 218200:
		  BroadcastOption = 218100;
		  break;
//////////////////////////////////////////////////
//  Case 22
//////////////////////////////////////////////////
	  case 220100:
	  case 220101:
		  BroadcastOption = 250;
		  break;
	  case 221000:
		  BroadcastOption = 220100;
		  break;
	  case 221100:
	  case 221101:
		  BroadcastOption = 221000;
		  break;
	  case 222000:
		  BroadcastOption = 221100;
		  break;
	  case 223000:
	  case 223001:
		  BroadcastOption = 222000;
		  break;
	  case 223100:
	  case 223101:
		  BroadcastOption = 223000;
		  break;
	  case 223200:
		  BroadcastOption = 223100;
		  break;
	  case 224100:
	  case 224101:
		  BroadcastOption = 223200;
		  break;
	  case 225000:
		  BroadcastOption = 224100;
		  break;
	  case 225100:
	  case 225101:
		  BroadcastOption = 225000;
		  break;
	  case 226000:
		  BroadcastOption = 225100;
		  break;
	  case 227000:
	  case 227001:
		  BroadcastOption = 226000;
		  break;
	  case 227100:
	  case 227101:
		  BroadcastOption = 227000;
		  break;
	  case 227200:
		  BroadcastOption = 227100;
		  break;
	  case 228100:
		  BroadcastOption = 227200;
		  break;
	  case 228200:
		  BroadcastOption = 228100;
		  break;

//////////////////////////////////////////////////
//  Case 23
//////////////////////////////////////////////////
	  case 230100:
	  case 230101:
		  BroadcastOption = 250;
		  break;
	  case 231000:
		  BroadcastOption = 230100;
		  break;
	  case 231100:
	  case 231101:
		  BroadcastOption = 231000;
		  break;
	  case 232000:
		  BroadcastOption = 231100;
		  break;
	  case 233000:
	  case 233001:
		  BroadcastOption = 232000;
		  break;
	  case 233100:
	  case 233101:
		  BroadcastOption = 233000;
		  break;
	  case 233200:
		  BroadcastOption = 233100;
		  break;
	  case 234100:
	  case 234101:
		  BroadcastOption = 233200;
		  break;
	  case 235000:
		  BroadcastOption = 234100;
		  break;
	  case 235100:
	  case 235101:
		  BroadcastOption = 235000;
		  break;
	  case 236000:
		  BroadcastOption = 235100;
		  break;
	  case 237000:
	  case 237001:
		  BroadcastOption = 236000;
		  break;
	  case 237100:
	  case 237101:
		  BroadcastOption = 237000;
		  break;
	  case 237200:
		  BroadcastOption = 237100;
		  break;
	  case 238100:
		  BroadcastOption = 237200;
		  break;
	  case 238200:
		  BroadcastOption = 238100;
		  break;
/////////////////////////////////////////////////
//  Case 24
//////////////////////////////////////////////////
	  case 240100:
	  case 240101:
		  BroadcastOption = 250;
		  break;
	  case 241000:
		  BroadcastOption = 240100;
		  break;
	  case 241100:
	  case 241101:
		  BroadcastOption = 241000;
		  break;
	  case 242000:
		  BroadcastOption = 241100;
		  break;
	  case 243000:
	  case 243001:
		  BroadcastOption = 242000;
		  break;
	  case 243100:
	  case 243101:
		  BroadcastOption = 243000;
		  break;
	  case 243200:
		  BroadcastOption = 243100;
		  break;
	  case 244100:
	  case 244101:
		  BroadcastOption = 243200;
		  break;
	  case 245000:
		  BroadcastOption = 244100;
		  break;
	  case 245100:
	  case 245101:
		  BroadcastOption = 245000;
		  break;
	  case 246000:
		  BroadcastOption = 245100;
		  break;
	  case 247000:
	  case 247001:
		  BroadcastOption = 246000;
		  break;
	  case 247100:
	  case 247101:
		  BroadcastOption = 247000;
		  break;
	  case 247200:
		  BroadcastOption = 247100;
		  break;
	  case 248100:
		  BroadcastOption = 247200;
		  break;
	  case 248200:
		  BroadcastOption = 248100;
		  break;
 	  }
	  ReturnActive = FALSE;
	  displayBroadcast();
  }

  ///////////////////////////////////////////////
  // When "Calculate" is clicked
  if ((b == GLUT_LEFT_BUTTON) && (CalculateActive == TRUE)){
	  CalculateActive = FALSE;
	  displayBroadcast();
  }

  ///////////////////////////////
  //  When "Exit" is clicked
  if ((b == GLUT_LEFT_BUTTON) && (ExitActive == TRUE)){
		exit(0);
  }
}

void ControlMousePassive(int x, int y)
{

	/////////////////////////////////
	// Mouse over "Next File"
	if ((x >= 140 && x <= 190) && (y >= 30 && y <= 70)){
		if (NextActive == FALSE) {
			NextActive = TRUE;
			displayControls();
		}
	}

	else {
		if (NextActive == TRUE){
			NextActive = FALSE;
			displayControls();
		}
	}

	/////////////////////////////////
	// Mouse over "Return File"
	if ((x >= 290 && x <= 350) && (y >= 30 && y <= 70)){
		if (ReturnActive == FALSE) {
			ReturnActive = TRUE;
			displayControls();
		}
	}

	else {
		if (ReturnActive == TRUE){
			ReturnActive = FALSE;
			displayControls();
		}
	}

	/////////////////////////////////
	// Mouse over "Calculate File"
	if ((x >= 435 && x <= 525) && (y >= 30 && y <= 70)){
		if (CalculateActive == FALSE) {
			CalculateActive = TRUE;
			displayControls();
		}
	}

	else {
		if (CalculateActive == TRUE){
			CalculateActive = FALSE;
			displayControls();
		}
	}

	/////////////////////////////////
	// Mouse over "Exit File"
	if ((x >= 600 && x <= 650) && (y >= 30 && y <= 70)){
		if (ExitActive == FALSE) {
			ExitActive = TRUE;
			displayControls();
		}
	}

	else {
		if (ExitActive == TRUE){
			ExitActive = FALSE;
			displayControls();
		}
	}
}



//////////////////////////////////////////

void ftoa(float f)
{
	clearString(BroadcastString);
	sprintf(BroadcastString, "%f\0", f);
}

void ftoa_2(float f)
{
	clearString(BroadcastString);
	sprintf(BroadcastString, "%8.2f\0", f);
}

void ftoa_3(float f)
{
	clearString(BroadcastString);
	sprintf(BroadcastString, "%8.3f\0", f);
}

void ftoa_4(float f)
{
	clearString(BroadcastString);
	sprintf(BroadcastString, "%8.4f\0", f);
}


void itoa(int i)
{
	clearString(BroadcastString);
	sprintf(BroadcastString, "%d\0", i);
}

//////////////////////////
// ReadFile for data
int readfile(char *fileName, char *targetName)
{
	double *tempData = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];

	char buffer[512];
	float data;
	/////////deal with the fileName////////////////
	char *newfile=trimString(fileName);
	/////////////////////////////////////////////////
	
	ifstream fin(newfile, ios::nocreate);

	if(!fin){
		cout << "Unable to open file: "<< fileName << endl;
		fin.close();
		return 0;
	}

	int i=0;
	while (fin.getline(buffer, 512)&&(i<NormalEnd1->sample_size1+NormalEnd1->sample_size2)){
	  if (buffer[0] == '#'){}			// Strip comments and blank lines
      else if (buffer[0] == '\0'){}
      else{
         sscanf(buffer, "%f", &data);
		 tempData[i]=data;
		 i++;
	  }
	}

	if (strcmp(targetName, "dataEnd11") == 0){
		dataEnd11 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd11 = tempData;
	}
	else if (strcmp(targetName, "dataEnd21") == 0){
		dataEnd21 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd21 = tempData;
	}
	else if (strcmp(targetName, "dataEnd12") == 0){
		dataEnd12 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd12 = tempData;
	}
	else if (strcmp(targetName, "dataEnd22") == 0){
		dataEnd22 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd22 = tempData;
	}
	else if (strcmp(targetName, "dataEnd13") == 0){
		dataEnd13 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd13 = tempData;
	}
	else if (strcmp(targetName, "dataEnd23") == 0){
		dataEnd23 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd23 = tempData;
	}
	else if (strcmp(targetName, "dataEnd14") == 0){
		dataEnd14 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd14 = tempData;
	}
	else if (strcmp(targetName, "dataEnd24") == 0){
		dataEnd24 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd24 = tempData;
	}
	else if (strcmp(targetName, "dataEnd15") == 0){
		dataEnd15 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd15 = tempData;
	}
	else if (strcmp(targetName, "dataEnd25") == 0){
		dataEnd25 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd25 = tempData;
	}
	else if (strcmp(targetName, "dataEnd16") == 0){
		dataEnd16 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd16 = tempData;
	}
	else if (strcmp(targetName, "dataEnd26") == 0){
		dataEnd26 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd26 = tempData;
	}
	else if (strcmp(targetName, "dataEnd17") == 0){
		dataEnd17 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd17 = tempData;
	}
	else if (strcmp(targetName, "dataEnd62") == 0){
		dataEnd27 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd27 = tempData;
	}
	else if (strcmp(targetName, "dataEnd18") == 0){
		dataEnd18 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd18 = tempData;
	}
	else if (strcmp(targetName, "dataEnd28") == 0){
		dataEnd28 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd28 = tempData;
	}
	else if (strcmp(targetName, "dataEnd19") == 0){
		dataEnd19 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd19 = tempData;
	}
	else if (strcmp(targetName, "dataEnd29") == 0){
		dataEnd29 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd29 = tempData;
	}
	else if (strcmp(targetName, "dataEnd10") == 0){
		dataEnd10 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd10 = tempData;
	}
	else if (strcmp(targetName, "dataEnd92") == 0){
		dataEnd20 = new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		dataEnd20 = tempData;
	}
	else {
	}

	return 1;
	
}









///////  The Calculation Part   ///////
/// All the Data Input and Output should be done above   ////


// The Standardization of Data.
// Return value is the [mean, std. dev]

double *Standardize(double *origin, int length1)
{
	double mean1, sum1;
	double variance1, varSum1;
	int i;
	double mean_std[2];
  
	for(i=0; i< length1; i++){
		sum1=sum1+origin[i];
	}

	mean1=sum1/length1;
	for(i=0; i<length1; i++){
		origin[i]=origin[i]-mean1;
	}

	for(i=0; i<length1; i++){
		varSum1=varSum1+origin[i]*origin[i];
	}
	variance1=varSum1/length1;
	
	mean_std[0]=mean1;
	mean_std[1]=sqrt(variance1);

	return mean_std; //------------------check !!!!!!!!!!!!!!!!!!!!
}





// absolute value:
double absD(double temp)
{
	return temp>=0 ? temp: -temp;
}



int LoadDataN1(char* filename, int look_order)
{
	char* buffer=new char[512];
	float value1, value2, value3, value4, value5, value6, value7, value8, value9, value10;
	ifstream fin(filename,ios::nocreate);

	if(!fin){
		cerr << "Unable to open file: "<< filename << endl;
		fin.close();
		return 0;
	}
	
	dataEnd11=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	dataEnd12=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	dataEnd13=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	dataEnd14=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	dataEnd15=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	dataEnd16=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	dataEnd17=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	dataEnd18=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	dataEnd19=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	dataEnd10=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];

	fin.getline(buffer, 512);
	int row =2;
	while (fin.getline(buffer, 512) && row-2<NormalEnd1->looksimul){
		if (buffer[0] == '#'){}			// Strip comments and blank lines
		else if (buffer[0] == '\0'){}
		else{
			sscanf(buffer, "%f %f %f %f %f %f %f %f %f %f", &value1, &value2, &value3, &value4, &value5, &value6, &value7, &value8, &value9, &value10);
			dataEnd11[row-2]=value1;
			dataEnd12[row-2]=value2;
			dataEnd13[row-2]=value3;
			dataEnd14[row-2]=value4;
			dataEnd15[row-2]=value5;
			dataEnd16[row-2]=value6;
			dataEnd17[row-2]=value7;
			dataEnd18[row-2]=value8;
			dataEnd19[row-2]=value9;
			dataEnd10[row-2]=value10;
		}
		row++;
	}
	fin.close();
	return 1;
}



int LoadDataN2(char* filename, int look_order)
{
	char* buffer=new char[512];
	float value1, value2, value3, value4, value5, value6, value7, value8, value9, value10;
	ifstream fin(filename,ios::nocreate);

	if(!fin){
		cerr << "Unable to open file: "<< filename << endl;
		fin.close();
		return 0;
	}
	
	dataEnd21=new double[NormalEnd2->sample_size1+NormalEnd2->sample_size2];
	dataEnd22=new double[NormalEnd2->sample_size1+NormalEnd2->sample_size2];
	dataEnd23=new double[NormalEnd2->sample_size1+NormalEnd2->sample_size2];
	dataEnd24=new double[NormalEnd2->sample_size1+NormalEnd2->sample_size2];
	dataEnd25=new double[NormalEnd2->sample_size1+NormalEnd2->sample_size2];
	dataEnd26=new double[NormalEnd2->sample_size1+NormalEnd2->sample_size2];
	dataEnd27=new double[NormalEnd2->sample_size1+NormalEnd2->sample_size2];
	dataEnd28=new double[NormalEnd2->sample_size1+NormalEnd2->sample_size2];
	dataEnd29=new double[NormalEnd2->sample_size1+NormalEnd2->sample_size2];
	dataEnd20=new double[NormalEnd2->sample_size1+NormalEnd2->sample_size2];

	fin.getline(buffer, 512);
	int row =2;
	while (fin.getline(buffer, 512) && row-2<NormalEnd2->looksimul){
		if (buffer[0] == '#'){}			// Strip comments and blank lines
		else if (buffer[0] == '\0'){}
		else{
			sscanf(buffer, "%f %f %f %f %f %f %f %f %f %f", &value1, &value2, &value3, &value4, &value5, &value6, &value7, &value8, &value9, &value10);
			dataEnd21[row-2]=value1;
			dataEnd22[row-2]=value2;
			dataEnd23[row-2]=value3;
			dataEnd24[row-2]=value4;
			dataEnd25[row-2]=value5;
			dataEnd26[row-2]=value6;
			dataEnd27[row-2]=value7;
			dataEnd28[row-2]=value8;
			dataEnd29[row-2]=value9;
			dataEnd20[row-2]=value10;
		}
		row++;
	}
	fin.close();
	return 1;
}

int LoadDataS1(char* filename)
{
	char* buffer=new char[512];
	float end, type, ID, entry, event, Indicator;

	ifstream fin(filename,ios::nocreate);

	if(!fin){
		cerr << "Unable to open file: "<< filename << endl;
		fin.close();
		return 0;
	}
	
	dataS1 = new double[6*(SurvivalEnd1->sample_size1+SurvivalEnd1->sample_size2)];

	fin.getline(buffer, 512);
	int row =2;
	while (fin.getline(buffer, 512) && row-2<SurvivalEnd1->sample_size1+SurvivalEnd1->sample_size2){
	if (buffer[0] == '#'){}			// Strip comments and blank lines
		else if (buffer[0] == '\0'){}
		else{
			sscanf(buffer, "%f %f %f %f %f %f", &end, &type, &ID, &entry, &event, &Indicator);
			dataS1[6*(row-2)+0] = end;
			dataS1[6*(row-2)+1] = type;
			dataS1[6*(row-2)+2] = ID;
			dataS1[6*(row-2)+3] = entry;
			dataS1[6*(row-2)+4] = event;
			dataS1[6*(row-2)+5] = Indicator;
			row++;
		}
	}
	fin.close();

	return 1;
}

int LoadDataS2(char* filename)
{
	char* buffer=new char[512];
	float end, type, ID, entry, event, Indicator;

	ifstream fin(filename,ios::nocreate);

	if(!fin){
		cerr << "Unable to open file: "<< filename << endl;
		fin.close();
		return 0;
	}
	
	dataS2 = new double[6*(SurvivalEnd2->sample_size1+SurvivalEnd2->sample_size2)];

	fin.getline(buffer, 512);
	int row =2;
	while (fin.getline(buffer, 512) && row-2<SurvivalEnd2->sample_size1+SurvivalEnd2->sample_size2){
	if (buffer[0] == '#'){}			// Strip comments and blank lines
		else if (buffer[0] == '\0'){}
		else{
			sscanf(buffer, "%f %f %f %f %f %f", &end, &type, &ID, &entry, &event, &Indicator);
			dataS2[6*(row-2)+0] = end;
			dataS2[6*(row-2)+1] = type;
			dataS2[6*(row-2)+2] = ID;
			dataS2[6*(row-2)+3] = entry;
			dataS2[6*(row-2)+4] = event;
			dataS2[6*(row-2)+5] = Indicator;
			row++;
		}
	}
	fin.close();

	return 1;
}

/*
//load data:
int LoadDataN1(char* filename, int look_order)
{
	char* buffer=new char[512];
	float value1, value2, value3, value4, value5, value6, value7, value8, value9, value10;
	ifstream fin(filename,ios::nocreate);

	if(!fin){
		cerr << "Unable to open file: "<< filename << endl;
		fin.close();
		return 0;
	}

	switch(look_order){
	case 10:
		dataEnd10=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	case 9:
		dataEnd19=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	case 8:
		dataEnd18=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	case 7:
		dataEnd17=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	case 6:
		dataEnd16=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	case 5:
		dataEnd15=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	case 4:
		dataEnd14=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	case 3:
		dataEnd13=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	case 2:
		dataEnd12=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
	case 1:
		dataEnd11=new double[NormalEnd1->sample_size1+NormalEnd1->sample_size2];
		break;
	}

	fin.getline(buffer, 512);
	int row =2;
	while (fin.getline(buffer, 512) && row-2<NormalEnd1->looksimul){
	if (buffer[0] == '#'){}			// Strip comments and blank lines
		else if (buffer[0] == '\0'){}
		else{
			switch(look_order){
			case 1:
				sscanf(buffer, "%f", &value1);
				dataEnd11[row-2]=value1;
				break;
			case 2:
				sscanf(buffer, "%f %f", &value1, &value2);
				dataEnd11[row-2]=value1;
				dataEnd12[row-2]=value2;
				break;
			case 3:
				sscanf(buffer, "%f %f %f", &value1, &value2, &value3);
				dataEnd11[row-2]=value1;
				dataEnd12[row-2]=value2;
				dataEnd13[row-2]=value3;
				break;
			case 4:
				sscanf(buffer, "%f %f %f %f", &value1, &value2, &value3, &value4);
				dataEnd11[row-2]=value1;
				dataEnd12[row-2]=value2;
				dataEnd13[row-2]=value3;
				dataEnd14[row-2]=value4;
				break;
			case 5:
				sscanf(buffer, "%f %f %f %f %f", &value1, &value2, &value3, &value4, &value5);
				dataEnd11[row-2]=value1;
				dataEnd12[row-2]=value2;
				dataEnd13[row-2]=value3;
				dataEnd14[row-2]=value4;
				dataEnd15[row-2]=value5;
				break;
			case 6:
				sscanf(buffer, "%f %f %f %f %f %f", &value1, &value2, &value3, &value4, &value5, &value6);
				dataEnd11[row-2]=value1;
				dataEnd12[row-2]=value2;
				dataEnd13[row-2]=value3;
				dataEnd14[row-2]=value4;
				dataEnd15[row-2]=value5;
				dataEnd16[row-2]=value6;
				break;
			case 7:
				sscanf(buffer, "%f %f %f %f %f %f %f", &value1, &value2, &value3, &value4, &value5, &value6, &value7);
				dataEnd11[row-2]=value1;
				dataEnd12[row-2]=value2;
				dataEnd13[row-2]=value3;
				dataEnd14[row-2]=value4;
				dataEnd15[row-2]=value5;
				dataEnd16[row-2]=value6;
				dataEnd17[row-2]=value7;
				break;
			case 8:
				sscanf(buffer, "%f %f %f %f %f %f %f %f", &value1, &value2, &value3, &value4, &value5, &value6, &value7, &value8);
				dataEnd11[row-2]=value1;
				dataEnd12[row-2]=value2;
				dataEnd13[row-2]=value3;
				dataEnd14[row-2]=value4;
				dataEnd15[row-2]=value5;
				dataEnd16[row-2]=value6;
				dataEnd17[row-2]=value7;
				dataEnd18[row-2]=value8;
				break;
			case 9:
				sscanf(buffer, "%f %f %f %f %f %f %f %f %f", &value1, &value2, &value3, &value4, &value5, &value6, &value7, &value8, &value9);
				dataEnd11[row-2]=value1;
				dataEnd12[row-2]=value2;
				dataEnd13[row-2]=value3;
				dataEnd14[row-2]=value4;
				dataEnd15[row-2]=value5;
				dataEnd16[row-2]=value6;
				dataEnd17[row-2]=value7;
				dataEnd18[row-2]=value8;
				dataEnd19[row-2]=value9;
				break;
			case 10:
				sscanf(buffer, "%f %f %f %f %f %f %f %f %f %f", &value1, &value2, &value3, &value4, &value5, &value6, &value7, &value8, &value9, &value10);
				dataEnd11[row-2]=value1;
				dataEnd12[row-2]=value2;
				dataEnd13[row-2]=value3;
				dataEnd14[row-2]=value4;
				dataEnd15[row-2]=value5;
				dataEnd16[row-2]=value6;
				dataEnd17[row-2]=value7;
				dataEnd18[row-2]=value8;
				dataEnd19[row-2]=value9;
				dataEnd10[row-2]=value10;
				break;
			}
			row++;
		}
	}
	fin.close();
	return 1;
}


int LoadDataN2(char* filename, int look_order)
{
	char* buffer=new char[512];
	float value1, value2, value3, value4, value5, value6, value7, value8, value9, value10;
	ifstream fin(filename,ios::nocreate);

	if(!fin){
		cerr << "Unable to open file: "<< filename << endl;
		fin.close();
		return 0;
	}

	switch(look_order){
	case 10:
		dataEnd20=new double[NormalEnd2->looksimul];
	case 9:
		dataEnd29=new double[NormalEnd2->looksimul];
	case 8:
		dataEnd28=new double[NormalEnd2->looksimul];
	case 7:
		dataEnd27=new double[NormalEnd2->looksimul];
	case 6:
		dataEnd26=new double[NormalEnd2->looksimul];
	case 5:
		dataEnd25=new double[NormalEnd2->looksimul];
	case 4:
		dataEnd24=new double[NormalEnd2->looksimul];
	case 3:
		dataEnd23=new double[NormalEnd2->looksimul];
	case 2:
		dataEnd22=new double[NormalEnd2->looksimul];
	case 1:
		dataEnd21=new double[NormalEnd2->looksimul];
		break;
	}

	fin.getline(buffer, 512);
	int row =2;
	while (fin.getline(buffer, 512) && row-2<NormalEnd2->looksimul){
	if (buffer[0] == '#'){}			// Strip comments and blank lines
		else if (buffer[0] == '\0'){}
		else{
			switch(look_order){
			case 1:
				sscanf(buffer, "%f", &value1);
				dataEnd21[row-2]=value1;
				break;
			case 2:
				sscanf(buffer, "%f %f", &value1, &value2);
				dataEnd21[row-2]=value1;
				dataEnd22[row-2]=value2;
				break;
			case 3:
				sscanf(buffer, "%f %f %f", &value1, &value2, &value3);
				dataEnd21[row-2]=value1;
				dataEnd22[row-2]=value2;
				dataEnd23[row-2]=value3;
				break;
			case 4:
				sscanf(buffer, "%f %f %f %f", &value1, &value2, &value3, &value4);
				dataEnd21[row-2]=value1;
				dataEnd22[row-2]=value2;
				dataEnd23[row-2]=value3;
				dataEnd24[row-2]=value4;
				break;
			case 5:
				sscanf(buffer, "%f %f %f %f %f", &value1, &value2, &value3, &value4, &value5);
				dataEnd21[row-2]=value1;
				dataEnd22[row-2]=value2;
				dataEnd23[row-2]=value3;
				dataEnd24[row-2]=value4;
				dataEnd25[row-2]=value5;
				break;
			case 6:
				sscanf(buffer, "%f %f %f %f %f %f", &value1, &value2, &value3, &value4, &value5, &value6);
				dataEnd21[row-2]=value1;
				dataEnd22[row-2]=value2;
				dataEnd23[row-2]=value3;
				dataEnd24[row-2]=value4;
				dataEnd25[row-2]=value5;
				dataEnd26[row-2]=value6;
				break;
			case 7:
				sscanf(buffer, "%f %f %f %f %f %f %f", &value1, &value2, &value3, &value4, &value5, &value6, &value7);
				dataEnd21[row-2]=value1;
				dataEnd22[row-2]=value2;
				dataEnd23[row-2]=value3;
				dataEnd24[row-2]=value4;
				dataEnd25[row-2]=value5;
				dataEnd26[row-2]=value6;
				dataEnd27[row-2]=value7;
				break;
			case 8:
				sscanf(buffer, "%f %f %f %f %f %f %f %f", &value1, &value2, &value3, &value4, &value5, &value6, &value7, &value8);
				dataEnd21[row-2]=value1;
				dataEnd22[row-2]=value2;
				dataEnd23[row-2]=value3;
				dataEnd24[row-2]=value4;
				dataEnd25[row-2]=value5;
				dataEnd26[row-2]=value6;
				dataEnd27[row-2]=value7;
				dataEnd28[row-2]=value8;
				break;
			case 9:
				sscanf(buffer, "%f %f %f %f %f %f %f %f %f", &value1, &value2, &value3, &value4, &value5, &value6, &value7, &value8, &value9);
				dataEnd21[row-2]=value1;
				dataEnd22[row-2]=value2;
				dataEnd23[row-2]=value3;
				dataEnd24[row-2]=value4;
				dataEnd25[row-2]=value5;
				dataEnd26[row-2]=value6;
				dataEnd27[row-2]=value7;
				dataEnd28[row-2]=value8;
				dataEnd29[row-2]=value9;
				break;
			case 10:
				sscanf(buffer, "%f %f %f %f %f %f %f %f %f %f", &value1, &value2, &value3, &value4, &value5, &value6, &value7, &value8, &value9, &value10);
				dataEnd21[row-2]=value1;
				dataEnd22[row-2]=value2;
				dataEnd23[row-2]=value3;
				dataEnd24[row-2]=value4;
				dataEnd25[row-2]=value5;
				dataEnd26[row-2]=value6;
				dataEnd27[row-2]=value7;
				dataEnd28[row-2]=value8;
				dataEnd29[row-2]=value9;
				dataEnd20[row-2]=value10;
				break;
			}
			row++;
		}
	}
	fin.close();
	return 1;
}

*/































double SEEDD[5000];

int ICOUNT=0;

//
//   For one NOrmal endpoint case
//
//   Taking into account control and treat, the difference is meanAlter and the covariance matrix

void UniNormalDecision()
// The decision making for one normal end:
{
	int con1;

	int i,j, k, l, m, n;
	int currentlook=NormalEnd1->look_order;
	int maxlook=LIMIT_N_LOOK;

	int *size1, *size2, *size;
	size=new int[2*maxlook];
	size1=new int[currentlook];
	size2=new int[currentlook];

	size=UNSize1();

	for(i=0; i<currentlook; i++){
		size1[i]=size[i];
		size2[i]=size[i+maxlook];
	}

	char decision;
	srand ((unsigned)time(NULL));
	for(i=0; i<5000; i++)
		SEEDD[i]= (double) ( rand() % 2000) / 2000.0;


	//
	// Now Simulate Normal with the same Structure:
	//
	double *workarray;
	double *workmean, *workvar, *workcovA;	
	workarray=new double[currentlook*NormalEnd1->looksimul];
	workmean=new double[currentlook];
	workvar=new double[currentlook];
	workcovA=new double[currentlook*currentlook];

	double *workNullA, *workAlterA;
	workNullA=new double[currentlook*NormalEnd1->looksimul];
	workAlterA=new double[currentlook*NormalEnd1->looksimul];

	double *meanNull, *meanAlter;
	meanNull=new double[NormalEnd1->num_look];
	meanAlter=new double[NormalEnd1->num_look];


	// get the workstructure:
	double *meanA1, *varA1, *covA1;
	meanA1=new double[currentlook*2];
	varA1=new double[currentlook];
	covA1=new double[currentlook*currentlook];
//	meanA1=UNMean(NormalEnd1);
//	varA1=UNVar(NormalEnd1);
//	covA1=UNCov(NormalEnd1);
	meanA1=UNMeanNew(NormalEnd1);
	varA1=UNVarNew(NormalEnd1);
	covA1=UNCovNew(NormalEnd1);


	for(i=0; i<currentlook; i++){
		workmean[i]=meanA1[i];
		workvar[i]=varA1[i];
	}
	for(i=0; i<currentlook; i++){
		for(j=0; j<currentlook; j++){
			workcovA[i*currentlook+j]=covA1[i*currentlook+j];
		}
	}

	for(i=0; i<currentlook; i++){
		for(j=0; j<currentlook; j++){
			cout<<covA1[i*currentlook+j]<<"\t";
		}
		cout<<endl;
	}

	for(i=0; i<NormalEnd1->num_look; i++){
		meanNull[i]=NormalEnd1->meanNull;
		meanAlter[i]=NormalEnd1->meanAlter;
	}


	// Now we have meanA1, varA1, covA1 (from the real trial data)
	// meanNull[] & meanAlter[i];
	// we will calculate the structure of workNullA & workAlterA directly.
	
	double *StatMeanNull, *StatMeanAlter;
	double *StatVar, *StatCov;
	double stemp1, stemp2, stemp3, stemp4;
	int *SizeN;
	StatMeanNull=new double[currentlook];
	StatMeanAlter=new double[currentlook];
	StatVar=new double[currentlook];
	StatCov=new double[currentlook*currentlook];
	SizeN=new int[currentlook];


	int sizet1, sizet2;


	// Calculate the mean first:
	for(i=0; i<currentlook; i++){
		sizet1=0; 
		sizet2=0;
		for(k=0; k<=i; k++){
			sizet1=sizet1+size1[k];	//control
			sizet2=sizet2+size2[k];	//treat
		}
		StatMeanNull[i]=(sizet2*NormalEnd1->meanNull-sizet1*NormalEnd1->meanNull)/sqrt(1.0*(sizet1+sizet2)) ;
		StatMeanAlter[i]=(sizet2*NormalEnd1->meanAlter-sizet1*NormalEnd1->meanNull)/sqrt(1.0*(sizet1+sizet2));

	}


	// new version of calculation of cov and var:
	// the estimated cov is in covA1.

	for(i=0; i<currentlook; i++){
		for(j=0; j<=i; j++){
			stemp1=0;
			stemp2=0;
			stemp3=0;
			stemp4=0;

			for(k=0; k<=i; k++){
				for(l=0; l<=j; l++){
					stemp3=stemp3+minInt(size1[k], size1[l])*workcovA[k*currentlook+l];
				}
			}
			for(k=0; k<=i; k++){
				for(l=0; l<=j; l++){
					stemp4=stemp4+minInt(size2[k], size2[l])*workcovA[k*currentlook+l];
				}
			}

			for(k=0; k<=i; k++){
				stemp1=stemp1+size1[k]+size2[k];
			}
			for(k=0; k<=j; k++){
				stemp2=stemp2+size1[k]+size2[k];
			}

			StatCov[i*currentlook+j]=(stemp4+stemp3)/sqrt(1.0*(stemp2*stemp1));
			StatCov[j*currentlook+i]=(stemp4+stemp3)/sqrt(1.0*(stemp2*stemp1));

		}
	}


	for(i=0; i<currentlook; i++){
		StatVar[i]=StatCov[i*currentlook+i];
	}
	cout<<"Cov structure"<<endl;

	double * sqrttemp;
	sqrttemp=new double[currentlook*currentlook];
	sqrttemp=sqrt_matrix(currentlook, StatCov);



	// Now we can simulate workNullA & workAlterA:
	workNullA=UNNormalSimul(currentlook, NormalEnd1->looksimul, StatMeanNull, StatVar, StatCov);
	workAlterA=UNNormalSimul(currentlook, NormalEnd1->looksimul, StatMeanAlter, StatVar, StatCov);
	

	// the check of workNullA and workAlterA:
	double *meanB1, *meanB2;
	double *varB1, *varB2;
	meanB1=new double[currentlook];
	meanB2=new double[currentlook];
	varB1=new double[currentlook];
	varB2=new double[currentlook];

	for(m=0; m<currentlook; m++){
		meanB1[m]=0;
		meanB2[m]=0;
		for(n=0; n<NormalEnd1->looksimul; n++){
			meanB1[m]=meanB1[m]+workNullA[n*currentlook+m];
			meanB2[m]=meanB2[m]+workAlterA[n*currentlook+m];
		}
		meanB1[m]=meanB1[m]/NormalEnd1->looksimul;
		meanB2[m]=meanB2[m]/NormalEnd1->looksimul;
	}

	cout<<"mean of Null and Alter of Z"<<endl;
	for(m=0; m<currentlook; m++)
		cout<<meanB1[m]<<"\t";
	cout<<endl;
	for(m=0; m<currentlook; m++)
		cout<<meanB2[m]<<"\t";
	cout<<endl;

	for(m=0; m<currentlook; m++){
		varB1[m]=0;
		varB2[m]=0;
		for(n=0; n<NormalEnd1->looksimul; n++){
			varB1[m]=varB1[m]+(workNullA[n*currentlook+m]-meanB1[m])*(workNullA[n*currentlook+m]-meanB1[m]);
			varB2[m]=varB2[m]+(workAlterA[n*currentlook+m]-meanB2[m])*(workAlterA[n*currentlook+m]-meanB2[m]);
		}
		varB1[m]=varB1[m]/NormalEnd1->looksimul;
		varB2[m]=varB2[m]/NormalEnd1->looksimul;
	}
/*	cout<<"var of Null and Alter of Z"<<endl;
	for(m=0; m<currentlook; m++)
		cout<<varB1[m]<<"\t";
	cout<<endl;
	for(m=0; m<currentlook; m++)
		cout<<varB2[m]<<"\t";
	cout<<endl;
*/


	

	
	// The Calculation of Boundary Procedure:
	double *boundary1;
	double *upperbound1;
	double *lowerbound1;
	boundary1=new double[2*NormalEnd1->num_look];
	upperbound1=new double[NormalEnd1->num_look];
	lowerbound1=new double[NormalEnd1->num_look];

	for(i=0; i<NormalEnd1->num_look; i++){
		upperbound1[i]=0;
		lowerbound1[i]=0;
	}
	for(i=0; i<2*NormalEnd1->num_look; i++){
		boundary1[i]=0;
	}

	boundary1=UNBound(currentlook, workNullA, workAlterA, NormalEnd1);

	NormalEnd1->boundary=boundary1;

	//Calculate the Z (test statistic for OUR data):
	double * TestZ;
	TestZ=new double[NormalEnd1->num_look];
	for(i=0; i<NormalEnd1->num_look; i++)
		TestZ[i]=0;
	
	double *work;
	work=new double[maxlook*(NormalEnd1->sample_size1+NormalEnd1->sample_size2)];
	for(i=0; i< (NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++){
		work[i*maxlook+0]=dataEnd11[i];
		work[i*maxlook+1]=dataEnd12[i];
		work[i*maxlook+2]=dataEnd13[i];
		work[i*maxlook+3]=dataEnd14[i];
		work[i*maxlook+4]=dataEnd15[i];
		work[i*maxlook+5]=dataEnd16[i];
		work[i*maxlook+6]=dataEnd17[i];
		work[i*maxlook+7]=dataEnd18[i];
		work[i*maxlook+8]=dataEnd19[i];
		work[i*maxlook+9]=dataEnd10[i];
	}
	
	for(i=0; i<currentlook; i++){
		stemp1=0;
		stemp2=0;

		sizet1=0; 
		sizet2=0;
		for(k=0; k<=i; k++){
			sizet1=sizet1+size1[k];	//control
			sizet2=sizet2+size2[k];	//treat
		}
		
		for(j=0; j<=i; j++){
			for(k=0; k<size1[j]; k++){
				stemp1=stemp1+work[k*maxlook+j];	//control
			}
			for(k=NormalEnd1->sample_size1; k<NormalEnd1->sample_size1+size2[j]; k++){
				stemp2=stemp2+work[k*maxlook+j];	//treat
			}
		}
		TestZ[i]=(stemp2-stemp1)/sqrt(sizet1+sizet2);
	}

	for(i=0; i<NormalEnd1->num_look; i++){
		NormalEnd1->testZ[i] = TestZ[i];
	}


}





double *UNMean(TrialEndNormal *end1)
{
	int maxlook=LIMIT_N_LOOK;
//	int con1;
	int i;
	
	double *meanA1;
	meanA1=new double[maxlook];

	for(i=0; i<maxlook; i++)
		meanA1[i]=0;

	// check the mean structure:
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		meanA1[0]=meanA1[0]+dataEnd11[i];
	meanA1[0]=meanA1[0]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		meanA1[1]=meanA1[1]+dataEnd12[i];
	meanA1[1]=meanA1[1]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		meanA1[2]=meanA1[2]+dataEnd13[i];
	meanA1[2]=meanA1[2]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		meanA1[3]=meanA1[3]+dataEnd14[i];
	meanA1[3]=meanA1[3]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		meanA1[4]=meanA1[4]+dataEnd15[i];
	meanA1[4]=meanA1[4]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		meanA1[5]=meanA1[5]+dataEnd16[i];
	meanA1[5]=meanA1[5]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		meanA1[6]=meanA1[6]+dataEnd17[i];
	meanA1[6]=meanA1[6]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		meanA1[7]=meanA1[7]+dataEnd18[i];
	meanA1[7]=meanA1[7]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		meanA1[8]=meanA1[8]+dataEnd19[i];
	meanA1[8]=meanA1[8]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		meanA1[9]=meanA1[9]+dataEnd10[i];
	meanA1[9]=meanA1[9]/(end1->sample_size1+end1->sample_size2);

	end1->mean = meanA1;
	return meanA1;
}


double *UNVar(TrialEndNormal *end1)
{
	int maxlook=LIMIT_N_LOOK;
//	int con1;
	int i;
	
	double *meanA1;
	double *varA1;
	meanA1=new double[maxlook];
	varA1=new double[maxlook];
	for(i=0; i<maxlook; i++)
		varA1[i]=0;
	
	meanA1=UNMean(end1);

	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		varA1[0]=varA1[0]+(dataEnd11[i]-meanA1[0])*(dataEnd11[i]-meanA1[0]);
	varA1[0]=varA1[0]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		varA1[1]=varA1[1]+(dataEnd12[i]-meanA1[1])*(dataEnd12[i]-meanA1[1]);
	varA1[1]=varA1[1]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		varA1[2]=varA1[2]+(dataEnd13[i]-meanA1[2])*(dataEnd13[i]-meanA1[2]);
	varA1[2]=varA1[2]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		varA1[3]=varA1[3]+(dataEnd14[i]-meanA1[3])*(dataEnd14[i]-meanA1[3]);
	varA1[3]=varA1[3]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		varA1[4]=varA1[4]+(dataEnd15[i]-meanA1[4])*(dataEnd15[i]-meanA1[4]);
	varA1[4]=varA1[4]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		varA1[5]=varA1[5]+(dataEnd16[i]-meanA1[5])*(dataEnd16[i]-meanA1[5]);
	varA1[5]=varA1[5]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		varA1[6]=varA1[6]+(dataEnd17[i]-meanA1[6])*(dataEnd17[i]-meanA1[6]);
	varA1[6]=varA1[6]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		varA1[7]=varA1[7]+(dataEnd18[i]-meanA1[7])*(dataEnd18[i]-meanA1[7]);
	varA1[7]=varA1[7]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		varA1[8]=varA1[8]+(dataEnd19[i]-meanA1[8])*(dataEnd19[i]-meanA1[8]);
	varA1[8]=varA1[8]/(end1->sample_size1+end1->sample_size2);
	for(i=0; i<end1->sample_size1+end1->sample_size2; i++)
		varA1[9]=varA1[9]+(dataEnd10[i]-meanA1[9])*(dataEnd10[i]-meanA1[9]);
	varA1[9]=varA1[9]/(end1->sample_size1+end1->sample_size2);

	// Now check the variance:
	end1->var = varA1;
	return varA1;

}


double *UNCov(TrialEndNormal *end1)
{
	int maxlook=LIMIT_N_LOOK;
	int samplesize=end1->sample_size1+end1->sample_size2;
	int i,j, k;
	
//	int con1;
	double *meanA1;
	double *varA1;
	double *covA1;
//	double *structure;
	meanA1=new double[maxlook];
	varA1=new double[maxlook];
	covA1=new double[maxlook*maxlook];

	meanA1=UNMean(end1);
	varA1=UNVar(end1);

	for(i=0; i<maxlook*maxlook; i++){
		covA1[i]=0;
	}

	double * data;
	data=new double[maxlook*(end1->sample_size1+end1->sample_size2)];

	for(i=0; i<samplesize; i++){
		data[i*maxlook+0]=dataEnd11[i];
		data[i*maxlook+1]=dataEnd12[i];
		data[i*maxlook+2]=dataEnd13[i];
		data[i*maxlook+3]=dataEnd14[i];
		data[i*maxlook+4]=dataEnd15[i];
		data[i*maxlook+5]=dataEnd16[i];
		data[i*maxlook+6]=dataEnd17[i];
		data[i*maxlook+7]=dataEnd18[i];
		data[i*maxlook+8]=dataEnd19[i];
		data[i*maxlook+9]=dataEnd10[i];
	}

	for(i=0; i<maxlook; i++){
		for(j=0; j<maxlook; j++){
			covA1[i*maxlook+j]=0;
			for(k=0; k<(end1->sample_size1+end1->sample_size2); k++){
				covA1[i*maxlook+j]=covA1[i*maxlook+j]+(data[k*maxlook+i]-meanA1[i])*(data[k*maxlook+j]-meanA1[j]);
			}
			covA1[i*maxlook+j]=covA1[i*maxlook+j]/(end1->sample_size1+end1->sample_size2);
		}
	}

	end1->coVar = covA1;
	return covA1;endl;
	for(i=0; i<end1->num_look; i++){
		for(j=0; j<end1->num_look; j++) {
			cout<<covA1[i*maxlook+j]<<"\t";
		}
	}
}



//
// the new version of mean, var and cov estimate.
// taking into account the treat and control group
double *UNMeanNew(TrialEndNormal *end1)
{
	int con1;
	int i, j;
	double *mean;
	mean=new double[2*end1->look_order];

	int lookorder=end1->look_order;
	int maxlook=LIMIT_N_LOOK;

	int *size;
	size=new int[maxlook*2];
	size=UNSize1();
	
	double *work;
	work=new double[maxlook*(end1->sample_size1+end1->sample_size2)];
	for(i=0; i< (end1->sample_size1+end1->sample_size2); i++){
		work[i*maxlook+0]=dataEnd11[i];
		work[i*maxlook+1]=dataEnd12[i];
		work[i*maxlook+2]=dataEnd13[i];
		work[i*maxlook+3]=dataEnd14[i];
		work[i*maxlook+4]=dataEnd15[i];
		work[i*maxlook+5]=dataEnd16[i];
		work[i*maxlook+6]=dataEnd17[i];
		work[i*maxlook+7]=dataEnd18[i];
		work[i*maxlook+8]=dataEnd19[i];
		work[i*maxlook+9]=dataEnd10[i];
	}
	
	for(i=0; i<2*lookorder; i++){
		mean[i]=0;
	}

	for(i=0; i<lookorder; i++){
		for(j=0; j<size[i]; j++){
			mean[i]=mean[i]+work[j*maxlook+i];
		}
		mean[i]=mean[i]/size[i];
		for(j=end1->sample_size1; j<(end1->sample_size1+size[maxlook+i]); j++){
			mean[i+lookorder]=mean[i+lookorder]+work[j*maxlook+i];
		}
		mean[i+lookorder]=mean[i+lookorder]/size[i+maxlook];
	}

	//checked and correct

	return mean;
}

double *UNVarNew(TrialEndNormal *end1)
{
	int con1;
	int i, j, k;

	double *var;
	var=new double[end1->look_order];
	
	int maxlook=LIMIT_N_LOOK;
	int lookorder=end1->look_order;
	int *size;
	size=new int[2*maxlook];
	size=UNSize1();
	double *mean;
	mean=new double[2*lookorder];
	mean=UNMeanNew(NormalEnd1);

	for(i=0; i<lookorder; i++)
		var[i]=0;

	double *work;
	work=new double[maxlook*(end1->sample_size1+end1->sample_size2)];
	for(i=0; i< (end1->sample_size1+end1->sample_size2); i++){
		work[i*maxlook+0]=dataEnd11[i];
		work[i*maxlook+1]=dataEnd12[i];
		work[i*maxlook+2]=dataEnd13[i];
		work[i*maxlook+3]=dataEnd14[i];
		work[i*maxlook+4]=dataEnd15[i];
		work[i*maxlook+5]=dataEnd16[i];
		work[i*maxlook+6]=dataEnd17[i];
		work[i*maxlook+7]=dataEnd18[i];
		work[i*maxlook+8]=dataEnd19[i];
		work[i*maxlook+9]=dataEnd10[i];
	}

	// substract mean
	for(j=0; j<lookorder; j++){
		for(i=0; i<size[j]; i++){
			work[i*maxlook+j]=work[i*maxlook+j]-mean[j];	//control
		}
		for(i=end1->sample_size1; i<size[j+maxlook]; i++){
			work[i*maxlook+j]=work[i*maxlook+j]-mean[j+lookorder];	//treat
		}
	}

	//calculation of var:
	int tempsize;
	for(j=0; j<lookorder; j++){
		for(i=0; i<size[j]; i++){
			var[j]=var[j]+work[i*maxlook+j]*work[i*maxlook+j];
		}
		for(i=end1->sample_size1; i<(size[j+maxlook]+end1->sample_size1); i++){
			var[j]=var[j]+work[i*maxlook+j]*work[i*maxlook+j];
		}
		var[j]=var[j]/(size[j]+size[j+maxlook]);
	}

	//checked and correct
	return var;
}


double *UNCovNew(TrialEndNormal *end1)
{
	int con1;
	
	double *cov;
	cov=new double[end1->look_order*end1->look_order];
	
	int i, j, k;
	int maxlook=LIMIT_N_LOOK;
	int lookorder=end1->look_order;

	int *size;
	size=new int[maxlook*2];
	size=UNSize1();
	double *mean;
	mean=new double[2*lookorder];
	mean=UNMeanNew(NormalEnd1);

	double *work;
	work=new double[maxlook*(end1->sample_size1+end1->sample_size2)];
	for(i=0; i< (end1->sample_size1+end1->sample_size2); i++){
		work[i*maxlook+0]=dataEnd11[i];
		work[i*maxlook+1]=dataEnd12[i];
		work[i*maxlook+2]=dataEnd13[i];
		work[i*maxlook+3]=dataEnd14[i];
		work[i*maxlook+4]=dataEnd15[i];
		work[i*maxlook+5]=dataEnd16[i];
		work[i*maxlook+6]=dataEnd17[i];
		work[i*maxlook+7]=dataEnd18[i];
		work[i*maxlook+8]=dataEnd19[i];
		work[i*maxlook+9]=dataEnd10[i];
	}

	// substract mean
	for(j=0; j<lookorder; j++){
		for(i=0; i<size[j]; i++){
			work[i*maxlook+j]=work[i*maxlook+j]-mean[j];	//control
		}
		for(i=end1->sample_size1; i<size[j+maxlook]; i++){
			work[i*maxlook+j]=work[i*maxlook+j]-mean[j+lookorder];	//treat
		}
	}
	
	int sizetemp1, sizetemp2;
	for(i=0; i<lookorder*lookorder; i++)
		cov[i]=0;
	for(i=0; i<lookorder; i++){
		for(j=0; j<lookorder; j++){
			
			//control
			if(size[i]<size[j])
				sizetemp1=size[i];
			else sizetemp1=size[j];
			//treat
			if(size[i+maxlook]<size[j+maxlook])
				sizetemp2=size[i+maxlook];
			else sizetemp2=size[j+maxlook];
	
			for(k=0; k<sizetemp1; k++){
				cov[i*lookorder+j]=cov[i*lookorder+j]+work[k*maxlook+i]*work[k*maxlook+j];
			}
			for(k=end1->sample_size1; k<(end1->sample_size1+sizetemp2); k++){
				cov[i*lookorder+j]=cov[i*lookorder+j]+work[k*maxlook+i]*work[k*maxlook+j];
			}
			cov[i*lookorder+j]=cov[i*lookorder+j]/(sizetemp1+sizetemp2);
		}
	}

	// checked and return reasonable square root matrix
	return cov;
}









// Structure estimate for one normal case:
double * UNParameterEstimate()
{	// length:NormalEnd1->sample_size
	int maxlook=LIMIT_N_LOOK;
	
	int con1;
	double *meanA1;
	double *varA1;
	double *covA1;
	double *structure;
	meanA1=new double[maxlook];
	varA1=new double[maxlook];
	covA1=new double[maxlook*maxlook];
	structure=new double[2*maxlook+maxlook*maxlook];

	int i, j;
	for(i=0; i<maxlook; i++){
		meanA1[i]=0;
		varA1[i]=0;
	}
	for(i=0; i<maxlook*maxlook; i++)
		covA1[i]=0;

	cout<<"here"<<endl;
	//Estimate mean:
	

////////////////////////////////////////////////////////////////////////////////
	// check the mean structure:
	for(i=0; i<NormalEnd1->sample_size1+NormalEnd1->sample_size2; i++)
		meanA1[0]=meanA1[0]+dataEnd11[i];
	meanA1[0]=meanA1[0]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<NormalEnd1->sample_size1+NormalEnd1->sample_size2; i++)
		meanA1[1]=meanA1[1]+dataEnd12[i];
	meanA1[1]=meanA1[1]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<NormalEnd1->sample_size1+NormalEnd1->sample_size2; i++)
		meanA1[2]=meanA1[2]+dataEnd13[i];
	meanA1[2]=meanA1[2]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<NormalEnd1->sample_size1+NormalEnd1->sample_size2; i++)
		meanA1[3]=meanA1[3]+dataEnd14[i];
	meanA1[3]=meanA1[3]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<NormalEnd1->sample_size1+NormalEnd1->sample_size2; i++)
		meanA1[4]=meanA1[4]+dataEnd15[i];
	meanA1[4]=meanA1[4]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<NormalEnd1->sample_size1+NormalEnd1->sample_size2; i++)
		meanA1[5]=meanA1[5]+dataEnd16[i];
	meanA1[5]=meanA1[5]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<NormalEnd1->sample_size1+NormalEnd1->sample_size2; i++)
		meanA1[6]=meanA1[6]+dataEnd17[i];
	meanA1[6]=meanA1[6]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<NormalEnd1->sample_size1+NormalEnd1->sample_size2; i++)
		meanA1[7]=meanA1[7]+dataEnd18[i];
	meanA1[7]=meanA1[7]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<NormalEnd1->sample_size1+NormalEnd1->sample_size2; i++)
		meanA1[8]=meanA1[8]+dataEnd19[i];
	meanA1[8]=meanA1[8]/(NormalEnd1->sample_size+NormalEnd1->sample_size2);
	for(i=0; i<NormalEnd1->sample_size1+NormalEnd1->sample_size2; i++)
		meanA1[9]=meanA1[9]+dataEnd10[i];
	meanA1[9]=meanA1[9]/(NormalEnd1->sample_size+NormalEnd1->sample_size2);


	cout<<"check of the mean"<<endl;
	for(i=0; i<maxlook; i++)
		cout<<meanA1[i]<<"\t";
	
	//Estimate var:
	for(i=0; i<NormalEnd1->sample_size+NormalEnd1->sample_size2; i++)
		varA1[0]=varA1[0]+(dataEnd11[i]-meanA1[0])*(dataEnd11[i]-meanA1[0]);
	varA1[0]=varA1[0]/(NormalEnd1->sample_size+NormalEnd1->sample_size2);
	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		varA1[1]=varA1[1]+(dataEnd12[i]-meanA1[1])*(dataEnd12[i]-meanA1[1]);
	varA1[1]=varA1[1]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		varA1[2]=varA1[2]+(dataEnd13[i]-meanA1[2])*(dataEnd13[i]-meanA1[2]);
	varA1[2]=varA1[2]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		varA1[3]=varA1[3]+(dataEnd14[i]-meanA1[3])*(dataEnd14[i]-meanA1[3]);
	varA1[3]=varA1[3]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		varA1[4]=varA1[4]+(dataEnd15[i]-meanA1[4])*(dataEnd15[i]-meanA1[4]);
	varA1[4]=varA1[4]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		varA1[5]=varA1[5]+(dataEnd16[i]-meanA1[5])*(dataEnd16[i]-meanA1[5]);
	varA1[5]=varA1[5]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		varA1[6]=varA1[6]+(dataEnd17[i]-meanA1[6])*(dataEnd17[i]-meanA1[6]);
	varA1[6]=varA1[6]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		varA1[7]=varA1[7]+(dataEnd18[i]-meanA1[7])*(dataEnd18[i]-meanA1[7]);
	varA1[7]=varA1[7]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		varA1[8]=varA1[8]+(dataEnd19[i]-meanA1[8])*(dataEnd19[i]-meanA1[8]);
	varA1[8]=varA1[8]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		varA1[9]=varA1[9]+(dataEnd10[i]-meanA1[9])*(dataEnd10[i]-meanA1[9]);
	varA1[9]=varA1[9]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);


	// Now check the variance:
	cout<<"check of the var:"<<endl;
	for(i=0; i<maxlook; i++)
		cout<<varA1[i]<<"\t";

	// Estimate the covariance structure:
	for(i=0; i<maxlook*maxlook; i++){
		covA1[i]=0;
	}
	
	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[0*maxlook+0]=covA1[0*maxlook+0]+(dataEnd11[i]-meanA1[0])*(dataEnd11[i]-meanA1[0]);
	covA1[0*maxlook+0]=covA1[0*maxlook+0]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[0*maxlook+1]=covA1[0*maxlook+1]+(dataEnd11[i]-meanA1[0])*(dataEnd12[i]-meanA1[1]);
	covA1[0*maxlook+1]=covA1[0*maxlook+1]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	
	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[0*maxlook+2]=covA1[0*maxlook+2]+(dataEnd11[i]-meanA1[0])*(dataEnd13[i]-meanA1[2]);
	covA1[0*maxlook+2]=covA1[0*maxlook+2]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[0*maxlook+3]=covA1[0*maxlook+3]+(dataEnd11[i]-meanA1[0])*(dataEnd14[i]-meanA1[3]);
	covA1[0*maxlook+3]=covA1[0*maxlook+3]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[0*maxlook+4]=covA1[0*maxlook+4]+(dataEnd11[i]-meanA1[0])*(dataEnd15[i]-meanA1[4]);
	covA1[0*maxlook+4]=covA1[0*maxlook+4]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[0*maxlook+5]=covA1[0*maxlook+5]+(dataEnd11[i]-meanA1[0])*(dataEnd16[i]-meanA1[5]);
	covA1[0*maxlook+5]=covA1[0*maxlook+5]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[0*maxlook+6]=covA1[0*maxlook+6]+(dataEnd11[i]-meanA1[0])*(dataEnd17[i]-meanA1[6]);
	covA1[0*maxlook+6]=covA1[0*maxlook+6]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[0*maxlook+7]=covA1[0*maxlook+7]+(dataEnd11[i]-meanA1[0])*(dataEnd18[i]-meanA1[7]);
	covA1[0*maxlook+7]=covA1[0*maxlook+7]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[0*maxlook+8]=covA1[0*maxlook+8]+(dataEnd11[i]-meanA1[0])*(dataEnd19[i]-meanA1[8]);
	covA1[0*maxlook+8]=covA1[0*maxlook+8]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[0*maxlook+9]=covA1[0*maxlook+9]+(dataEnd11[i]-meanA1[0])*(dataEnd10[i]-meanA1[9]);
	covA1[0*maxlook+9]=covA1[0*maxlook+9]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
		// initialize the first line finished.

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[1*maxlook+1]=covA1[1*maxlook+1]+(dataEnd12[i]-meanA1[1])*(dataEnd12[i]-meanA1[1]);
	covA1[1*maxlook+1]=covA1[1*maxlook+1]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	
	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[1*maxlook+2]=covA1[1*maxlook+2]+(dataEnd12[i]-meanA1[1])*(dataEnd13[i]-meanA1[2]);
	covA1[1*maxlook+2]=covA1[1*maxlook+2]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[1*maxlook+3]=covA1[1*maxlook+3]+(dataEnd12[i]-meanA1[1])*(dataEnd14[i]-meanA1[3]);
	covA1[1*maxlook+3]=covA1[1*maxlook+3]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[1*maxlook+4]=covA1[1*maxlook+4]+(dataEnd12[i]-meanA1[1])*(dataEnd15[i]-meanA1[4]);
	covA1[1*maxlook+4]=covA1[1*maxlook+4]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[1*maxlook+5]=covA1[1*maxlook+5]+(dataEnd12[i]-meanA1[1])*(dataEnd16[i]-meanA1[5]);
	covA1[1*maxlook+5]=covA1[1*maxlook+5]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[1*maxlook+6]=covA1[1*maxlook+6]+(dataEnd12[i]-meanA1[1])*(dataEnd17[i]-meanA1[6]);
	covA1[1*maxlook+6]=covA1[1*maxlook+6]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[1*maxlook+7]=covA1[1*maxlook+7]+(dataEnd12[i]-meanA1[1])*(dataEnd18[i]-meanA1[7]);
	covA1[1*maxlook+7]=covA1[1*maxlook+7]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[1*maxlook+8]=covA1[1*maxlook+8]+(dataEnd12[i]-meanA1[1])*(dataEnd19[i]-meanA1[8]);
	covA1[1*maxlook+8]=covA1[1*maxlook+8]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[1*maxlook+9]=covA1[1*maxlook+9]+(dataEnd12[i]-meanA1[1])*(dataEnd10[i]-meanA1[9]);
	covA1[1*maxlook+9]=covA1[1*maxlook+9]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	//initialize the second line finished.

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[2*maxlook+2]=covA1[2*maxlook+2]+(dataEnd13[i]-meanA1[2])*(dataEnd13[i]-meanA1[2]);
	covA1[2*maxlook+2]=covA1[2*maxlook+2]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[2*maxlook+3]=covA1[2*maxlook+3]+(dataEnd13[i]-meanA1[2])*(dataEnd14[i]-meanA1[3]);
	covA1[2*maxlook+3]=covA1[2*maxlook+3]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[2*maxlook+4]=covA1[2*maxlook+4]+(dataEnd13[i]-meanA1[2])*(dataEnd15[i]-meanA1[4]);
	covA1[2*maxlook+4]=covA1[2*maxlook+4]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[2*maxlook+5]=covA1[2*maxlook+5]+(dataEnd13[i]-meanA1[2])*(dataEnd16[i]-meanA1[5]);
	covA1[2*maxlook+5]=covA1[2*maxlook+5]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[2*maxlook+6]=covA1[2*maxlook+6]+(dataEnd13[i]-meanA1[2])*(dataEnd17[i]-meanA1[6]);
	covA1[2*maxlook+6]=covA1[2*maxlook+6]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[2*maxlook+7]=covA1[2*maxlook+7]+(dataEnd13[i]-meanA1[2])*(dataEnd18[i]-meanA1[7]);
	covA1[2*maxlook+7]=covA1[2*maxlook+7]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[2*maxlook+8]=covA1[2*maxlook+8]+(dataEnd13[i]-meanA1[2])*(dataEnd19[i]-meanA1[8]);
	covA1[2*maxlook+8]=covA1[2*maxlook+8]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[2*maxlook+9]=covA1[2*maxlook+9]+(dataEnd13[i]-meanA1[2])*(dataEnd10[i]-meanA1[9]);
	covA1[2*maxlook+9]=covA1[2*maxlook+9]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	//Initialize the 3rd line finished.

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[3*maxlook+3]=covA1[3*maxlook+3]+(dataEnd14[i]-meanA1[3])*(dataEnd14[i]-meanA1[3]);
	covA1[3*maxlook+3]=covA1[3*maxlook+3]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[3*maxlook+4]=covA1[3*maxlook+4]+(dataEnd14[i]-meanA1[3])*(dataEnd15[i]-meanA1[4]);
	covA1[3*maxlook+4]=covA1[3*maxlook+4]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[3*maxlook+5]=covA1[3*maxlook+5]+(dataEnd14[i]-meanA1[3])*(dataEnd16[i]-meanA1[5]);
	covA1[3*maxlook+5]=covA1[3*maxlook+5]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[3*maxlook+6]=covA1[3*maxlook+6]+(dataEnd14[i]-meanA1[3])*(dataEnd17[i]-meanA1[6]);
	covA1[3*maxlook+6]=covA1[3*maxlook+6]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[3*maxlook+7]=covA1[3*maxlook+7]+(dataEnd14[i]-meanA1[3])*(dataEnd18[i]-meanA1[7]);
	covA1[3*maxlook+7]=covA1[3*maxlook+7]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[3*maxlook+8]=covA1[3*maxlook+8]+(dataEnd14[i]-meanA1[3])*(dataEnd19[i]-meanA1[8]);
	covA1[3*maxlook+8]=covA1[3*maxlook+8]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[3*maxlook+9]=covA1[3*maxlook+9]+(dataEnd14[i]-meanA1[3])*(dataEnd10[i]-meanA1[9]);
	covA1[3*maxlook+9]=covA1[3*maxlook+9]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	//Initialize the 4th line finished.

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[4*maxlook+4]=covA1[4*maxlook+4]+(dataEnd15[i]-meanA1[4])*(dataEnd15[i]-meanA1[4]);
	covA1[4*maxlook+4]=covA1[4*maxlook+4]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[4*maxlook+5]=covA1[4*maxlook+5]+(dataEnd15[i]-meanA1[4])*(dataEnd16[i]-meanA1[5]);
	covA1[4*maxlook+5]=covA1[4*maxlook+5]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[4*maxlook+6]=covA1[4*maxlook+6]+(dataEnd15[i]-meanA1[4])*(dataEnd17[i]-meanA1[6]);
	covA1[4*maxlook+6]=covA1[4*maxlook+6]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[4*maxlook+7]=covA1[4*maxlook+7]+(dataEnd15[i]-meanA1[4])*(dataEnd18[i]-meanA1[7]);
	covA1[4*maxlook+7]=covA1[4*maxlook+7]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[4*maxlook+8]=covA1[4*maxlook+8]+(dataEnd15[i]-meanA1[4])*(dataEnd19[i]-meanA1[8]);
	covA1[4*maxlook+8]=covA1[4*maxlook+8]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[4*maxlook+9]=covA1[4*maxlook+9]+(dataEnd15[i]-meanA1[4])*(dataEnd10[i]-meanA1[9]);
	covA1[4*maxlook+9]=covA1[4*maxlook+9]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	// initialize the 5th line finished.

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[5*maxlook+5]=covA1[5*maxlook+5]+(dataEnd16[i]-meanA1[5])*(dataEnd16[i]-meanA1[5]);
	covA1[5*maxlook+5]=covA1[5*maxlook+5]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[5*maxlook+6]=covA1[5*maxlook+6]+(dataEnd16[i]-meanA1[5])*(dataEnd17[i]-meanA1[6]);
	covA1[5*maxlook+6]=covA1[5*maxlook+6]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[5*maxlook+7]=covA1[5*maxlook+7]+(dataEnd16[i]-meanA1[5])*(dataEnd18[i]-meanA1[7]);
	covA1[5*maxlook+7]=covA1[5*maxlook+7]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[5*maxlook+8]=covA1[5*maxlook+8]+(dataEnd16[i]-meanA1[5])*(dataEnd19[i]-meanA1[8]);
	covA1[5*maxlook+8]=covA1[5*maxlook+8]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[5*maxlook+9]=covA1[5*maxlook+9]+(dataEnd16[i]-meanA1[5])*(dataEnd10[i]-meanA1[9]);
	covA1[5*maxlook+9]=covA1[5*maxlook+9]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	// initialize the 6th line finished.

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[6*maxlook+6]=covA1[6*maxlook+6]+(dataEnd17[i]-meanA1[6])*(dataEnd17[i]-meanA1[6]);
	covA1[6*maxlook+6]=covA1[6*maxlook+6]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[6*maxlook+7]=covA1[6*maxlook+7]+(dataEnd17[i]-meanA1[6])*(dataEnd18[i]-meanA1[7]);
	covA1[6*maxlook+7]=covA1[6*maxlook+7]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[6*maxlook+8]=covA1[6*maxlook+8]+(dataEnd17[i]-meanA1[6])*(dataEnd19[i]-meanA1[8]);
	covA1[6*maxlook+8]=covA1[6*maxlook+8]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[6*maxlook+9]=covA1[6*maxlook+9]+(dataEnd17[i]-meanA1[6])*(dataEnd10[i]-meanA1[9]);
	covA1[6*maxlook+9]=covA1[6*maxlook+9]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	//initialize the 7th line finished:

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[7*maxlook+7]=covA1[7*maxlook+7]+(dataEnd18[i]-meanA1[7])*(dataEnd18[i]-meanA1[7]);
	covA1[7*maxlook+7]=covA1[7*maxlook+7]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[7*maxlook+8]=covA1[7*maxlook+8]+(dataEnd18[i]-meanA1[7])*(dataEnd19[i]-meanA1[8]);
	covA1[7*maxlook+8]=covA1[7*maxlook+8]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[7*maxlook+9]=covA1[7*maxlook+9]+(dataEnd18[i]-meanA1[7])*(dataEnd10[i]-meanA1[9]);
	covA1[7*maxlook+9]=covA1[7*maxlook+9]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	// initialize the 8th line finished.

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[8*maxlook+8]=covA1[8*maxlook+8]+(dataEnd19[i]-meanA1[8])*(dataEnd19[i]-meanA1[8]);
	covA1[8*maxlook+8]=covA1[8*maxlook+8]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[8*maxlook+9]=covA1[8*maxlook+9]+(dataEnd19[i]-meanA1[8])*(dataEnd10[i]-meanA1[9]);
	covA1[8*maxlook+9]=covA1[8*maxlook+9]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	//initialzie the 9th line finished.

	for(i=0; i<(NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++)
		covA1[9*maxlook+9]=covA1[9*maxlook+9]+(dataEnd10[i]-meanA1[9])*(dataEnd10[i]-meanA1[9]);
	covA1[9*maxlook+9]=covA1[9*maxlook+9]/(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	// initialize the 10th line finished.

	// now we initialize the corresponding components:
	for(i=0; i<maxlook; i++){
		for(j=0; j<i; j++){
			covA1[i*maxlook+j]=covA1[j*maxlook+i];
		}
	}

	// Initialize structure:
	for(i=0; i<maxlook; i++){
		structure[i]=meanA1[i];
		structure[maxlook+i]=varA1[i];
	}
	for(i=0; i<maxlook*maxlook; i++)
		structure[i+2*maxlook]=covA1[i];

	for(i=0; i<(2+maxlook); i++){
		for(j=0; j<maxlook; j++){
			cout<<structure[i*maxlook+j]<<"\t";
		}
		cout<<endl;
	}
	return structure;

}


//
//	Simulate according to previous structure:
//

double *UNNormalSimul(int currentlook,int length, double *meanA, double *varA, double *covA)
{
	double *workarray;
	workarray=new double[currentlook*length];

	double *v3sq;
	double *transv3sq;
	double *transpose;

	v3sq=new double[currentlook*currentlook];
	transv3sq=new double[currentlook*currentlook];
	transpose=new double[currentlook*length];

	int i, j, k;
	
	workarray=Stand_Normal(currentlook*length);
	v3sq=sqrt_matrix(currentlook, covA);
	
	// check of v3sq:

	for(i=0; i<currentlook; i++){
		for(j=0; j<currentlook; j++){
			transv3sq[i*currentlook+j]=v3sq[i+currentlook*j];
		}
	}

	// check the transv3sq
	for(i=0; i<currentlook*length; i++)
		transpose[i]=0;
	

	for(i=0; i<currentlook; i++){
		for(j=0; j<length; j++){
			for(k=0; k<currentlook; k++){
				transpose[i*length+j]=transpose[i*length+j]+transv3sq[i*currentlook+k]*workarray[k*length+j];
			}
		}
	}

	for(i=0; i<length; i++){
		for(j=0; j<currentlook; j++){
			workarray[i*currentlook+j]=transpose[i+j*length];
		}
	}

	// add the mean structure of the workarray:
	for(i=0; i<length; i++){
		for(j=0; j<currentlook; j++){
			workarray[i*currentlook+j]=workarray[i*currentlook+j]+meanA[j];
		}
	}

	return workarray;

}


//
//	The boundary calculation:
//

double *UNBound(int currentlook, double *workNullA, double *workAlterA, TrialEndNormal *end1)
{
	int decisionsign=0;
	
	int i, j, k, l, m, p, q, r, s;
	int con1;
	double *boundaryA;
	double *upperboundA;
	double *lowerboundA;

	boundaryA=new double[2*currentlook];
	upperboundA=new double[currentlook];
	lowerboundA=new double[currentlook];
 
	int *countAfterNull; // the number of samples left after each look.
	int *countAfterAlter;
	countAfterNull=new int[end1->num_look];
	countAfterAlter=new int[end1->num_look];
	countAfterNull[0]=end1->looksimul;
	countAfterAlter[0]=end1->looksimul;


	double *alpha3, *beta3;
	double *alpha4, *beta4;
	alpha3=new double[end1->num_look];
	beta3=new double[end1->num_look];
	alpha4=new double[end1->num_look];
	beta4=new double[end1->num_look];
//	cout<<"Start of UNBound"<<endl;

	// in case the end has already had detail spending information:
	for(i=0; i<end1->num_look; i++){
		alpha3[i]=end1->alpha[i];
		beta3[i]=end1->beta[i];
	}

	for(i=0; i<end1->num_look; i++)
		end1->inform_time[i]=end1->inform_time[i]/end1->inform_time[end1->num_look-1];

	if(end1->spending_number==1){
		alpha3=alpha_beta1(end1->overall_alpha, end1->inform_time, end1->num_look);
		beta3=alpha_beta1(end1->overall_beta, end1->inform_time, end1->num_look);
	}
	if(end1->spending_number==2){
		alpha3=alpha_beta2(end1->overall_alpha, end1->inform_time, end1->num_look);
		beta3=alpha_beta2(end1->overall_beta,end1->inform_time, end1->num_look);
	}  
	if(end1->spending_number==3){
		alpha3=alpha_beta3(end1->overall_alpha, end1->inform_time, end1->num_look);
		beta3=alpha_beta3(end1->overall_beta, end1->inform_time, end1->num_look);
	}  


	// The caulcation of critical Boundaries:	

	double *currentNull, *currentAlter;
	double *absNull, *absAlter; 
	currentNull=new double[end1->looksimul];
	currentAlter=new double[end1->looksimul];
	absNull=new double[currentlook*end1->looksimul];
	absAlter=new double[currentlook*end1->looksimul];


	int li, lj, lk, lm, ln, lo;

	double *countNull, *countAlter;
	countNull=new double[end1->num_look];
	countAlter=new double[end1->num_look];

	for(li=0; li<end1->num_look; li++){
		countNull[li]=0;
		countAlter[li]=0;
	}

	int signNull=0, signAlter=0;
	int positionNull=0, positionAlter=0;

	for(li=0; li<currentlook*end1->looksimul; li++){
		absNull[li]=absd(workNullA[li]);
		absAlter[li]=absd(workAlterA[li]);
	}

	for(li=0; li<end1->num_look; li++){
		countNull[li]=0;
		countAlter[li]=0;
	}

	for(ln=0; ln<end1->num_look; ln++) {
		alpha4[ln]=alpha3[ln];
		beta4[ln]=beta3[ln];
	}

//	cout<<"here 1"<<endl;
	//
	// Now get the Boundary for the First Look First:
	
	for(li=0; li<end1->looksimul; li++){
		currentNull[li]=absNull[li*currentlook+0];
		currentAlter[li]=absAlter[li*currentlook+0];
	}

//	cout<<"here 1.5 \t"<<end1->looksimul;
	for(i=0; i<end1->num_look;i++){
		cout<<currentNull[i]<<"\t"<<currentAlter[i]<<endl;
	}

	upperboundA[0]=Sample_Quan(end1->looksimul, currentNull, 1-alpha3[0]);
	lowerboundA[0]=Sample_Quan(end1->looksimul, currentAlter, beta3[0]);
	
//	cout<<"here 2"<<endl;

	for(li=0; li<end1->looksimul; li++) {
		if( (currentNull[li] < upperboundA[0]) && (currentNull[li] > lowerboundA[0]) )
			countNull[0]=countNull[0]+1;
		if( (currentAlter[li] < upperboundA[0]) && (currentAlter[li] > lowerboundA[0]) )
			countAlter[0]=countAlter[0]+1;
	}

	if( upperboundA[0] < lowerboundA[0]) {
		lowerboundA[0]=upperboundA[0];
		decisionsign=1;
	}

	// The critical Bound for the rest looks:
	for(lj=1; lj<currentlook; lj++) {
		
		positionNull=0;
		positionAlter=0;
		//first get currentNull and currentAlter
		for(lk=0; lk<end1->looksimul; lk++) {
			signNull=0;
			signAlter=0;
			for(lm=0; lm<lj; lm++) {
				if( (absNull[lk*currentlook+lm] > upperboundA[lm] ) || ( absNull[lk*currentlook+lm] <lowerboundA[lm]) )
					signNull=1;
				if( (absAlter[lk*currentlook+lm] > upperboundA[lm] ) || ( absAlter[lk*currentlook+lm] <lowerboundA[lm]) )
					signAlter=1;
			}

			if(signNull==0) {
				currentNull[positionNull]=absNull[lk*currentlook+lj];
				positionNull=positionNull+1;
			}	

			if(signAlter==0) {
				currentAlter[positionAlter]=absAlter[lk*currentlook+lj];
				positionAlter=positionAlter+1;
			}	
			
		}
			
		
		// we can get boundary now???

		alpha4[lj]=alpha3[lj]*end1->looksimul/countNull[lj-1];
		beta4[lj]=beta3[lj]*end1->looksimul/countAlter[lj-1];
		upperboundA[lj]=Sample_Quan( positionNull, currentNull, 1-alpha4[lj]);
		if( upperboundA[lj] > upperboundA[lj-1] )
			upperboundA[lj]=upperboundA[lj-1];
		lowerboundA[lj]=Sample_Quan( positionAlter, currentAlter, beta4[lj]);
//		cout<<"lowerbound"<<"\t"<<lowerboundA[lj]<<"\t"<<"upperbound"<<"\t"<<upperboundA[lj]<<endl;

		if(upperboundA[lj] < lowerboundA[lj]) {
			lowerboundA[lj]=upperboundA[lj];
			decisionsign=1;
		}

		//now we count: after the current bound, how many left:
		for(lk=0; lk<end1->looksimul; lk++) {
			signNull=0;
			signAlter=0;
			for(lm=0; lm<=lj; lm++) {
				if( (absNull[lk*currentlook+lm] > upperboundA[lm] ) || ( absNull[lk*currentlook+lm] <lowerboundA[lm]) )
					signNull=1;
				if( (absAlter[lk*currentlook+lm] > upperboundA[lm] ) || ( absAlter[lk*currentlook+lm] <lowerboundA[lm]) )
					signAlter=1;
			}

			if(signNull==0) countNull[lj]=countNull[lj]+1;
			if(signAlter==0) countAlter[lj]=countAlter[lj]+1;
		}

//		cout<<"countNull"<<"\t"<<countNull[lj]<<"\t"<<"countAlter"<<"\t"<<countAlter[lj]<<endl;
	}

	for(li=0; li<currentlook; li++){
		boundaryA[li*2]=lowerboundA[li];
		boundaryA[li*2+1]=upperboundA[li];
	}

//	cout<<"Ready to finish boundary calculation"<<endl;
	return boundaryA;
}






//
//	The new version of normal decision
//
//the program used to find the sample size for each look
int *UNSize1()
{
	int con1;
	int i, j, k;
	int *size1;
	size1=new int[2*LIMIT_N_LOOK];
	
	int samplesize1=NormalEnd1->sample_size1;
	int samplesize2=NormalEnd1->sample_size2;

	for(i=0; i<2*LIMIT_N_LOOK; i++)
		size1[i]=0;

	i=0;
	while( (dataEnd11[i]!=-9999) && (i<samplesize1) ){
		size1[0]=size1[0]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd11[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[0+LIMIT_N_LOOK]=size1[0+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd12[i]!=-9999) && (i<samplesize1) ){
		size1[1]=size1[1]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd12[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[1+LIMIT_N_LOOK]=size1[1+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd13[i]!=-9999) && (i<samplesize1) ){
		size1[2]=size1[2]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd13[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[2+LIMIT_N_LOOK]=size1[2+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd14[i]!=-9999) && (i<samplesize1) ){
		size1[3]=size1[3]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd14[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[3+LIMIT_N_LOOK]=size1[3+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd15[i]!=-9999) && (i<samplesize1) ){
		size1[4]=size1[4]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd15[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[4+LIMIT_N_LOOK]=size1[4+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd16[i]!=-9999) && (i<samplesize1) ){
		size1[5]=size1[5]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd16[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[5+LIMIT_N_LOOK]=size1[5+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd17[i]!=-9999) && (i<samplesize1) ){
		size1[6]=size1[6]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd18[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[7+LIMIT_N_LOOK]=size1[7+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd19[i]!=-9999) && (i<samplesize1) ){
		size1[8]=size1[8]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd19[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[8+LIMIT_N_LOOK]=size1[8+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd10[i]!=-9999) && (i<samplesize1) ){
		size1[9]=size1[9]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd10[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[9+LIMIT_N_LOOK]=size1[9+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	return size1;
}


// entry size for the second endpoint (used for TNNormalDecision)
int *UNSize2()
{
	int con1;
	int i, j, k;
	int *size1;
	size1=new int[2*LIMIT_N_LOOK];
	
	int samplesize1=NormalEnd2->sample_size1;
	int samplesize2=NormalEnd2->sample_size2;

	for(i=0; i<2*LIMIT_N_LOOK; i++)
		size1[i]=0;

	i=0;
	while( (dataEnd21[i]!=-9999) && (i<samplesize1) ){
		size1[0]=size1[0]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd21[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[0+LIMIT_N_LOOK]=size1[0+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd22[i]!=-9999) && (i<samplesize1) ){
		size1[1]=size1[1]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd22[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[1+LIMIT_N_LOOK]=size1[1+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd23[i]!=-9999) && (i<samplesize1) ){
		size1[2]=size1[2]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd23[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[2+LIMIT_N_LOOK]=size1[2+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd24[i]!=-9999) && (i<samplesize1) ){
		size1[3]=size1[3]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd24[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[3+LIMIT_N_LOOK]=size1[3+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd25[i]!=-9999) && (i<samplesize1) ){
		size1[4]=size1[4]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd25[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[4+LIMIT_N_LOOK]=size1[4+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd26[i]!=-9999) && (i<samplesize1) ){
		size1[5]=size1[5]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd26[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[5+LIMIT_N_LOOK]=size1[5+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd27[i]!=-9999) && (i<samplesize1) ){
		size1[6]=size1[6]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd28[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[7+LIMIT_N_LOOK]=size1[7+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd29[i]!=-9999) && (i<samplesize1) ){
		size1[8]=size1[8]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd29[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[8+LIMIT_N_LOOK]=size1[8+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	i=0;
	while( (dataEnd20[i]!=-9999) && (i<samplesize1) ){
		size1[9]=size1[9]+1;
		i=i+1;
	}
	i=samplesize1;
	while( (dataEnd20[i]!=-9999) && (i<(samplesize1+samplesize2)) ){
		size1[9+LIMIT_N_LOOK]=size1[9+LIMIT_N_LOOK]+1;
		i=i+1;
	}

	return size1;
}










//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


//
//	Two Normal Case:
//
void TwoNormalDecision()
{

	int con1;
	int i, j, k, l, m;
	int maxlook=LIMIT_N_LOOK;

	// Initialize seed:
	srand ((unsigned)time(NULL));
	for(i=0; i<5000; i++)
		SEEDD[i]= (double) ( rand() % 2000) / 2000.0;


	// check NormalEnd1 & NormalEnd2:
	double *meanA1, *meanA2;
	double *varA1, *varA2;
	double *covA1, *covA2;
	double *crossCov;

	int num_look=NormalEnd1->num_look;
	int lookorder=NormalEnd1->look_order;
	meanA1=new double[2*lookorder];
	meanA2=new double[2*lookorder];
	varA1=new double[lookorder];
	varA2=new double[lookorder];
	covA1=new double[lookorder*lookorder];
	covA2=new double[lookorder*lookorder];
	
	crossCov=new double[4*lookorder*lookorder];

	meanA1=UNMeanNew(NormalEnd1);
	meanA2=TNMeanNew(NormalEnd2);
	varA1=UNVarNew(NormalEnd1);
	varA2=TNVarNew(NormalEnd2);
	covA1=UNCovNew(NormalEnd1);
	covA2=TNCovNew(NormalEnd2);
	crossCov=TNCrossCovNew();
	
	// Initialize the two NormalEnd:
	TNInitialize(NormalEnd1);
	TNInitialize(NormalEnd2);


	// Get the original data structure:
	double *workvar1, *workvar2;
	double *workcov1, *workcov2;
	double *cross, *checkcross;
	workvar1=new double[num_look];
	workvar2=new double[num_look];
	workcov1=new double[num_look*num_look];
	workcov2=new double[num_look*num_look];
	cross=new double[num_look*num_look];
	checkcross=new double[num_look*num_look];
	for(i=0; i<num_look; i++){
		workvar1[i]=varA1[i];
		workvar2[i]=varA2[i];
	}
	for(i=0; i<num_look; i++){
		for(j=0; j<num_look; j++){
			workcov1[i*num_look+j]=covA1[i*maxlook+j];
			workcov2[i*num_look+j]=covA2[i*maxlook+j];
		}
	}
	for(i=0; i<num_look; i++){
		for(j=0; j<num_look; j++){
			cross[i*num_look+j]=crossCov[i*2*maxlook+maxlook+j];
			checkcross[i*num_look+j]=crossCov[(i+maxlook)*2*maxlook+j];
		}
	}

	// the check procedure of orginal data:

	int samplesize=(NormalEnd1->sample_size1+NormalEnd1->sample_size2);
	int looksimul=NormalEnd1->looksimul;
	
	// The overall cov structure:
	double *covsimul;
	covsimul=new double[2*lookorder*2*lookorder];
	for(i=0; i<lookorder; i++){
		for(j=0; j<lookorder; j++){
			covsimul[i*2*lookorder+j]=workcov1[i*num_look+j];
			covsimul[(i+lookorder)*2*lookorder+j]=checkcross[i*num_look+j];
			covsimul[i*2*lookorder+lookorder+j]=cross[i*num_look+j];
			covsimul[(i+lookorder)*2*lookorder+lookorder+j]=workcov2[i*num_look+j];
		}
	}

	// Open the necessary arrays:

	double *boundary1, *boundary2;
	double *upperbound1, *lowerbound1;
	double *upperbound2, *lowerbound2;
	boundary1=new double[2*num_look];
	boundary2=new double[2*num_look];
	upperbound1=new double[num_look];
	lowerbound1=new double[num_look];
	upperbound2=new double[num_look];
	lowerbound2=new double[num_look];
	for(i=0; i<2*num_look; i++){
		boundary1[i]=0;
		boundary2[i]=0;
	}

	//	Get the marginal critical boundary for end1:
	boundary1=TNUniBound(workcov1, NormalEnd1->meanAlter, (NormalEnd1->sample_size1+NormalEnd1->sample_size2), NormalEnd1->looksimul, NormalEnd1->look_order, 1);
	for(l=0; l<lookorder; l++){
		lowerbound1[l]=boundary1[2*l+0];
		upperbound1[l]=boundary1[2*l+1];
	}

//	cout<<"check of the critical bound for end1"<<endl;
//	cout<<"lowerbound"<<"\t"<<"upperbound"<<endl;
//	for(l=0; l<lookorder; l++){
//		cout<<lowerbound1[l]<<"\t"<<upperbound1[l]<<endl;
//	}

	//  Get the marginal critical boundary for end2:
	boundary2=TNUniBound(workcov2, NormalEnd2->meanAlter, NormalEnd2->sample_size, NormalEnd2->looksimul, NormalEnd2->look_order, 2);
	for(l=0; l<lookorder; l++){
		lowerbound2[l]=boundary2[2*l+0];
		upperbound2[l]=boundary2[2*l+1];
	}

//	cout<<"check of the critical bound for end2"<<endl;
//	cout<<"lowerbound"<<"\t"<<"upperbound"<<endl;
//	for(l=0; l<lookorder; l++){
//		cout<<lowerbound2[l]<<"\t"<<upperbound2[l]<<endl;
//	}

	//	search for the constant c.

	// simulate Z (Null & ALter), then seperate:
	double *workZ;
	double *ZNullEnd1, *ZAlterEnd1;
	double *ZNullEnd2, *ZAlterEnd2;
	workZ=new double[looksimul*2*lookorder];
	ZNullEnd1=new double[looksimul*lookorder];
	ZAlterEnd1=new double[looksimul*lookorder];
	ZNullEnd2=new double[looksimul*lookorder];
	ZAlterEnd2=new double[looksimul*lookorder];

//	workZ=TNZSimul(covsimul, lookorder, looksimul, NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	workZ=TNZSimulA(covsimul, lookorder, looksimul, NormalEnd1->sample_size1+NormalEnd1->sample_size2);

	for(i=0; i<looksimul; i++){
		for(j=0; j<lookorder; j++){
			ZNullEnd1[i*lookorder+j]=workZ[i*2*lookorder+j];
			ZNullEnd2[i*lookorder+j]=workZ[i*2*lookorder+lookorder+j];
			ZAlterEnd1[i*lookorder+j]=workZ[i*2*lookorder+j]+NormalEnd1->meanAlter*sqrt((j+1)*NormalEnd1->sample_size1+NormalEnd1->sample_size2);
			ZAlterEnd2[i*lookorder+j]=workZ[i*2*lookorder+lookorder+j]+NormalEnd2->meanAlter*sqrt((j+1)*NormalEnd2->sample_size);
		}
	}


	// up to here has been checked. (March 16th, 3:50PM.)

	double *adjustupper1, *adjustlower1;
	double *adjustupper2, *adjustlower2;
	adjustupper1=new double[num_look];
	adjustlower1=new double[num_look];
	adjustupper2=new double[num_look];
	adjustlower2=new double[num_look];
	
	double *cc;
	cc=new double[num_look];
	for(l=0; l<num_look; l++)
		cc[l]=1.0;
	double c_mid, c_upper, c_lower;

	double *BiAlpha;
	BiAlpha=new double[num_look];

	for(i=0; i<num_look; i++)
		BiAlpha[i]=NormalEnd1->AlphaGlobal[i];

	double *alpha4;
	alpha4=new double[num_look];

	int *count1, *count2;
	count1=new int[num_look];
	count2=new int[num_look];


	double *workNull1, *workNull2;
	double *workAlter1, *workAlter2;
	workNull1=new double[lookorder*looksimul];
	workNull2=new double[lookorder*looksimul];
	workAlter1=new double[lookorder*looksimul];
	workAlter2=new double[lookorder*looksimul];
	for(i=0; i<lookorder*looksimul; i++) {
		workNull1[i]=absd(ZNullEnd1[i]);
		workNull2[i]=absd(ZNullEnd2[i]);
		workAlter1[i]=absd(ZAlterEnd1[i]);
		workAlter2[i]=absd(ZAlterEnd2[i]);
	}

	double *work1, *work2;
	work1=new double[looksimul];
	work2=new double[looksimul];

	// since only alpha is invloved, we only need the distribution under the Null,
	// however, since we may need to report the beta spending eventually, we also
	// get the Alternative distribution for future use.

	// workNull1 & workNull2 are positive !!!
	// get c for the first look:
	
	
	for(i=0; i<looksimul; i++){
		work1[i]=workNull1[i*lookorder+0];
		work2[i]=workNull2[i*lookorder+0];
	}


	int search_length=1000;
	int n;
	double *c_search;
	c_search=new double[search_length];

	c_lower=0.01;
	c_upper=15.0;
	double c_range=c_upper-c_lower;
	double alphawork=0;
	double countt=0;	
	double minalphawork=1.0;
	int lengthlook;
	int nn;
	int indi;		// indicator.

	// calculate c by the "search" method:



	int decisiontype=NormalEnd1->rule_decision;
	// in case of hard:
	
	if(decisiontype==1) {
		for(n=0; n<search_length; n++){	
			// Initialize c_search:
			c_search[n]=c_lower+n*c_range/search_length;

			countt=0;
			adjustupper1[0]=upperbound1[0]*c_search[n];
			adjustlower1[0]=lowerbound1[0]*c_search[n];
			adjustupper2[0]=upperbound2[0]*c_search[n];
			adjustlower2[0]=lowerbound2[0]*c_search[n];

			for(m=0; m<looksimul; m++){
				if( (work1[m]>adjustupper1[0]) && (work2[m]>adjustupper2[0]) )
					countt=countt+1;	// H++ H+- H-+ H--
				else if( (work1[m]>adjustupper1[0]) && (work2[m]<adjustlower2[0]) )
					countt=countt+1;	// H+0 H-0
				else if( (work1[m]<adjustlower1[0]) && (work2[m]>adjustupper2[0]) )
					countt=countt+1;	// H0+ H0-
			}

			alphawork=countt/looksimul;

			if( minalphawork > absd(alphawork-BiAlpha[0]) ){
				c_mid=c_search[n];
				minalphawork=absd(alphawork-BiAlpha[0]);
			}
		}
	
		adjustupper1[0]=upperbound1[0]*c_mid;
		adjustlower1[0]=lowerbound1[0]*c_mid;
		adjustupper2[0]=upperbound2[0]*c_mid;
		adjustlower2[0]=lowerbound2[0]*c_mid;
	
//		cout<<"search of c for the first look:"<<"\t"<<c_mid<<"\t";
//		cout<<"minalphawork"<<"\t"<<minalphawork<<endl;

		// now we search the const c for the rest of looks:
		for(i=1; i<lookorder; i++){
			minalphawork=1;
			lengthlook=0;
			for(j=0; j<looksimul; j++){
				indi=0;
			
				for(m=0; m<i; m++){
					if( indi!=1) {
						if( workNull1[j*lookorder+m]>adjustupper1[m] && workNull2[j*lookorder+m]>adjustupper2[m])
							indi=1;		
						else if( workNull1[j*lookorder+m]>adjustupper1[m] && workNull2[j*lookorder+m]<adjustlower2[m])
							indi=1;
						else if( workNull1[j*lookorder+m]<adjustlower1[m] && workNull2[j*lookorder+m]>adjustupper2[m])
							indi=1;
					}
				}

				if(indi==0){
					work1[lengthlook]=workNull1[j*lookorder+i];
					work2[lengthlook]=workNull2[j*lookorder+i];
					lengthlook=lengthlook+1;
				}
			}

			for(n=0; n<search_length; n++){	
			// Initialize c_search:
				c_search[n]=c_lower+n*c_range/search_length;

				countt=0;
				adjustupper1[i]=upperbound1[i]*c_search[n];
				adjustlower1[i]=lowerbound1[i]*c_search[n];
				adjustupper2[i]=upperbound2[i]*c_search[n];
				adjustlower2[i]=lowerbound2[i]*c_search[n];
		
				for(nn=0; nn<lengthlook; nn++){
					if( (work1[nn]>adjustupper1[i]) && (work2[nn]>adjustupper2[i]) )
						countt=countt+1;
					else if( (work1[nn]<adjustlower1[i]) && (work2[nn]>adjustupper2[i]) )
						countt=countt+1;
					else if( (work1[nn]>adjustupper1[i]) && (work2[nn]<adjustlower2[i]) )
						countt=countt+1;
				}

				alphawork=countt/lengthlook;

				if( minalphawork > absd(alphawork-BiAlpha[i]) ){
					c_mid=c_search[n];
					minalphawork=absd(alphawork-BiAlpha[i]);
				}
			}

//			cout<<"search of c end for look"<<"\t"<<i<<"\t";
//			cout<<"minalphawork"<<"\t"<<minalphawork<<"\t"<<"const c"<<"\t"<<c_mid<<endl;

			adjustupper1[i]=upperbound1[i]*c_mid;
			adjustlower1[i]=lowerbound1[i]*c_mid;
			adjustupper2[i]=upperbound2[i]*c_mid;
			adjustlower2[i]=lowerbound2[i]*c_mid;
		}

		for(i=0; i<lookorder; i++){
			NormalEnd1->UpperAdjust[i] = adjustupper1[i];
			NormalEnd1->LowerAdjust[i] = adjustlower1[i];
			NormalEnd2->UpperAdjust[i] = adjustupper2[i];
			NormalEnd2->LowerAdjust[i] = adjustlower2[i];
		}
	}


	// in case of soft decision:
	//mainly copy from the above calculation:
	// work can not be used DIRECTLY.
	else if(decisiontype==0){	
		for(n=0; n<search_length; n++){	
			// Initialize c_search:
			c_search[n]=c_lower+n*c_range/search_length;

			countt=0;
			adjustupper1[0]=upperbound1[0]*c_search[n];
			adjustlower1[0]=lowerbound1[0]*c_search[n];
			adjustupper2[0]=upperbound2[0]*c_search[n];
			adjustlower2[0]=lowerbound2[0]*c_search[n];
		
			//initialize work:
			for(m=0; m<looksimul; m++){
				work1[m]=ZNullEnd1[m*lookorder+0];
				work2[m]=ZNullEnd2[m*lookorder+0];
			}

			for(m=0; m<looksimul; m++){
				if( absd(work1[m])>adjustupper1[0] )	
					countt=countt+1;		// H-* & H+*
				else if( (absd(work1[m])<adjustlower1[0]) && (absd(work2[m])>adjustupper2[0]) )
					countt=countt+1;		//H0+ & H0-
				else if( (work1[m]<-adjustlower1[0]) && (work1[m]>-adjustupper1[0]) && (work2[m]<-adjustupper2[0]) )
					countt=countt+1;		// H(-)-
			}

			alphawork=countt/looksimul;

			if( minalphawork > absd(alphawork-BiAlpha[0]) ){
				c_mid=c_search[n];
				minalphawork=absd(alphawork-BiAlpha[0]);
			}
		}
	
		adjustupper1[0]=upperbound1[0]*c_mid;
		adjustlower1[0]=lowerbound1[0]*c_mid;
		adjustupper2[0]=upperbound2[0]*c_mid;
		adjustlower2[0]=lowerbound2[0]*c_mid;
	
//		cout<<"search of c for the first look [SOFT DECISION]:"<<"\t"<<c_mid<<"\t";
//		cout<<"minalphawork"<<"\t"<<minalphawork<<endl;

		// now we search the const c for the rest of looks:
		for(i=1; i<lookorder; i++){
			minalphawork=1;
			lengthlook=0;

			for(j=0; j<looksimul; j++){
				indi=0;

				for(m=0; m<i; m++){
					if( indi!=1) {
						if( absd(ZNullEnd1[j*lookorder+m])>adjustupper1[m] )
							indi=1;		// H-*  H+*
						else if( absd(ZNullEnd1[j*lookorder+m])<adjustlower1[m] && absd(ZNullEnd2[j*lookorder+m])>adjustupper2[m])
							indi=1;		// H0- & H0+
						else if( (ZNullEnd1[j*lookorder+m]<-adjustlower1[m]) && (ZNullEnd1[j*lookorder+m]>-adjustupper1[m]) && (ZNullEnd2[j*lookorder+m]<-adjustupper2[m]) )
							indi=1;		// H(-)-
					}
				}

				if(indi==0){
					work1[lengthlook]=ZNullEnd1[j*lookorder+i];
					work2[lengthlook]=ZNullEnd2[j*lookorder+i];
					lengthlook=lengthlook+1;
				}
			}

			for(n=0; n<search_length; n++){	
			// Initialize c_search:
				c_search[n]=c_lower+n*c_range/search_length;

				countt=0;
				adjustupper1[i]=upperbound1[i]*c_search[n];
				adjustlower1[i]=lowerbound1[i]*c_search[n];
				adjustupper2[i]=upperbound2[i]*c_search[n];
				adjustlower2[i]=lowerbound2[i]*c_search[n];
		
				for(nn=0; nn<lengthlook; nn++){		// make mistake in this look:
				//	if( (work1[nn]>adjustupper1[i]) || (work2[nn]>adjustupper2[i]) )
				//		countt=countt+1;
					if( absd(work1[nn])>adjustupper1[i] )					
						countt=countt+1;	// H-* H+*
					else if( (absd(work1[nn])<adjustlower1[i]) && (absd(work2[nn])>adjustupper2[i]))
						countt=countt+1;	// H0- H0+
					else if( (work1[nn]<-adjustlower1[i]) && (work1[nn]>-adjustupper1[i]) && (work2[nn]<-adjustupper2[i]) )
						countt=countt+1;
				}


				alphawork=countt/lengthlook;

				if( minalphawork > absd(alphawork-BiAlpha[i]) ){
					c_mid=c_search[n];
					minalphawork=absd(alphawork-BiAlpha[i]);
				}
			}

//			cout<<"search of c end for look"<<"\t"<<i<<"\t";
//			cout<<"minalphawork"<<"\t"<<minalphawork<<"\t"<<"const c"<<"\t"<<c_mid<<endl;

			adjustupper1[i]=upperbound1[i]*c_mid;
			adjustlower1[i]=lowerbound1[i]*c_mid;
			adjustupper2[i]=upperbound2[i]*c_mid;
			adjustlower2[i]=lowerbound2[i]*c_mid;
		}

		for(i=0; i<lookorder; i++){
			NormalEnd1->UpperAdjust[i] = adjustupper1[i];
			NormalEnd1->LowerAdjust[i] = adjustlower1[i];
			NormalEnd2->UpperAdjust[i] = adjustupper2[i];
			NormalEnd2->LowerAdjust[i] = adjustlower2[i];
		}
	}



	//calculation of test statistic from our data:
	double *twork1;
	twork1=new double[maxlook*(NormalEnd1->sample_size1+NormalEnd1->sample_size2)];
	for(i=0; i< (NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++){
		twork1[i*maxlook+0]=dataEnd11[i];
		twork1[i*maxlook+1]=dataEnd12[i];
		twork1[i*maxlook+2]=dataEnd13[i];
		twork1[i*maxlook+3]=dataEnd14[i];
		twork1[i*maxlook+4]=dataEnd15[i];
		twork1[i*maxlook+5]=dataEnd16[i];
		twork1[i*maxlook+6]=dataEnd17[i];
		twork1[i*maxlook+7]=dataEnd18[i];
		twork1[i*maxlook+8]=dataEnd19[i];
		twork1[i*maxlook+9]=dataEnd10[i];
	}

	double *twork2;
	twork2=new double[maxlook*(NormalEnd1->sample_size1+NormalEnd1->sample_size2)];
	for(i=0; i< (NormalEnd1->sample_size1+NormalEnd1->sample_size2); i++){
		twork2[i*maxlook+0]=dataEnd21[i];
		twork2[i*maxlook+1]=dataEnd22[i];
		twork2[i*maxlook+2]=dataEnd23[i];
		twork2[i*maxlook+3]=dataEnd24[i];
		twork2[i*maxlook+4]=dataEnd25[i];
		twork2[i*maxlook+5]=dataEnd26[i];
		twork2[i*maxlook+6]=dataEnd27[i];
		twork2[i*maxlook+7]=dataEnd28[i];
		twork2[i*maxlook+8]=dataEnd29[i];
		twork2[i*maxlook+9]=dataEnd20[i];
	}
	
	double *test1, *test2;
	test1=new double[num_look];
	test2=new double[num_look];
	for(i=0; i<num_look; i++){
		test1[i]=0;
		test2[i]=0;
	}
	int *size1, *size2;
	size1=new int[2*maxlook];
	size2=new int[2*maxlook];
	size1=UNSize1();
	size2=UNSize2();
	int *size11, *size12, *size21, *size22;
	size11=new int[lookorder];
	size12=new int[lookorder];
	size21=new int[lookorder];
	size22=new int[lookorder];
	
	for(i=0; i<lookorder; i++){
		size11[i]=size1[i];
		size12[i]=size1[i+lookorder];
		size21[i]=size2[i];
		size22[i]=size2[i+lookorder];
	}

	double stemp1, stemp2;
	int sizet1, sizet2;

	for(i=0; i<lookorder; i++){
		stemp1=0;
		stemp2=0;

		sizet1=0; 
		sizet2=0;
		for(k=0; k<=i; k++){
			sizet1=sizet1+size11[k];	//control
			sizet2=sizet2+size12[k];	//treat
		}
		
		for(j=0; j<=i; j++){
			for(k=0; k<size11[j]; k++){
				stemp1=stemp1+twork1[k*maxlook+j];	//control
			}
			for(k=NormalEnd1->sample_size1; k<NormalEnd1->sample_size1+size12[j]; k++){
				stemp2=stemp2+twork1[k*maxlook+j];	//treat
			}
		}
		test1[i]=(stemp2-stemp1)/sqrt(sizet1+sizet2);
	}

	for(i=0; i<lookorder; i++){
		stemp1=0;
		stemp2=0;

		sizet1=0; 
		sizet2=0;
		for(k=0; k<=i; k++){
			sizet1=sizet1+size21[k];	//control
			sizet2=sizet2+size22[k];	//treat
		}
		
		for(j=0; j<=i; j++){
			for(k=0; k<size21[j]; k++){
				stemp1=stemp1+twork2[k*maxlook+j];	//control
			}
			for(k=NormalEnd1->sample_size1; k<NormalEnd1->sample_size1+size22[j]; k++){
				stemp2=stemp2+twork2[k*maxlook+j];	//treat
			}
		}
		test2[i]=(stemp2-stemp1)/sqrt(sizet1+sizet2);
	}


	for(i=0; i<lookorder; i++){
		NormalEnd1->testZ[i]=test1[i];
		NormalEnd2->testZ[i]=test2[i];
	}

}




// The same mean, var & cov estimate for the second Normal End:
double *TNMean(TrialEndNormal *end1)
{
	int maxlook=LIMIT_N_LOOK;
//	int con1;
	int i;
	
	double *meanA1;
	meanA1=new double[maxlook];

	for(i=0; i<maxlook; i++)
		meanA1[i]=0;

	// check the mean structure:
	for(i=0; i<end1->sample_size; i++)
		meanA1[0]=meanA1[0]+dataEnd21[i];
	meanA1[0]=meanA1[0]/(end1->sample_size);
	for(i=0; i<end1->sample_size; i++)
		meanA1[1]=meanA1[1]+dataEnd22[i];
	meanA1[1]=meanA1[1]/(end1->sample_size);
	for(i=0; i<end1->sample_size; i++)
		meanA1[2]=meanA1[2]+dataEnd23[i];
	meanA1[2]=meanA1[2]/(end1->sample_size);
	for(i=0; i<end1->sample_size; i++)
		meanA1[3]=meanA1[3]+dataEnd24[i];
	meanA1[3]=meanA1[3]/(end1->sample_size);
	for(i=0; i<end1->sample_size; i++)
		meanA1[4]=meanA1[4]+dataEnd25[i];
	meanA1[4]=meanA1[4]/(end1->sample_size);
	for(i=0; i<end1->sample_size; i++)
		meanA1[5]=meanA1[5]+dataEnd26[i];
	meanA1[5]=meanA1[5]/(end1->sample_size);
	for(i=0; i<end1->sample_size; i++)
		meanA1[6]=meanA1[6]+dataEnd27[i];
	meanA1[6]=meanA1[6]/(end1->sample_size);
	for(i=0; i<end1->sample_size; i++)
		meanA1[7]=meanA1[7]+dataEnd28[i];
	meanA1[7]=meanA1[7]/(end1->sample_size);
	for(i=0; i<end1->sample_size; i++)
		meanA1[8]=meanA1[8]+dataEnd29[i];
	meanA1[8]=meanA1[8]/(end1->sample_size);
	for(i=0; i<end1->sample_size; i++)
		meanA1[9]=meanA1[9]+dataEnd20[i];
	meanA1[9]=meanA1[9]/(end1->sample_size);

	
	end1->mean = meanA1;

	return meanA1;
}


double *TNVar(TrialEndNormal *end1)
{
	int maxlook=LIMIT_N_LOOK;
//	int con1;
	int i;
	
	double *meanA1;
	double *varA1;
	meanA1=new double[maxlook];
	varA1=new double[maxlook];
	for(i=0; i<maxlook; i++)
		varA1[i]=0;
	
	meanA1=TNMean(end1);

	for(i=0; i<end1->sample_size; i++)
		varA1[0]=varA1[0]+(dataEnd21[i]-meanA1[0])*(dataEnd21[i]-meanA1[0]);
	varA1[0]=varA1[0]/end1->sample_size;
	for(i=0; i<end1->sample_size; i++)
		varA1[1]=varA1[1]+(dataEnd22[i]-meanA1[1])*(dataEnd22[i]-meanA1[1]);
	varA1[1]=varA1[1]/end1->sample_size;
	for(i=0; i<end1->sample_size; i++)
		varA1[2]=varA1[2]+(dataEnd23[i]-meanA1[2])*(dataEnd23[i]-meanA1[2]);
	varA1[2]=varA1[2]/end1->sample_size;
	for(i=0; i<end1->sample_size; i++)
		varA1[3]=varA1[3]+(dataEnd24[i]-meanA1[3])*(dataEnd24[i]-meanA1[3]);
	varA1[3]=varA1[3]/end1->sample_size;
	for(i=0; i<end1->sample_size; i++)
		varA1[4]=varA1[4]+(dataEnd25[i]-meanA1[4])*(dataEnd25[i]-meanA1[4]);
	varA1[4]=varA1[4]/end1->sample_size;
	for(i=0; i<end1->sample_size; i++)
		varA1[5]=varA1[5]+(dataEnd26[i]-meanA1[5])*(dataEnd26[i]-meanA1[5]);
	varA1[5]=varA1[5]/end1->sample_size;
	for(i=0; i<end1->sample_size; i++)
		varA1[6]=varA1[6]+(dataEnd27[i]-meanA1[6])*(dataEnd27[i]-meanA1[6]);
	varA1[6]=varA1[6]/end1->sample_size;
	for(i=0; i<end1->sample_size; i++)
		varA1[7]=varA1[7]+(dataEnd28[i]-meanA1[7])*(dataEnd28[i]-meanA1[7]);
	varA1[7]=varA1[7]/end1->sample_size;
	for(i=0; i<end1->sample_size; i++)
		varA1[8]=varA1[8]+(dataEnd29[i]-meanA1[8])*(dataEnd29[i]-meanA1[8]);
	varA1[8]=varA1[8]/end1->sample_size;
	for(i=0; i<end1->sample_size; i++)
		varA1[9]=varA1[9]+(dataEnd20[i]-meanA1[9])*(dataEnd20[i]-meanA1[9]);
	varA1[9]=varA1[9]/end1->sample_size;

	// Now check the variance:

	end1->var = varA1;

	return varA1;

}


double *TNCov(TrialEndNormal *end1)
{
	int maxlook=LIMIT_N_LOOK;
	int samplesize=end1->sample_size;
	int i,j, k;
	
//	int con1;
	double *meanA1;
	double *varA1;
	double *covA1;
	double *structure;
	meanA1=new double[maxlook];
	varA1=new double[maxlook];
	covA1=new double[maxlook*maxlook];

	meanA1=TNMean(end1);
	varA1=TNVar(end1);

	for(i=0; i<maxlook*maxlook; i++){
		covA1[i]=0;
	}

	double * data;
	data=new double[maxlook*end1->sample_size];

	for(i=0; i<samplesize; i++){
		data[i*maxlook+0]=dataEnd21[i];
		data[i*maxlook+1]=dataEnd22[i];
		data[i*maxlook+2]=dataEnd23[i];
		data[i*maxlook+3]=dataEnd24[i];
		data[i*maxlook+4]=dataEnd25[i];
		data[i*maxlook+5]=dataEnd26[i];
		data[i*maxlook+6]=dataEnd27[i];
		data[i*maxlook+7]=dataEnd28[i];
		data[i*maxlook+8]=dataEnd29[i];
		data[i*maxlook+9]=dataEnd20[i];
	}

	for(i=0; i<maxlook; i++){
		for(j=0; j<maxlook; j++){
			covA1[i*maxlook+j]=0;
			for(k=0; k<end1->sample_size; k++){
				covA1[i*maxlook+j]=covA1[i*maxlook+j]+(data[k*maxlook+i]-meanA1[i])*(data[k*maxlook+j]-meanA1[j]);
			}
			covA1[i*maxlook+j]=covA1[i*maxlook+j]/end1->sample_size;
		}
	}


	end1->coVar = covA1;

	return covA1;
}



//
// the new version of mean, var and cov estimate.
// taking into account the treat and control group
// copy from the UN case:
double *TNMeanNew(TrialEndNormal *end1)
{
	int con1;
	int i, j;
	double *mean;
	mean=new double[2*end1->look_order];

	int lookorder=end1->look_order;
	int maxlook=LIMIT_N_LOOK;

	int *size;
	size=new int[maxlook*2];
	size=UNSize2();
	
	double *work;
	work=new double[maxlook*(end1->sample_size1+end1->sample_size2)];
	for(i=0; i< (end1->sample_size1+end1->sample_size2); i++){
		work[i*maxlook+0]=dataEnd21[i];
		work[i*maxlook+1]=dataEnd22[i];
		work[i*maxlook+2]=dataEnd23[i];
		work[i*maxlook+3]=dataEnd24[i];
		work[i*maxlook+4]=dataEnd25[i];
		work[i*maxlook+5]=dataEnd26[i];
		work[i*maxlook+6]=dataEnd27[i];
		work[i*maxlook+7]=dataEnd28[i];
		work[i*maxlook+8]=dataEnd29[i];
		work[i*maxlook+9]=dataEnd20[i];
	}
	
	for(i=0; i<2*lookorder; i++){
		mean[i]=0;
	}

	for(i=0; i<lookorder; i++){
		for(j=0; j<size[i]; j++){
			mean[i]=mean[i]+work[j*maxlook+i];
		}
		mean[i]=mean[i]/size[i];
		for(j=end1->sample_size1; j<(end1->sample_size1+size[maxlook+i]); j++){
			mean[i+lookorder]=mean[i+lookorder]+work[j*maxlook+i];
		}
		mean[i+lookorder]=mean[i+lookorder]/size[i+maxlook];
	}

	return mean;
}

double *TNVarNew(TrialEndNormal *end1)
{
	int con1;
	int i, j, k;

	double *var;
	var=new double[end1->look_order];
	
	int maxlook=LIMIT_N_LOOK;
	int lookorder=end1->look_order;
	int *size;
	size=new int[2*maxlook];
	size=UNSize2();
	double *mean;
	mean=new double[2*lookorder];
	mean=UNMeanNew(NormalEnd1);

	for(i=0; i<lookorder; i++)
		var[i]=0;

	double *work;
	work=new double[maxlook*(end1->sample_size1+end1->sample_size2)];
	for(i=0; i< (end1->sample_size1+end1->sample_size2); i++){
		work[i*maxlook+0]=dataEnd21[i];
		work[i*maxlook+1]=dataEnd22[i];
		work[i*maxlook+2]=dataEnd23[i];
		work[i*maxlook+3]=dataEnd24[i];
		work[i*maxlook+4]=dataEnd25[i];
		work[i*maxlook+5]=dataEnd26[i];
		work[i*maxlook+6]=dataEnd27[i];
		work[i*maxlook+7]=dataEnd28[i];
		work[i*maxlook+8]=dataEnd29[i];
		work[i*maxlook+9]=dataEnd20[i];
	}

	// substract mean
	for(j=0; j<lookorder; j++){
		for(i=0; i<size[j]; i++){
			work[i*maxlook+j]=work[i*maxlook+j]-mean[j];	//control
		}
		for(i=end1->sample_size1; i<size[j+maxlook]; i++){
			work[i*maxlook+j]=work[i*maxlook+j]-mean[j+lookorder];	//treat
		}
	}

	//calculation of var:
	int tempsize;
	for(j=0; j<lookorder; j++){
		for(i=0; i<size[j]; i++){
			var[j]=var[j]+work[i*maxlook+j]*work[i*maxlook+j];
		}
		for(i=end1->sample_size1; i<(size[j+maxlook]+end1->sample_size1); i++){
			var[j]=var[j]+work[i*maxlook+j]*work[i*maxlook+j];
		}
		var[j]=var[j]/(size[j]+size[j+maxlook]);
	}

	return var;
}


double *TNCovNew(TrialEndNormal *end1)
{
	int con1;
	
	double *cov;
	cov=new double[end1->look_order*end1->look_order];
	
	int i, j, k;
	int maxlook=LIMIT_N_LOOK;
	int lookorder=end1->look_order;

	int *size;
	size=new int[maxlook*2];
	size=UNSize2();
	double *mean;
	mean=new double[2*lookorder];
	mean=UNMeanNew(NormalEnd1);

	double *work;
	work=new double[maxlook*(end1->sample_size1+end1->sample_size2)];
	for(i=0; i< (end1->sample_size1+end1->sample_size2); i++){
		work[i*maxlook+0]=dataEnd21[i];
		work[i*maxlook+1]=dataEnd22[i];
		work[i*maxlook+2]=dataEnd23[i];
		work[i*maxlook+3]=dataEnd24[i];
		work[i*maxlook+4]=dataEnd25[i];
		work[i*maxlook+5]=dataEnd26[i];
		work[i*maxlook+6]=dataEnd27[i];
		work[i*maxlook+7]=dataEnd28[i];
		work[i*maxlook+8]=dataEnd29[i];
		work[i*maxlook+9]=dataEnd20[i];
	}

	// substract mean
	for(j=0; j<lookorder; j++){
		for(i=0; i<size[j]; i++){
			work[i*maxlook+j]=work[i*maxlook+j]-mean[j];	//control
		}
		for(i=end1->sample_size1; i<size[j+maxlook]; i++){
			work[i*maxlook+j]=work[i*maxlook+j]-mean[j+lookorder];	//treat
		}
	}
	
	int sizetemp1, sizetemp2;
	for(i=0; i<lookorder*lookorder; i++)
		cov[i]=0;
	for(i=0; i<lookorder; i++){
		for(j=0; j<lookorder; j++){
			
			//control
			if(size[i]<size[j])
				sizetemp1=size[i];
			else sizetemp1=size[j];
			//treat
			if(size[i+maxlook]<size[j+maxlook])
				sizetemp2=size[i+maxlook];
			else sizetemp2=size[j+maxlook];
	
			for(k=0; k<sizetemp1; k++){
				cov[i*lookorder+j]=cov[i*lookorder+j]+work[k*maxlook+i]*work[k*maxlook+j];
			}
			for(k=end1->sample_size1; k<(end1->sample_size1+sizetemp2); k++){
				cov[i*lookorder+j]=cov[i*lookorder+j]+work[k*maxlook+i]*work[k*maxlook+j];
			}
			cov[i*lookorder+j]=cov[i*lookorder+j]/(sizetemp1+sizetemp2);
		}
	}

	// checked and return reasonable square root matrix
	return cov;
}





double *TNCrossCov()
{
	int maxlook=LIMIT_N_LOOK;
	int samplesize=NormalEnd1->sample_size;
	double *data;
	data=new double[2*maxlook*samplesize];
	double *cov;
	cov=new double[4*maxlook*maxlook];
	double *mean1, *mean2;
	mean1=new double[maxlook];
	mean2=new double[maxlook];
	double *mean;
	mean=new double[2*maxlook];

	int i, j, k;
	// Initialize data:
	for(i=0; i<samplesize; i++){
		data[i*2*maxlook+0]=dataEnd11[i];
		data[i*2*maxlook+1]=dataEnd12[i];
		data[i*2*maxlook+2]=dataEnd13[i];
		data[i*2*maxlook+3]=dataEnd14[i];
		data[i*2*maxlook+4]=dataEnd15[i];
		data[i*2*maxlook+5]=dataEnd16[i];
		data[i*2*maxlook+6]=dataEnd17[i];
		data[i*2*maxlook+7]=dataEnd18[i];
		data[i*2*maxlook+8]=dataEnd19[i];
		data[i*2*maxlook+9]=dataEnd10[i];

		data[i*2*maxlook+10]=dataEnd21[i];
		data[i*2*maxlook+11]=dataEnd22[i];
		data[i*2*maxlook+12]=dataEnd23[i];
		data[i*2*maxlook+13]=dataEnd24[i];
		data[i*2*maxlook+14]=dataEnd25[i];
		data[i*2*maxlook+15]=dataEnd26[i];
		data[i*2*maxlook+16]=dataEnd27[i];
		data[i*2*maxlook+17]=dataEnd28[i];
		data[i*2*maxlook+18]=dataEnd29[i];
		data[i*2*maxlook+19]=dataEnd20[i];
	}

	mean1=UNMean(NormalEnd1);
	mean2=TNMean(NormalEnd2);
	for(i=0; i<maxlook; i++){
		mean[i]=mean1[i];
		mean[i+maxlook]=mean2[i];
	}
	// Now calculate the coviance:

	for(i=0; i<2*maxlook; i++){
		for(j=0; j<2*maxlook; j++){
			cov[i*2*maxlook+j]=0;
			for(k=0; k<samplesize; k++){
				cov[i*2*maxlook+j]=cov[i*2*maxlook+j]+(data[k*2*maxlook+i]-mean[i])*(data[k*2*maxlook+j]-mean[j]);
			}
			cov[i*2*maxlook+j]=cov[i*2*maxlook+j]/samplesize;
		}
	}
	
	return cov;
}



double *TNCrossCovNew()
{
	int con1;
	
	int i, j, k;
	double *cross;
	int lookorder=NormalEnd1->look_order;
	int maxlook=LIMIT_N_LOOK;
	cross=new double[4*lookorder*lookorder];

	double *mean1, *mean2;
	mean1=new double[lookorder];
	mean2=new double[lookorder];
	mean1=UNMeanNew(NormalEnd1);
	mean2=TNMeanNew(NormalEnd2);

	double *data;
	data=new double[2*maxlook*(NormalEnd1->sample_size1+NormalEnd1->sample_size2)];
	
	int samplesize1=NormalEnd1->sample_size1;
	int samplesize2=NormalEnd1->sample_size2;

	double *work1, *work2;
	work1=new double[maxlook*(samplesize1+samplesize2)];
	work2=new double[maxlook*(samplesize1+samplesize2)];

	int *size1, *size2;
	size1=new int[2*maxlook];
	size2=new int[2*maxlook];
	size1=UNSize1();
	size2=UNSize2();

	int *size11, *size12;
	int *size21, *size22;
	size11=new int[lookorder];
	size12=new int[lookorder];
	size21=new int[lookorder];
	size22=new int[lookorder];

	for(i=0; i<lookorder; i++){
		size11[i]=size1[i];			//control end 1
		size12[i]=size1[i+maxlook];	//treat	end 1
		size21[i]=size2[i];			//control end 1
		size22[i]=size2[i+maxlook];	//treat end 1
	}

	for(i=0; i< (samplesize1+samplesize2); i++){
		work1[i*maxlook+0]=dataEnd11[i];
		work1[i*maxlook+1]=dataEnd12[i];
		work1[i*maxlook+2]=dataEnd13[i];
		work1[i*maxlook+3]=dataEnd14[i];
		work1[i*maxlook+4]=dataEnd15[i];
		work1[i*maxlook+5]=dataEnd16[i];
		work1[i*maxlook+6]=dataEnd17[i];
		work1[i*maxlook+7]=dataEnd18[i];
		work1[i*maxlook+8]=dataEnd19[i];
		work1[i*maxlook+9]=dataEnd10[i];
	}

	for(i=0; i< (samplesize1+samplesize2); i++){
		work2[i*maxlook+0]=dataEnd21[i];
		work2[i*maxlook+1]=dataEnd22[i];
		work2[i*maxlook+2]=dataEnd23[i];
		work2[i*maxlook+3]=dataEnd24[i];
		work2[i*maxlook+4]=dataEnd25[i];
		work2[i*maxlook+5]=dataEnd26[i];
		work2[i*maxlook+6]=dataEnd27[i];
		work2[i*maxlook+7]=dataEnd28[i];
		work2[i*maxlook+8]=dataEnd29[i];
		work2[i*maxlook+9]=dataEnd20[i];
	}

	// substract mean
	for(j=0; j<lookorder; j++){
		for(i=0; i<size1[j]; i++){
			work1[i*maxlook+j]=work1[i*maxlook+j]-mean1[j];	//control	end 1
		}
		for(i=samplesize1; i<size1[j+maxlook]; i++){
			work1[i*maxlook+j]=work1[i*maxlook+j]-mean1[j+lookorder];	//treat		end 1
		}
	}

	for(j=0; j<lookorder; j++){
		for(i=0; i<size2[j]; i++){
			work2[i*maxlook+j]=work2[i*maxlook+j]-mean2[j];	//control	end 2
		}
		for(i=samplesize1; i<size2[j+maxlook]; i++){
			work2[i*maxlook+j]=work2[i*maxlook+j]-mean2[j+lookorder];	//treat		end 2
		}
	}

	// seperate into four blocks:
	for(i=0; i<4*lookorder*lookorder; i++)
		cross[i]=0;
	
	int sizetemp1, sizetemp2;

	// block 1, end 1  v.s.  end  1
	for(i=0; i<lookorder; i++){
		sizetemp1=0;
		sizetemp2=0;
		for(j=0; j<lookorder; j++){
			//control
			if(size1[i]<size1[j])
				sizetemp1=size1[i];
			else sizetemp1=size1[j];
			//treat
			if(size1[i+maxlook]<size1[j+maxlook])
				sizetemp2=size1[i+maxlook];
			else sizetemp2=size1[j+maxlook];
	
			for(k=0; k<sizetemp1; k++){
				cross[i*2*lookorder+j]=cross[i*2*lookorder+j]+work1[k*maxlook+i]*work1[k*maxlook+j];
			}
			for(k=samplesize1; k<(samplesize1+sizetemp2); k++){
				cross[i*2*lookorder+j]=cross[i*2*lookorder+j]+work1[k*maxlook+i]*work1[k*maxlook+j];
			}
			cross[i*2*lookorder+j]=cross[i*2*lookorder+j]/(sizetemp1+sizetemp2);
		}
	}

	// block 4, end 2  v.s.  end  2
	for(i=0; i<lookorder; i++){
		sizetemp1=0;
		sizetemp2=0;
		for(j=0; j<lookorder; j++){
			//control
			if(size2[i]<size2[j])
				sizetemp1=size2[i];
			else sizetemp1=size2[j];
			//treat
			if(size2[i+maxlook]<size2[j+maxlook])
				sizetemp2=size2[i+maxlook];
			else sizetemp2=size2[j+maxlook];
	
			for(k=0; k<sizetemp1; k++){
				cross[(i+lookorder)*2*lookorder+j+lookorder]=cross[(i+lookorder)*2*lookorder+j+lookorder]+work2[k*maxlook+i]*work2[k*maxlook+j];
			}
			for(k=samplesize1; k<(samplesize1+sizetemp2); k++){
				cross[(i+lookorder)*2*lookorder+j+lookorder]=cross[(i+lookorder)*2*lookorder+j+lookorder]+work2[k*maxlook+i]*work2[k*maxlook+j];
			}
			cross[(i+lookorder)*2*lookorder+j+lookorder]=cross[(i+lookorder)*2*lookorder+j+lookorder]/(sizetemp1+sizetemp2);
		}
	}

	// block 2, end 1 v.s. end 2
	// block 3, end 2 v.s. end 1
	// end 1: i      end 2: j
	for(i=0; i<lookorder; i++){
		sizetemp1=0;
		sizetemp2=0;
		for(j=0; j<lookorder; j++){
			//control
			if(size1[i]<size2[j])
				sizetemp1=size1[i];
			else sizetemp1=size2[j];
			//treat
			if(size1[i+maxlook]<size2[j+maxlook])
				sizetemp2=size1[i+maxlook];
			else sizetemp2=size2[j+maxlook];
	
			for(k=0; k<sizetemp1; k++){
				cross[i*2*lookorder+j+lookorder]=cross[i*2*lookorder+j+lookorder]+work1[k*maxlook+i]*work2[k*maxlook+j];
			}
			for(k=samplesize1; k<(samplesize1+sizetemp2); k++){
				cross[lookorder*2*i+j+lookorder]=cross[i*2*lookorder+j+lookorder]+work1[k*maxlook+i]*work2[k*maxlook+j];
			}
			cross[i*2*lookorder+j+lookorder]=cross[i*2*lookorder+j+lookorder]/(sizetemp1+sizetemp2);
			cross[(i+lookorder)*2*lookorder+j]=cross[i*2*lookorder+j+lookorder];
		}
	}

	return cross;
}




void OutNormal(TrialEndNormal *end1)
{
	int i, j;
	cout<<"Check of TrialEndNormal"<<endl;
	cout<<"Order"<<"\t"<<end1->order<<endl;
	cout<<"Num of Look"<<"\t"<<end1->num_look<<endl;
	cout<<"Look #"<<"\t"<<end1->look_order<<endl;
	cout<<"Num of simulation"<<"\t"<<end1->num_simul<<endl;
	cout<<"look simul"<<"\t"<<end1->looksimul<<endl;
	cout<<"sample size"<<"\t"<<end1->sample_size<<endl;
	cout<<"alpha & beta spending"<<"\t"<<end1->spending_number<<endl;
	cout<<"meanNull"<<"\t"<<end1->meanNull<<"\t"<<"meanAlter"<<"\t"<<end1->meanAlter<<endl;
	cout<<"Bi_Alpha"<<"\t"<<end1->Bi_Alpha<<"\t"<<"Bi_Beta"<<"\t"<<end1->Bi_Beta<<endl;
	cout<<"overall_alpha"<<"\t"<<end1->overall_alpha<<"\t"<<"overall_beta"<<"\t"<<end1->overall_beta<<endl;
	cout<<"The detail alpha & beta spending"<<endl;
	for(i=0; i<end1->num_look; i++)
		cout<<end1->alpha[i]<<"\t"<<end1->beta[i]<<endl;
	cout<<"Information Spending"<<"\t";
	for(j=0; j<end1->num_look; j++)
		cout<<end1->inform_time[j]<<"\t";

	cout<<endl<<"Bi Alpha Spending"<<endl;
	for(i=0; i<end1->num_look; i++)
		cout<<end1->AlphaGlobal[i]<<"\t";
	cout<<endl<<"check of TrialNormalEnd Accomplished"<<endl;


}




void TNInitialize(TrialEndNormal *end1)
{
	int i, j, k;
	
	for(i=0; i<end1->num_look; i++)
		end1->inform_time[i]=end1->inform_time[i]/end1->inform_time[end1->num_look-1];

	end1->looksimul=end1->num_simul/end1->num_look;

	if(end1->spending_number==1){
		end1->alpha=alpha_beta1(end1->overall_alpha, end1->inform_time, end1->num_look);
		end1->beta=alpha_beta1(end1->overall_beta, end1->inform_time, end1->num_look);
	}

	if(end1->spending_number==2){
		end1->alpha=alpha_beta2(end1->overall_alpha, end1->inform_time, end1->num_look);
		end1->beta=alpha_beta2(end1->overall_beta, end1->inform_time, end1->num_look);
	}

	if(end1->spending_number==3){
		end1->alpha=alpha_beta3(end1->overall_alpha, end1->inform_time, end1->num_look);
		end1->beta=alpha_beta3(end1->overall_beta, end1->inform_time, end1->num_look);
	}

	if(end1->BiSpending==1){
		end1->AlphaGlobal=alpha_beta1(end1->Bi_Alpha, end1->inform_time, end1->num_look);
	}

	if(end1->BiSpending==2){
		end1->AlphaGlobal=alpha_beta2(end1->Bi_Alpha, end1->inform_time, end1->num_look);
	}

	if(end1->BiSpending==3){
		end1->AlphaGlobal=alpha_beta3(end1->Bi_Alpha, end1->inform_time, end1->num_look);
	}

}



double *TNUniBound(double *workcovA, double meanalter, int samplesize, int simul, int lookorder, int endnum)
{
	int con1;
	int i, j, k, l, m, n;
	double *boundary;	

	double stemp1, stemp2, stemp3, stemp4;
	double *meanNull, *meanAlter;
	double *StatCov;
	int *sizeN;
	int maxlook=LIMIT_N_LOOK;

	double meannull;
	if(endnum==1)
		meannull=NormalEnd1->meanNull;
	else
		meannull=NormalEnd2->meanNull;

	meanAlter=new double[lookorder];
	meanNull=new double[lookorder];
	StatCov=new double[lookorder*lookorder];
	sizeN=new int[maxlook*2];
	
	for(i=0; i<lookorder; i++){
		if(endnum==1){
			meanNull[i]=NormalEnd1->meanNull;
			meanAlter[i]=NormalEnd1->meanAlter;
		}
		else if(endnum==2){
			meanNull[i]=NormalEnd2->meanNull;
			meanAlter[i]=NormalEnd2->meanAlter;
		}
	}

	if(endnum==1)
		sizeN=UNSize1();
	else
		sizeN=UNSize2();

	double *StatMeanNull, *StatMeanAlter;
	StatMeanNull=new double[lookorder];
	StatMeanAlter=new double[lookorder];

	double ttemp1, ttemp2;
	for(i=0; i<lookorder; i++){
		ttemp1=0;
		ttemp2=0;
		for(k=0; k<=i; k++){
			ttemp1=ttemp1+sizeN[k];			//treat
			ttemp2=ttemp2+sizeN[k+maxlook]; //control
		}
		StatMeanNull[i]=(ttemp2-ttemp1)*meannull/sqrt(ttemp1+ttemp2) ;
		StatMeanAlter[i]=(ttemp2*meanalter-ttemp1*meannull)/sqrt(ttemp1+ttemp2) ;
	}
	
	double *varA1;
	double *StatVar;
	varA1=new double[lookorder];
	StatVar=new double[lookorder*lookorder];

	for(i=0; i<lookorder; i++)
		varA1[i]=workcovA[i*NormalEnd1->num_look+i];
	// now stored in workCovA; target -> StatCov

	for(i=0; i<lookorder; i++){
		for(j=0; j<=i; j++){
			stemp1=0;
			stemp2=0;
			stemp3=0;
			stemp4=0;

			for(k=0; k<=i; k++){
				for(l=0; l<=j; l++){
					stemp3=stemp3+minInt(sizeN[k], sizeN[l])*workcovA[k*lookorder+l];
				}
			}
			for(k=0; k<=i; k++){
				for(l=0; l<=j; l++){
					stemp4=stemp4+minInt(sizeN[k+maxlook], sizeN[l+maxlook])*workcovA[k*lookorder+l];
				}
			}

			for(k=0; k<=i; k++){
				stemp1=stemp1+sizeN[k]+sizeN[k+maxlook];
			}
			for(k=0; k<=j; k++){
				stemp2=stemp2+sizeN[k]+sizeN[k+maxlook];
			}

			StatCov[i*lookorder+j]=(stemp4+stemp3)/sqrt(1.0*(stemp2*stemp1));
			StatCov[j*lookorder+i]=(stemp4+stemp3)/sqrt(1.0*(stemp2*stemp1));

		}
	}

	for(i=0; i<lookorder; i++)
		StatVar[i]=StatCov[i*lookorder+i];
	// calculate the var and cov structure:


/*	cout<<"check of cov of Z before simul"<<endl;
	for(i=0; i<lookorder; i++){
		for(j=0; j<lookorder; j++){
			cout<<StatCov[i*lookorder+j]<<"\t";
		}
		cout<<endl;
	}
*/
	double *workNullA, *workAlterA;
	workNullA=new double[lookorder*simul];
	workAlterA=new double[lookorder*simul];

	workNullA=UNNormalSimul(lookorder, simul, StatMeanNull, StatVar, StatCov);
	workAlterA=UNNormalSimul(lookorder, simul, StatMeanAlter, StatVar, StatCov);

	// check of workNullA & workAlterA:
	// the check of workNullA and workAlterA:
	double *meanB1, *meanB2;
	double *varB1, *varB2;
	meanB1=new double[lookorder];
	meanB2=new double[lookorder];
	varB1=new double[lookorder];
	varB2=new double[lookorder];

	for(m=0; m<lookorder; m++){
		meanB1[m]=0;
		meanB2[m]=0;
		for(n=0; n<NormalEnd1->looksimul; n++){
			meanB1[m]=meanB1[m]+workNullA[n*lookorder+m];
			meanB2[m]=meanB2[m]+workAlterA[n*lookorder+m];
		}
		meanB1[m]=meanB1[m]/NormalEnd1->looksimul;
		meanB2[m]=meanB2[m]/NormalEnd1->looksimul;
	}

/*	cout<<"mean of Null and Alter of Z"<<endl;
	for(m=0; m<lookorder; m++)
		cout<<meanB1[m]<<"\t";
	cout<<endl;
	for(m=0; m<lookorder; m++)
		cout<<meanB2[m]<<"\t";
	cout<<endl;
*/
	for(m=0; m<lookorder; m++){
		varB1[m]=0;
		varB2[m]=0;
		for(n=0; n<NormalEnd1->looksimul; n++){
			varB1[m]=varB1[m]+(workNullA[n*lookorder+m]-meanB1[m])*(workNullA[n*lookorder+m]-meanB1[m]);
			varB2[m]=varB2[m]+(workAlterA[n*lookorder+m]-meanB2[m])*(workAlterA[n*lookorder+m]-meanB2[m]);
		}
		varB1[m]=varB1[m]/NormalEnd1->looksimul;
		varB2[m]=varB2[m]/NormalEnd1->looksimul;
	}
/*	cout<<"var of Null and Alter of Z"<<endl;
	for(m=0; m<lookorder; m++)
		cout<<varB1[m]<<"\t";
	cout<<endl;
	for(m=0; m<lookorder; m++)
		cout<<varB2[m]<<"\t";
	cout<<endl;
*/
	// calculation of boundary:
	boundary=new double[2*NormalEnd1->num_look];
	for(i=0; i<2*NormalEnd1->num_look; i++){
		boundary[i]=0;
	}

//	cout<<"The Boundary calculation for end"<<"\t"<<endnum<<endl;
	if(endnum==1){
		boundary=UNBound(lookorder, workNullA, workAlterA, NormalEnd1);
	}
	else if(endnum==2){
		boundary=UNBound(lookorder, workNullA, workAlterA, NormalEnd2);
	}

	return boundary;
}




double *TNZSimul(double *covsimul, int lookorder, int looksimul, int samplesize)
// covsimul[2*lookorder, 2*lookorder];
{
	int con1;
	int i, j, k, l, m, n;
	double *workarray;
	double *workNull, *workAlter;
	double *Zstat;
	double *mean, *var;	
	double *temp1, *temp2;

	workarray=new double[2*lookorder*samplesize];
	workNull=new double[lookorder*samplesize];
	workAlter=new double[lookorder*samplesize];
	Zstat=new double[2*looksimul*lookorder];
	mean=new double[2*lookorder];
	var=new double[2*lookorder];
	temp1=new double[lookorder];
	temp2=new double[lookorder];

	for(i=0; i<2*lookorder; i++){
		mean[i]=0;
		var[i]=covsimul[i*2*lookorder+i];
	}

	cout<<"before calculation of Z in TNZSimul"<<endl;

	for(i=0; i<looksimul; i++){
		workarray=UNNormalSimul(2*lookorder, samplesize, mean, var, covsimul);

		double *struc3;
		struc3=new double[2*2*lookorder+4*lookorder*lookorder];
		struc3=NormalCheck(2*lookorder, samplesize, workarray);

		for(j=0; j<samplesize; j++){
			for(k=0; k<lookorder; k++){
				workNull[j*lookorder+k]=workarray[j*2*lookorder+k];
				workAlter[j*lookorder+k]=workarray[j*2*lookorder+lookorder+k];
			}
		}

		for(j=0; j<lookorder; j++){
			temp1[j]=0;
			temp2[j]=0;
			for(k=0; k<samplesize; k++){
				for(l=0; l<=j; l++){
					temp1[j]=temp1[j]+workNull[k*lookorder+l];
					temp2[j]=temp2[j]+workAlter[k*lookorder+l];
				}
			}
			temp1[j]=temp1[j]/sqrt(samplesize*(j+1));
			temp2[j]=temp2[j]/sqrt(samplesize*(j+1));
		}

		for(j=0; j<lookorder; j++){
			Zstat[i*2*lookorder+j]=temp1[j];
			Zstat[i*2*lookorder+lookorder+j]=temp2[j];
		}
	}

	double *struc1;
	struc1=new double[2*2*lookorder+2*lookorder*2*lookorder];
	struc1=NormalCheck(2*lookorder, looksimul, Zstat);
	for(i=0; i<2+2*lookorder; i++){
		for(j=0; j<2*lookorder; j++){
			cout<<struc1[i*2*lookorder+j]<<"\t";
		}
		cout<<endl;
	}

	return Zstat;

}


// we calculate the structure of Z directly and then simulate:
double * TNZSimulA(double *covsimul, int lookorder, int looksimul, int samplesize)
{
	int i, j, k, l;
	int con1;
	double stemp1, stemp2, stemp3;
	int *Size1, *Size2;

	double *cov1, *cov2, *inter1, *inter2;
	double *Zcov1, *Zcov2;
	double *Zcross1, *Zcross2;
	double *Zcov;
	double *workarray;
	double *meanA, *varA;

	Size1=new int[lookorder];
	Size2=new int[lookorder];

	cov1=new double[lookorder*lookorder];
	cov2=new double[lookorder*lookorder];
	inter1=new double[lookorder*lookorder];
	inter2=new double[lookorder*lookorder];

	Zcov1=new double[lookorder*lookorder];
	Zcov2=new double[lookorder*lookorder];
	Zcross1=new double[lookorder*lookorder];
	Zcross2=new double[lookorder*lookorder];
	Zcov=new double[2*lookorder*2*lookorder];
	workarray=new double[2*lookorder*looksimul];

	meanA=new double[2*lookorder];
	varA=new double[2*lookorder];

	for(i=0; i<lookorder; i++){
		Size1[i]=NormalEnd1->sample_size;
		Size2[i]=NormalEnd1->sample_size;
	}

	//get cov from orginal covsimul:
	for(i=0; i<lookorder; i++){
		for(j=0; j<lookorder; j++){
			cov1[i*lookorder+j]=covsimul[i*2*lookorder+j];
			cov2[i*lookorder+j]=covsimul[(i+lookorder)*2*lookorder+lookorder+j];
			inter1[i*lookorder+j]=covsimul[i*2*lookorder+lookorder+j];
			inter2[i*lookorder+j]=covsimul[(i+lookorder)*2*lookorder+j];
		}
	}

	Zcov=TNCrossCovNew();	

	// simulate workarray:
	for(i=0; i<2*lookorder; i++){
		meanA[i]=0;
		varA[i]=Zcov[i*2*lookorder+i];
	}
	
	workarray=UNNormalSimul(2*lookorder, looksimul, meanA, varA, Zcov);

	// check workarray:
	double *struc4;
	struc4=new double[4*lookorder+2*lookorder*2*lookorder];
	struc4=NormalCheck(2*lookorder, looksimul, workarray);
	cout<<"Check of workarray structure in TNZSimul"<<endl;
	return workarray;
}














//
//	One Survival Case:
//
//  data is stored in dataS1, information in SurvivalEnd1.   
//  mainly copy from the NormalSurvivalDecision

void UniSurvivalDecision()
{
	int con1;
	cout<<"start of uni survival decision"<<endl;

	SurvivalEnd2=SurvivalEnd1;	// in case ....
	
	int MAXLOOK1;
	MAXLOOK1=10;

	int samplesize1, samplesize2;
	int num_look;
	int looksimul;
	int lookorder;

	samplesize1=SurvivalEnd1->sample_size1;
	samplesize2=SurvivalEnd1->sample_size2;
	num_look=SurvivalEnd1->num_look;
	looksimul=SurvivalEnd1->num_simul;
	lookorder=SurvivalEnd1->look_order;

	int column=6;
	int i, j, k, l, m, n;

	// now seperate the survival data:
	// we will only have send21 & send22 for the second endpoint:

	double *send21, *send22;
	send21=new double[column*(samplesize1+samplesize2)];	//control
	send22=new double[column*(samplesize1+samplesize2)];	//treatment

	int p1=0, p2=0, p3=0, p4=0;

	for(i=0; i<samplesize1+samplesize2; i++){
		if( (dataS1[i*column+0]==1) && (dataS1[i*column+1]==0) ){
			send21[p3*column+0]=dataS1[i*column+0];
			send21[p3*column+1]=dataS1[i*column+1];
			send21[p3*column+2]=dataS1[i*column+2];
			send21[p3*column+3]=dataS1[i*column+3];
			send21[p3*column+4]=dataS1[i*column+4];
			send21[p3*column+5]=dataS1[i*column+5];
			p3=p3+1;
		}	// control

		if( (dataS1[i*column+0]==1) && (dataS1[i*column+1]==1) ){
			send22[p4*column+0]=dataS1[i*column+0];
			send22[p4*column+1]=dataS1[i*column+1];
			send22[p4*column+2]=dataS1[i*column+2];
			send22[p4*column+3]=dataS1[i*column+3];
			send22[p4*column+4]=dataS1[i*column+4];
			send22[p4*column+5]=dataS1[i*column+5];
			p4=p4+1;
		}	// treatment

	}


	// correct so far

	double *looktime;
	looktime=new double[lookorder];
	for(i=0; i<lookorder; i++)
		looktime[i]=SurvivalEnd1->look_time[i];

	double *entry21, *entry22;
	double *event21, *event22;
	double *indicator21, *indicator22; 
	double *indentify21, *indentify22;
	// the one separate directly from data

	double *lookevent21, *lookevent22;
	double *looktime21, *looktime22;
	double *lookindicator21, *lookindicator22; 
	//after considering the different look time.

	entry21=new double[samplesize1];
	entry22=new double[samplesize2];

	event21=new double[samplesize1];
	event22=new double[samplesize2];

	indicator21=new double[samplesize1];
	indicator22=new double[samplesize2];

	indentify21=new double[samplesize1*lookorder];
	indentify22=new double[samplesize2*lookorder];

	lookevent21=new double[samplesize1];
	lookevent22=new double[samplesize2];

	looktime21=new double[samplesize1*lookorder];
	looktime22=new double[samplesize2*lookorder];

	lookindicator21=new double[samplesize1*lookorder];
	lookindicator22=new double[samplesize2*lookorder];

	//initialize entry event, and indicator
	for(i=0; i<samplesize1; i++){
		// control
		entry21[i]=send21[i*column+3];
		event21[i]=send21[i*column+4];
		indicator21[i]=send21[i*column+5];
		for(j=0; j<lookorder; j++){
			indentify21[i*lookorder+j]=send21[i*column+2];
		}
	}
	
	for(i=0; i<samplesize2; i++){
		// treatment
		entry22[i]=send22[i*column+3];
		event22[i]=send22[i*column+4];
		indicator22[i]=send22[i*column+5];
		for(j=0; j<lookorder; j++){
			indentify22[i*lookorder+j]=send22[i*column+2];
		}
	}


	// initialize lookevent, looktime and lookindicator:

	// control
	for(i=0; i<samplesize1; i++){
		lookevent21[i]=event21[i]-entry21[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry21[i] ){
				looktime21[i*lookorder+j]=-1;   //not entered yet
				lookindicator21[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry21[i]){
				if(looktime[j]>=event21[i]){		//enter. by the time of look, event happens
					looktime21[i*lookorder+j]=looktime[j]-entry21[i];
					lookindicator21[i*lookorder+j]=indicator21[i];
				}
				else if(looktime[j]<event21[i]){		//by the time of look, event not happen yet.
					looktime21[i*lookorder+j]=looktime[j]-entry21[i];
					lookindicator21[i*lookorder+j]=1;
				}
			}
		}
	}	

	// treatment
	for(i=0; i<samplesize2; i++){
		lookevent22[i]=event22[i]-entry22[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry22[i] ){
				looktime22[i*lookorder+j]=-1;   //not entered yet
				lookindicator22[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry22[i]){
				if(looktime[j]>=event22[i]){		//enter. by the time of look, event happens
					looktime22[i*lookorder+j]=looktime[j]-entry22[i];
					lookindicator22[i*lookorder+j]=indicator22[i];
				}
				else if(looktime[j]<event22[i]){		//by the time of look, event not happen yet.
					looktime22[i*lookorder+j]=looktime[j]-entry22[i];
					lookindicator22[i*lookorder+j]=1;
				}
			}
		}
	}	


	// sort each one according to lookevent
	double *sort3, *sort4;
	sort3=new double[(1+3*lookorder)*samplesize1]; //end21
	sort4=new double[(1+3*lookorder)*samplesize2]; //end22
	sort3=SortNSCov(samplesize1, lookorder, lookevent21, looktime21, lookindicator21, indentify21);
	sort4=SortNSCov(samplesize2, lookorder, lookevent22, looktime22, lookindicator22, indentify22);


	// Re-separate lookevent, looktime, lookindicator & indentify:

	// control
	for(i=0; i<samplesize1; i++){
		lookevent21[i]=sort3[i*(1+3*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime21[i*lookorder+j]=sort3[i*(1+3*lookorder)+j+1];
			lookindicator21[i*lookorder+j]=sort3[i*(1+3*lookorder)+j+1+lookorder];
			indentify21[i*lookorder+j]=sort3[i*(1+3*lookorder)+j+1+lookorder*2];
		}
	}
	// treat
	for(i=0; i<samplesize2; i++){
		lookevent22[i]=sort4[i*(1+3*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime22[i*lookorder+j]=sort4[i*(1+3*lookorder)+j+1];
			lookindicator22[i*lookorder+j]=sort4[i*(1+3*lookorder)+j+1+lookorder];
			indentify22[i*lookorder+j]=sort4[i*(1+3*lookorder)+j+1+lookorder*2];
		}
	}

	// now calculate nhat, yhat and time of change
	double *nhat21, *nhat22;
	double *yhat21, *yhat22;
	double *ctime21, *ctime22;
	int *IDhat21, *IDhat22;

	nhat21=new double[samplesize1*lookorder];
	nhat22=new double[samplesize2*lookorder];

	yhat21=new double[samplesize1*lookorder];
	yhat22=new double[samplesize2*lookorder];

	ctime21=new double[samplesize1*lookorder];
	ctime22=new double[samplesize2*lookorder];

	IDhat21=new int[samplesize1*lookorder];
	IDhat22=new int[samplesize2*lookorder];

	// sort looktime and lookindicator to calculate yhat, nhat and ctime:

	double *tltime, *tlindicator, *tlID;
	double *tlsort1;
	int length1;
	
	int tdead, tcount;

	tltime=new double[max(samplesize1, samplesize2)];
	tlindicator=new double[max(samplesize1, samplesize2)];
	tlID=new double[max(samplesize1, samplesize2)];
	tlsort1=new double[3*max(samplesize1, samplesize2)];


	// control:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize1; j++){
			if( looktime21[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime21[j*lookorder+i];
				tlindicator[length1]=lookindicator21[j*lookorder+i];
				tlID[length1]=indentify21[j*lookorder+i];
				length1=length1+1;
			}
		}
		
		// sort with respect to tltime (looktime):
		tlsort1=NSSort1(length1, samplesize1, tltime, tlindicator, tlID);

		// then separate:
		for(j=0; j<samplesize1; j++){
			tltime[j]=tlsort1[j*3+0];
			tlindicator[j]=tlsort1[j*3+1];
			tlID[j]=tlsort1[j*3+2];
		}

		// count nhat21(dead), yhat21(at risk), and ctime11
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat21[j*lookorder+i]=tdead;
				yhat21[j*lookorder+i]=samplesize1-tcount;
				ctime21[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat21[j*lookorder+i]=tdead;
				yhat21[j*lookorder+i]=samplesize1-tcount;
				ctime21[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize1; j++){
			nhat21[j*lookorder+i]=nhat21[(j-1)*lookorder+i];
			yhat21[j*lookorder+i]=yhat21[(j-1)*lookorder+i];
			ctime21[j*lookorder+i]=-1;	// those not entered yet
		}

		for(j=0; j<length1; j++)
			IDhat21[j*lookorder+i]=tlID[j];
		for(j=length1; j<samplesize1; j++)
			IDhat21[j*lookorder+i]=-1;
	}


	// treatment:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize2; j++){
			if( looktime22[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime22[j*lookorder+i];
				tlindicator[length1]=lookindicator22[j*lookorder+i];
				tlID[length1]=indentify22[j*lookorder+i];
				length1=length1+1;
			}
		}
		
		// sort with respect to tltime (looktime):
		tlsort1=NSSort1(length1, samplesize2, tltime, tlindicator, tlID);
		// then separate:
		for(j=0; j<samplesize2; j++){
			tltime[j]=tlsort1[j*3+0];
			tlindicator[j]=tlsort1[j*3+1];
			tlID[j]=tlsort1[j*3+2];
		}

		// count nhat22(dead), yhat22(at risk), and ctime22
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat22[j*lookorder+i]=tdead;
				yhat22[j*lookorder+i]=samplesize2-tcount;
				ctime22[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat22[j*lookorder+i]=tdead;
				yhat22[j*lookorder+i]=samplesize2-tcount;
				ctime22[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize2; j++){
			nhat22[j*lookorder+i]=nhat22[(j-1)*lookorder+i];
			yhat22[j*lookorder+i]=yhat22[(j-1)*lookorder+i];
			ctime22[j*lookorder+i]=-1;	// those not entered yet
		}
		
		for(j=0; j<length1; j++)
			IDhat22[j*lookorder+i]=tlID[j];
		for(j=length1; j<samplesize2; j++)
			IDhat22[j*lookorder+i]=tlID[j];
	}


	int *ID21, *ID22;	// the converted to integer version
	ID21=new int[samplesize1*lookorder];
	ID22=new int[samplesize2*lookorder];

	for(i=0; i<samplesize1; i++){
		for(j=0; j<lookorder; j++){
			ID21[i*lookorder+j]=(int) indentify21[i*lookorder+j];
		}
	}

	for(i=0; i<samplesize2; i++){
		for(j=0; j<lookorder; j++){
			ID22[i*lookorder+j]=(int) indentify22[i*lookorder+j];
		}
	}

	
	// now calculate uhat DIRECTLY:
	double *uhat21, *uhat22;

	uhat21=new double[samplesize1*lookorder];
	uhat22=new double[samplesize2*lookorder];

	for(i=0; i<samplesize1*lookorder; i++){
		uhat21[i]=0;
	}
	for(i=0; i<samplesize2*lookorder; i++){
		uhat22[i]=0;
	}

	double deltaM;


	// in the order version, the calculation of deltaM is correct
	// the problem is in the calculation of yhat12


	double tyhat21, tyhat22;
	double timepoint;

	//  control:
	for(i=0; i<lookorder; i++){
		for(j=0; j<samplesize1; j++){
			if(ctime21[j*lookorder+i]!=-1){	// if has entered

				if(j==0){
					if( lookindicator21[j*lookorder+i]==0){		//event
						deltaM=1-nhat21[0*lookorder+i]/yhat21[0*lookorder+i];
					}
					else if( lookindicator21[j*lookorder+i]!=0){	//censor
						deltaM=-nhat21[0*lookorder+i]/yhat21[0*lookorder+i];
					}
					tyhat21=yhat21[j*lookorder+i];

					//find tyhat22:
					timepoint=ctime21[j*lookorder+i];
					l=0;
					while(ctime22[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat22=samplesize2;
					if(l!=0)
						tyhat22=yhat22[(l-1)*lookorder+i];
					
					uhat21[j*lookorder+i]=uhat21[j*lookorder+i]+deltaM*(1-(tyhat21)/(tyhat21+tyhat22));

				}
				
				if(j!=0){
					// calculate those before
					for(k=0; k<j-1; k++){
						if(k==0){
							deltaM=-nhat21[0*lookorder+i]/yhat21[0*lookorder+i];
						}
						if(k!=0){
							deltaM=-(nhat21[k*lookorder+i]-nhat21[(k-1)*lookorder+i])/yhat21[k*lookorder+i];
						}

						tyhat21=yhat21[k*lookorder+i];
						// find tyhat22:
						timepoint=ctime21[k*lookorder+i];
						l=0;
						while(ctime22[l*lookorder+i] <timepoint)
							l=l+1;
						if(l==0)
							tyhat22=samplesize2;
						if(l!=0)
							tyhat22=yhat22[(l-1)*lookorder+i];

						uhat21[j*lookorder+i]=uhat21[j*lookorder+i]+(1-(tyhat21)/(tyhat21+tyhat22))*deltaM;
					}

					// calculate its own
					if( lookindicator21[j*lookorder+i]==0 ) {   //event
						deltaM=1-(nhat21[j*lookorder+i]-nhat21[(j-1)*lookorder+i])/yhat21[j*lookorder+i];
					}
					else if ( lookindicator21[j*lookorder+i]!=0 ) {
						deltaM=-(nhat21[j*lookorder+i]-nhat21[(j-1)*lookorder+i])/yhat21[j*lookorder+i];
					}
					
					tyhat21=yhat21[j*lookorder+i];
					//find tyhat22:
					timepoint=ctime21[j*lookorder+i];
					l=0;
					while(ctime22[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat22=samplesize2;
					if(l!=0)
						tyhat22=yhat22[(l-1)*lookorder+i];

					uhat21[j*lookorder+i]=uhat21[j*lookorder+i]+(1-(tyhat21)/(tyhat21+tyhat22))*deltaM;
				}
			}
		}
	}

	//  treatment:
	for(i=0; i<lookorder; i++){
		for(j=0; j<samplesize2; j++){
			if(ctime22[j*lookorder+i]!=-1){	// if has entered

				if(j==0){
					if( lookindicator22[j*lookorder+i]==0 ){   //event
						deltaM=1-nhat22[0*lookorder+i]/yhat22[0*lookorder+i];
					}
					if( lookindicator22[j*lookorder+i]!=0 ){   //censor
						deltaM=-nhat22[0*lookorder+i]/yhat22[0*lookorder+i];
					}
					tyhat22=yhat22[j*lookorder+i];

					//find tyhat21:
					timepoint=ctime22[j*lookorder+i];
					l=0;
					while(ctime21[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat21=samplesize1;
					if(l!=0)
						tyhat21=yhat21[(l-1)*lookorder+i];
					
					uhat22[j*lookorder+i]=uhat22[j*lookorder+i]+deltaM*(1-(tyhat22)/(tyhat21+tyhat22));

				}
				
				if(j!=0){
					// calculate those before
					for(k=0; k<j-1; k++){
						if(k==0){
							deltaM=-nhat22[0*lookorder+i]/yhat22[0*lookorder+i];
						}
						if(k!=0){
							deltaM=-(nhat22[k*lookorder+i]-nhat22[(k-1)*lookorder+i])/yhat22[k*lookorder+i];
						}

						tyhat22=yhat22[k*lookorder+i];
						// find tyhat21:
						timepoint=ctime22[k*lookorder+i];
						l=0;
						while(ctime21[l*lookorder+i] <timepoint)
							l=l+1;
						if(l==0)
							tyhat21=samplesize1;
						if(l!=0)
							tyhat21=yhat21[(l-1)*lookorder+i];

						uhat22[j*lookorder+i]=uhat22[j*lookorder+i]+(1-(tyhat22)/(tyhat21+tyhat22))*deltaM;
					}

					// calculate its own
					if( lookindicator22[j*lookorder+i]==0 ){   //event
						deltaM=1-(nhat22[j*lookorder+i]-nhat22[(j-1)*lookorder+i])/yhat22[j*lookorder+i];
					}
					else if( lookindicator22[j*lookorder+i]!=0 ){   //censor
						deltaM=-(nhat22[j*lookorder+i]-nhat22[(j-1)*lookorder+i])/yhat22[j*lookorder+i];
					}
					
					tyhat22=yhat22[j*lookorder+i];
					//find tyhat21:
					timepoint=ctime22[j*lookorder+i];
					l=0;
					while(ctime21[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat21=samplesize1;
					if(l!=0)
						tyhat21=yhat21[(l-1)*lookorder+i];

					uhat22[j*lookorder+i]=uhat22[j*lookorder+i]+(1-(tyhat22)/(tyhat21+tyhat22))*deltaM;
				}
			}
		}
	}


	// seems to be reasonable August 19th 9:20AM
	int *sizecontrol, *sizetreat;	// the sample size at each look.
	sizecontrol=new int[lookorder];
	sizetreat=new int[lookorder];

	for(i=0; i<lookorder; i++){
		sizecontrol[i]=0;
		sizetreat[i]=0;
	}

	for(i=0; i<lookorder; i++){
		//control:
		for(j=0; j<samplesize1; j++){
			if(ctime21[j*lookorder+i]!=-1)
				sizecontrol[i]=sizecontrol[i]+1;
		}
		//treat
		for(j=0; j<samplesize2; j++){
			if(ctime22[j*lookorder+i]!=-1)
				sizetreat[i]=sizetreat[i]+1;
		}
	}
	

	// calculation of the omega hat:
	double *omegahat;
	int j1, j2, i1, i2;
	double temp1, temp2;
	omegahat=new double[lookorder*lookorder];
	double *omegacheck;
	omegacheck=new double[lookorder*lookorder];

	// now only the first block left:

	// block 4:
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			temp1=0;
			temp2=0;
			for(i1=0; i1<samplesize1; i1++){
				temp1=temp1+uhat21[i1*lookorder+j1]*uhat21[i1*lookorder+j2];
			}
			for(i2=0; i2<samplesize2; i2++){
				temp2=temp2+uhat22[i2*lookorder+j1]*uhat22[i2*lookorder+j2];
			}
			omegahat[j1*lookorder+j2]=(temp1+temp2)/(samplesize1+samplesize2);
		}
	}

	for(i=0; i<lookorder; i++)
		for(j=0; j<lookorder; j++)
			omegacheck[i*lookorder+j]=omegahat[i*lookorder+j]/sqrt(omegahat[i*lookorder+i]*omegahat[j*lookorder+j]);

	double *sqrtomega;
	sqrtomega=new double[lookorder*lookorder];
	sqrtomega=sqrt_matrix(lookorder, omegacheck);

	cout<<"The square root of omegacheck"<<endl;
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			cout<<sqrtomega[j1*lookorder+j2]<<"\t";
		}
		cout<<endl;
	}

	

//	the following is copied from the code of two survival.


	double *overCov;
	overCov=new double[lookorder*lookorder];

	for(i=0; i<lookorder*lookorder; i++)
		overCov[i]=omegahat[i];

	double * overCovA;
	overCovA=new double[lookorder*lookorder];

	for(i=0; i<lookorder; i++){ 
		for(j=0; j<lookorder; j++){  
			overCovA[i*lookorder+j]=overCov[i*lookorder+j]/sqrt(overCov[i*lookorder+i]*overCov[j*lookorder+j]);
		}
	}


	double *overArray;
	overArray=new double[lookorder*looksimul];
	
	double *meanA1, *varA1;
	meanA1=new double[lookorder];
	varA1=new double[lookorder];

	for(i=0; i<lookorder; i++){
		meanA1[i]=0;
		varA1[i]=overCovA[i*lookorder+i];
	}

	overArray=UNNormalSimul(lookorder, looksimul, meanA1, varA1, overCovA);
	

	double *meanend2;
	meanend2=new double[lookorder];
	
	//need to calculate the mean for each end at each look.
	for(i=0; i<lookorder; i++){
		con1=0;
		for(j=0; j<=i; j++)
			con1=con1+sizetreat[j];

		meanend2[i]=(sqrt(samplesize1+samplesize2))*absd(log(SurvivalEnd2->lambdaAlter/SurvivalEnd2->lambdaNull))*sqrt(overCov[i*lookorder+i]);
	}



	cout<<"check of mean"<<endl;
	for(i=0; i<lookorder; i++)
		cout<<meanend2[i]<<"\t";
	cout<<endl;




	// Separate nend11, nend12
	double *nend11, *nend12;
	nend11=new double[looksimul*lookorder];
	nend12=new double[looksimul*lookorder];

	for(i=0; i<looksimul; i++){
		for(j=0; j<lookorder; j++){
			nend11[i*lookorder+j]=overArray[i*lookorder+j];	// control
			nend12[i*lookorder+j]=overArray[i*lookorder+j]+meanend2[j];	// treat
		}
	}






	// calculation of mariginal critical boundary:
	double *boundary1; 
	boundary1=new double[2*lookorder];


	// create two quasi TrialEndNormal Type for the calculation of UNBound:
	TrialEndNormal *Tend2;
	Tend2=new TrialEndNormal;

	Tend2->order=1;
	Tend2->num_look=num_look;
	Tend2->look_order=lookorder;
	Tend2->looksimul=looksimul;
	Tend2->sample_size=samplesize1+samplesize2;
	Tend2->spending_number=SurvivalEnd2->alphaSpend;
	Tend2->meanNull=0;
	Tend2->meanAlter=absd(log(SurvivalEnd2->lambdaAlter/SurvivalEnd2->lambdaNull));
	Tend2->Bi_Alpha=SurvivalEnd2->global_alpha;
	Tend2->Bi_Beta=SurvivalEnd2->global_beta;
	Tend2->overall_alpha=SurvivalEnd2->alpha;
	Tend2->overall_beta=SurvivalEnd2->beta;
	

	for(i=0; i<num_look; i++){
		Tend2->inform_time[i]=SurvivalEnd2->inform_time[i];
		Tend2->alpha[i]=SurvivalEnd2->alpha_spending[i];
		Tend2->beta[i]=SurvivalEnd2->beta_spending[i];

	}


	OutNormal(Tend2);


	boundary1=UNBound(lookorder, nend11, nend12, Tend2);
	

	// check of boundary 1 and boundary2:
	cout<<"Boundary for end 1:"<<endl;
	for(i=0; i<2*lookorder; i++)
		cout<<boundary1[i]<<"\t";
	cout<<endl;

	double *lowerA1, *upperA1;
	lowerA1=new double[SurvivalEnd1->num_look];
	upperA1=new double[SurvivalEnd1->num_look];

	for(i=0; i<SurvivalEnd1->num_look; i++){
		lowerA1[i]=0;
		upperA1[i]=0;
	}

	for(i=0; i<SurvivalEnd1->look_order; i++){
		lowerA1[i]=boundary1[2*i];
		upperA1[i]=boundary1[2*i+1];
	}

	//repair the boundary:
	i=0;
	while(upperA1[i]>lowerA1[i])
		i=i+1;
	lowerA1[i]=upperA1[i];
	for(j=i; j<lookorder; j++){
		upperA1[j]=upperA1[i];
		lowerA1[j]=lowerA1[i];
	}


	cout<<"check the Marginal bound after repair before searching c"<<endl;
	cout<<"lower 1"<<"\t";
	for(i=0; i<lookorder; i++)
		cout<<lowerA1[i]<<"\t";
	cout<<endl;
	cout<<"upper 1"<<"\t";
	for(i=0; i<lookorder; i++)
		cout<<upperA1[i]<<"\t";
	cout<<endl;

	
	for(i=0; i<lookorder; i++){
		SurvivalEnd1->UpperAdjust[i]=upperA1[i];
		SurvivalEnd1->LowerAdjust[i]=lowerA1[i];
		SurvivalEnd1->upperbound[i]=upperA1[i];
		SurvivalEnd1->lowerbound[i]=lowerA1[i];
	}


	//test statistics calculation:	

	double *temp_stat2;
	double *temp_send11;
	double *temp_send12;
	temp_stat2=new double[2*lookorder];
	temp_send11=new double[column*(samplesize1+samplesize2)];
	temp_send12=new double[column*(samplesize1+samplesize2)];

	for(i=0; i<column*(samplesize1+samplesize2); i++){
		temp_send11[i]=send21[i];
		temp_send12[i]=send22[i];
	}
	
	temp_stat2=LogRank3(lookorder, num_look, samplesize1, samplesize2, column, temp_send11, temp_send12, send21, send22, looktime);
	
	cout<<"teststatistics"<<endl;
	for(i=0; i<2*lookorder; i++){
		cout<<temp_stat2[i]<<"\t";
	}
	cout<<endl;
	for(i=0; i<lookorder; i++){
		SurvivalEnd1->testZ[i]=temp_stat2[i];
	}

}
















//
//	two Survival Case:
//

void TwoSurvivalDecision()
{
	int column=6;
	int con1;
	int i, j, k, l;

	// The first step is to separate data into four big array:
	double *send11, *send12, *send21, *send22;
	send11=new double[column*(SurvivalEnd1->sample_size1+SurvivalEnd1->sample_size2)];	//end1 control
	send12=new double[column*(SurvivalEnd1->sample_size1+SurvivalEnd1->sample_size2)];	//end1 treatment
	send21=new double[column*(SurvivalEnd1->sample_size1+SurvivalEnd1->sample_size2)];	//end1 control
	send22=new double[column*(SurvivalEnd1->sample_size1+SurvivalEnd1->sample_size2)];	//end1 treatment

	int p1=0, p2=0, p3=0, p4=0;
	for(i=0; i<SurvivalEnd1->sample_size1+SurvivalEnd1->sample_size2; i++){

		if( (dataS1[i*column+0]==1) && (dataS1[i*column+1]==0) ){
			send11[p1*column+0]=dataS1[i*column+0];
			send11[p1*column+1]=dataS1[i*column+1];
			send11[p1*column+2]=dataS1[i*column+2];
			send11[p1*column+3]=dataS1[i*column+3];
			send11[p1*column+4]=dataS1[i*column+4];
			send11[p1*column+5]=dataS1[i*column+5];
			p1=p1+1;
		}	// end1 control
		if( (dataS1[i*column+0]==1) && (dataS1[i*column+1]==1) ){
			send12[p2*column+0]=dataS1[i*column+0];
			send12[p2*column+1]=dataS1[i*column+1];
			send12[p2*column+2]=dataS1[i*column+2];
			send12[p2*column+3]=dataS1[i*column+3];
			send12[p2*column+4]=dataS1[i*column+4];
			send12[p2*column+5]=dataS1[i*column+5];
			p2=p2+1;
		}	// end1 treatment
	}


	for(i=0; i<SurvivalEnd1->sample_size1+SurvivalEnd1->sample_size2; i++){
		if( (dataS2[i*column+0]==2) && (dataS2[i*column+1]==0) ){
			send21[p3*column+0]=dataS2[i*column+0];
			send21[p3*column+1]=dataS2[i*column+1];
			send21[p3*column+2]=dataS2[i*column+2];
			send21[p3*column+3]=dataS2[i*column+3];
			send21[p3*column+4]=dataS2[i*column+4];
			send21[p3*column+5]=dataS2[i*column+5];
			p3=p3+1;
		}	// end2 control

		if( (dataS2[i*column+0]==2) && (dataS2[i*column+1]==1) ){
			send22[p4*column+0]=dataS2[i*column+0];
			send22[p4*column+1]=dataS2[i*column+1];
			send22[p4*column+2]=dataS2[i*column+2];
			send22[p4*column+3]=dataS2[i*column+3];
			send22[p4*column+4]=dataS2[i*column+4];
			send22[p4*column+5]=dataS2[i*column+5];
			p4=p4+1;
		}	// end2 treatment

	}


	int samplesize1=SurvivalEnd1->sample_size1;
	int samplesize2=SurvivalEnd1->sample_size2;
	int num_look=SurvivalEnd1->num_look;
	int lookorder=SurvivalEnd1->look_order;
	int num_simul=SurvivalEnd1->num_simul;

	int looksimul=num_simul/num_look;



	//the check procedure of above inputs:
	cout<<"samplesize1"<<"\t"<<samplesize1<<endl;
	cout<<"samplesize2"<<"\t"<<samplesize2<<endl;
//	cout<<"looksimul"<<"\t"<<looksimul<<endl;

	// generate the Normal array to be calculated for bound
	// the data structure:
	//				end1							end2
	//	control				treat	||| 	control				treat
	//  look1, look2....
	double *overCov;
	overCov=new double[2*lookorder*2*lookorder];

	double *looktime;
	looktime=new double[lookorder];
	for(i=0; i<lookorder; i++){
		looktime[i]=SurvivalEnd1->look_time[i];
		cout<<looktime[i]<<"\t";
	}

	overCov=TSCov(lookorder, num_look, samplesize1, samplesize2, column, send11, send12, send21, send22, looktime);

    cout<<"ss 1 check"<<endl;
	double * overCovA;
	overCovA=new double[2*lookorder*2*lookorder];

	for(i=0; i<lookorder; i++){ 
		for(j=0; j<lookorder; j++){  
			overCovA[i*2*lookorder+j]=overCov[i*2*lookorder+j]/sqrt(overCov[i*2*lookorder+i]*overCov[j*2*lookorder+j]);
			overCovA[(i+lookorder)*2*lookorder+j]=overCov[(i+lookorder)*2*lookorder+j]/sqrt(overCov[j*2*lookorder+j]*overCov[(i+lookorder)*2*lookorder+lookorder+i]);
			overCovA[i*2*lookorder+j+lookorder]=overCov[i*2*lookorder+j+lookorder]/sqrt(overCov[i*2*lookorder+i]*overCov[(j+lookorder)*2*lookorder+lookorder+j]);
			overCovA[(i+lookorder)*2*lookorder+j+lookorder]=overCov[(i+lookorder)*2*lookorder+j+lookorder]/sqrt(overCov[(i+lookorder)*2*lookorder+i+lookorder]*overCov[(j+lookorder)*2*lookorder+lookorder+j]);
		}
	}

	double *tempAA;
	tempAA=new double[2*lookorder*2*lookorder];
	tempAA=sqrt_matrix(2*lookorder, overCovA);


	double *overArray;
	overArray=new double[2*lookorder*looksimul];
	
	double *meanA1, *varA1;
	meanA1=new double[2*lookorder];
	varA1=new double[2*lookorder];

	for(i=0; i<2*lookorder; i++){
		meanA1[i]=0;
		varA1[i]=overCovA[i*2*lookorder+i];
	}

	overArray=UNNormalSimul(2*lookorder, looksimul, meanA1, varA1, overCovA);
	
	// the check procedure of overArray.
//	cout<<"The check procedure of overArray"<<endl;
	double *checkstructure1;
	int sizec1=2*lookorder;
	int sizec2=looksimul;
	checkstructure1=new double[sizec1*(2+sizec1)];
	checkstructure1=NormalCheck(sizec1, sizec2, overArray);

	double *meanend1, *meanend2;
	meanend1=new double[lookorder];
	meanend2=new double[lookorder];

	for(i=0; i<lookorder; i++){
		meanend1[i]=(sqrt(samplesize1+samplesize2))*absd(log(SurvivalEnd1->lambdaAlter/SurvivalEnd1->lambdaNull))*sqrt(overCov[i*2*lookorder+i]);
		meanend2[i]=(sqrt(samplesize1+samplesize2))*absd(log(SurvivalEnd2->lambdaAlter/SurvivalEnd2->lambdaNull))*sqrt(overCov[(i+lookorder)*2*lookorder+i+lookorder]);
	}


	// Separate nend11, nend12, nend21, nend22:
	double *nend11, *nend12, *nend21, *nend22;
	nend11=new double[looksimul*lookorder];
	nend12=new double[looksimul*lookorder];
	nend21=new double[looksimul*lookorder];
	nend22=new double[looksimul*lookorder];

	for(i=0; i<looksimul; i++){
		for(j=0; j<lookorder; j++){
			nend11[i*lookorder+j]=overArray[i*2*lookorder+j];	//end 1 control
			nend12[i*lookorder+j]=overArray[i*2*lookorder+j]+meanend1[j];	//end1 treat
			nend21[i*lookorder+j]=overArray[i*2*lookorder+lookorder+j];		//end2 control
			nend22[i*lookorder+j]=overArray[i*2*lookorder+lookorder+j]+meanend2[j];	//end2 treat
		}
	}

	// calculation of mariginal critical boundary:
	double *boundary1, *boundary2;
	boundary1=new double[2*lookorder];
	boundary2=new double[2*lookorder];


	cout<<"before the calculation of marginal critical boundary"<<endl;
	// create two quasi TrialEndNormal Type for the calculation of UNBound:
	TrialEndNormal *Tend1, *Tend2;
	Tend1=new TrialEndNormal;
	Tend2=new TrialEndNormal;


	Tend1->order=1;
	Tend1->num_look=num_look;
	Tend1->look_order=lookorder;
	Tend1->looksimul=looksimul;
	Tend1->sample_size=samplesize1+samplesize2;
	Tend1->spending_number=SurvivalEnd1->alphaSpend;
	Tend1->meanNull=0;
	Tend1->meanAlter=absd(log(SurvivalEnd1->lambdaAlter/SurvivalEnd1->lambdaNull));
	Tend1->Bi_Alpha=SurvivalEnd1->global_alpha;
	Tend1->Bi_Beta=SurvivalEnd1->global_beta;
	Tend1->overall_alpha=SurvivalEnd1->alpha;
	Tend1->overall_beta=SurvivalEnd1->beta;
	
	Tend2->order=2;
	Tend2->num_look=num_look;
	Tend2->look_order=lookorder;
	Tend2->looksimul=looksimul;
	Tend2->sample_size=samplesize1+samplesize2;
	Tend2->spending_number=SurvivalEnd2->alphaSpend;
	Tend2->meanNull=0;
	Tend2->meanAlter=absd(log(SurvivalEnd2->lambdaAlter/SurvivalEnd2->lambdaNull));
	Tend2->Bi_Alpha=SurvivalEnd2->global_alpha;
	Tend2->Bi_Beta=SurvivalEnd2->global_beta;
	Tend2->overall_alpha=SurvivalEnd2->alpha;
	Tend2->overall_beta=SurvivalEnd2->beta;
	

	for(i=0; i<num_look; i++){
		Tend1->inform_time[i]=SurvivalEnd1->inform_time[i];
		Tend2->inform_time[i]=SurvivalEnd2->inform_time[i];

		Tend1->alpha[i]=SurvivalEnd1->alpha_spending[i];
		Tend1->beta[i]=SurvivalEnd1->beta_spending[i];
		Tend2->alpha[i]=SurvivalEnd2->alpha_spending[i];
		Tend2->beta[i]=SurvivalEnd2->beta_spending[i];

	}

	boundary1=UNBound(lookorder, nend11, nend12, Tend1);
	boundary2=UNBound(lookorder, nend21, nend22, Tend2);
	

	cout<<"start the search for constant C"<<endl;

	// neccessary definition needed


	int decisiontype;		//hard versus soft.
	decisiontype=SurvivalEnd1->rule_decision;
	
	double *BiAlpha;
	BiAlpha=new double[SurvivalEnd1->num_look];
	for(i=0; i<SurvivalEnd1->num_look; i++)
		BiAlpha[i]=SurvivalEnd1->BiAlphaSpending[i];


	double *work1, *work2;
	work1=new double[looksimul];
	work2=new double[looksimul];

	// since only alpha is invloved, we only need the distribution under the Null,
	// however, since we may need to report the beta spending eventually, we also
	// get the Alternative distribution for future use.

	int search_length=1000;
	int n, m;
	double *c_search;
	c_search=new double[search_length];

	double c_lower=0.01;
	double c_upper=10.0;
	double c_mid;
	double c_range=c_upper-c_lower;
	double alphawork=0;
	double countt=0;	
	double minalphawork=1.0;

	int nn;
	int lengthlook;
	int indi;
	
	
	double *upper1, *lower1, *upper2, *lower2;
	double *adjustupper1, *adjustlower1, *adjustupper2, *adjustlower2;
	
	upper1=new double[lookorder];
	lower1=new double[lookorder];
	upper2=new double[lookorder];
	lower2=new double[lookorder];
	adjustupper1=new double[lookorder];
	adjustlower1=new double[lookorder];
	adjustupper2=new double[lookorder];
	adjustlower2=new double[lookorder];

	for(i=0; i<lookorder; i++){
		lower1[i]=boundary1[2*i];
		upper1[i]=boundary1[2*i+1];
		lower2[i]=boundary2[2*i];
		upper2[i]=boundary2[2*i+1];
	}

	//repair the boundary:
	i=0;
	while(upper1[i]>lower1[i])
		i=i+1;
	lower1[i]=upper1[i];
	for(j=i; j<lookorder; j++){
		upper1[j]=upper1[i];
		lower1[j]=lower1[i];
	}

	i=0;
	while(upper2[i]>lower2[i])
		i=i+1;
	lower2[i]=upper2[i];
	for(j=i; j<lookorder; j++){
		upper2[j]=upper2[i];
		lower2[j]=lower2[i];
	}


	// the search for constant c:
	//mainly copy from the Normal case.		7/6/2002 3:22PM.


	// in case of hard decision:

	// initialize work:
	for(i=0; i<looksimul; i++){
		work1[i]=absd(nend11[i*lookorder+0]);
		work2[i]=absd(nend21[i*lookorder|0]);
	}

	if(decisiontype==1) {
		for(n=0; n<search_length; n++){	
			// Initialize c_search:
			c_search[n]=c_lower+n*c_range/search_length;

			countt=0;
			adjustupper1[0]=upper1[0]*c_search[n];
			adjustlower1[0]=lower1[0]*c_search[n];
			adjustupper2[0]=upper2[0]*c_search[n];
			adjustlower2[0]=lower2[0]*c_search[n];

			for(m=0; m<looksimul; m++){
				if( (work1[m]>adjustupper1[0]) && (work2[m]>adjustupper2[0]) )
					countt=countt+1;	// H++ H+- H-+ H--
				else if( (work1[m]>adjustupper1[0]) && (work2[m]<adjustlower2[0]) )
					countt=countt+1;	// H+0 H-0
				else if( (work1[m]<adjustlower1[0]) && (work2[m]>adjustupper2[0]) )
					countt=countt+1;	// H0+ H0-
			}

			alphawork=countt/looksimul;

			if( minalphawork > absd(alphawork-BiAlpha[0]) ){
				c_mid=c_search[n];
				minalphawork=absd(alphawork-BiAlpha[0]);
			}
		}
	
		adjustupper1[0]=upper1[0]*c_mid;
		adjustlower1[0]=lower1[0]*c_mid;
		adjustupper2[0]=upper2[0]*c_mid;
		adjustlower2[0]=lower2[0]*c_mid;
	

		// now we search the const c for the rest of looks:
		for(i=1; i<lookorder; i++){
			minalphawork=1;
			lengthlook=0;
			for(j=0; j<looksimul; j++){
				indi=0;
			
				for(m=0; m<i; m++){
					if( indi!=1) {
						if( absd(nend11[j*lookorder+m])>adjustupper1[m] && absd(nend21[j*lookorder+m])>adjustupper2[m])
							indi=1;		
						else if( absd(nend11[j*lookorder+m])>adjustupper1[m] && absd(nend21[j*lookorder+m])<adjustlower2[m])
							indi=1;
						else if( absd(nend11[j*lookorder+m])<adjustlower1[m] && absd(nend21[j*lookorder+m])>adjustupper2[m])
							indi=1;
					}
				}

				if(indi==0){
					work1[lengthlook]=absd(nend11[j*lookorder+i]);
					work2[lengthlook]=absd(nend21[j*lookorder+i]);
					lengthlook=lengthlook+1;
				}
			}

			for(n=0; n<search_length; n++){	
			// Initialize c_search:
				c_search[n]=c_lower+n*c_range/search_length;

				countt=0;
				adjustupper1[i]=upper1[i]*c_search[n];
				adjustlower1[i]=lower1[i]*c_search[n];
				adjustupper2[i]=upper2[i]*c_search[n];
				adjustlower2[i]=lower2[i]*c_search[n];
		
				for(nn=0; nn<lengthlook; nn++){
					if( (work1[nn]>adjustupper1[i]) && (work2[nn]>adjustupper2[i]) )
						countt=countt+1;
					else if( (work1[nn]<adjustlower1[i]) && (work2[nn]>adjustupper2[i]) )
						countt=countt+1;
					else if( (work1[nn]>adjustupper1[i]) && (work2[nn]<adjustlower2[i]) )
						countt=countt+1;
				}

				alphawork=countt/lengthlook;

				if( minalphawork > absd(alphawork-BiAlpha[i]) ){
					c_mid=c_search[n];
					minalphawork=absd(alphawork-BiAlpha[i]);
				}
			}

//			cout<<"search of c end for look"<<"\t"<<i<<"\t";
//			cout<<"minalphawork"<<"\t"<<minalphawork<<"\t"<<"const c"<<"\t"<<c_mid<<endl;
			adjustupper1[i]=upper1[i]*c_mid;
			adjustlower1[i]=lower1[i]*c_mid;
			adjustupper2[i]=upper2[i]*c_mid;
			adjustlower2[i]=lower2[i]*c_mid;
		}

		for(i=0; i<lookorder; i++){
			SurvivalEnd1->UpperAdjust[i]=adjustupper1[i];
			SurvivalEnd1->LowerAdjust[i]=adjustlower1[i];
			SurvivalEnd2->UpperAdjust[i]=adjustupper2[i];
			SurvivalEnd2->LowerAdjust[i]=adjustlower2[i];
		}

	}


	// in case of soft decision:
	//mainly copy from the above calculation:
	// work can not be used DIRECTLY.

	else if(decisiontype==0){	
		for(n=0; n<search_length; n++){	
			// Initialize c_search:
			c_search[n]=c_lower+n*c_range/search_length;

			countt=0;
			adjustupper1[0]=upper1[0]*c_search[n];
			adjustlower1[0]=lower1[0]*c_search[n];
			adjustupper2[0]=upper2[0]*c_search[n];
			adjustlower2[0]=lower2[0]*c_search[n];
		
			//initialize work:
			for(m=0; m<looksimul; m++){
				work1[m]=nend11[m*lookorder+0];
				work2[m]=nend21[m*lookorder+0];
			}

			for(m=0; m<looksimul; m++){
				if( absd(work1[m])>adjustupper1[0] )	
					countt=countt+1;		// H-* & H+*
				else if( (absd(work1[m])<adjustlower1[0]) && (absd(work2[m])>adjustupper2[0]) )
					countt=countt+1;		//H0+ & H0-
				else if( (work1[m]<-adjustlower1[0]) && (work1[m]>-adjustupper1[0]) && (work2[m]<-adjustupper2[0]) )
					countt=countt+1;		// H(-)-
			}

			alphawork=countt/looksimul;

			if( minalphawork > absd(alphawork-BiAlpha[0]) ){
				c_mid=c_search[n];
				minalphawork=absd(alphawork-BiAlpha[0]);
			}
		}
	
		adjustupper1[0]=upper1[0]*c_mid;
		adjustlower1[0]=lower1[0]*c_mid;
		adjustupper2[0]=upper2[0]*c_mid;
		adjustlower2[0]=lower2[0]*c_mid;
	
		// now we search the const c for the rest of looks:
		for(i=1; i<lookorder; i++){
			minalphawork=1;
			lengthlook=0;

			for(j=0; j<looksimul; j++){
				indi=0;

				for(m=0; m<i; m++){
					if( indi!=1) {
						if( absd(nend11[j*lookorder+m])>adjustupper1[m] )
							indi=1;		// H-*  H+*
						else if( absd(nend11[j*lookorder+m])<adjustlower1[m] && absd(nend21[j*lookorder+m])>adjustupper2[m])
							indi=1;		// H0- & H0+
						else if( (nend11[j*lookorder+m]<-adjustlower1[m]) && (nend11[j*lookorder+m]>-adjustupper1[m]) && (nend21[j*lookorder+m]<-adjustupper2[m]) )
							indi=1;		// H(-)-
					}
				}

				if(indi==0){
					work1[lengthlook]=nend11[j*lookorder+i];
					work2[lengthlook]=nend21[j*lookorder+i];
					lengthlook=lengthlook+1;
				}
			}

			for(n=0; n<search_length; n++){	
			// Initialize c_search:
				c_search[n]=c_lower+n*c_range/search_length;

				countt=0;
				adjustupper1[i]=upper1[i]*c_search[n];
				adjustlower1[i]=lower1[i]*c_search[n];
				adjustupper2[i]=upper2[i]*c_search[n];
				adjustlower2[i]=lower2[i]*c_search[n];
		
				for(nn=0; nn<lengthlook; nn++){		// make mistake in this look:
				//	if( (work1[nn]>adjustupper1[i]) || (work2[nn]>adjustupper2[i]) )
				//		countt=countt+1;
					if( absd(work1[nn])>adjustupper1[i] )					
						countt=countt+1;	// H-* H+*
					else if( (absd(work1[nn])<adjustlower1[i]) && (absd(work2[nn])>adjustupper2[i]))
						countt=countt+1;	// H0- H0+
					else if( (work1[nn]<-adjustlower1[i]) && (work1[nn]>-adjustupper1[i]) && (work2[nn]<-adjustupper2[i]) )
						countt=countt+1;
				}


				alphawork=countt/lengthlook;

				if( minalphawork > absd(alphawork-BiAlpha[i]) ){
					c_mid=c_search[n];
					minalphawork=absd(alphawork-BiAlpha[i]);
				}
			}

//			cout<<"search of c end for look"<<"\t"<<i<<"\t";
//			cout<<"minalphawork"<<"\t"<<minalphawork<<"\t"<<"const c"<<"\t"<<c_mid<<endl;
			adjustupper1[i]=upper1[i]*c_mid;
			adjustlower1[i]=lower1[i]*c_mid;
			adjustupper2[i]=upper2[i]*c_mid;
			adjustlower2[i]=lower2[i]*c_mid;
		}

		for(i=0; i<lookorder; i++){
			SurvivalEnd1->UpperAdjust[i]=adjustupper1[i];
			SurvivalEnd1->LowerAdjust[i]=adjustlower1[i];
			SurvivalEnd2->UpperAdjust[i]=adjustupper2[i];
			SurvivalEnd2->LowerAdjust[i]=adjustlower2[i];
		}

	}


	//now the left is the calculation of the test statistic:
	double *teststatistic;
	teststatistic=new double[2*lookorder];


	teststatistic=LogRank3(lookorder, num_look, samplesize1, samplesize2, column, send11, send12, send21, send22, looktime);

	for(i=0; i<num_look; i++){
		SurvivalEnd1->testZ[i]=0;
		SurvivalEnd2->testZ[i]=0;
	}
	for(i=0; i<lookorder; i++){
		SurvivalEnd1->testZ[i]=teststatistic[i];
		SurvivalEnd2->testZ[i]=teststatistic[lookorder+i];
	}

}











// the calculation of logrank test statistic:
// the calculation of nhat and yhat are copied from the TSCov.
// part of the documentation should be refered to TSCov.
// 7/6/2002 4:14PM:

double * LogRank2(int lookorder, int numlook, int samplesize1, int samplesize2, int column, double *send11, double *send12, double *send21, double *send22, double *looktime)
{

	int i, j, k, l, m, n;
	int con1;

	cout<<"Start of LogRank2"<<endl;
	cout<<"lookorder"<<"\t"<<lookorder<<endl;

	double *entry11, *entry12, *entry21, *entry22;
	double *event11, *event12, *event21, *event22;
	double *indicator11, *indicator12, *indicator21, *indicator22; 
	// the one separate directly from data

	double *lookevent11, *lookevent12, *lookevent21, *lookevent22;
	double *looktime11, *looktime12, *looktime21, *looktime22;
	double *lookindicator11, *lookindicator12, *lookindicator21, *lookindicator22; 
	//after considering the different look time.

	entry11=new double[samplesize1];
	entry12=new double[samplesize2];
	entry21=new double[samplesize1];
	entry22=new double[samplesize2];

	event11=new double[samplesize1];
	event12=new double[samplesize2];
	event21=new double[samplesize1];
	event22=new double[samplesize2];

	indicator11=new double[samplesize1];
	indicator12=new double[samplesize2];
	indicator21=new double[samplesize1];
	indicator22=new double[samplesize2];

	lookevent11=new double[samplesize1];
	lookevent12=new double[samplesize2];
	lookevent21=new double[samplesize1];
	lookevent22=new double[samplesize2];

	looktime11=new double[samplesize1*lookorder];
	looktime12=new double[samplesize2*lookorder];
	looktime21=new double[samplesize1*lookorder];
	looktime22=new double[samplesize2*lookorder];

	lookindicator11=new double[samplesize1*lookorder];
	lookindicator12=new double[samplesize2*lookorder];
	lookindicator21=new double[samplesize1*lookorder];
	lookindicator22=new double[samplesize2*lookorder];

	//initialize entry event, and indicator
	for(i=0; i<samplesize1; i++){
		//end 1 control
		entry11[i]=send11[i*column+3];
		event11[i]=send11[i*column+4];
		indicator11[i]=send11[i*column+5];
		//end 2 control
		entry21[i]=send21[i*column+3];
		event21[i]=send21[i*column+4];
		indicator21[i]=send21[i*column+5];
	}
	
	for(i=0; i<samplesize2; i++){
		//end 1 treatment
		entry12[i]=send12[i*column+3];
		event12[i]=send12[i*column+4];
		indicator12[i]=send12[i*column+5];
		//end 2 treatment
		entry22[i]=send22[i*column+3];
		event22[i]=send22[i*column+4];
		indicator22[i]=send22[i*column+5];
	}


	// initialize lookevent, looktime and lookindicator:

	//end1 control:
	for(i=0; i<samplesize1; i++){
		lookevent11[i]=event11[i]-entry11[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry11[i] ){
				looktime11[i*lookorder+j]=-1;   //not entered yet
				lookindicator11[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry11[i]){
				if(looktime[j]>=event11[i]){		//enter. by the time of look, event happens
					looktime11[i*lookorder+j]=looktime[j]-entry11[i];
					lookindicator11[i*lookorder+j]=indicator11[i];
				}
				else if(looktime[j]<event11[i]){		//by the time of look, event not happen yet.
					looktime11[i*lookorder+j]=looktime[j]-entry11[i];
					lookindicator11[i*lookorder+j]=1;
				}
			}
		}
	}

	//end1 treatment:
	for(i=0; i<samplesize2; i++){
		lookevent12[i]=event12[i]-entry12[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry12[i] ){
				looktime12[i*lookorder+j]=-1;   //not entered yet
				lookindicator12[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry12[i]){
				if(looktime[j]>=event12[i]){		//enter. by the time of look, event happens
					looktime12[i*lookorder+j]=looktime[j]-entry12[i];
					lookindicator12[i*lookorder+j]=indicator12[i];
				}
				else if(looktime[j]<event12[i]){		//by the time of look, event not happen yet.
					looktime12[i*lookorder+j]=looktime[j]-entry12[i];
					lookindicator12[i*lookorder+j]=1;
				}
			}
		}
	}

	//end 2 control
	for(i=0; i<samplesize1; i++){
		lookevent21[i]=event21[i]-entry21[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry21[i] ){
				looktime21[i*lookorder+j]=-1;   //not entered yet
				lookindicator21[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry21[i]){
				if(looktime[j]>=event21[i]){		//enter. by the time of look, event happens
					looktime21[i*lookorder+j]=looktime[j]-entry21[i];
					lookindicator21[i*lookorder+j]=indicator21[i];
				}
				else if(looktime[j]<event21[i]){		//by the time of look, event not happen yet.
					looktime21[i*lookorder+j]=looktime[j]-entry21[i];
					lookindicator21[i*lookorder+j]=1;
				}
			}
		}
	}	

	//end 2 treatment
	for(i=0; i<samplesize2; i++){
		lookevent22[i]=event22[i]-entry22[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry22[i] ){
				looktime22[i*lookorder+j]=-1;   //not entered yet
				lookindicator22[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry22[i]){
				if(looktime[j]>=event22[i]){		//enter. by the time of look, event happens
					looktime22[i*lookorder+j]=looktime[j]-entry22[i];
					lookindicator22[i*lookorder+j]=indicator22[i];
				}
				else if(looktime[j]<event22[i]){		//by the time of look, event not happen yet.
					looktime22[i*lookorder+j]=looktime[j]-entry22[i];
					lookindicator22[i*lookorder+j]=1;
				}
			}
		}
	}	


	// sort each one according to lookevent
	double *sort1, *sort2, *sort3, *sort4;
	sort1=new double[(1+2*lookorder)*samplesize1]; //end11
	sort2=new double[(1+2*lookorder)*samplesize2]; //end12
	sort3=new double[(1+2*lookorder)*samplesize1]; //end21
	sort4=new double[(1+2*lookorder)*samplesize2]; //end22
	sort1=SortTSCov(samplesize1, lookorder, lookevent11, looktime11, lookindicator11);
	sort2=SortTSCov(samplesize2, lookorder, lookevent12, looktime12, lookindicator12);
	sort3=SortTSCov(samplesize1, lookorder, lookevent21, looktime21, lookindicator21);
	sort4=SortTSCov(samplesize2, lookorder, lookevent22, looktime22, lookindicator22);

	// Re-separate lookevent, looktime, lookindicator:
	//end 1 control:
	for(i=0; i<samplesize1; i++){
		lookevent11[i]=sort1[i*(1+2*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime11[i*lookorder+j]=sort1[i*(1+2*lookorder)+j+1];
			lookindicator11[i*lookorder+j]=sort1[i*(1+2*lookorder)+j+1+lookorder];
		}
	}
	//end1 treat
	for(i=0; i<samplesize2; i++){
		lookevent12[i]=sort2[i*(1+2*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime12[i*lookorder+j]=sort2[i*(1+2*lookorder)+j+1];
			lookindicator12[i*lookorder+j]=sort2[i*(1+2*lookorder)+j+1+lookorder];
		}
	}
	//end2 control
	for(i=0; i<samplesize1; i++){
		lookevent21[i]=sort3[i*(1+2*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime21[i*lookorder+j]=sort3[i*(1+2*lookorder)+j+1];
			lookindicator21[i*lookorder+j]=sort3[i*(1+2*lookorder)+j+1+lookorder];
		}
	}
	//end2 treat
	for(i=0; i<samplesize2; i++){
		lookevent22[i]=sort4[i*(1+2*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime22[i*lookorder+j]=sort4[i*(1+2*lookorder)+j+1];
			lookindicator22[i*lookorder+j]=sort4[i*(1+2*lookorder)+j+1+lookorder];
		}
	}


	// now calculate nhat, yhat and time of change
	double *nhat11, *nhat12, *nhat21, *nhat22;
	double *yhat11, *yhat12, *yhat21, *yhat22;
	double *ctime11, *ctime12, *ctime21, *ctime22;

	nhat11=new double[samplesize1*lookorder];
	nhat12=new double[samplesize2*lookorder];
	nhat21=new double[samplesize1*lookorder];
	nhat22=new double[samplesize2*lookorder];

	yhat11=new double[samplesize1*lookorder];
	yhat12=new double[samplesize2*lookorder];
	yhat21=new double[samplesize1*lookorder];
	yhat22=new double[samplesize2*lookorder];

	ctime11=new double[samplesize1*lookorder];
	ctime12=new double[samplesize2*lookorder];
	ctime21=new double[samplesize1*lookorder];
	ctime22=new double[samplesize2*lookorder];

	// sort looktime and lookindicator to calculate yhat, nhat and ctime:

	double *tltime, *tlindicator;
	double *tlsort1;
	int length1;
	
	int tdead, tcount;

	tltime=new double[max(samplesize1, samplesize2)];
	tlindicator=new double[max(samplesize1, samplesize2)];
	tlsort1=new double[2*max(samplesize1, samplesize2)];


	//end 1 control:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize1; j++){
			if( looktime11[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime11[j*lookorder+i];
				tlindicator[length1]=lookindicator11[j*lookorder+i];
				length1=length1+1;
			}
		}

		// sort with respect to tltime (looktime):
		tlsort1=TSSort1(length1, samplesize1, tltime, tlindicator);
		// then separate:
		for(j=0; j<samplesize1; j++){
			tltime[j]=tlsort1[j*2+0];
			tlindicator[j]=tlsort1[j*2+1];
		}

		// count nhat11(dead), yhat11(at risk), and ctime11
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat11[j*lookorder+i]=tdead;
				yhat11[j*lookorder+i]=samplesize1-tcount;
				ctime11[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat11[j*lookorder+i]=tdead;
				yhat11[j*lookorder+i]=samplesize1-tcount;
				ctime11[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize1; j++){
			nhat11[j*lookorder+i]=nhat11[(j-1)*lookorder+i];
			yhat11[j*lookorder+i]=yhat11[(j-1)*lookorder+i];
			ctime11[j*lookorder+i]=-1;	// those not entered yet
		}
	}

	//end 1 treatment:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize2; j++){
			if( looktime12[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime12[j*lookorder+i];
				tlindicator[length1]=lookindicator12[j*lookorder+i];
				length1=length1+1;
			}
		}
		
		// sort with respect to tltime (looktime):
		tlsort1=TSSort1(length1, samplesize2, tltime, tlindicator);
		// then separate:
		for(j=0; j<samplesize2; j++){
			tltime[j]=tlsort1[j*2+0];
			tlindicator[j]=tlsort1[j*2+1];
		}

		// count nhat12(dead), yhat12(at risk), and ctime12
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat12[j*lookorder+i]=tdead;
				yhat12[j*lookorder+i]=samplesize2-tcount;
				ctime12[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat12[j*lookorder+i]=tdead;
				yhat12[j*lookorder+i]=samplesize2-tcount;
				ctime12[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize2; j++){
			nhat12[j*lookorder+i]=nhat12[(j-1)*lookorder+i];
			yhat12[j*lookorder+i]=yhat12[(j-1)*lookorder+i];
			ctime12[j*lookorder+i]=-1;	// those not entered yet
		}
	}

	//end 2 control:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize1; j++){
			if( looktime21[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime21[j*lookorder+i];
				tlindicator[length1]=lookindicator21[j*lookorder+i];
				length1=length1+1;
			}
		}
		
		// sort with respect to tltime (looktime):
		tlsort1=TSSort1(length1, samplesize1, tltime, tlindicator);
		// then separate:
		for(j=0; j<samplesize1; j++){
			tltime[j]=tlsort1[j*2+0];
			tlindicator[j]=tlsort1[j*2+1];
		}

		// count nhat21(dead), yhat21(at risk), and ctime11
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat21[j*lookorder+i]=tdead;
				yhat21[j*lookorder+i]=samplesize1-tcount;
				ctime21[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat21[j*lookorder+i]=tdead;
				yhat21[j*lookorder+i]=samplesize1-tcount;
				ctime21[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize1; j++){
			nhat21[j*lookorder+i]=nhat21[(j-1)*lookorder+i];
			yhat21[j*lookorder+i]=yhat21[(j-1)*lookorder+i];
			ctime21[j*lookorder+i]=-1;	// those not entered yet
		}
	}

	//end 2 treatment:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize2; j++){
			if( looktime22[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime22[j*lookorder+i];
				tlindicator[length1]=lookindicator22[j*lookorder+i];
				length1=length1+1;
			}
		}
		
		// sort with respect to tltime (looktime):
		tlsort1=TSSort1(length1, samplesize2, tltime, tlindicator);
		// then separate:
		for(j=0; j<samplesize2; j++){
			tltime[j]=tlsort1[j*2+0];
			tlindicator[j]=tlsort1[j*2+1];
		}

		// count nhat22(dead), yhat22(at risk), and ctime22
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat22[j*lookorder+i]=tdead;
				yhat22[j*lookorder+i]=samplesize2-tcount;
				ctime22[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat22[j*lookorder+i]=tdead;
				yhat22[j*lookorder+i]=samplesize2-tcount;
				ctime22[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize2; j++){
			nhat22[j*lookorder+i]=nhat22[(j-1)*lookorder+i];
			yhat22[j*lookorder+i]=yhat22[(j-1)*lookorder+i];
			ctime22[j*lookorder+i]=-1;	// those not entered yet
		}
	}



	// now check the above nhat, yhat and ctime:

	// the structure:
	// nhat:
	// # of event at first look... # of event at second look... # of event at 3rd look...
	// yhat:
	// # of survive first look.... # of survive second look.... # of survive 3rd look...
	// ctime: time of change, otherwise -1.


	// the calculation of test statistic:
	double *logrank1, *logrank2, *teststatistic;
	logrank1=new double[lookorder];
	logrank2=new double[lookorder];
	teststatistic=new double[lookorder*2];

	
	double *timeA, *yhat1, *yhat2, *nhat1, *nhat2;
	timeA=new double[(samplesize1+samplesize2)*lookorder];
	yhat1=new double[(samplesize1+samplesize2)*lookorder];
	yhat2=new double[(samplesize1+samplesize2)*lookorder];
	nhat1=new double[(samplesize1+samplesize2)*lookorder];
	nhat2=new double[(samplesize1+samplesize2)*lookorder];

	int position1=0;
	int position2=0;
	int position=0;


	for(i=0; i<lookorder; i++){
		position1=0;
		position2=0;
		position=0;
		while( position<samplesize1+samplesize2){
			if(position1<samplesize1-1 && ctime11[position1*lookorder+i]==ctime11[(position1+1)*lookorder+i]){
				position1++;
			}
			if(position2<samplesize2-1 && ctime12[position2*lookorder+i]==ctime12[(position2+1)*lookorder+i]){
				position2++;
			}
			if(ctime11[position1*lookorder+i]==-1&&ctime12[position2*lookorder+i]==-1){
				timeA[position*lookorder+i]=-1;
				yhat1[position*lookorder+i]=-1;
				yhat2[position*lookorder+i]=-1;
				nhat1[position*lookorder+i]=-1;
				nhat2[position*lookorder+i]=-1;
			}
			else if( ctime11[position1*lookorder+i] == ctime12[position2*lookorder+i]){
				timeA[position*lookorder+i]=ctime11[position1*lookorder+i];
				yhat1[position*lookorder+i]=yhat11[position1*lookorder+i];
				yhat2[position*lookorder+i]=yhat12[position2*lookorder+i];
				nhat1[position*lookorder+i]=nhat11[position1*lookorder+i];
				nhat2[position*lookorder+i]=nhat12[position2*lookorder+i];
				position1++;
				position2++;
			}
			else if( ctime11[position1*lookorder+i]!=-1 && (ctime11[position1*lookorder+i] < ctime12[position2*lookorder+i] || ctime12[position2*lookorder+i]==-1)) {
				timeA[position*lookorder+i]=ctime11[position1*lookorder+i];
				yhat1[position*lookorder+i]=yhat11[position1*lookorder+i];
				nhat1[position*lookorder+i]=nhat11[position1*lookorder+i];
				if(position2!=0){
					yhat2[position*lookorder+i]=yhat12[(position2-1)*lookorder+i];
					nhat2[position*lookorder+i]=nhat12[(position2-1)*lookorder+i];
				}
				else{
					yhat2[position*lookorder+i]=yhat12[position2*lookorder+i];
					nhat2[position*lookorder+i]=nhat12[position2*lookorder+i];
				}
				position1++;
			}
			else if( ctime12[position2*lookorder+i]!=-1 && (ctime11[position1*lookorder+i] > ctime12[position2*lookorder+i]) || (ctime11[position1*lookorder+i]==-1)) {
				timeA[position*lookorder+i]=ctime12[position2*lookorder+i];
				yhat2[position*lookorder+i]=yhat12[position2*lookorder+i];
				nhat2[position*lookorder+i]=nhat12[position2*lookorder+i];
				if(position1!=0){
					yhat1[position*lookorder+i]=yhat11[(position1-1)*lookorder+i];
					nhat1[position*lookorder+i]=nhat11[(position1-1)*lookorder+i];
				}
				else{
					yhat1[position*lookorder+i]=yhat11[position1*lookorder+i];
					nhat1[position*lookorder+i]=nhat11[position1*lookorder+i];
				}
				position2++;
			}
			else{
			}
			position++;
		}
	}

	double *temptest;
	temptest=new double[(samplesize1+samplesize2)*lookorder];
	for(i=0; i<(samplesize1+samplesize2)*lookorder; i++)
		temptest[i]=0;
	
	// now calculate the logrank test statistic:
	for(i=0; i<lookorder; i++){
		logrank1[i]=0;
		j=1;
		while ( (timeA[(j+2)*lookorder+i]>0.000001) && (j<samplesize1+samplesize2-2) ){
			temptest[j*lookorder+i]=(yhat1[j*lookorder+i]*yhat2[j*lookorder+i])/(yhat1[j*lookorder+i]+yhat2[j*lookorder+i])*((nhat1[j*lookorder+i]-nhat1[(j-1)*lookorder+i])/(yhat1[j*lookorder+i])-(nhat2[j*lookorder+i]-nhat2[(j-1)*lookorder+i])/(yhat2[j*lookorder+i]));
			logrank1[i]=logrank1[i]+(yhat1[j*lookorder+i]*yhat2[j*lookorder+i])/(yhat1[j*lookorder+i]+yhat2[j*lookorder+i])*((nhat1[j*lookorder+i]-nhat1[(j-1)*lookorder+i])/(yhat1[j*lookorder+i])-(nhat2[j*lookorder+i]-nhat2[(j-1)*lookorder+i])/(yhat2[j*lookorder+i]));
			j=j+1;
		}
		logrank1[i]=logrank1[i]*sqrt(1.0/(samplesize1+samplesize2));
	}
	

	//7/15/2002 10:50PM
	// test statistics for the second end:
	// mostly copy and paste from the above calculation
	double *timeB, *yhatB1, *yhatB2, *nhatB1, *nhatB2;
	timeB=new double[(samplesize1+samplesize2)*lookorder];
	yhatB1=new double[(samplesize1+samplesize2)*lookorder];
	yhatB2=new double[(samplesize1+samplesize2)*lookorder];
	nhatB1=new double[(samplesize1+samplesize2)*lookorder];
	nhatB2=new double[(samplesize1+samplesize2)*lookorder];

	int positionB1=0;
	int positionB2=0;
	int positionB=0;

	for(i=0; i<lookorder; i++){
		positionB1=0;
		positionB2=0;
		positionB=0;
		while( positionB<samplesize1+samplesize2){
			if(positionB1<samplesize1-1 && ctime21[positionB1*lookorder+i]==ctime21[(positionB1+1)*lookorder+i]){
				positionB1++;
			}
			if(positionB2<samplesize2-1 && ctime22[positionB2*lookorder+i]==ctime22[(positionB2+1)*lookorder+i]){
				positionB2++;
			}
			if(ctime21[positionB1*lookorder+i]==-1&&ctime22[positionB2*lookorder+i]==-1){
				timeB[positionB*lookorder+i]=-1;
				yhatB1[positionB*lookorder+i]=-1;
				yhatB2[positionB*lookorder+i]=-1;
				nhatB1[positionB*lookorder+i]=-1;
				nhatB2[positionB*lookorder+i]=-1;
			}
			else if( ctime21[positionB1*lookorder+i] == ctime22[positionB2*lookorder+i]){
				timeB[positionB*lookorder+i]=ctime21[positionB1*lookorder+i];
				yhatB1[positionB*lookorder+i]=yhat21[positionB1*lookorder+i];
				yhatB2[positionB*lookorder+i]=yhat22[positionB2*lookorder+i];
				nhatB1[positionB*lookorder+i]=nhat21[positionB1*lookorder+i];
				nhatB2[positionB*lookorder+i]=nhat22[positionB2*lookorder+i];
				positionB1++;
				positionB2++;
			}
			else if( ctime21[positionB1*lookorder+i]!=-1 && (ctime21[positionB1*lookorder+i] < ctime22[positionB2*lookorder+i] || ctime22[positionB2*lookorder+i]==-1)) {
				timeB[positionB*lookorder+i]=ctime21[positionB1*lookorder+i];
				yhatB1[positionB*lookorder+i]=yhat21[positionB1*lookorder+i];
				nhatB1[positionB*lookorder+i]=nhat21[positionB1*lookorder+i];
				if(positionB2!=0){
					yhatB2[positionB*lookorder+i]=yhat22[(positionB2-1)*lookorder+i];
					nhatB2[positionB*lookorder+i]=nhat22[(positionB2-1)*lookorder+i];
				}
				else{
					yhatB2[positionB*lookorder+i]=yhat22[positionB2*lookorder+i];
					nhatB2[positionB*lookorder+i]=nhat22[positionB2*lookorder+i];
				}
				positionB1++;
			}
			else if( ctime22[positionB2*lookorder+i]!=-1 && (ctime21[positionB1*lookorder+i] > ctime22[positionB2*lookorder+i]) || (ctime21[positionB1*lookorder+i]==-1)) {
				timeB[positionB*lookorder+i]=ctime22[positionB2*lookorder+i];
				yhatB2[positionB*lookorder+i]=yhat22[positionB2*lookorder+i];
				nhatB2[positionB*lookorder+i]=nhat22[positionB2*lookorder+i];
				if(positionB1!=0){
					yhatB1[positionB*lookorder+i]=yhat21[(positionB1-1)*lookorder+i];
					nhatB1[positionB*lookorder+i]=nhat21[(positionB1-1)*lookorder+i];
				}
				else{
					yhatB1[positionB*lookorder+i]=yhat21[positionB1*lookorder+i];
					nhatB1[positionB*lookorder+i]=nhat21[positionB1*lookorder+i];
				}
				positionB2++;
			}
			else{
			}
			positionB++;
		}
	}

	double *temptestB;
	temptestB=new double[(samplesize1+samplesize2)*lookorder];
	for(i=0; i<(samplesize1+samplesize2)*lookorder; i++)
		temptestB[i]=0;
	
	// now calculate the logrank test statistic:
	for(i=0; i<lookorder; i++){
		logrank2[i]=0;
		j=1;
		while ( (timeB[(j+2)*lookorder+i]>0.000001) && (j<samplesize1+samplesize2-2) ){
			temptestB[j*lookorder+i]=(yhatB1[j*lookorder+i]*yhatB2[j*lookorder+i])/(yhatB1[j*lookorder+i]+yhatB2[j*lookorder+i])*((nhatB1[j*lookorder+i]-nhatB1[(j-1)*lookorder+i])/(yhatB1[j*lookorder+i])-(nhatB2[j*lookorder+i]-nhatB2[(j-1)*lookorder+i])/(yhatB2[j*lookorder+i]));
			logrank2[i]=logrank2[i]+(yhatB1[j*lookorder+i]*yhatB2[j*lookorder+i])/(yhatB1[j*lookorder+i]+yhatB2[j*lookorder+i])*((nhatB1[j*lookorder+i]-nhatB1[(j-1)*lookorder+i])/(yhatB1[j*lookorder+i])-(nhatB2[j*lookorder+i]-nhatB2[(j-1)*lookorder+i])/(yhatB2[j*lookorder+i]));
			j=j+1;
		}
		logrank2[i]=logrank2[i]*sqrt(1.0/(samplesize1+samplesize2));
	}
	

	for(i=0; i<lookorder; i++){
		teststatistic[i]=logrank1[i];
		teststatistic[i+lookorder]=logrank2[i];

	}
	

	int look1=1;

	ofstream timeAout("timeA2.txt", ios::trunc); 
	timeAout<<"timeA\tctime11\tctime12yhat1\t\tyhat2\tnhat1\tnhat2"<<endl;
	for(i=0; i<samplesize1+samplesize2; i++){
		if(i<samplesize1){
			timeAout<<timeA[i*lookorder+look1]<<"\t"<<ctime11[i*lookorder+look1]<<"\t"<<ctime12[i*lookorder+look1]<<"\t";
			timeAout<<yhat1[i*lookorder+look1]<<"\t"<<yhat2[i*lookorder+look1]<<"\t";
			timeAout<<nhat1[i*lookorder+look1]<<"\t"<<nhat2[i*lookorder+look1]<<endl;
		}
		else if(i<samplesize2){
			timeAout<<timeA[i*lookorder+look1]<<"\t\t"<<ctime12[i*lookorder+look1]<<"\t";
			timeAout<<yhat1[i*lookorder+look1]<<"\t"<<yhat2[i*lookorder+look1]<<"\t";
			timeAout<<nhat1[i*lookorder+look1]<<"\t"<<nhat2[i*lookorder+look1]<<endl;
		}
		else{
			timeAout<<timeA[i*lookorder]<<"\t\t\t";
			timeAout<<yhat1[i*lookorder]<<"\t"<<yhat2[i*lookorder]<<"\t";
			timeAout<<nhat1[i*lookorder]<<"\t"<<nhat2[i*lookorder]<<endl;
		}
	}

	timeAout<<"temp test"<<endl;
	for(i=0; i<samplesize1+samplesize2; i++){
		for(j=0; j<lookorder; j++){
			timeAout<<temptest[i*lookorder+j]<<"\t";
		}
		timeAout<<endl;
	}

	cout<<"data written finished"<<endl;
	return teststatistic;
}

















// the latest version of logrank test statistics calculation
// most part copied from Logrank2.
// the only difference is the calculation part, 
// the nhat, yhat calculations remain unchanged

double * LogRank3(int lookorder, int numlook, int samplesize1, int samplesize2, int column, double *send11, double *send12, double *send21, double *send22, double *looktime)
{

	int i, j, k, l, m, n;
	int con1;

	cout<<"Start of LogRank3, latest version"<<endl;

	double *entry11, *entry12, *entry21, *entry22;
	double *event11, *event12, *event21, *event22;
	double *indicator11, *indicator12, *indicator21, *indicator22; 
	// the one separate directly from data

	double *lookevent11, *lookevent12, *lookevent21, *lookevent22;
	double *looktime11, *looktime12, *looktime21, *looktime22;
	double *lookindicator11, *lookindicator12, *lookindicator21, *lookindicator22; 
	//after considering the different look time.

	entry11=new double[samplesize1];
	entry12=new double[samplesize2];
	entry21=new double[samplesize1];
	entry22=new double[samplesize2];

	event11=new double[samplesize1];
	event12=new double[samplesize2];
	event21=new double[samplesize1];
	event22=new double[samplesize2];

	indicator11=new double[samplesize1];
	indicator12=new double[samplesize2];
	indicator21=new double[samplesize1];
	indicator22=new double[samplesize2];

	lookevent11=new double[samplesize1];
	lookevent12=new double[samplesize2];
	lookevent21=new double[samplesize1];
	lookevent22=new double[samplesize2];

	looktime11=new double[samplesize1*lookorder];
	looktime12=new double[samplesize2*lookorder];
	looktime21=new double[samplesize1*lookorder];
	looktime22=new double[samplesize2*lookorder];

	lookindicator11=new double[samplesize1*lookorder];
	lookindicator12=new double[samplesize2*lookorder];
	lookindicator21=new double[samplesize1*lookorder];
	lookindicator22=new double[samplesize2*lookorder];

	//initialize entry event, and indicator
	for(i=0; i<samplesize1; i++){
		//end 1 control
		entry11[i]=send11[i*column+3];
		event11[i]=send11[i*column+4];
		indicator11[i]=send11[i*column+5];
		//end 2 control
		entry21[i]=send21[i*column+3];
		event21[i]=send21[i*column+4];
		indicator21[i]=send21[i*column+5];
	}
	
	for(i=0; i<samplesize2; i++){
		//end 1 treatment
		entry12[i]=send12[i*column+3];
		event12[i]=send12[i*column+4];
		indicator12[i]=send12[i*column+5];
		//end 2 treatment
		entry22[i]=send22[i*column+3];
		event22[i]=send22[i*column+4];
		indicator22[i]=send22[i*column+5];
	}


	// initialize lookevent, looktime and lookindicator:

	//end1 control:
	for(i=0; i<samplesize1; i++){
		lookevent11[i]=event11[i]-entry11[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry11[i] ){
				looktime11[i*lookorder+j]=-1;   //not entered yet
				lookindicator11[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry11[i]){
				if(looktime[j]>=event11[i]){		//enter. by the time of look, event happens
					looktime11[i*lookorder+j]=looktime[j]-entry11[i];
					lookindicator11[i*lookorder+j]=indicator11[i];
				}
				else if(looktime[j]<event11[i]){		//by the time of look, event not happen yet.
					looktime11[i*lookorder+j]=looktime[j]-entry11[i];
					lookindicator11[i*lookorder+j]=1;
				}
			}
		}
	}

	//end1 treatment:
	for(i=0; i<samplesize2; i++){
		lookevent12[i]=event12[i]-entry12[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry12[i] ){
				looktime12[i*lookorder+j]=-1;   //not entered yet
				lookindicator12[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry12[i]){
				if(looktime[j]>=event12[i]){		//enter. by the time of look, event happens
					looktime12[i*lookorder+j]=looktime[j]-entry12[i];
					lookindicator12[i*lookorder+j]=indicator12[i];
				}
				else if(looktime[j]<event12[i]){		//by the time of look, event not happen yet.
					looktime12[i*lookorder+j]=looktime[j]-entry12[i];
					lookindicator12[i*lookorder+j]=1;
				}
			}
		}
	}

	//end 2 control
	for(i=0; i<samplesize1; i++){
		lookevent21[i]=event21[i]-entry21[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry21[i] ){
				looktime21[i*lookorder+j]=-1;   //not entered yet
				lookindicator21[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry21[i]){
				if(looktime[j]>=event21[i]){		//enter. by the time of look, event happens
					looktime21[i*lookorder+j]=looktime[j]-entry21[i];
					lookindicator21[i*lookorder+j]=indicator21[i];
				}
				else if(looktime[j]<event21[i]){		//by the time of look, event not happen yet.
					looktime21[i*lookorder+j]=looktime[j]-entry21[i];
					lookindicator21[i*lookorder+j]=1;
				}
			}
		}
	}	

	//end 2 treatment
	for(i=0; i<samplesize2; i++){
		lookevent22[i]=event22[i]-entry22[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry22[i] ){
				looktime22[i*lookorder+j]=-1;   //not entered yet
				lookindicator22[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry22[i]){
				if(looktime[j]>=event22[i]){		//enter. by the time of look, event happens
					looktime22[i*lookorder+j]=looktime[j]-entry22[i];
					lookindicator22[i*lookorder+j]=indicator22[i];
				}
				else if(looktime[j]<event22[i]){		//by the time of look, event not happen yet.
					looktime22[i*lookorder+j]=looktime[j]-entry22[i];
					lookindicator22[i*lookorder+j]=1;
				}
			}
		}
	}	


	// sort each one according to lookevent
	double *sort1, *sort2, *sort3, *sort4;
	sort1=new double[(1+2*lookorder)*samplesize1]; //end11
	sort2=new double[(1+2*lookorder)*samplesize2]; //end12
	sort3=new double[(1+2*lookorder)*samplesize1]; //end21
	sort4=new double[(1+2*lookorder)*samplesize2]; //end22
	sort1=SortTSCov(samplesize1, lookorder, lookevent11, looktime11, lookindicator11);
	sort2=SortTSCov(samplesize2, lookorder, lookevent12, looktime12, lookindicator12);
	sort3=SortTSCov(samplesize1, lookorder, lookevent21, looktime21, lookindicator21);
	sort4=SortTSCov(samplesize2, lookorder, lookevent22, looktime22, lookindicator22);

	// Re-separate lookevent, looktime, lookindicator:
	//end 1 control:
	for(i=0; i<samplesize1; i++){
		lookevent11[i]=sort1[i*(1+2*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime11[i*lookorder+j]=sort1[i*(1+2*lookorder)+j+1];
			lookindicator11[i*lookorder+j]=sort1[i*(1+2*lookorder)+j+1+lookorder];
		}
	}
	//end1 treat
	for(i=0; i<samplesize2; i++){
		lookevent12[i]=sort2[i*(1+2*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime12[i*lookorder+j]=sort2[i*(1+2*lookorder)+j+1];
			lookindicator12[i*lookorder+j]=sort2[i*(1+2*lookorder)+j+1+lookorder];
		}
	}
	//end2 control
	for(i=0; i<samplesize1; i++){
		lookevent21[i]=sort3[i*(1+2*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime21[i*lookorder+j]=sort3[i*(1+2*lookorder)+j+1];
			lookindicator21[i*lookorder+j]=sort3[i*(1+2*lookorder)+j+1+lookorder];
		}
	}
	//end2 treat
	for(i=0; i<samplesize2; i++){
		lookevent22[i]=sort4[i*(1+2*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime22[i*lookorder+j]=sort4[i*(1+2*lookorder)+j+1];
			lookindicator22[i*lookorder+j]=sort4[i*(1+2*lookorder)+j+1+lookorder];
		}
	}


	// now calculate nhat, yhat and time of change
	double *nhat11, *nhat12, *nhat21, *nhat22;
	double *yhat11, *yhat12, *yhat21, *yhat22;
	double *ctime11, *ctime12, *ctime21, *ctime22;

	nhat11=new double[samplesize1*lookorder];
	nhat12=new double[samplesize2*lookorder];
	nhat21=new double[samplesize1*lookorder];
	nhat22=new double[samplesize2*lookorder];

	yhat11=new double[samplesize1*lookorder];
	yhat12=new double[samplesize2*lookorder];
	yhat21=new double[samplesize1*lookorder];
	yhat22=new double[samplesize2*lookorder];

	ctime11=new double[samplesize1*lookorder];
	ctime12=new double[samplesize2*lookorder];
	ctime21=new double[samplesize1*lookorder];
	ctime22=new double[samplesize2*lookorder];

	// sort looktime and lookindicator to calculate yhat, nhat and ctime:

	double *tltime, *tlindicator;
	double *tlsort1;
	int length1;
	
	int tdead, tcount;

	tltime=new double[max(samplesize1, samplesize2)];
	tlindicator=new double[max(samplesize1, samplesize2)];
	tlsort1=new double[2*max(samplesize1, samplesize2)];


	//end 1 control:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize1; j++){
			if( looktime11[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime11[j*lookorder+i];
				tlindicator[length1]=lookindicator11[j*lookorder+i];
				length1=length1+1;
			}
		}

		// sort with respect to tltime (looktime):
		tlsort1=TSSort1(length1, samplesize1, tltime, tlindicator);
		// then separate:
		for(j=0; j<samplesize1; j++){
			tltime[j]=tlsort1[j*2+0];
			tlindicator[j]=tlsort1[j*2+1];
		}

		// count nhat11(dead), yhat11(at risk), and ctime11
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat11[j*lookorder+i]=tdead;
				yhat11[j*lookorder+i]=samplesize1-tcount;
				ctime11[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat11[j*lookorder+i]=tdead;
				yhat11[j*lookorder+i]=samplesize1-tcount;
				ctime11[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize1; j++){
			nhat11[j*lookorder+i]=nhat11[(j-1)*lookorder+i];
			yhat11[j*lookorder+i]=yhat11[(j-1)*lookorder+i];
			ctime11[j*lookorder+i]=-1;	// those not entered yet
		}
	}

	//end 1 treatment:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize2; j++){
			if( looktime12[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime12[j*lookorder+i];
				tlindicator[length1]=lookindicator12[j*lookorder+i];
				length1=length1+1;
			}
		}
		
		// sort with respect to tltime (looktime):
		tlsort1=TSSort1(length1, samplesize2, tltime, tlindicator);
		// then separate:
		for(j=0; j<samplesize2; j++){
			tltime[j]=tlsort1[j*2+0];
			tlindicator[j]=tlsort1[j*2+1];
		}

		// count nhat12(dead), yhat12(at risk), and ctime12
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat12[j*lookorder+i]=tdead;
				yhat12[j*lookorder+i]=samplesize2-tcount;
				ctime12[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat12[j*lookorder+i]=tdead;
				yhat12[j*lookorder+i]=samplesize2-tcount;
				ctime12[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize2; j++){
			nhat12[j*lookorder+i]=nhat12[(j-1)*lookorder+i];
			yhat12[j*lookorder+i]=yhat12[(j-1)*lookorder+i];
			ctime12[j*lookorder+i]=-1;	// those not entered yet
		}
	}

	//end 2 control:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize1; j++){
			if( looktime21[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime21[j*lookorder+i];
				tlindicator[length1]=lookindicator21[j*lookorder+i];
				length1=length1+1;
			}
		}
		
		// sort with respect to tltime (looktime):
		tlsort1=TSSort1(length1, samplesize1, tltime, tlindicator);
		// then separate:
		for(j=0; j<samplesize1; j++){
			tltime[j]=tlsort1[j*2+0];
			tlindicator[j]=tlsort1[j*2+1];
		}

		// count nhat21(dead), yhat21(at risk), and ctime11
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat21[j*lookorder+i]=tdead;
				yhat21[j*lookorder+i]=samplesize1-tcount;
				ctime21[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat21[j*lookorder+i]=tdead;
				yhat21[j*lookorder+i]=samplesize1-tcount;
				ctime21[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize1; j++){
			nhat21[j*lookorder+i]=nhat21[(j-1)*lookorder+i];
			yhat21[j*lookorder+i]=yhat21[(j-1)*lookorder+i];
			ctime21[j*lookorder+i]=-1;	// those not entered yet
		}
	}

	//end 2 treatment:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize2; j++){
			if( looktime22[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime22[j*lookorder+i];
				tlindicator[length1]=lookindicator22[j*lookorder+i];
				length1=length1+1;
			}
		}
		
		// sort with respect to tltime (looktime):
		tlsort1=TSSort1(length1, samplesize2, tltime, tlindicator);
		// then separate:
		for(j=0; j<samplesize2; j++){
			tltime[j]=tlsort1[j*2+0];
			tlindicator[j]=tlsort1[j*2+1];
		}

		// count nhat22(dead), yhat22(at risk), and ctime22
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat22[j*lookorder+i]=tdead;
				yhat22[j*lookorder+i]=samplesize2-tcount;
				ctime22[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat22[j*lookorder+i]=tdead;
				yhat22[j*lookorder+i]=samplesize2-tcount;
				ctime22[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize2; j++){
			nhat22[j*lookorder+i]=nhat22[(j-1)*lookorder+i];
			yhat22[j*lookorder+i]=yhat22[(j-1)*lookorder+i];
			ctime22[j*lookorder+i]=-1;	// those not entered yet
		}
	}

	// now check the above nhat, yhat and ctime:

	// the structure:
	// nhat:
	// # of event at first look... # of event at second look... # of event at 3rd look...
	// yhat:
	// # of survive first look.... # of survive second look.... # of survive 3rd look...
	// ctime: time of change, otherwise -1.


	// the calculation of test statistic:
	double *logrank1, *logrank2, *teststatistic;
	logrank1=new double[lookorder];
	logrank2=new double[lookorder];
	teststatistic=new double[lookorder*2];

	
	double *timeA, *yhat1, *yhat2, *nhat1, *nhat2;
	timeA=new double[(samplesize1+samplesize2)*lookorder];
	yhat1=new double[(samplesize1+samplesize2)*lookorder];
	yhat2=new double[(samplesize1+samplesize2)*lookorder];
	nhat1=new double[(samplesize1+samplesize2)*lookorder];
	nhat2=new double[(samplesize1+samplesize2)*lookorder];

	int position1=0;
	int position2=0;
	int position=0;

	for(i=0; i<lookorder; i++){
		position1=0;
		position2=0;
		position=0;
		while( position<samplesize1+samplesize2){
			if(position1<samplesize1-1 && ctime11[position1*lookorder+i]==ctime11[(position1+1)*lookorder+i]){
				position1++;
			}
			if(position2<samplesize2-1 && ctime12[position2*lookorder+i]==ctime12[(position2+1)*lookorder+i]){
				position2++;
			}
			if(ctime11[position1*lookorder+i]==-1&&ctime12[position2*lookorder+i]==-1){
				timeA[position*lookorder+i]=-1;
				yhat1[position*lookorder+i]=-1;
				yhat2[position*lookorder+i]=-1;
				nhat1[position*lookorder+i]=-1;
				nhat2[position*lookorder+i]=-1;
			}
			else if( ctime11[position1*lookorder+i] == ctime12[position2*lookorder+i]){
				timeA[position*lookorder+i]=ctime11[position1*lookorder+i];
				yhat1[position*lookorder+i]=yhat11[position1*lookorder+i];
				yhat2[position*lookorder+i]=yhat12[position2*lookorder+i];
				nhat1[position*lookorder+i]=nhat11[position1*lookorder+i];
				nhat2[position*lookorder+i]=nhat12[position2*lookorder+i];
				position1++;
				position2++;
			}
			else if( ctime11[position1*lookorder+i]!=-1 && (ctime11[position1*lookorder+i] < ctime12[position2*lookorder+i] || ctime12[position2*lookorder+i]==-1)) {
				timeA[position*lookorder+i]=ctime11[position1*lookorder+i];
				yhat1[position*lookorder+i]=yhat11[position1*lookorder+i];
				nhat1[position*lookorder+i]=nhat11[position1*lookorder+i];
				if(position2!=0){
					yhat2[position*lookorder+i]=yhat12[(position2-1)*lookorder+i];
					nhat2[position*lookorder+i]=nhat12[(position2-1)*lookorder+i];
				}
				else{
					yhat2[position*lookorder+i]=yhat12[position2*lookorder+i];
					nhat2[position*lookorder+i]=nhat12[position2*lookorder+i];
				}
				position1++;
			}
			else if( ctime12[position2*lookorder+i]!=-1 && (ctime11[position1*lookorder+i] > ctime12[position2*lookorder+i]) || (ctime11[position1*lookorder+i]==-1)) {
				timeA[position*lookorder+i]=ctime12[position2*lookorder+i];
				yhat2[position*lookorder+i]=yhat12[position2*lookorder+i];
				nhat2[position*lookorder+i]=nhat12[position2*lookorder+i];
				if(position1!=0){
					yhat1[position*lookorder+i]=yhat11[(position1-1)*lookorder+i];
					nhat1[position*lookorder+i]=nhat11[(position1-1)*lookorder+i];
				}
				else{
					yhat1[position*lookorder+i]=yhat11[position1*lookorder+i];
					nhat1[position*lookorder+i]=nhat11[position1*lookorder+i];
				}
				position2++;
			}
			else{
			}
			position++;
		}
	}

	
	// logrank for the first end point:

	double *D1k, *D2k;
	D1k=new double[(samplesize1+samplesize2)*lookorder];
	D2k=new double[(samplesize1+samplesize2)*lookorder];
	double *Y1k, *Y2k;
	Y1k=new double[(samplesize1+samplesize2)*lookorder];
	Y2k=new double[(samplesize1+samplesize2)*lookorder];

	for(i=0; i<(samplesize1+samplesize2)*lookorder; i++){
		D1k[i]=0;
		D2k[i]=0;
		Y1k[i]=0;
		Y2k[i]=0;
	}

	for(i=0; i<lookorder; i++){
		D1k[0*lookorder+i]=nhat1[0*lookorder+i];
		D2k[0*lookorder+i]=nhat2[0*lookorder+i];
		Y1k[0*lookorder+i]=samplesize1;
		Y2k[0*lookorder+i]=samplesize2;

		j=1;
		while( (timeA[(j+2)*lookorder+i]>0.000001) && (j<samplesize1+samplesize2) ){
			D1k[j*lookorder+i]=nhat1[(j+1)*lookorder+i]-nhat1[j*lookorder+i];
			D2k[j*lookorder+i]=nhat2[(j+1)*lookorder+i]-nhat2[j*lookorder+i];
			Y1k[j*lookorder+i]=D1k[j*lookorder+i]+yhat1[j*lookorder+i];
			Y2k[j*lookorder+i]=D2k[j*lookorder+i]+yhat2[j*lookorder+i];
			j=j+1;
		}

	}

	double *E1k, *V1k;
	double pp1, pp2;
	double kk1, kk2;
	E1k=new double[(samplesize1+samplesize2)*lookorder];
	V1k=new double[(samplesize1+samplesize2)*lookorder];

	for(i=0; i<lookorder; i++){
		j=0;
		kk1=0;
		kk2=0;
		while( (timeA[(j+2)*lookorder+i]>0.000001) && (j<samplesize1+samplesize2) && ((Y1k[j*lookorder+i]+Y2k[j*lookorder+i])>1.000001) ){
			E1k[j*lookorder+i]=(D1k[j*lookorder+i]+D2k[j*lookorder+i])*Y1k[j*lookorder+i]/(Y1k[j*lookorder+i]+Y2k[j*lookorder+i]);
			pp1=(D1k[j*lookorder+i]+D2k[j*lookorder+i])*Y1k[j*lookorder+i]*Y2k[j*lookorder+i]/( (Y1k[j*lookorder+i]+Y2k[j*lookorder+i])*(Y1k[j*lookorder+i]+Y2k[j*lookorder+i]) );
			pp2=(Y1k[j*lookorder+i]+Y2k[j*lookorder+i]-D1k[j*lookorder+i]-D2k[j*lookorder+i])/(Y1k[j*lookorder+i]+Y2k[j*lookorder+i]-1);
			V1k[j*lookorder+i]=pp1*pp2;
			kk1=kk1-E1k[j*lookorder+i]+D1k[j*lookorder+i];
			kk2=kk2+V1k[j*lookorder+i];
			j=j+1;
		}
		logrank1[i]=kk1/sqrt(kk2);
	}


	//7/15/2002 10:50PM
	// test statistics for the second end:
	// mostly copy and paste from the above calculation
	double *timeB, *yhatB1, *yhatB2, *nhatB1, *nhatB2;
	timeB=new double[(samplesize1+samplesize2)*lookorder];
	yhatB1=new double[(samplesize1+samplesize2)*lookorder];
	yhatB2=new double[(samplesize1+samplesize2)*lookorder];
	nhatB1=new double[(samplesize1+samplesize2)*lookorder];
	nhatB2=new double[(samplesize1+samplesize2)*lookorder];

	int positionB1=0;
	int positionB2=0;
	int positionB=0;

	for(i=0; i<lookorder; i++){
		positionB1=0;
		positionB2=0;
		positionB=0;
		while( positionB<samplesize1+samplesize2){
			if(positionB1<samplesize1-1 && ctime21[positionB1*lookorder+i]==ctime21[(positionB1+1)*lookorder+i]){
				positionB1++;
			}
			if(positionB2<samplesize2-1 && ctime22[positionB2*lookorder+i]==ctime22[(positionB2+1)*lookorder+i]){
				positionB2++;
			}
			if(ctime21[positionB1*lookorder+i]==-1&&ctime22[positionB2*lookorder+i]==-1){
				timeB[positionB*lookorder+i]=-1;
				yhatB1[positionB*lookorder+i]=-1;
				yhatB2[positionB*lookorder+i]=-1;
				nhatB1[positionB*lookorder+i]=-1;
				nhatB2[positionB*lookorder+i]=-1;
			}
			else if( ctime21[positionB1*lookorder+i] == ctime22[positionB2*lookorder+i]){
				timeB[positionB*lookorder+i]=ctime21[positionB1*lookorder+i];
				yhatB1[positionB*lookorder+i]=yhat21[positionB1*lookorder+i];
				yhatB2[positionB*lookorder+i]=yhat22[positionB2*lookorder+i];
				nhatB1[positionB*lookorder+i]=nhat21[positionB1*lookorder+i];
				nhatB2[positionB*lookorder+i]=nhat22[positionB2*lookorder+i];
				positionB1++;
				positionB2++;
			}
			else if( ctime21[positionB1*lookorder+i]!=-1 && (ctime21[positionB1*lookorder+i] < ctime22[positionB2*lookorder+i] || ctime22[positionB2*lookorder+i]==-1)) {
				timeB[positionB*lookorder+i]=ctime21[positionB1*lookorder+i];
				yhatB1[positionB*lookorder+i]=yhat21[positionB1*lookorder+i];
				nhatB1[positionB*lookorder+i]=nhat21[positionB1*lookorder+i];
				if(positionB2!=0){
					yhatB2[positionB*lookorder+i]=yhat22[(positionB2-1)*lookorder+i];
					nhatB2[positionB*lookorder+i]=nhat22[(positionB2-1)*lookorder+i];
				}
				else{
					yhatB2[positionB*lookorder+i]=yhat22[positionB2*lookorder+i];
					nhatB2[positionB*lookorder+i]=nhat22[positionB2*lookorder+i];
				}
				positionB1++;
			}
			else if( ctime22[positionB2*lookorder+i]!=-1 && (ctime21[positionB1*lookorder+i] > ctime22[positionB2*lookorder+i]) || (ctime21[positionB1*lookorder+i]==-1)) {
				timeB[positionB*lookorder+i]=ctime22[positionB2*lookorder+i];
				yhatB2[positionB*lookorder+i]=yhat22[positionB2*lookorder+i];
				nhatB2[positionB*lookorder+i]=nhat22[positionB2*lookorder+i];
				if(positionB1!=0){
					yhatB1[positionB*lookorder+i]=yhat21[(positionB1-1)*lookorder+i];
					nhatB1[positionB*lookorder+i]=nhat21[(positionB1-1)*lookorder+i];
				}
				else{
					yhatB1[positionB*lookorder+i]=yhat21[positionB1*lookorder+i];
					nhatB1[positionB*lookorder+i]=nhat21[positionB1*lookorder+i];
				}
				positionB2++;
			}
			else{
			}
			positionB++;
		}
	}


	// logrank for the second end point:
	// add "B" to all the definitions:
	double *D1kB, *D2kB;
	D1kB=new double[(samplesize1+samplesize2)*lookorder];
	D2kB=new double[(samplesize1+samplesize2)*lookorder];
	double *Y1kB, *Y2kB;
	Y1kB=new double[(samplesize1+samplesize2)*lookorder];
	Y2kB=new double[(samplesize1+samplesize2)*lookorder];

	for(i=0; i<(samplesize1+samplesize2)*lookorder; i++){
		D1kB[i]=0;
		D2kB[i]=0;
		Y1kB[i]=0;
		Y2kB[i]=0;
	}

	for(i=0; i<lookorder; i++){
		D1kB[0*lookorder+i]=nhatB1[0*lookorder+i];
		D2kB[0*lookorder+i]=nhatB2[0*lookorder+i];
		Y1kB[0*lookorder+i]=samplesize1;
		Y2kB[0*lookorder+i]=samplesize2;

		j=1;
		while( (timeB[(j+2)*lookorder+i]>0.000001) && (j<samplesize1+samplesize2) ){
			D1kB[j*lookorder+i]=nhatB1[(j+1)*lookorder+i]-nhatB1[j*lookorder+i];
			D2kB[j*lookorder+i]=nhatB2[(j+1)*lookorder+i]-nhatB2[j*lookorder+i];
			Y1kB[j*lookorder+i]=D1kB[j*lookorder+i]+yhatB1[j*lookorder+i];
			Y2kB[j*lookorder+i]=D2kB[j*lookorder+i]+yhatB2[j*lookorder+i];
			j=j+1;
		}

	}

	double *E1kB, *V1kB;
	double pp1B, pp2B;
	double kk1B, kk2B;
	E1kB=new double[(samplesize1+samplesize2)*lookorder];
	V1kB=new double[(samplesize1+samplesize2)*lookorder];

	for(i=0; i<lookorder; i++){
		j=0;
		kk1B=0;
		kk2B=0;
		while( (timeB[(j+2)*lookorder+i]>0.000001) && (j<samplesize1+samplesize2) && ((Y1kB[j*lookorder+i]+Y2kB[j*lookorder+i])>1.000001) ){
			E1kB[j*lookorder+i]=(D1kB[j*lookorder+i]+D2kB[j*lookorder+i])*Y1kB[j*lookorder+i]/(Y1kB[j*lookorder+i]+Y2kB[j*lookorder+i]);
			pp1B=(D1kB[j*lookorder+i]+D2kB[j*lookorder+i])*Y1kB[j*lookorder+i]*Y2kB[j*lookorder+i]/( (Y1kB[j*lookorder+i]+Y2kB[j*lookorder+i])*(Y1kB[j*lookorder+i]+Y2kB[j*lookorder+i]) );
			pp2B=(Y1kB[j*lookorder+i]+Y2kB[j*lookorder+i]-D1kB[j*lookorder+i]-D2kB[j*lookorder+i])/(Y1kB[j*lookorder+i]+Y2kB[j*lookorder+i]-1);
			V1kB[j*lookorder+i]=pp1B*pp2B;
			kk1B=kk1B-E1kB[j*lookorder+i]+D1kB[j*lookorder+i];
			kk2B=kk2B+V1kB[j*lookorder+i];
			j=j+1;
		}
		logrank2[i]=kk1B/sqrt(kk2B);
	}


	for(i=0; i<lookorder; i++){
		teststatistic[i]=logrank1[i];
		teststatistic[i+lookorder]=logrank2[i];

	}
	
	int look1=1;

	ofstream timeAout("timeA2.txt", ios::trunc); 
	timeAout<<"timeA\tctime11\tctime12yhat1\t\tyhat2\tnhat1\tnhat2"<<endl;
	for(i=0; i<samplesize1+samplesize2; i++){
		if(i<samplesize1){
			timeAout<<timeA[i*lookorder+look1]<<"\t"<<ctime11[i*lookorder+look1]<<"\t"<<ctime12[i*lookorder+look1]<<"\t";
			timeAout<<yhat1[i*lookorder+look1]<<"\t"<<yhat2[i*lookorder+look1]<<"\t";
			timeAout<<nhat1[i*lookorder+look1]<<"\t"<<nhat2[i*lookorder+look1]<<endl;
		}
		else if(i<samplesize2){
			timeAout<<timeA[i*lookorder+look1]<<"\t\t"<<ctime12[i*lookorder+look1]<<"\t";
			timeAout<<yhat1[i*lookorder+look1]<<"\t"<<yhat2[i*lookorder+look1]<<"\t";
			timeAout<<nhat1[i*lookorder+look1]<<"\t"<<nhat2[i*lookorder+look1]<<endl;
		}
		else{
			timeAout<<timeA[i*lookorder]<<"\t\t\t";
			timeAout<<yhat1[i*lookorder]<<"\t"<<yhat2[i*lookorder]<<"\t";
			timeAout<<nhat1[i*lookorder]<<"\t"<<nhat2[i*lookorder]<<endl;
		}
	}

	return teststatistic;
}















	// the data structure:
	//				end1							end2
	//	control				treat	||| 	control				treat
	//  look1, look2....
// calculation of covariance structure of logrank test statistics:

// ATT: samplesize for treatment and control can be different!

double * TSCov(int lookorder, int numlook, int samplesize1, int samplesize2, int column, double *send11, double *send12, double *send21, double *send22, double *looktime)
{

	int i, j, k, l;
	int con1;

	cout<<"Start of TSCov"<<endl;

	double *entry11, *entry12, *entry21, *entry22;
	double *event11, *event12, *event21, *event22;
	double *indicator11, *indicator12, *indicator21, *indicator22; 
	// the one separate directly from data

	double *lookevent11, *lookevent12, *lookevent21, *lookevent22;
	double *looktime11, *looktime12, *looktime21, *looktime22;
	double *lookindicator11, *lookindicator12, *lookindicator21, *lookindicator22; 
	//after considering the different look time.

	entry11=new double[samplesize1];
	entry12=new double[samplesize2];
	entry21=new double[samplesize1];
	entry22=new double[samplesize2];

	event11=new double[samplesize1];
	event12=new double[samplesize2];
	event21=new double[samplesize1];
	event22=new double[samplesize2];

	indicator11=new double[samplesize1];
	indicator12=new double[samplesize2];
	indicator21=new double[samplesize1];
	indicator22=new double[samplesize2];

	lookevent11=new double[samplesize1];
	lookevent12=new double[samplesize2];
	lookevent21=new double[samplesize1];
	lookevent22=new double[samplesize2];

	looktime11=new double[samplesize1*lookorder];
	looktime12=new double[samplesize2*lookorder];
	looktime21=new double[samplesize1*lookorder];
	looktime22=new double[samplesize2*lookorder];

	lookindicator11=new double[samplesize1*lookorder];
	lookindicator12=new double[samplesize2*lookorder];
	lookindicator21=new double[samplesize1*lookorder];
	lookindicator22=new double[samplesize2*lookorder];

//	cout<<"check point 1"<<endl;

	//initialize entry event, and indicator
	for(i=0; i<samplesize1; i++){
		//end 1 control
		entry11[i]=send11[i*column+3];
		event11[i]=send11[i*column+4];
		indicator11[i]=send11[i*column+5];
		//end 2 control
		entry21[i]=send21[i*column+3];
		event21[i]=send21[i*column+4];
		indicator21[i]=send21[i*column+5];
	}
	
	for(i=0; i<samplesize2; i++){
		//end 1 treatment
		entry12[i]=send12[i*column+3];
		event12[i]=send12[i*column+4];
		indicator12[i]=send12[i*column+5];
		//end 2 treatment
		entry22[i]=send22[i*column+3];
		event22[i]=send22[i*column+4];
		indicator22[i]=send22[i*column+5];
	}


	// initialize lookevent, looktime and lookindicator:

	//end1 control:
	for(i=0; i<samplesize1; i++){
		lookevent11[i]=event11[i]-entry11[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry11[i] ){
				looktime11[i*lookorder+j]=-1;   //not entered yet
				lookindicator11[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry11[i]){
				if(looktime[j]>=event11[i]){		//enter. by the time of look, event happens
					looktime11[i*lookorder+j]=looktime[j]-entry11[i];
					lookindicator11[i*lookorder+j]=indicator11[i];
				}
				else if(looktime[j]<event11[i]){		//by the time of look, event not happen yet.
					looktime11[i*lookorder+j]=looktime[j]-entry11[i];
					lookindicator11[i*lookorder+j]=1;
				}
			}
		}
	}

	//end1 treatment:
	for(i=0; i<samplesize2; i++){
		lookevent12[i]=event12[i]-entry12[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry12[i] ){
				looktime12[i*lookorder+j]=-1;   //not entered yet
				lookindicator12[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry12[i]){
				if(looktime[j]>=event12[i]){		//enter. by the time of look, event happens
					looktime12[i*lookorder+j]=looktime[j]-entry12[i];
					lookindicator12[i*lookorder+j]=indicator12[i];
				}
				else if(looktime[j]<event12[i]){		//by the time of look, event not happen yet.
					looktime12[i*lookorder+j]=looktime[j]-entry12[i];
					lookindicator12[i*lookorder+j]=1;
				}
			}
		}
	}

	//end 2 control
	for(i=0; i<samplesize1; i++){
		lookevent21[i]=event21[i]-entry21[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry21[i] ){
				looktime21[i*lookorder+j]=-1;   //not entered yet
				lookindicator21[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry21[i]){
				if(looktime[j]>=event21[i]){		//enter. by the time of look, event happens
					looktime21[i*lookorder+j]=looktime[j]-entry21[i];
					lookindicator21[i*lookorder+j]=indicator21[i];
				}
				else if(looktime[j]<event21[i]){		//by the time of look, event not happen yet.
					looktime21[i*lookorder+j]=looktime[j]-entry21[i];
					lookindicator21[i*lookorder+j]=1;
				}
			}
		}
	}	

	//end 2 treatment
	for(i=0; i<samplesize2; i++){
		lookevent22[i]=event22[i]-entry22[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry22[i] ){
				looktime22[i*lookorder+j]=-1;   //not entered yet
				lookindicator22[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry22[i]){
				if(looktime[j]>=event22[i]){		//enter. by the time of look, event happens
					looktime22[i*lookorder+j]=looktime[j]-entry22[i];
					lookindicator22[i*lookorder+j]=indicator22[i];
				}
				else if(looktime[j]<event22[i]){		//by the time of look, event not happen yet.
					looktime22[i*lookorder+j]=looktime[j]-entry22[i];
					lookindicator22[i*lookorder+j]=1;
				}
			}
		}
	}	

//	cout<<"check point 3"<<endl;

	// sort each one according to lookevent
	double *sort1, *sort2, *sort3, *sort4;
	sort1=new double[(1+2*lookorder)*samplesize1]; //end11
	sort2=new double[(1+2*lookorder)*samplesize2]; //end12
	sort3=new double[(1+2*lookorder)*samplesize1]; //end21
	sort4=new double[(1+2*lookorder)*samplesize2]; //end22
	sort1=SortTSCov(samplesize1, lookorder, lookevent11, looktime11, lookindicator11);
	sort2=SortTSCov(samplesize2, lookorder, lookevent12, looktime12, lookindicator12);
	sort3=SortTSCov(samplesize1, lookorder, lookevent21, looktime21, lookindicator21);
	sort4=SortTSCov(samplesize2, lookorder, lookevent22, looktime22, lookindicator22);

	// Re-separate lookevent, looktime, lookindicator:
	//end 1 control:
	for(i=0; i<samplesize1; i++){
		lookevent11[i]=sort1[i*(1+2*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime11[i*lookorder+j]=sort1[i*(1+2*lookorder)+j+1];
			lookindicator11[i*lookorder+j]=sort1[i*(1+2*lookorder)+j+1+lookorder];
		}
	}

//	cout<<"check point 4.5"<<endl;

	//end1 treat
	for(i=0; i<samplesize2; i++){
		lookevent12[i]=sort2[i*(1+2*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime12[i*lookorder+j]=sort2[i*(1+2*lookorder)+j+1];
			lookindicator12[i*lookorder+j]=sort2[i*(1+2*lookorder)+j+1+lookorder];
		}
	}
	//end2 control
	for(i=0; i<samplesize1; i++){
		lookevent21[i]=sort3[i*(1+2*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime21[i*lookorder+j]=sort3[i*(1+2*lookorder)+j+1];
			lookindicator21[i*lookorder+j]=sort3[i*(1+2*lookorder)+j+1+lookorder];
		}
	}
	//end2 treat
	for(i=0; i<samplesize2; i++){
		lookevent22[i]=sort4[i*(1+2*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime22[i*lookorder+j]=sort4[i*(1+2*lookorder)+j+1];
			lookindicator22[i*lookorder+j]=sort4[i*(1+2*lookorder)+j+1+lookorder];
		}
	}

	
	// now calculate nhat, yhat and time of change
	double *nhat11, *nhat12, *nhat21, *nhat22;
	double *yhat11, *yhat12, *yhat21, *yhat22;
	double *ctime11, *ctime12, *ctime21, *ctime22;

	nhat11=new double[samplesize1*lookorder];
	nhat12=new double[samplesize2*lookorder];
	nhat21=new double[samplesize1*lookorder];
	nhat22=new double[samplesize2*lookorder];

	yhat11=new double[samplesize1*lookorder];
	yhat12=new double[samplesize2*lookorder];
	yhat21=new double[samplesize1*lookorder];
	yhat22=new double[samplesize2*lookorder];

	ctime11=new double[samplesize1*lookorder];
	ctime12=new double[samplesize2*lookorder];
	ctime21=new double[samplesize1*lookorder];
	ctime22=new double[samplesize2*lookorder];

	// sort looktime and lookindicator to calculate yhat, nhat and ctime:

	double *tltime, *tlindicator;
	double *tlsort1;
	int length1;
	
	int tdead, tcount;

	tltime=new double[max(samplesize1, samplesize2)];
	tlindicator=new double[max(samplesize1, samplesize2)];
	tlsort1=new double[2*max(samplesize1, samplesize2)];

	//end 1 control:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize1; j++){
			if( looktime11[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime11[j*lookorder+i];
				tlindicator[length1]=lookindicator11[j*lookorder+i];
				length1=length1+1;
			}
		}

		// sort with respect to tltime (looktime):
		tlsort1=TSSort1(length1, samplesize1, tltime, tlindicator);
		// then separate:
		for(j=0; j<samplesize1; j++){
			tltime[j]=tlsort1[j*2+0];
			tlindicator[j]=tlsort1[j*2+1];
		}

		// count nhat11(dead), yhat11(at risk), and ctime11
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat11[j*lookorder+i]=tdead;
				yhat11[j*lookorder+i]=samplesize1-tcount;
				ctime11[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat11[j*lookorder+i]=tdead;
				yhat11[j*lookorder+i]=samplesize1-tcount;
				ctime11[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize1; j++){
			nhat11[j*lookorder+i]=nhat11[(j-1)*lookorder+i];
			yhat11[j*lookorder+i]=yhat11[(j-1)*lookorder+i];
			ctime11[j*lookorder+i]=-1;	// those not entered yet
		}
	}

	//end 1 treatment:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize2; j++){
			if( looktime12[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime12[j*lookorder+i];
				tlindicator[length1]=lookindicator12[j*lookorder+i];
				length1=length1+1;
			}
		}
		int con3;

		// sort with respect to tltime (looktime):

		tlsort1=TSSort1(length1, samplesize2, tltime, tlindicator);

		// then separate:
		for(j=0; j<samplesize2; j++){
			tltime[j]=tlsort1[j*2+0];
			tlindicator[j]=tlsort1[j*2+1];
		}

		// count nhat12(dead), yhat12(at risk), and ctime12
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat12[j*lookorder+i]=tdead;
				yhat12[j*lookorder+i]=samplesize2-tcount;
				ctime12[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat12[j*lookorder+i]=tdead;
				yhat12[j*lookorder+i]=samplesize2-tcount;
				ctime12[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize2; j++){
			nhat12[j*lookorder+i]=nhat12[(j-1)*lookorder+i];
			yhat12[j*lookorder+i]=yhat12[(j-1)*lookorder+i];
			ctime12[j*lookorder+i]=-1;	// those not entered yet
		}
	}

	//end 2 control:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize1; j++){
			if( looktime21[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime21[j*lookorder+i];
				tlindicator[length1]=lookindicator21[j*lookorder+i];
				length1=length1+1;
			}
		}
		
		// sort with respect to tltime (looktime):
		tlsort1=TSSort1(length1, samplesize1, tltime, tlindicator);
		// then separate:
		for(j=0; j<samplesize1; j++){
			tltime[j]=tlsort1[j*2+0];
			tlindicator[j]=tlsort1[j*2+1];
		}

		// count nhat21(dead), yhat21(at risk), and ctime11
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat21[j*lookorder+i]=tdead;
				yhat21[j*lookorder+i]=samplesize1-tcount;
				ctime21[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat21[j*lookorder+i]=tdead;
				yhat21[j*lookorder+i]=samplesize1-tcount;
				ctime21[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize1; j++){
			nhat21[j*lookorder+i]=nhat21[(j-1)*lookorder+i];
			yhat21[j*lookorder+i]=yhat21[(j-1)*lookorder+i];
			ctime21[j*lookorder+i]=-1;	// those not entered yet
		}
	}

	//end 2 treatment:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize2; j++){
			if( looktime22[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime22[j*lookorder+i];
				tlindicator[length1]=lookindicator22[j*lookorder+i];
				length1=length1+1;
			}
		}
		
		// sort with respect to tltime (looktime):
		tlsort1=TSSort1(length1, samplesize2, tltime, tlindicator);
		// then separate:
		for(j=0; j<samplesize2; j++){
			tltime[j]=tlsort1[j*2+0];
			tlindicator[j]=tlsort1[j*2+1];
		}

		// count nhat22(dead), yhat22(at risk), and ctime22
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat22[j*lookorder+i]=tdead;
				yhat22[j*lookorder+i]=samplesize2-tcount;
				ctime22[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat22[j*lookorder+i]=tdead;
				yhat22[j*lookorder+i]=samplesize2-tcount;
				ctime22[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize2; j++){
			nhat22[j*lookorder+i]=nhat22[(j-1)*lookorder+i];
			yhat22[j*lookorder+i]=yhat22[(j-1)*lookorder+i];
			ctime22[j*lookorder+i]=-1;	// those not entered yet
		}
	}

	// so far has been checked. 
	// More attention on the numerical results may be needed.


	// now calculate uhat DIRECTLY:
	double *uhat11, *uhat12, *uhat21, *uhat22;

	uhat11=new double[samplesize1*lookorder];
	uhat12=new double[samplesize2*lookorder];
	uhat21=new double[samplesize1*lookorder];
	uhat22=new double[samplesize2*lookorder];

	for(i=0; i<samplesize1*lookorder; i++){
		uhat11[i]=0;
		uhat21[i]=0;
	}
	for(i=0; i<samplesize2*lookorder; i++){
		uhat12[i]=0;
		uhat22[i]=0;
	}

	double deltaM;


	// in the order version, the calculation of deltaM is correct
	// the problem is in the calculation of yhat12


	double tyhat11, tyhat12, tyhat21, tyhat22;
	double timepoint;

	// end 1 control:
	for(i=0; i<lookorder; i++){
		for(j=0; j<samplesize1; j++){
			if(ctime11[j*lookorder+i]!=-1){	// if has entered

				if(j==0){
					if(lookindicator11[j*lookorder+i]==0){	//event
						deltaM=1-nhat11[0*lookorder+i]/yhat11[0*lookorder+i];
					}
					else if(lookindicator11[j*lookorder+i]!=0){  //censor
						deltaM=-nhat11[0*lookorder+i]/yhat11[0*lookorder+i];
					}

					tyhat11=yhat11[j*lookorder+i];

					//find tyhat12:
					timepoint=ctime11[j*lookorder+i];
					l=0;
					while(ctime12[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat12=samplesize2;
					if(l!=0)
						tyhat12=yhat12[(l-1)*lookorder+i];
					
					uhat11[j*lookorder+i]=uhat11[j*lookorder+i]+deltaM*(1-(tyhat11)/(tyhat11+tyhat12));

				}
				
				if(j!=0){
					// calculate those before
					for(k=0; k<j-1; k++){
						if(k==0){
							deltaM=-nhat11[0*lookorder+i]/yhat11[0*lookorder+i];
						}
						if(k!=0){
							deltaM=-(nhat11[k*lookorder+i]-nhat11[(k-1)*lookorder+i])/yhat11[k*lookorder+i];
						}

						tyhat11=yhat11[k*lookorder+i];
						// find tyhat12:
						timepoint=ctime11[k*lookorder+i];
						l=0;
						while(ctime12[l*lookorder+i] <timepoint)
							l=l+1;
						if(l==0)
							tyhat12=samplesize2;
						if(l!=0)
							tyhat12=yhat12[(l-1)*lookorder+i];

						uhat11[j*lookorder+i]=uhat11[j*lookorder+i]+(1-(tyhat11)/(tyhat11+tyhat12))*deltaM;
					}

					// calculate its own
					if(lookindicator11[j*lookorder+i]==0) {    //event
						deltaM=1-(nhat11[j*lookorder+i]-nhat11[(j-1)*lookorder+i])/yhat11[j*lookorder+i];
					}
					else if (lookindicator11[j*lookorder+i]!=0){  //censor
						deltaM=-(nhat11[j*lookorder+i]-nhat11[(j-1)*lookorder+i])/yhat11[j*lookorder+i];
					}
					
					tyhat11=yhat11[j*lookorder+i];
					//find tyhat12:
					timepoint=ctime11[j*lookorder+i];
					l=0;
					while(ctime12[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat12=samplesize2;
					if(l!=0)
						tyhat12=yhat12[(l-1)*lookorder+i];

					uhat11[j*lookorder+i]=uhat11[j*lookorder+i]+(1-(tyhat11)/(tyhat11+tyhat12))*deltaM;
				}
			}
		}
	}

	// end 1 treatment:
	for(i=0; i<lookorder; i++){
		for(j=0; j<samplesize2; j++){
			if(ctime12[j*lookorder+i]!=-1){	// if has entered

				if(j==0){
					if( lookindicator12[j*lookorder+i]==0){	//event
						deltaM=1-nhat12[0*lookorder+i]/yhat12[0*lookorder+i];
					}
					else if( lookindicator12[j*lookorder+i]!=0) {   //censor
						deltaM=-nhat12[0*lookorder+i]/yhat12[0*lookorder+i];
					}

					tyhat12=yhat12[j*lookorder+i];

					//find tyhat11:
					timepoint=ctime12[j*lookorder+i];
					l=0;
					while(ctime11[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat11=samplesize1;
					if(l!=0)
						tyhat11=yhat11[(l-1)*lookorder+i];
					
					uhat12[j*lookorder+i]=uhat12[j*lookorder+i]+deltaM*(1-(tyhat12)/(tyhat11+tyhat12));

				}
				
				if(j!=0){
					// calculate those before
					for(k=0; k<j-1; k++){
						if(k==0){
							deltaM=-nhat12[0*lookorder+i]/yhat12[0*lookorder+i];
						}
						if(k!=0){
							deltaM=-(nhat12[k*lookorder+i]-nhat12[(k-1)*lookorder+i])/yhat12[k*lookorder+i];
						}

						tyhat12=yhat12[k*lookorder+i];
						// find tyhat11:
						timepoint=ctime12[k*lookorder+i];
						l=0;
						while(ctime11[l*lookorder+i] <timepoint)
							l=l+1;
						if(l==0)
							tyhat11=samplesize1;
						if(l!=0)
							tyhat11=yhat11[(l-1)*lookorder+i];

						uhat12[j*lookorder+i]=uhat12[j*lookorder+i]+(1-(tyhat12)/(tyhat11+tyhat12))*deltaM;
					}

					// calculate its own
					if( lookindicator12[j*lookorder+i]==0 ) {  //event
						deltaM=1-(nhat12[j*lookorder+i]-nhat12[(j-1)*lookorder+i])/yhat12[j*lookorder+i];
					}
					else if( lookindicator12[j*lookorder+i]!=0) {   //censor
						deltaM=-(nhat12[j*lookorder+i]-nhat12[(j-1)*lookorder+i])/yhat12[j*lookorder+i];
					}
					
					tyhat12=yhat12[j*lookorder+i];
					//find tyhat11:
					timepoint=ctime12[j*lookorder+i];
					l=0;
					while(ctime11[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat11=samplesize1;
					if(l!=0)
						tyhat11=yhat11[(l-1)*lookorder+i];

					uhat12[j*lookorder+i]=uhat12[j*lookorder+i]+(1-(tyhat12)/(tyhat11+tyhat12))*deltaM;
				}
			}
		}
	}

	// end 2 control:
	for(i=0; i<lookorder; i++){
		for(j=0; j<samplesize1; j++){
			if(ctime21[j*lookorder+i]!=-1){	// if has entered

				if(j==0){
					if( lookindicator21[j*lookorder+i]==0){		//event
						deltaM=1-nhat21[0*lookorder+i]/yhat21[0*lookorder+i];
					}
					else if( lookindicator21[j*lookorder+i]!=0){	//censor
						deltaM=-nhat21[0*lookorder+i]/yhat21[0*lookorder+i];
					}
					tyhat21=yhat21[j*lookorder+i];

					//find tyhat22:
					timepoint=ctime21[j*lookorder+i];
					l=0;
					while(ctime22[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat22=samplesize2;
					if(l!=0)
						tyhat22=yhat22[(l-1)*lookorder+i];
					
					uhat21[j*lookorder+i]=uhat21[j*lookorder+i]+deltaM*(1-(tyhat21)/(tyhat21+tyhat22));

				}
				
				if(j!=0){
					// calculate those before
					for(k=0; k<j-1; k++){
						if(k==0){
							deltaM=-nhat21[0*lookorder+i]/yhat21[0*lookorder+i];
						}
						if(k!=0){
							deltaM=-(nhat21[k*lookorder+i]-nhat21[(k-1)*lookorder+i])/yhat21[k*lookorder+i];
						}

						tyhat21=yhat21[k*lookorder+i];
						// find tyhat22:
						timepoint=ctime21[k*lookorder+i];
						l=0;
						while(ctime22[l*lookorder+i] <timepoint)
							l=l+1;
						if(l==0)
							tyhat22=samplesize2;
						if(l!=0)
							tyhat22=yhat22[(l-1)*lookorder+i];

						uhat21[j*lookorder+i]=uhat21[j*lookorder+i]+(1-(tyhat21)/(tyhat21+tyhat22))*deltaM;
					}

					// calculate its own
					if( lookindicator21[j*lookorder+i]==0 ) {   //event
						deltaM=1-(nhat21[j*lookorder+i]-nhat21[(j-1)*lookorder+i])/yhat21[j*lookorder+i];
					}
					else if ( lookindicator21[j*lookorder+i]!=0 ) {
						deltaM=-(nhat21[j*lookorder+i]-nhat21[(j-1)*lookorder+i])/yhat21[j*lookorder+i];
					}
					
					tyhat21=yhat21[j*lookorder+i];
					//find tyhat22:
					timepoint=ctime21[j*lookorder+i];
					l=0;
					while(ctime22[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat22=samplesize2;
					if(l!=0)
						tyhat22=yhat22[(l-1)*lookorder+i];

					uhat21[j*lookorder+i]=uhat21[j*lookorder+i]+(1-(tyhat21)/(tyhat21+tyhat22))*deltaM;
				}
			}
		}
	}

	// end 2 treatment:
	for(i=0; i<lookorder; i++){
		for(j=0; j<samplesize2; j++){
			if(ctime22[j*lookorder+i]!=-1){	// if has entered

				if(j==0){
					if( lookindicator22[j*lookorder+i]==0 ){   //event
						deltaM=1-nhat22[0*lookorder+i]/yhat22[0*lookorder+i];
					}
					if( lookindicator22[j*lookorder+i]!=0 ){   //censor
						deltaM=-nhat22[0*lookorder+i]/yhat22[0*lookorder+i];
					}
					tyhat22=yhat22[j*lookorder+i];

					//find tyhat21:
					timepoint=ctime22[j*lookorder+i];
					l=0;
					while(ctime21[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat21=samplesize1;
					if(l!=0)
						tyhat21=yhat21[(l-1)*lookorder+i];
					
					uhat22[j*lookorder+i]=uhat22[j*lookorder+i]+deltaM*(1-(tyhat22)/(tyhat21+tyhat22));

				}
				
				if(j!=0){
					// calculate those before
					for(k=0; k<j-1; k++){
						if(k==0){
							deltaM=-nhat22[0*lookorder+i]/yhat22[0*lookorder+i];
						}
						if(k!=0){
							deltaM=-(nhat22[k*lookorder+i]-nhat22[(k-1)*lookorder+i])/yhat22[k*lookorder+i];
						}

						tyhat22=yhat12[k*lookorder+i];
						// find tyhat21:
						timepoint=ctime22[k*lookorder+i];
						l=0;
						while(ctime21[l*lookorder+i] <timepoint)
							l=l+1;
						if(l==0)
							tyhat21=samplesize1;
						if(l!=0)
							tyhat21=yhat21[(l-1)*lookorder+i];

						uhat22[j*lookorder+i]=uhat22[j*lookorder+i]+(1-(tyhat22)/(tyhat21+tyhat22))*deltaM;
					}

					// calculate its own
					if( lookindicator22[j*lookorder+i]==0 ){   //event
						deltaM=1-(nhat22[j*lookorder+i]-nhat22[(j-1)*lookorder+i])/yhat22[j*lookorder+i];
					}
					else if( lookindicator22[j*lookorder+i]!=0 ){   //censor
						deltaM=-(nhat22[j*lookorder+i]-nhat22[(j-1)*lookorder+i])/yhat22[j*lookorder+i];
					}
					
					tyhat22=yhat22[j*lookorder+i];
					//find tyhat21:
					timepoint=ctime22[j*lookorder+i];
					l=0;
					while(ctime21[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat21=samplesize1;
					if(l!=0)
						tyhat21=yhat21[(l-1)*lookorder+i];

					uhat22[j*lookorder+i]=uhat22[j*lookorder+i]+(1-(tyhat22)/(tyhat21+tyhat22))*deltaM;
				}
			}
		}
	}


	// calculation of the omega hat:
	double *omegahat;
	int j1, j2, i1, i2;
	double temp1, temp2;
	omegahat=new double[2*lookorder*2*lookorder];
	double *omegacheck;
	omegacheck=new double[lookorder*lookorder];

	// separate into 4 blocks:

	// block 1:
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			temp1=0;
			temp2=0;
			for(i1=0; i1<samplesize1; i1++){
				temp1=temp1+uhat11[i1*lookorder+j1]*uhat11[i1*lookorder+j2];
			}
			for(i2=0; i2<samplesize2; i2++){
				temp2=temp2+uhat12[i2*lookorder+j1]*uhat12[i2*lookorder+j2];
			}
			omegahat[j1*2*lookorder+j2]=(temp1+temp2)/(samplesize1+samplesize2);
		}
	}

	//normalize the first block:
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			omegacheck[j1*lookorder+j2]=omegahat[j1*2*lookorder+j2]/sqrt(omegahat[j1*2*lookorder+j1]*omegahat[j2*2*lookorder+j2]);
		}
	}

	// block 2:
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			temp1=0;
			temp2=0;
			for(i1=0; i1<samplesize1; i1++){
				temp1=temp1+uhat11[i1*lookorder+j1]*uhat21[i1*lookorder+j2];
			}
			for(i2=0; i2<samplesize2; i2++){
				temp2=temp2+uhat12[i2*lookorder+j1]*uhat22[i2*lookorder+j2];
			}
			omegahat[j1*2*lookorder+j2+lookorder]=(temp1+temp2)/(samplesize1+samplesize2);
		}
	}

	// block 3:
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			temp1=0;
			temp2=0;
			for(i1=0; i1<samplesize1; i1++){
				temp1=temp1+uhat21[i1*lookorder+j1]*uhat11[i1*lookorder+j2];
			}
			for(i2=0; i2<samplesize2; i2++){
				temp2=temp2+uhat22[i2*lookorder+j1]*uhat12[i2*lookorder+j2];
			}
			omegahat[(j1+lookorder)*2*lookorder+j2]=(temp1+temp2)/(samplesize1+samplesize2);
		}
	}

	// block 4:
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			temp1=0;
			temp2=0;
			for(i1=0; i1<samplesize1; i1++){
				temp1=temp1+uhat21[i1*lookorder+j1]*uhat21[i1*lookorder+j2];
			}
			for(i2=0; i2<samplesize2; i2++){
				temp2=temp2+uhat22[i2*lookorder+j1]*uhat22[i2*lookorder+j2];
			}
			omegahat[(j1+lookorder)*2*lookorder+j2+lookorder]=(temp1+temp2)/(samplesize1+samplesize2);
		}
	}

	// the check of omega hat:
	cout<<"The normalized first block"<<endl;
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			cout<<omegacheck[j1*lookorder+j2]<<"\t";
		}
		cout<<endl;
	}
	return omegahat;

}






double *TSSort1(int length1, int size, double *tltime, double *tlindicator)
{
	int i, j, k;
	int con1;

	double *tlsort1;
	tlsort1=new double[2*size];
	
	for(i=0; i<length1; i++)
		tlsort1[i*2+0]=1000000;

	tlsort1[0*2+0]=tltime[0];
	tlsort1[0*2+1]=tlindicator[0];
	
	// search the rest one by one:
	for(i=1; i<length1; i++){
		j=0;
		while(tltime[i]>=tlsort1[j*2+0]){
			j=j+1;
		}
		if(j<length1-1){
			for(k=length1-1; k>j; k--){
				tlsort1[k*2+0]=tlsort1[(k-1)*2+0];
				tlsort1[k*2+1]=tlsort1[(k-1)*2+1];
			}
		}
		tlsort1[j*2+0]=tltime[i];
		tlsort1[j*2+1]=tlindicator[i];
	}


	for(i=length1; i<size; i++){
		tlsort1[i*2+0]=0;
		tlsort1[i*2+1]=0;
	}

	return tlsort1;
}





// the sort function with respect to event time in the TSCov;
// return value in the order of: entry, event, indicator.
double *SortTSCov(int samplesize, int lookorder, double *lookevent, double *looktime, double *lookindicator)
{
	int i, j, k, l;
//	int con1;

	double *returnsort;
	returnsort=new double[(1+2*lookorder)*samplesize];

	for(i=0; i<samplesize; i++)
		returnsort[i*(1+2*lookorder)+0]=10000;

	//initialize the first one:
	returnsort[0*(1+2*lookorder)+0]=lookevent[0];
	for(i=0; i<lookorder; i++){
		returnsort[0*(1+2*lookorder)+1+i]=looktime[0*lookorder+i];
		returnsort[0*(1+2*lookorder)+1+lookorder+i]=lookindicator[0*lookorder+i];
	}
	
	//search the rest one by one:
	for(i=1; i<samplesize; i++){
		j=0;
		while(lookevent[i]>returnsort[j*(1+2*lookorder)+0])
			j=j+1;
		for(k=samplesize-1; k>j; k--){
			for(l=0; l<1+2*lookorder; l++){
				returnsort[k*(1+2*lookorder)+l]=returnsort[(k-1)*(1+2*lookorder)+l];
			}
		}
		returnsort[j*(1+2*lookorder)+0]=lookevent[i];
		for(l=0; l<lookorder; l++){
			returnsort[j*(1+2*lookorder)+1+l]=looktime[i*lookorder+l];
			returnsort[j*(1+2*lookorder)+1+l+lookorder]=lookindicator[i*lookorder+l];
		}
	}
	return returnsort;
}











//
//	The NormalSurvival Case
//

// Data should be in NormalEnd1 & SurvivalEnd2
void NormalSurvivalDecision()
{

	int con1;

	int MAXLOOK1;
	MAXLOOK1=10;

	int samplesize1, samplesize2;
	int num_look;
	int looksimul;
	int lookorder;

	samplesize1=SurvivalEnd2->sample_size1;
	samplesize2=SurvivalEnd2->sample_size2;
	num_look=SurvivalEnd2->num_look;
	looksimul=SurvivalEnd2->num_simul;
	lookorder=SurvivalEnd2->look_order;

	int column=6;
	int i, j, k, l, m, n;

	// the normal data is in dataEnd11, dataEnd12...	 
	// normal data is stored in normalcontrol and normaltreat
	double *normalcontrol, *normaltreat;
	normalcontrol=new double[MAXLOOK*samplesize1];	// normal data control
	normaltreat=new double[MAXLOOK*samplesize2];	// normal data treatment

	for(i=0; i<samplesize1; i++){
		normalcontrol[i*MAXLOOK1+0]=dataEnd11[i];
		normalcontrol[i*MAXLOOK1+1]=dataEnd12[i];
		normalcontrol[i*MAXLOOK1+2]=dataEnd13[i];
		normalcontrol[i*MAXLOOK1+3]=dataEnd14[i];
		normalcontrol[i*MAXLOOK1+4]=dataEnd15[i];
		normalcontrol[i*MAXLOOK1+5]=dataEnd16[i];
		normalcontrol[i*MAXLOOK1+6]=dataEnd17[i];
		normalcontrol[i*MAXLOOK1+7]=dataEnd18[i];
		normalcontrol[i*MAXLOOK1+8]=dataEnd19[i];
		normalcontrol[i*MAXLOOK1+9]=dataEnd10[i];
	}

	for(i=0; i<samplesize2; i++){
		normaltreat[i*MAXLOOK1+0]=dataEnd11[samplesize1+i];
		normaltreat[i*MAXLOOK1+1]=dataEnd12[samplesize1+i];
		normaltreat[i*MAXLOOK1+2]=dataEnd13[samplesize1+i];
		normaltreat[i*MAXLOOK1+3]=dataEnd14[samplesize1+i];
		normaltreat[i*MAXLOOK1+4]=dataEnd15[samplesize1+i];
		normaltreat[i*MAXLOOK1+5]=dataEnd16[samplesize1+i];
		normaltreat[i*MAXLOOK1+6]=dataEnd17[samplesize1+i];
		normaltreat[i*MAXLOOK1+7]=dataEnd18[samplesize1+i];
		normaltreat[i*MAXLOOK1+8]=dataEnd19[samplesize1+i];
		normaltreat[i*MAXLOOK1+9]=dataEnd10[samplesize1+i];
	}
	
	// now seperate the survival data:
	// we will only have send21 & send22 for the second endpoint:

	double *send21, *send22;
	send21=new double[column*(samplesize1+samplesize2)];	//end2 control
	send22=new double[column*(samplesize1+samplesize2)];	//end2 treatment

	int p1=0, p2=0, p3=0, p4=0;

	for(i=0; i<samplesize1+samplesize2; i++){
		if( (dataS2[i*column+0]==2) && (dataS2[i*column+1]==0) ){
			send21[p3*column+0]=dataS2[i*column+0];
			send21[p3*column+1]=dataS2[i*column+1];
			send21[p3*column+2]=dataS2[i*column+2];
			send21[p3*column+3]=dataS2[i*column+3];
			send21[p3*column+4]=dataS2[i*column+4];
			send21[p3*column+5]=dataS2[i*column+5];
			p3=p3+1;
		}	// end2 control

		if( (dataS2[i*column+0]==2) && (dataS2[i*column+1]==1) ){
			send22[p4*column+0]=dataS2[i*column+0];
			send22[p4*column+1]=dataS2[i*column+1];
			send22[p4*column+2]=dataS2[i*column+2];
			send22[p4*column+3]=dataS2[i*column+3];
			send22[p4*column+4]=dataS2[i*column+4];
			send22[p4*column+5]=dataS2[i*column+5];
			p4=p4+1;
		}	// end2 treatment

	}


	double *looktime;
	looktime=new double[lookorder];
	for(i=0; i<lookorder; i++)
		looktime[i]=SurvivalEnd2->look_time[i];


	// the following is mostly copied from the TSCov:

	//
	// The MAIN CHANGE IS THAT: we will need the ID information.
	//

	double *entry21, *entry22;
	double *event21, *event22;
	double *indicator21, *indicator22; 
	double *indentify21, *indentify22;
	// the one separate directly from data

	double *lookevent21, *lookevent22;
	double *looktime21, *looktime22;
	double *lookindicator21, *lookindicator22; 
	//after considering the different look time.

	entry21=new double[samplesize1];
	entry22=new double[samplesize2];

	event21=new double[samplesize1];
	event22=new double[samplesize2];

	indicator21=new double[samplesize1];
	indicator22=new double[samplesize2];

	indentify21=new double[samplesize1*lookorder];
	indentify22=new double[samplesize2*lookorder];

	lookevent21=new double[samplesize1];
	lookevent22=new double[samplesize2];

	looktime21=new double[samplesize1*lookorder];
	looktime22=new double[samplesize2*lookorder];

	lookindicator21=new double[samplesize1*lookorder];
	lookindicator22=new double[samplesize2*lookorder];

	//initialize entry event, and indicator
	for(i=0; i<samplesize1; i++){
		//end 2 control
		entry21[i]=send21[i*column+3];
		event21[i]=send21[i*column+4];
		indicator21[i]=send21[i*column+5];
		for(j=0; j<lookorder; j++){
			indentify21[i*lookorder+j]=send21[i*column+2];
		}
	}
	
	for(i=0; i<samplesize2; i++){
		//end 2 treatment
		entry22[i]=send22[i*column+3];
		event22[i]=send22[i*column+4];
		indicator22[i]=send22[i*column+5];
		for(j=0; j<lookorder; j++){
			indentify22[i*lookorder+j]=send22[i*column+2];
		}
	}


	// initialize lookevent, looktime and lookindicator:

	//end 2 control
	for(i=0; i<samplesize1; i++){
		lookevent21[i]=event21[i]-entry21[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry21[i] ){
				looktime21[i*lookorder+j]=-1;   //not entered yet
				lookindicator21[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry21[i]){
				if(looktime[j]>=event21[i]){		//enter. by the time of look, event happens
					looktime21[i*lookorder+j]=looktime[j]-entry21[i];
					lookindicator21[i*lookorder+j]=indicator21[i];
				}
				else if(looktime[j]<event21[i]){		//by the time of look, event not happen yet.
					looktime21[i*lookorder+j]=looktime[j]-entry21[i];
					lookindicator21[i*lookorder+j]=1;
				}
			}
		}
	}	

	//end 2 treatment
	for(i=0; i<samplesize2; i++){
		lookevent22[i]=event22[i]-entry22[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry22[i] ){
				looktime22[i*lookorder+j]=-1;   //not entered yet
				lookindicator22[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry22[i]){
				if(looktime[j]>=event22[i]){		//enter. by the time of look, event happens
					looktime22[i*lookorder+j]=looktime[j]-entry22[i];
					lookindicator22[i*lookorder+j]=indicator22[i];
				}
				else if(looktime[j]<event22[i]){		//by the time of look, event not happen yet.
					looktime22[i*lookorder+j]=looktime[j]-entry22[i];
					lookindicator22[i*lookorder+j]=1;
				}
			}
		}
	}	

	//
	//	in the sort process, we need to have indentify21 (22) sorted also
	//

	// sort each one according to lookevent
	double *sort3, *sort4;
	sort3=new double[(1+3*lookorder)*samplesize1]; //end21
	sort4=new double[(1+3*lookorder)*samplesize2]; //end22
	sort3=SortNSCov(samplesize1, lookorder, lookevent21, looktime21, lookindicator21, indentify21);
	sort4=SortNSCov(samplesize2, lookorder, lookevent22, looktime22, lookindicator22, indentify22);


	// Re-separate lookevent, looktime, lookindicator & indentify:

	//end2 control
	for(i=0; i<samplesize1; i++){
		lookevent21[i]=sort3[i*(1+3*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime21[i*lookorder+j]=sort3[i*(1+3*lookorder)+j+1];
			lookindicator21[i*lookorder+j]=sort3[i*(1+3*lookorder)+j+1+lookorder];
			indentify21[i*lookorder+j]=sort3[i*(1+3*lookorder)+j+1+lookorder*2];
		}
	}
	//end2 treat
	for(i=0; i<samplesize2; i++){
		lookevent22[i]=sort4[i*(1+3*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime22[i*lookorder+j]=sort4[i*(1+3*lookorder)+j+1];
			lookindicator22[i*lookorder+j]=sort4[i*(1+3*lookorder)+j+1+lookorder];
			indentify22[i*lookorder+j]=sort4[i*(1+3*lookorder)+j+1+lookorder*2];
		}
	}

	
	// check process after SortNSCov:

	// now calculate nhat, yhat and time of change
	double *nhat21, *nhat22;
	double *yhat21, *yhat22;
	double *ctime21, *ctime22;
	int *IDhat21, *IDhat22;

	nhat21=new double[samplesize1*lookorder];
	nhat22=new double[samplesize2*lookorder];

	yhat21=new double[samplesize1*lookorder];
	yhat22=new double[samplesize2*lookorder];

	ctime21=new double[samplesize1*lookorder];
	ctime22=new double[samplesize2*lookorder];

	IDhat21=new int[samplesize1*lookorder];
	IDhat22=new int[samplesize2*lookorder];

	// sort looktime and lookindicator to calculate yhat, nhat and ctime:

	double *tltime, *tlindicator, *tlID;
	double *tlsort1;
	int length1;
	
	int tdead, tcount;

	tltime=new double[max(samplesize1, samplesize2)];
	tlindicator=new double[max(samplesize1, samplesize2)];
	tlID=new double[max(samplesize1, samplesize2)];
	tlsort1=new double[3*max(samplesize1, samplesize2)];


	//end 2 control:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize1; j++){
			if( looktime21[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime21[j*lookorder+i];
				tlindicator[length1]=lookindicator21[j*lookorder+i];
				tlID[length1]=indentify21[j*lookorder+i];
				length1=length1+1;
			}
		}
		
		// sort with respect to tltime (looktime):
		tlsort1=NSSort1(length1, samplesize1, tltime, tlindicator, tlID);

		// then separate:
		for(j=0; j<samplesize1; j++){
			tltime[j]=tlsort1[j*3+0];
			tlindicator[j]=tlsort1[j*3+1];
			tlID[j]=tlsort1[j*3+2];
		}

		// count nhat21(dead), yhat21(at risk), and ctime11
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat21[j*lookorder+i]=tdead;
				yhat21[j*lookorder+i]=samplesize1-tcount;
				ctime21[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat21[j*lookorder+i]=tdead;
				yhat21[j*lookorder+i]=samplesize1-tcount;
				ctime21[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize1; j++){
			nhat21[j*lookorder+i]=nhat21[(j-1)*lookorder+i];
			yhat21[j*lookorder+i]=yhat21[(j-1)*lookorder+i];
			ctime21[j*lookorder+i]=-1;	// those not entered yet
		}

		for(j=0; j<length1; j++)
			IDhat21[j*lookorder+i]=tlID[j];
		for(j=length1; j<samplesize1; j++)
			IDhat21[j*lookorder+i]=-1;
	}


	//end 2 treatment:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize2; j++){
			if( looktime22[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime22[j*lookorder+i];
				tlindicator[length1]=lookindicator22[j*lookorder+i];
				tlID[length1]=indentify22[j*lookorder+i];
				length1=length1+1;
			}
		}
		
		// sort with respect to tltime (looktime):
		tlsort1=NSSort1(length1, samplesize2, tltime, tlindicator, tlID);
		// then separate:
		for(j=0; j<samplesize2; j++){
			tltime[j]=tlsort1[j*3+0];
			tlindicator[j]=tlsort1[j*3+1];
			tlID[j]=tlsort1[j*3+2];
		}

		// count nhat22(dead), yhat22(at risk), and ctime22
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat22[j*lookorder+i]=tdead;
				yhat22[j*lookorder+i]=samplesize2-tcount;
				ctime22[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat22[j*lookorder+i]=tdead;
				yhat22[j*lookorder+i]=samplesize2-tcount;
				ctime22[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize2; j++){
			nhat22[j*lookorder+i]=nhat22[(j-1)*lookorder+i];
			yhat22[j*lookorder+i]=yhat22[(j-1)*lookorder+i];
			ctime22[j*lookorder+i]=-1;	// those not entered yet
		}
		
		for(j=0; j<length1; j++)
			IDhat22[j*lookorder+i]=tlID[j];
		for(j=length1; j<samplesize2; j++)
			IDhat22[j*lookorder+i]=tlID[j];
	}


	int *ID21, *ID22;	// the converted to integer version
	ID21=new int[samplesize1*lookorder];
	ID22=new int[samplesize2*lookorder];

	for(i=0; i<samplesize1; i++){
		for(j=0; j<lookorder; j++){
			ID21[i*lookorder+j]=(int) indentify21[i*lookorder+j];
		}
	}

	for(i=0; i<samplesize2; i++){
		for(j=0; j<lookorder; j++){
			ID22[i*lookorder+j]=(int) indentify22[i*lookorder+j];
		}
	}

	
	// now calculate uhat DIRECTLY:
	double *uhat21, *uhat22;

	uhat21=new double[samplesize1*lookorder];
	uhat22=new double[samplesize2*lookorder];

	for(i=0; i<samplesize1*lookorder; i++){
		uhat21[i]=0;
	}
	for(i=0; i<samplesize2*lookorder; i++){
		uhat22[i]=0;
	}

	double deltaM;


	// in the order version, the calculation of deltaM is correct
	// the problem is in the calculation of yhat12


	double tyhat21, tyhat22;
	double timepoint;

	// end 2 control:
	for(i=0; i<lookorder; i++){
		for(j=0; j<samplesize1; j++){
			if(ctime21[j*lookorder+i]!=-1){	// if has entered

				if(j==0){
					if( lookindicator21[j*lookorder+i]==0){		//event
						deltaM=1-nhat21[0*lookorder+i]/yhat21[0*lookorder+i];
					}
					else if( lookindicator21[j*lookorder+i]!=0){	//censor
						deltaM=-nhat21[0*lookorder+i]/yhat21[0*lookorder+i];
					}
					tyhat21=yhat21[j*lookorder+i];

					//find tyhat22:
					timepoint=ctime21[j*lookorder+i];
					l=0;
					while(ctime22[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat22=samplesize2;
					if(l!=0)
						tyhat22=yhat22[(l-1)*lookorder+i];
					
					uhat21[j*lookorder+i]=uhat21[j*lookorder+i]+deltaM*(1-(tyhat21)/(tyhat21+tyhat22));

				}
				
				if(j!=0){
					// calculate those before
					for(k=0; k<j-1; k++){
						if(k==0){
							deltaM=-nhat21[0*lookorder+i]/yhat21[0*lookorder+i];
						}
						if(k!=0){
							deltaM=-(nhat21[k*lookorder+i]-nhat21[(k-1)*lookorder+i])/yhat21[k*lookorder+i];
						}

						tyhat21=yhat21[k*lookorder+i];
						// find tyhat22:
						timepoint=ctime21[k*lookorder+i];
						l=0;
						while(ctime22[l*lookorder+i] <timepoint)
							l=l+1;
						if(l==0)
							tyhat22=samplesize2;
						if(l!=0)
							tyhat22=yhat22[(l-1)*lookorder+i];

						uhat21[j*lookorder+i]=uhat21[j*lookorder+i]+(1-(tyhat21)/(tyhat21+tyhat22))*deltaM;
					}

					// calculate its own
					if( lookindicator21[j*lookorder+i]==0 ) {   //event
						deltaM=1-(nhat21[j*lookorder+i]-nhat21[(j-1)*lookorder+i])/yhat21[j*lookorder+i];
					}
					else if ( lookindicator21[j*lookorder+i]!=0 ) {
						deltaM=-(nhat21[j*lookorder+i]-nhat21[(j-1)*lookorder+i])/yhat21[j*lookorder+i];
					}
					
					tyhat21=yhat21[j*lookorder+i];
					//find tyhat22:
					timepoint=ctime21[j*lookorder+i];
					l=0;
					while(ctime22[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat22=samplesize2;
					if(l!=0)
						tyhat22=yhat22[(l-1)*lookorder+i];

					uhat21[j*lookorder+i]=uhat21[j*lookorder+i]+(1-(tyhat21)/(tyhat21+tyhat22))*deltaM;
				}
			}
		}
	}

	// end 2 treatment:
	for(i=0; i<lookorder; i++){
		for(j=0; j<samplesize2; j++){
			if(ctime22[j*lookorder+i]!=-1){	// if has entered

				if(j==0){
					if( lookindicator22[j*lookorder+i]==0 ){   //event
						deltaM=1-nhat22[0*lookorder+i]/yhat22[0*lookorder+i];
					}
					if( lookindicator22[j*lookorder+i]!=0 ){   //censor
						deltaM=-nhat22[0*lookorder+i]/yhat22[0*lookorder+i];
					}
					tyhat22=yhat22[j*lookorder+i];

					//find tyhat21:
					timepoint=ctime22[j*lookorder+i];
					l=0;
					while(ctime21[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat21=samplesize1;
					if(l!=0)
						tyhat21=yhat21[(l-1)*lookorder+i];
					
					uhat22[j*lookorder+i]=uhat22[j*lookorder+i]+deltaM*(1-(tyhat22)/(tyhat21+tyhat22));

				}
				
				if(j!=0){
					// calculate those before
					for(k=0; k<j-1; k++){
						if(k==0){
							deltaM=-nhat22[0*lookorder+i]/yhat22[0*lookorder+i];
						}
						if(k!=0){
							deltaM=-(nhat22[k*lookorder+i]-nhat22[(k-1)*lookorder+i])/yhat22[k*lookorder+i];
						}

						tyhat22=yhat22[k*lookorder+i];
						// find tyhat21:
						timepoint=ctime22[k*lookorder+i];
						l=0;
						while(ctime21[l*lookorder+i] <timepoint)
							l=l+1;
						if(l==0)
							tyhat21=samplesize1;
						if(l!=0)
							tyhat21=yhat21[(l-1)*lookorder+i];

						uhat22[j*lookorder+i]=uhat22[j*lookorder+i]+(1-(tyhat22)/(tyhat21+tyhat22))*deltaM;
					}

					// calculate its own
					if( lookindicator22[j*lookorder+i]==0 ){   //event
						deltaM=1-(nhat22[j*lookorder+i]-nhat22[(j-1)*lookorder+i])/yhat22[j*lookorder+i];
					}
					else if( lookindicator22[j*lookorder+i]!=0 ){   //censor
						deltaM=-(nhat22[j*lookorder+i]-nhat22[(j-1)*lookorder+i])/yhat22[j*lookorder+i];
					}
					
					tyhat22=yhat22[j*lookorder+i];
					//find tyhat21:
					timepoint=ctime22[j*lookorder+i];
					l=0;
					while(ctime21[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat21=samplesize1;
					if(l!=0)
						tyhat21=yhat21[(l-1)*lookorder+i];

					uhat22[j*lookorder+i]=uhat22[j*lookorder+i]+(1-(tyhat22)/(tyhat21+tyhat22))*deltaM;
				}
			}
		}
	}


	// seems to be reasonable August 19th 9:20AM
	int *sizecontrol, *sizetreat;	// the sample size at each look.
	sizecontrol=new int[lookorder];
	sizetreat=new int[lookorder];

	for(i=0; i<lookorder; i++){
		sizecontrol[i]=0;
		sizetreat[i]=0;
	}

	for(i=0; i<lookorder; i++){
		//control:
		for(j=0; j<samplesize1; j++){
			if(ctime21[j*lookorder+i]!=-1)
				sizecontrol[i]=sizecontrol[i]+1;
		}
		//treat
		for(j=0; j<samplesize2; j++){
			if(ctime22[j*lookorder+i]!=-1)
				sizetreat[i]=sizetreat[i]+1;
		}
	}
	
//	
//	double *normaluhat11, *normaluhat12;	//end 1 (normal data)
	// we can define similarky normaluhat11 & normaluhat12

//	normaluhat11=new double[samplesize1*lookorder];
//	normaluhat12=new double[samplesize2*lookorder];

	// the organized normal data.
	// the original data is in normalcontrol & normaltreat
	double *control_org, *treat_org;
	control_org=new double[samplesize1*lookorder];
	treat_org=new double[samplesize2*lookorder];

	for(i=0; i<samplesize1*lookorder; i++)
		control_org[i]=0;
	for(i=0; i<samplesize2*lookorder; i++)
		treat_org[i]=0;

	for(i=0; i<lookorder; i++){
		for(j=0; j<sizecontrol[i]; j++)
			control_org[j*lookorder+i]=normalcontrol[ID21[j*lookorder+i]*MAXLOOK1+i];
		for(j=0; j<sizetreat[i]; j++)
			treat_org[j*lookorder+i]=normaltreat[ID22[j*lookorder+i]*MAXLOOK1+i];
	}


	double *meancontrol, *meantreat;
	meancontrol=new double[lookorder];
	meantreat=new double[lookorder];

	for(i=0; i<lookorder; i++){
		meancontrol[i]=0;
		meantreat[i]=0;
	}

	for(i=0; i<lookorder; i++){
		for(j=0; j<sizecontrol[i]; j++){
			meancontrol[i]=meancontrol[i]+control_org[j*lookorder+i];
		}
		meancontrol[i]=meancontrol[i]/sizecontrol[i];

		for(j=0; j<sizetreat[i]; j++){
			meantreat[i]=meantreat[i]+treat_org[j*lookorder+i];
		}
		meantreat[i]=meantreat[i]/sizetreat[i];
	}

/*	cout<<"check point"<<endl;
	for(i=0; i<lookorder; i++)
		cout<<meancontrol[i]<<"\t";
	cout<<endl;
	for(i=0; i<lookorder; i++)
		cout<<meantreat[i]<<"\t";
	cout<<endl<<"mean of control and treat"<<endl;
*/

	double *uhat11, *uhat12;
	uhat11=new double[samplesize1*lookorder];
	uhat12=new double[samplesize2*lookorder];

	for(i=0; i<samplesize1*lookorder; i++)
		uhat11[i]=0;
	for(i=0; i<samplesize2*lookorder; i++)
		uhat12[i]=0;

	for(i=0; i<lookorder; i++){
		for(j=0; j<sizecontrol[i]; j++){
			uhat11[j*lookorder+i]=control_org[j*lookorder+i]-meancontrol[i];
		}

		for(j=0; j<sizetreat[i]; j++){
			uhat12[j*lookorder+i]=treat_org[j*lookorder+i]-meantreat[i];
		}
	}


	// calculation of the omega hat:
	double *omegahat;
	int j1, j2, i1, i2;
	double temp1, temp2;
	omegahat=new double[2*lookorder*2*lookorder];
	double *omegacheck;
	omegacheck=new double[2*lookorder*2*lookorder];

	// separate into 4 blocks:

	// block 1:
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			temp1=0;
			temp2=0;
			for(i1=0; i1<samplesize1; i1++){
				temp1=temp1+uhat11[i1*lookorder+j1]*uhat11[i1*lookorder+j2];
			}
			for(i2=0; i2<samplesize2; i2++){
				temp2=temp2+uhat12[i2*lookorder+j1]*uhat12[i2*lookorder+j2];
			}
			omegahat[j1*2*lookorder+j2]=(temp1+temp2)/(samplesize1+samplesize2);
		}
	}


	// block 2:
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			temp1=0;
			temp2=0;
			for(i1=0; i1<samplesize1; i1++){
				temp1=temp1+uhat11[i1*lookorder+j1]*uhat21[i1*lookorder+j2];
			}
			for(i2=0; i2<samplesize2; i2++){
				temp2=temp2+uhat12[i2*lookorder+j1]*uhat22[i2*lookorder+j2];
			}
			omegahat[j1*2*lookorder+j2+lookorder]=(temp1+temp2)/(samplesize1+samplesize2);
		}
	}

	// block 3:
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			temp1=0;
			temp2=0;
			for(i1=0; i1<samplesize1; i1++){
				temp1=temp1+uhat21[i1*lookorder+j1]*uhat11[i1*lookorder+j2];
			}
			for(i2=0; i2<samplesize2; i2++){
				temp2=temp2+uhat22[i2*lookorder+j1]*uhat12[i2*lookorder+j2];
			}
			omegahat[(j1+lookorder)*2*lookorder+j2]=(temp1+temp2)/(samplesize1+samplesize2);
		}
	}

	// block 4:
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			temp1=0;
			temp2=0;
			for(i1=0; i1<samplesize1; i1++){
				temp1=temp1+uhat21[i1*lookorder+j1]*uhat21[i1*lookorder+j2];
			}
			for(i2=0; i2<samplesize2; i2++){
				temp2=temp2+uhat22[i2*lookorder+j1]*uhat22[i2*lookorder+j2];
			}
			omegahat[(j1+lookorder)*2*lookorder+j2+lookorder]=(temp1+temp2)/(samplesize1+samplesize2);
		}
	}


	for(i=0; i<2*lookorder; i++)
		for(j=0; j<2*lookorder; j++)
			omegacheck[i*2*lookorder+j]=omegahat[i*2*lookorder+j]/sqrt(omegahat[i*2*lookorder+i]*omegahat[j*2*lookorder+j]);

	double *sqrtomega;
	sqrtomega=new double[2*lookorder*2*lookorder];
	sqrtomega=sqrt_matrix(2*lookorder, omegacheck);
	
//	the correlation has been found above. August 19th 8:00PM (checked)
//

//	the following is copied from the code of two survival.


	double *overCov;
	overCov=new double[2*lookorder*2*lookorder];

	for(i=0; i<2*lookorder*2*lookorder; i++)
		overCov[i]=omegahat[i];

	double * overCovA;
	overCovA=new double[2*lookorder*2*lookorder];

	for(i=0; i<lookorder; i++){ 
		for(j=0; j<lookorder; j++){  
			overCovA[i*2*lookorder+j]=overCov[i*2*lookorder+j]/sqrt(overCov[i*2*lookorder+i]*overCov[j*2*lookorder+j]);
			overCovA[(i+lookorder)*2*lookorder+j]=overCov[(i+lookorder)*2*lookorder+j]/sqrt(overCov[j*2*lookorder+j]*overCov[(i+lookorder)*2*lookorder+lookorder+i]);
			overCovA[i*2*lookorder+j+lookorder]=overCov[i*2*lookorder+j+lookorder]/sqrt(overCov[i*2*lookorder+i]*overCov[(j+lookorder)*2*lookorder+lookorder+j]);
			overCovA[(i+lookorder)*2*lookorder+j+lookorder]=overCov[(i+lookorder)*2*lookorder+j+lookorder]/sqrt(overCov[(i+lookorder)*2*lookorder+i+lookorder]*overCov[(j+lookorder)*2*lookorder+lookorder+j]);
		}
	}

	double *tempAA;
	tempAA=new double[2*lookorder*2*lookorder];
	tempAA=sqrt_matrix(2*lookorder, overCovA);

	double *overArray;
	overArray=new double[2*lookorder*looksimul];
	
	double *meanA1, *varA1;
	meanA1=new double[2*lookorder];
	varA1=new double[2*lookorder];

	for(i=0; i<2*lookorder; i++){
		meanA1[i]=0;
		varA1[i]=overCovA[i*2*lookorder+i];
	}

	overArray=UNNormalSimul(2*lookorder, looksimul, meanA1, varA1, overCovA);
	
	// the check procedure of overArray.
	double *checkstructure1;
	int sizec1=2*lookorder;
	int sizec2=looksimul;
	checkstructure1=new double[sizec1*(2+sizec1)];
	checkstructure1=NormalCheck(sizec1, sizec2, overArray);

	double *meanend1, *meanend2;
	meanend1=new double[lookorder];
	meanend2=new double[lookorder];
	
	double *l1, *l2;
	l1=new double[lookorder];
	l2=new double[lookorder];

	for(i=0; i<lookorder; i++){
		l1[i]=0;
		l2[i]=0;
		for(j=0; j<samplesize1; j++){
			for(k=0; k<=i; k++){
				if(ctime21[j*lookorder+k]>0){
					//enrolled
					l1[i]=l1[i]+1;
				}
			}
		}

		for(j=0; j<samplesize2; j++){
			for(k=0; k<=i; k++){
				if(ctime22[j*lookorder+k]>0){
					//enrolled
					l2[i]=l2[i]+1;
				}
			}
		}
	}


	//need to calculate the mean for each end at each look.
	for(i=0; i<lookorder; i++){
		con1=0;
		for(j=0; j<=i; j++)
			con1=con1+sizetreat[j];
		meanend1[i]=(NormalEnd1->meanAlter*l2[i]-NormalEnd1->meanNull*l1[i])/sqrt(l1[i]+l2[i]);

		meanend2[i]=(sqrt(samplesize1+samplesize2))*absd(log(SurvivalEnd2->lambdaAlter/SurvivalEnd2->lambdaNull))*sqrt(overCov[(i+lookorder)*2*lookorder+i+lookorder]);
	}

	// Separate nend11, nend12, nend21, nend22:
	double *nend11, *nend12, *nend21, *nend22;
	nend11=new double[looksimul*lookorder];
	nend12=new double[looksimul*lookorder];
	nend21=new double[looksimul*lookorder];
	nend22=new double[looksimul*lookorder];

	for(i=0; i<looksimul; i++){
		for(j=0; j<lookorder; j++){
			nend11[i*lookorder+j]=overArray[i*2*lookorder+j];	//end 1 control
			nend12[i*lookorder+j]=overArray[i*2*lookorder+j]+meanend1[j];	//end1 treat
			nend21[i*lookorder+j]=overArray[i*2*lookorder+lookorder+j];		//end2 control
			nend22[i*lookorder+j]=overArray[i*2*lookorder+lookorder+j]+meanend2[j];	//end2 treat
		}
	}

	// check of nend11, nend12, nend21, nend22:
	double *nendcheck;
	nendcheck=new double[lookorder*(2+lookorder)];

	// calculation of mariginal critical boundary:
	double *boundary1, *boundary2;
	boundary1=new double[2*lookorder];
	boundary2=new double[2*lookorder];


	// create two quasi TrialEndNormal Type for the calculation of UNBound:
	TrialEndNormal *Tend1, *Tend2;
	Tend1=new TrialEndNormal;
	Tend2=new TrialEndNormal;


	Tend1->order=1;
	Tend1->num_look=num_look;
	Tend1->look_order=lookorder;
	Tend1->looksimul=looksimul;
	Tend1->sample_size=samplesize1+samplesize2;
//	Tend1->spending_number=SurvivalEnd1->alphaSpend;
	Tend1->spending_number=NormalEnd1->spending_number;
	Tend1->meanNull=0;
//	Tend1->meanAlter=absd(log(SurvivalEnd1->lambdaAlter/SurvivalEnd1->lambdaNull));
	Tend1->meanAlter=NormalEnd1->meanAlter;
//	Tend1->Bi_Alpha=SurvivalEnd1->global_alpha;
	Tend1->Bi_Alpha=NormalEnd1->Bi_Alpha;
//	Tend1->Bi_Beta=SurvivalEnd1->global_beta;
	Tend1->Bi_Beta=NormalEnd1->Bi_Beta;
//	Tend1->overall_alpha=SurvivalEnd1->alpha;
	Tend1->overall_alpha=NormalEnd1->overall_alpha;
//	Tend1->overall_beta=SurvivalEnd1->beta;
	Tend1->overall_beta=NormalEnd1->overall_beta;
	
	Tend2->order=2;
	Tend2->num_look=num_look;
	Tend2->look_order=lookorder;
	Tend2->looksimul=looksimul;
	Tend2->sample_size=samplesize1+samplesize2;
	Tend2->spending_number=SurvivalEnd2->alphaSpend;
	Tend2->meanNull=0;
	Tend2->meanAlter=absd(log(SurvivalEnd2->lambdaAlter/SurvivalEnd2->lambdaNull));
	Tend2->Bi_Alpha=SurvivalEnd2->global_alpha;
	Tend2->Bi_Beta=SurvivalEnd2->global_beta;
	Tend2->overall_alpha=SurvivalEnd2->alpha;
	Tend2->overall_beta=SurvivalEnd2->beta;
	

	for(i=0; i<num_look; i++){
		Tend1->inform_time[i]=NormalEnd1->inform_time[i];
		Tend2->inform_time[i]=SurvivalEnd2->inform_time[i];

		Tend1->alpha[i]=NormalEnd1->alpha[i];
		Tend1->beta[i]=NormalEnd1->beta[i];
		Tend2->alpha[i]=SurvivalEnd2->alpha_spending[i];
		Tend2->beta[i]=SurvivalEnd2->beta_spending[i];

	}


	boundary1=UNBound(lookorder, nend11, nend12, Tend1);
	boundary2=UNBound(lookorder, nend21, nend22, Tend2);
	
	int decisiontype;		//hard versus soft.
	decisiontype=NormalEnd1->rule_decision;
	cout<<"decision"<<"\t"<<decisiontype<<endl;


	double *BiAlpha;
	BiAlpha=new double[SurvivalEnd2->num_look];
	for(i=0; i<SurvivalEnd2->num_look; i++)
		BiAlpha[i]=SurvivalEnd2->BiAlphaSpending[i];

	double *work1, *work2;
	work1=new double[looksimul];
	work2=new double[looksimul];

	// since only alpha is invloved, we only need the distribution under the Null,
	// however, since we may need to report the beta spending eventually, we also
	// get the Alternative distribution for future use.

	int search_length=1000;

	double *c_search;
	c_search=new double[search_length];

	double c_lower=0.01;
	double c_upper=10.0;
	double c_mid;
	double c_range=c_upper-c_lower;
	double alphawork=0;
	double countt=0;	
	double minalphawork=1.0;

	int nn;
	int lengthlook;
	int indi;
	
	
	double *upper1, *lower1, *upper2, *lower2;
	double *adjustupper1, *adjustlower1, *adjustupper2, *adjustlower2;
	
	upper1=new double[lookorder];
	lower1=new double[lookorder];
	upper2=new double[lookorder];
	lower2=new double[lookorder];
	adjustupper1=new double[lookorder];
	adjustlower1=new double[lookorder];
	adjustupper2=new double[lookorder];
	adjustlower2=new double[lookorder];

	for(i=0; i<lookorder; i++){
		lower1[i]=boundary1[2*i];
		upper1[i]=boundary1[2*i+1];
		lower2[i]=boundary2[2*i];
		upper2[i]=boundary2[2*i+1];
	}

	//repair the boundary:
	i=0;
	while(upper1[i]>lower1[i])
		i=i+1;
	lower1[i]=upper1[i];
	for(j=i; j<lookorder; j++){
		upper1[j]=upper1[i];
		lower1[j]=lower1[i];
	}

	i=0;
	while(upper2[i]>lower2[i])
		i=i+1;
	lower2[i]=upper2[i];
	for(j=i; j<lookorder; j++){
		upper2[j]=upper2[i];
		lower2[j]=lower2[i];
	}

	// the search for constant c:
	//mainly copy from the Normal case.		7/6/2002 3:22PM.


	// in case of hard decision:

	// initialize work:
	for(i=0; i<looksimul; i++){
		work1[i]=absd(nend11[i*lookorder+0]);
		work2[i]=absd(nend21[i*lookorder|0]);
	}

	if(decisiontype==1) {
		for(n=0; n<search_length; n++){	
			// Initialize c_search:
			c_search[n]=c_lower+n*c_range/search_length;

			countt=0;
			adjustupper1[0]=upper1[0]*c_search[n];
			adjustlower1[0]=lower1[0]*c_search[n];
			adjustupper2[0]=upper2[0]*c_search[n];
			adjustlower2[0]=lower2[0]*c_search[n];

			for(m=0; m<looksimul; m++){
				if( (work1[m]>adjustupper1[0]) && (work2[m]>adjustupper2[0]) )
					countt=countt+1;	// H++ H+- H-+ H--
				else if( (work1[m]>adjustupper1[0]) && (work2[m]<adjustlower2[0]) )
					countt=countt+1;	// H+0 H-0
				else if( (work1[m]<adjustlower1[0]) && (work2[m]>adjustupper2[0]) )
					countt=countt+1;	// H0+ H0-
			}

			alphawork=countt/looksimul;

			if( minalphawork > absd(alphawork-BiAlpha[0]) ){
				c_mid=c_search[n];
				minalphawork=absd(alphawork-BiAlpha[0]);
			}
		}
	
		adjustupper1[0]=upper1[0]*c_mid;
		adjustlower1[0]=lower1[0]*c_mid;
		adjustupper2[0]=upper2[0]*c_mid;
		adjustlower2[0]=lower2[0]*c_mid;
	
//		cout<<"search of c for the first look:"<<"\t"<<c_mid<<"\t";
//		cout<<"minalphawork"<<"\t"<<minalphawork<<endl;



		// now we search the const c for the rest of looks:
		for(i=1; i<lookorder; i++){
			minalphawork=1;
			lengthlook=0;
			for(j=0; j<looksimul; j++){
				indi=0;
			
				for(m=0; m<i; m++){
					if( indi!=1) {
						if( absd(nend11[j*lookorder+m])>adjustupper1[m] && absd(nend21[j*lookorder+m])>adjustupper2[m])
							indi=1;		
						else if( absd(nend11[j*lookorder+m])>adjustupper1[m] && absd(nend21[j*lookorder+m])<adjustlower2[m])
							indi=1;
						else if( absd(nend11[j*lookorder+m])<adjustlower1[m] && absd(nend21[j*lookorder+m])>adjustupper2[m])
							indi=1;
					}
				}

				if(indi==0){
					work1[lengthlook]=absd(nend11[j*lookorder+i]);
					work2[lengthlook]=absd(nend21[j*lookorder+i]);
					lengthlook=lengthlook+1;
				}
			}

			for(n=0; n<search_length; n++){	
			// Initialize c_search:
				c_search[n]=c_lower+n*c_range/search_length;

				countt=0;
				adjustupper1[i]=upper1[i]*c_search[n];
				adjustlower1[i]=lower1[i]*c_search[n];
				adjustupper2[i]=upper2[i]*c_search[n];
				adjustlower2[i]=lower2[i]*c_search[n];
		
				for(nn=0; nn<lengthlook; nn++){
					if( (work1[nn]>adjustupper1[i]) && (work2[nn]>adjustupper2[i]) )
						countt=countt+1;
					else if( (work1[nn]<adjustlower1[i]) && (work2[nn]>adjustupper2[i]) )
						countt=countt+1;
					else if( (work1[nn]>adjustupper1[i]) && (work2[nn]<adjustlower2[i]) )
						countt=countt+1;
				}

				alphawork=countt/lengthlook;

				if( minalphawork > absd(alphawork-BiAlpha[i]) ){
					c_mid=c_search[n];
					minalphawork=absd(alphawork-BiAlpha[i]);
				}
			}

			adjustupper1[i]=upper1[i]*c_mid;
			adjustlower1[i]=lower1[i]*c_mid;
			adjustupper2[i]=upper2[i]*c_mid;
			adjustlower2[i]=lower2[i]*c_mid;
		}

		for(i=0; i<lookorder; i++){
			NormalEnd1->UpperAdjust[i]=adjustupper1[i];
			NormalEnd1->LowerAdjust[i]=adjustlower1[i];
			SurvivalEnd2->UpperAdjust[i]=adjustupper2[i];
			SurvivalEnd2->LowerAdjust[i]=adjustlower2[i];
		}
	
	}


	// in case of soft decision:
	//mainly copy from the above calculation:
	// work can not be used DIRECTLY.

	else if(decisiontype==0){	
		for(n=0; n<search_length; n++){	
			// Initialize c_search:
			c_search[n]=c_lower+n*c_range/search_length;

			countt=0;
			adjustupper1[0]=upper1[0]*c_search[n];
			adjustlower1[0]=lower1[0]*c_search[n];
			adjustupper2[0]=upper2[0]*c_search[n];
			adjustlower2[0]=lower2[0]*c_search[n];
		
			//initialize work:
			for(m=0; m<looksimul; m++){
				work1[m]=nend11[m*lookorder+0];
				work2[m]=nend21[m*lookorder+0];
			}

			for(m=0; m<looksimul; m++){
				if( absd(work1[m])>adjustupper1[0] )	
					countt=countt+1;		// H-* & H+*
				else if( (absd(work1[m])<adjustlower1[0]) && (absd(work2[m])>adjustupper2[0]) )
					countt=countt+1;		//H0+ & H0-
				else if( (work1[m]<-adjustlower1[0]) && (work1[m]>-adjustupper1[0]) && (work2[m]<-adjustupper2[0]) )
					countt=countt+1;		// H(-)-
			}

			alphawork=countt/looksimul;

			if( minalphawork > absd(alphawork-BiAlpha[0]) ){
				c_mid=c_search[n];
				minalphawork=absd(alphawork-BiAlpha[0]);
			}
		}
	
		adjustupper1[0]=upper1[0]*c_mid;
		adjustlower1[0]=lower1[0]*c_mid;
		adjustupper2[0]=upper2[0]*c_mid;
		adjustlower2[0]=lower2[0]*c_mid;
	
//		cout<<"search of c for the first look [SOFT DECISION, Survival]:"<<"\t"<<c_mid<<"\t";
//		cout<<"minalphawork"<<"\t"<<minalphawork<<endl;



		// now we search the const c for the rest of looks:
		for(i=1; i<lookorder; i++){
			minalphawork=1;
			lengthlook=0;

			for(j=0; j<looksimul; j++){
				indi=0;

				for(m=0; m<i; m++){
					if( indi!=1) {
						if( absd(nend11[j*lookorder+m])>adjustupper1[m] )
							indi=1;		// H-*  H+*
						else if( absd(nend11[j*lookorder+m])<adjustlower1[m] && absd(nend21[j*lookorder+m])>adjustupper2[m])
							indi=1;		// H0- & H0+
						else if( (nend11[j*lookorder+m]<-adjustlower1[m]) && (nend11[j*lookorder+m]>-adjustupper1[m]) && (nend21[j*lookorder+m]<-adjustupper2[m]) )
							indi=1;		// H(-)-
					}
				}

				if(indi==0){
					work1[lengthlook]=nend11[j*lookorder+i];
					work2[lengthlook]=nend21[j*lookorder+i];
					lengthlook=lengthlook+1;
				}
			}

			for(n=0; n<search_length; n++){	
			// Initialize c_search:
				c_search[n]=c_lower+n*c_range/search_length;

				countt=0;
				adjustupper1[i]=upper1[i]*c_search[n];
				adjustlower1[i]=lower1[i]*c_search[n];
				adjustupper2[i]=upper2[i]*c_search[n];
				adjustlower2[i]=lower2[i]*c_search[n];
		
				for(nn=0; nn<lengthlook; nn++){		// make mistake in this look:
				//	if( (work1[nn]>adjustupper1[i]) || (work2[nn]>adjustupper2[i]) )
				//		countt=countt+1;
					if( absd(work1[nn])>adjustupper1[i] )					
						countt=countt+1;	// H-* H+*
					else if( (absd(work1[nn])<adjustlower1[i]) && (absd(work2[nn])>adjustupper2[i]))
						countt=countt+1;	// H0- H0+
					else if( (work1[nn]<-adjustlower1[i]) && (work1[nn]>-adjustupper1[i]) && (work2[nn]<-adjustupper2[i]) )
						countt=countt+1;
				}


				alphawork=countt/lengthlook;

				if( minalphawork > absd(alphawork-BiAlpha[i]) ){
					c_mid=c_search[n];
					minalphawork=absd(alphawork-BiAlpha[i]);
				}
			}

//			cout<<"search of c end for look"<<"\t"<<i<<"\t";
//			cout<<"minalphawork"<<"\t"<<minalphawork<<"\t"<<"const c"<<"\t"<<c_mid<<endl;
			adjustupper1[i]=upper1[i]*c_mid;
			adjustlower1[i]=lower1[i]*c_mid;
			adjustupper2[i]=upper2[i]*c_mid;
			adjustlower2[i]=lower2[i]*c_mid;
		}

		for(i=0; i<lookorder; i++){
			NormalEnd1->UpperAdjust[i]=adjustupper1[i];
			NormalEnd1->LowerAdjust[i]=adjustlower1[i];
			SurvivalEnd2->UpperAdjust[i]=adjustupper2[i];
			SurvivalEnd2->LowerAdjust[i]=adjustlower2[i];
		}
		cout<<"end of c searching"<<endl;
		cout<<"The finalized boundary: Soft decision 12.2"<<endl;
		for(i=0; i<lookorder; i++){
			cout<<adjustupper1[i]<<"\t";
		}
		cout<<endl;
		for(i=0; i<lookorder; i++){
			cout<<adjustlower1[i]<<"\t";
		}
		cout<<endl;
		for(i=0; i<lookorder; i++){
			cout<<adjustupper2[i]<<"\t";
		}
		cout<<endl;
		for(i=0; i<lookorder; i++){
			cout<<adjustlower2[i]<<"\t";
		}
		cout<<endl;
	}


	
	
	

	//now the left is the calculation of the test statistic:
	double *teststatistic;
	teststatistic=new double[2*lookorder];
	double *teststat1, *teststat2;
	teststat1=new double[lookorder];
	teststat2=new double[lookorder];
	double t1=0, t2=0;

	for(i=0; i<lookorder; i++){
		teststat1[i]=0;
		teststat2[i]=0;
	}
	
	// normal data is in the following two array:
	// revised version of the test statistic for Normal end 11/23/02
	// check ctime21 & ctime22 for enrollment and the data is in control_org and treat_org
	int *lengthc1, *lengthc2;
	lengthc1=new int[lookorder];
	lengthc2=new int[lookorder];
	double tk1, tk2;

	ofstream timeAout("check1.txt", ios::trunc);
	for(i=0; i<samplesize1; i++){
		for(j=0; j<lookorder; j++){
			timeAout<<control_org[i*lookorder+j]<<"\t";
		}
		timeAout<<endl;
	}
	ofstream timeBout("check2.txt", ios::trunc);
	for(i=0; i<samplesize2; i++){
		for(j=0; j<lookorder; j++){
			timeBout<<treat_org[i*lookorder+j]<<"\t";
		}
		timeBout<<endl;
	}

	for(i=0; i<lookorder; i++){
		lengthc1[i]=0;
		lengthc2[i]=0;
		t1=0;
		t2=0;
		for(j=0; j<samplesize1; j++){
			for(k=0; k<=i; k++){
				if(ctime21[j*lookorder+k]>0){
					//enrolled
					lengthc1[i]=lengthc1[i]+1;
					t1=t1+control_org[j*lookorder+k];
				}
			}
		}

		for(j=0; j<samplesize2; j++){
			for(k=0; k<=i; k++){
				if(ctime22[j*lookorder+k]>0){
					//enrolled
					lengthc2[i]=lengthc2[i]+1;
					t2=t2+treat_org[j*lookorder+k];
				}
			}
		}

		teststat1[i]=(t2-t1)/sqrt((lengthc1[i]+lengthc2[i])*1.0);
	}



	double *temp_stat2;
	double *temp_send11;
	double *temp_send12;
	temp_stat2=new double[2*lookorder];
	temp_send11=new double[column*(samplesize1+samplesize2)];
	temp_send12=new double[column*(samplesize1+samplesize2)];

	for(i=0; i<column*(samplesize1+samplesize2); i++){
		temp_send11[i]=send21[i];
		temp_send12[i]=send22[i];
	}
	
	temp_stat2=LogRank3(lookorder, num_look, samplesize1, samplesize2, column, temp_send11, temp_send12, send21, send22, looktime);

	for(i=0; i<lookorder; i++){
		NormalEnd1->testZ[i]=teststat1[i];
		SurvivalEnd2->testZ[i]=temp_stat2[i];
	}

}




//
//	the sort process mainly copied from SortTSCov
//
//	we also include the indentify array	
//
double *SortNSCov(int samplesize, int lookorder, double *lookevent, double *looktime, double *lookindicator, double *indentify)
{
	int i, j, k, l;
//	int con1;

	double *returnsort;
	returnsort=new double[(1+3*lookorder)*samplesize];

	for(i=0; i<samplesize; i++)
		returnsort[i*(1+3*lookorder)+0]=10000;

	//initialize the first one:
	returnsort[0*(1+3*lookorder)+0]=lookevent[0];
	for(i=0; i<lookorder; i++){
		returnsort[0*(1+3*lookorder)+1+i]=looktime[0*lookorder+i];
		returnsort[0*(1+3*lookorder)+1+lookorder+i]=lookindicator[0*lookorder+i];
		returnsort[0*(1+3*lookorder)+1+2*lookorder+i]=indentify[0*lookorder+i];
	}
	
	//search the rest one by one:
	for(i=1; i<samplesize; i++){
		j=0;
		while(lookevent[i]>returnsort[j*(1+3*lookorder)+0])
			j=j+1;
		for(k=samplesize-1; k>j; k--){
			for(l=0; l<1+3*lookorder; l++){
				returnsort[k*(1+3*lookorder)+l]=returnsort[(k-1)*(1+3*lookorder)+l];
			}
		}
		returnsort[j*(1+3*lookorder)+0]=lookevent[i];
		for(l=0; l<lookorder; l++){
			returnsort[j*(1+3*lookorder)+1+l]=looktime[i*lookorder+l];
			returnsort[j*(1+3*lookorder)+1+l+lookorder]=lookindicator[i*lookorder+l];
			returnsort[j*(1+3*lookorder)+1+l+2*lookorder]=indentify[i*lookorder+l];
		}
	}
	return returnsort;
}



double *NSSort1(int length1, int size, double *tltime, double *tlindicator, double *tlID)
{
	int i, j, k;
//	int con1;

	double *tlsort1;
	tlsort1=new double[3*size];
	
	for(i=0; i<length1; i++)
		tlsort1[i*3+0]=100000;

	tlsort1[0*3+0]=tltime[0];
	tlsort1[0*3+1]=tlindicator[0];
	tlsort1[0*3+2]=tlID[0];

	// search the rest one by one:
	for(i=0; i<length1; i++){
		j=0;
		while(tltime[i]>tlsort1[j*3+0])
			j=j+1;
		for(k=length1-1; k>j; k--){
			tlsort1[k*3+0]=tlsort1[(k-1)*3+0];
			tlsort1[k*3+1]=tlsort1[(k-1)*3+1];
			tlsort1[k*3+2]=tlsort1[(k-1)*3+2];
		}
		tlsort1[j*3+0]=tltime[i];
		tlsort1[j*3+1]=tlindicator[i];
		tlsort1[j*3+2]=tlID[i];
	}

	for(i=length1; i<size; i++){
		tlsort1[i*3+0]=0;
		tlsort1[i*3+1]=0;
		tlsort1[i*3+2]=0;
	}
	return tlsort1;
}








//
//	The SurvivalNormal Decision
//

void SurvivalNormalDecision()
{
	NormalEnd1 = NormalEnd2;
	SurvivalEnd2 = SurvivalEnd1;
	cout<<NormalEnd1->look_order<<"\t"<<SurvivalEnd2->sample_size1<<endl;
	//replace before the function
  
	dataEnd11 = dataEnd21;
	dataEnd12 = dataEnd22;
	dataEnd13 = dataEnd23;
	dataEnd14 = dataEnd24;
	dataEnd15 = dataEnd25;
	dataEnd16 = dataEnd26;
	dataEnd17 = dataEnd27;
	dataEnd18 = dataEnd28;
	dataEnd19 = dataEnd29;
	dataEnd10 = dataEnd20;
	dataS2 = dataS1;
	//above for replacing work

	int con1;

	int MAXLOOK1;
	MAXLOOK1=10;

	int samplesize1, samplesize2;
	int num_look;
	int looksimul;
	int lookorder;

	samplesize1=SurvivalEnd2->sample_size1;
	samplesize2=SurvivalEnd2->sample_size2;
	num_look=SurvivalEnd2->num_look;
	looksimul=SurvivalEnd2->num_simul;
	lookorder=SurvivalEnd2->look_order;

	int column=6;
	int i, j, k, l, m, n;

	// the normal data is in dataEnd11, dataEnd12...	 
	// normal data is stored in normalcontrol and normaltreat
	double *normalcontrol, *normaltreat;
	normalcontrol=new double[MAXLOOK*samplesize1];	// normal data control
	normaltreat=new double[MAXLOOK*samplesize2];	// normal data treatment

	for(i=0; i<samplesize1; i++){
		normalcontrol[i*MAXLOOK1+0]=dataEnd11[i];
		normalcontrol[i*MAXLOOK1+1]=dataEnd12[i];
		normalcontrol[i*MAXLOOK1+2]=dataEnd13[i];
		normalcontrol[i*MAXLOOK1+3]=dataEnd14[i];
		normalcontrol[i*MAXLOOK1+4]=dataEnd15[i];
		normalcontrol[i*MAXLOOK1+5]=dataEnd16[i];
		normalcontrol[i*MAXLOOK1+6]=dataEnd17[i];
		normalcontrol[i*MAXLOOK1+7]=dataEnd18[i];
		normalcontrol[i*MAXLOOK1+8]=dataEnd19[i];
		normalcontrol[i*MAXLOOK1+9]=dataEnd10[i];
	}

	for(i=0; i<samplesize2; i++){
		normaltreat[i*MAXLOOK1+0]=dataEnd11[samplesize1+i];
		normaltreat[i*MAXLOOK1+1]=dataEnd12[samplesize1+i];
		normaltreat[i*MAXLOOK1+2]=dataEnd13[samplesize1+i];
		normaltreat[i*MAXLOOK1+3]=dataEnd14[samplesize1+i];
		normaltreat[i*MAXLOOK1+4]=dataEnd15[samplesize1+i];
		normaltreat[i*MAXLOOK1+5]=dataEnd16[samplesize1+i];
		normaltreat[i*MAXLOOK1+6]=dataEnd17[samplesize1+i];
		normaltreat[i*MAXLOOK1+7]=dataEnd18[samplesize1+i];
		normaltreat[i*MAXLOOK1+8]=dataEnd19[samplesize1+i];
		normaltreat[i*MAXLOOK1+9]=dataEnd10[samplesize1+i];
	}
	

	// the check process of normalcontrol and normaltreat:
	// now seperate the survival data:
	// we will only have send21 & send22 for the second endpoint:

	double *send21, *send22;
	send21=new double[column*(samplesize1+samplesize2)];	//end2 control
	send22=new double[column*(samplesize1+samplesize2)];	//end2 treatment

	int p1=0, p2=0, p3=0, p4=0;

	for(i=0; i<samplesize1+samplesize2; i++){
		if( (dataS2[i*column+0]==1) && (dataS2[i*column+1]==0) ){
			send21[p3*column+0]=dataS2[i*column+0];
			send21[p3*column+1]=dataS2[i*column+1];
			send21[p3*column+2]=dataS2[i*column+2];
			send21[p3*column+3]=dataS2[i*column+3];
			send21[p3*column+4]=dataS2[i*column+4];
			send21[p3*column+5]=dataS2[i*column+5];
			p3=p3+1;
		}	// end2 control

		if( (dataS2[i*column+0]==1) && (dataS2[i*column+1]==1) ){
			send22[p4*column+0]=dataS2[i*column+0];
			send22[p4*column+1]=dataS2[i*column+1];
			send22[p4*column+2]=dataS2[i*column+2];
			send22[p4*column+3]=dataS2[i*column+3];
			send22[p4*column+4]=dataS2[i*column+4];
			send22[p4*column+5]=dataS2[i*column+5];
			p4=p4+1;
		}	// end2 treatment

	}

	double *looktime;
	looktime=new double[lookorder];
	for(i=0; i<lookorder; i++)
		looktime[i]=SurvivalEnd2->look_time[i];


	// the following is mostly copied from the TSCov:

	//
	// The MAIN CHANGE IS THAT: we will need the ID information.
	//

	double *entry21, *entry22;
	double *event21, *event22;
	double *indicator21, *indicator22; 
	double *indentify21, *indentify22;
	// the one separate directly from data

	double *lookevent21, *lookevent22;
	double *looktime21, *looktime22;
	double *lookindicator21, *lookindicator22; 
	//after considering the different look time.

	entry21=new double[samplesize1];
	entry22=new double[samplesize2];

	event21=new double[samplesize1];
	event22=new double[samplesize2];

	indicator21=new double[samplesize1];
	indicator22=new double[samplesize2];

	indentify21=new double[samplesize1*lookorder];
	indentify22=new double[samplesize2*lookorder];

	lookevent21=new double[samplesize1];
	lookevent22=new double[samplesize2];

	looktime21=new double[samplesize1*lookorder];
	looktime22=new double[samplesize2*lookorder];

	lookindicator21=new double[samplesize1*lookorder];
	lookindicator22=new double[samplesize2*lookorder];

	//initialize entry event, and indicator
	for(i=0; i<samplesize1; i++){
		//end 2 control
		entry21[i]=send21[i*column+3];
		event21[i]=send21[i*column+4];
		indicator21[i]=send21[i*column+5];
		for(j=0; j<lookorder; j++){
			indentify21[i*lookorder+j]=send21[i*column+2];
		}
	}
	
	for(i=0; i<samplesize2; i++){
		//end 2 treatment
		entry22[i]=send22[i*column+3];
		event22[i]=send22[i*column+4];
		indicator22[i]=send22[i*column+5];
		for(j=0; j<lookorder; j++){
			indentify22[i*lookorder+j]=send22[i*column+2];
		}
	}


	// initialize lookevent, looktime and lookindicator:

	//end 2 control
	for(i=0; i<samplesize1; i++){
		lookevent21[i]=event21[i]-entry21[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry21[i] ){
				looktime21[i*lookorder+j]=-1;   //not entered yet
				lookindicator21[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry21[i]){
				if(looktime[j]>=event21[i]){		//enter. by the time of look, event happens
					looktime21[i*lookorder+j]=looktime[j]-entry21[i];
					lookindicator21[i*lookorder+j]=indicator21[i];
				}
				else if(looktime[j]<event21[i]){		//by the time of look, event not happen yet.
					looktime21[i*lookorder+j]=looktime[j]-entry21[i];
					lookindicator21[i*lookorder+j]=1;
				}
			}
		}
	}	

	//end 2 treatment
	for(i=0; i<samplesize2; i++){
		lookevent22[i]=event22[i]-entry22[i];
		for(j=0; j<lookorder; j++){
			if( looktime[j] < entry22[i] ){
				looktime22[i*lookorder+j]=-1;   //not entered yet
				lookindicator22[i*lookorder+j]=1;  // censored
			}
			else if(looktime[j]>=entry22[i]){
				if(looktime[j]>=event22[i]){		//enter. by the time of look, event happens
					looktime22[i*lookorder+j]=looktime[j]-entry22[i];
					lookindicator22[i*lookorder+j]=indicator22[i];
				}
				else if(looktime[j]<event22[i]){		//by the time of look, event not happen yet.
					looktime22[i*lookorder+j]=looktime[j]-entry22[i];
					lookindicator22[i*lookorder+j]=1;
				}
			}
		}
	}	

	//
	//	in the sort process, we need to have indentify21 (22) sorted also
	//

	// sort each one according to lookevent
	double *sort3, *sort4;
	sort3=new double[(1+3*lookorder)*samplesize1]; //end21
	sort4=new double[(1+3*lookorder)*samplesize2]; //end22
	sort3=SortNSCov(samplesize1, lookorder, lookevent21, looktime21, lookindicator21, indentify21);
	sort4=SortNSCov(samplesize2, lookorder, lookevent22, looktime22, lookindicator22, indentify22);


	// Re-separate lookevent, looktime, lookindicator & indentify:

	//end2 control
	for(i=0; i<samplesize1; i++){
		lookevent21[i]=sort3[i*(1+3*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime21[i*lookorder+j]=sort3[i*(1+3*lookorder)+j+1];
			lookindicator21[i*lookorder+j]=sort3[i*(1+3*lookorder)+j+1+lookorder];
			indentify21[i*lookorder+j]=sort3[i*(1+3*lookorder)+j+1+lookorder*2];
		}
	}
	//end2 treat
	for(i=0; i<samplesize2; i++){
		lookevent22[i]=sort4[i*(1+3*lookorder)+0];
		for(j=0; j<lookorder; j++){
			looktime22[i*lookorder+j]=sort4[i*(1+3*lookorder)+j+1];
			lookindicator22[i*lookorder+j]=sort4[i*(1+3*lookorder)+j+1+lookorder];
			indentify22[i*lookorder+j]=sort4[i*(1+3*lookorder)+j+1+lookorder*2];
		}
	}

	// now calculate nhat, yhat and time of change
	double *nhat21, *nhat22;
	double *yhat21, *yhat22;
	double *ctime21, *ctime22;
	int *IDhat21, *IDhat22;

	nhat21=new double[samplesize1*lookorder];
	nhat22=new double[samplesize2*lookorder];

	yhat21=new double[samplesize1*lookorder];
	yhat22=new double[samplesize2*lookorder];

	ctime21=new double[samplesize1*lookorder];
	ctime22=new double[samplesize2*lookorder];

	IDhat21=new int[samplesize1*lookorder];
	IDhat22=new int[samplesize2*lookorder];

	// sort looktime and lookindicator to calculate yhat, nhat and ctime:

	double *tltime, *tlindicator, *tlID;
	double *tlsort1;
	int length1;
	
	int tdead, tcount;

	tltime=new double[max(samplesize1, samplesize2)];
	tlindicator=new double[max(samplesize1, samplesize2)];
	tlID=new double[max(samplesize1, samplesize2)];
	tlsort1=new double[3*max(samplesize1, samplesize2)];


	//end 2 control:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize1; j++){
			if( looktime21[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime21[j*lookorder+i];
				tlindicator[length1]=lookindicator21[j*lookorder+i];
				tlID[length1]=indentify21[j*lookorder+i];
				length1=length1+1;
			}
		}
		
		// sort with respect to tltime (looktime):
		tlsort1=NSSort1(length1, samplesize1, tltime, tlindicator, tlID);

		// then separate:
		for(j=0; j<samplesize1; j++){
			tltime[j]=tlsort1[j*3+0];
			tlindicator[j]=tlsort1[j*3+1];
			tlID[j]=tlsort1[j*3+2];
		}

		// count nhat21(dead), yhat21(at risk), and ctime11
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat21[j*lookorder+i]=tdead;
				yhat21[j*lookorder+i]=samplesize1-tcount;
				ctime21[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat21[j*lookorder+i]=tdead;
				yhat21[j*lookorder+i]=samplesize1-tcount;
				ctime21[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize1; j++){
			nhat21[j*lookorder+i]=nhat21[(j-1)*lookorder+i];
			yhat21[j*lookorder+i]=yhat21[(j-1)*lookorder+i];
			ctime21[j*lookorder+i]=-1;	// those not entered yet
		}

		for(j=0; j<length1; j++)
			IDhat21[j*lookorder+i]=tlID[j];
		for(j=length1; j<samplesize1; j++)
			IDhat21[j*lookorder+i]=-1;
	}


	//end 2 treatment:
	for(i=0; i<lookorder; i++){
		length1=0;
		for(j=0; j<samplesize2; j++){
			if( looktime22[j*lookorder+i]!=-1 ){
				tltime[length1]=looktime22[j*lookorder+i];
				tlindicator[length1]=lookindicator22[j*lookorder+i];
				tlID[length1]=indentify22[j*lookorder+i];
				length1=length1+1;
			}
		}
		
		// sort with respect to tltime (looktime):
		tlsort1=NSSort1(length1, samplesize2, tltime, tlindicator, tlID);
		// then separate:
		for(j=0; j<samplesize2; j++){
			tltime[j]=tlsort1[j*3+0];
			tlindicator[j]=tlsort1[j*3+1];
			tlID[j]=tlsort1[j*3+2];
		}

		// count nhat22(dead), yhat22(at risk), and ctime22
		tdead=0; tcount=0;
		for(j=0; j<length1; j++){
			if(tlindicator[j]==0){ //event
				tdead=tdead+1;
				nhat22[j*lookorder+i]=tdead;
				yhat22[j*lookorder+i]=samplesize2-tcount;
				ctime22[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
			if(tlindicator[j]!=0){ //consor
				tdead=tdead+0;
				nhat22[j*lookorder+i]=tdead;
				yhat22[j*lookorder+i]=samplesize2-tcount;
				ctime22[j*lookorder+i]=tltime[j];
				tcount=tcount+1;
			}
		}
		for(j=length1; j<samplesize2; j++){
			nhat22[j*lookorder+i]=nhat22[(j-1)*lookorder+i];
			yhat22[j*lookorder+i]=yhat22[(j-1)*lookorder+i];
			ctime22[j*lookorder+i]=-1;	// those not entered yet
		}
		
		for(j=0; j<length1; j++)
			IDhat22[j*lookorder+i]=tlID[j];
		for(j=length1; j<samplesize2; j++)
			IDhat22[j*lookorder+i]=tlID[j];
	}


	int *ID21, *ID22;	// the converted to integer version
	ID21=new int[samplesize1*lookorder];
	ID22=new int[samplesize2*lookorder];

	for(i=0; i<samplesize1; i++){
		for(j=0; j<lookorder; j++){
			ID21[i*lookorder+j]=(int) indentify21[i*lookorder+j];
		}
	}

	for(i=0; i<samplesize2; i++){
		for(j=0; j<lookorder; j++){
			ID22[i*lookorder+j]=(int) indentify22[i*lookorder+j];
		}
	}

	
	// now calculate uhat DIRECTLY:
	double *uhat21, *uhat22;

	uhat21=new double[samplesize1*lookorder];
	uhat22=new double[samplesize2*lookorder];

	for(i=0; i<samplesize1*lookorder; i++){
		uhat21[i]=0;
	}
	for(i=0; i<samplesize2*lookorder; i++){
		uhat22[i]=0;
	}

	double deltaM;


	// in the order version, the calculation of deltaM is correct
	// the problem is in the calculation of yhat12


	double tyhat21, tyhat22;
	double timepoint;

	// end 2 control:
	for(i=0; i<lookorder; i++){
		for(j=0; j<samplesize1; j++){
			if(ctime21[j*lookorder+i]!=-1){	// if has entered

				if(j==0){
					if( lookindicator21[j*lookorder+i]==0){		//event
						deltaM=1-nhat21[0*lookorder+i]/yhat21[0*lookorder+i];
					}
					else if( lookindicator21[j*lookorder+i]!=0){	//censor
						deltaM=-nhat21[0*lookorder+i]/yhat21[0*lookorder+i];
					}
					tyhat21=yhat21[j*lookorder+i];

					//find tyhat22:
					timepoint=ctime21[j*lookorder+i];
					l=0;
					while(ctime22[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat22=samplesize2;
					if(l!=0)
						tyhat22=yhat22[(l-1)*lookorder+i];
					
					uhat21[j*lookorder+i]=uhat21[j*lookorder+i]+deltaM*(1-(tyhat21)/(tyhat21+tyhat22));

				}
				
				if(j!=0){
					// calculate those before
					for(k=0; k<j-1; k++){
						if(k==0){
							deltaM=-nhat21[0*lookorder+i]/yhat21[0*lookorder+i];
						}
						if(k!=0){
							deltaM=-(nhat21[k*lookorder+i]-nhat21[(k-1)*lookorder+i])/yhat21[k*lookorder+i];
						}

						tyhat21=yhat21[k*lookorder+i];
						// find tyhat22:
						timepoint=ctime21[k*lookorder+i];
						l=0;
						while(ctime22[l*lookorder+i] <timepoint)
							l=l+1;
						if(l==0)
							tyhat22=samplesize2;
						if(l!=0)
							tyhat22=yhat22[(l-1)*lookorder+i];

						uhat21[j*lookorder+i]=uhat21[j*lookorder+i]+(1-(tyhat21)/(tyhat21+tyhat22))*deltaM;
					}

					// calculate its own
					if( lookindicator21[j*lookorder+i]==0 ) {   //event
						deltaM=1-(nhat21[j*lookorder+i]-nhat21[(j-1)*lookorder+i])/yhat21[j*lookorder+i];
					}
					else if ( lookindicator21[j*lookorder+i]!=0 ) {
						deltaM=-(nhat21[j*lookorder+i]-nhat21[(j-1)*lookorder+i])/yhat21[j*lookorder+i];
					}
					
					tyhat21=yhat21[j*lookorder+i];
					//find tyhat22:
					timepoint=ctime21[j*lookorder+i];
					l=0;
					while(ctime22[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat22=samplesize2;
					if(l!=0)
						tyhat22=yhat22[(l-1)*lookorder+i];

					uhat21[j*lookorder+i]=uhat21[j*lookorder+i]+(1-(tyhat21)/(tyhat21+tyhat22))*deltaM;
				}
			}
		}
	}

	// end 2 treatment:
	for(i=0; i<lookorder; i++){
		for(j=0; j<samplesize2; j++){
			if(ctime22[j*lookorder+i]!=-1){	// if has entered

				if(j==0){
					if( lookindicator22[j*lookorder+i]==0 ){   //event
						deltaM=1-nhat22[0*lookorder+i]/yhat22[0*lookorder+i];
					}
					if( lookindicator22[j*lookorder+i]!=0 ){   //censor
						deltaM=-nhat22[0*lookorder+i]/yhat22[0*lookorder+i];
					}
					tyhat22=yhat22[j*lookorder+i];

					//find tyhat21:
					timepoint=ctime22[j*lookorder+i];
					l=0;
					while(ctime21[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat21=samplesize1;
					if(l!=0)
						tyhat21=yhat21[(l-1)*lookorder+i];
					
					uhat22[j*lookorder+i]=uhat22[j*lookorder+i]+deltaM*(1-(tyhat22)/(tyhat21+tyhat22));

				}
				
				if(j!=0){
					// calculate those before
					for(k=0; k<j-1; k++){
						if(k==0){
							deltaM=-nhat22[0*lookorder+i]/yhat22[0*lookorder+i];
						}
						if(k!=0){
							deltaM=-(nhat22[k*lookorder+i]-nhat22[(k-1)*lookorder+i])/yhat22[k*lookorder+i];
						}

						tyhat22=yhat22[k*lookorder+i];
						// find tyhat21:
						timepoint=ctime22[k*lookorder+i];
						l=0;
						while(ctime21[l*lookorder+i] <timepoint)
							l=l+1;
						if(l==0)
							tyhat21=samplesize1;
						if(l!=0)
							tyhat21=yhat21[(l-1)*lookorder+i];

						uhat22[j*lookorder+i]=uhat22[j*lookorder+i]+(1-(tyhat22)/(tyhat21+tyhat22))*deltaM;
					}

					// calculate its own
					if( lookindicator22[j*lookorder+i]==0 ){   //event
						deltaM=1-(nhat22[j*lookorder+i]-nhat22[(j-1)*lookorder+i])/yhat22[j*lookorder+i];
					}
					else if( lookindicator22[j*lookorder+i]!=0 ){   //censor
						deltaM=-(nhat22[j*lookorder+i]-nhat22[(j-1)*lookorder+i])/yhat22[j*lookorder+i];
					}
					
					tyhat22=yhat22[j*lookorder+i];
					//find tyhat21:
					timepoint=ctime22[j*lookorder+i];
					l=0;
					while(ctime21[l*lookorder+i] <timepoint)
						l=l+1;
					if(l==0)
						tyhat21=samplesize1;
					if(l!=0)
						tyhat21=yhat21[(l-1)*lookorder+i];

					uhat22[j*lookorder+i]=uhat22[j*lookorder+i]+(1-(tyhat22)/(tyhat21+tyhat22))*deltaM;
				}
			}
		}
	}



	// seems to be reasonable August 19th 9:20AM
	int *sizecontrol, *sizetreat;	// the sample size at each look.
	sizecontrol=new int[lookorder];
	sizetreat=new int[lookorder];

	for(i=0; i<lookorder; i++){
		sizecontrol[i]=0;
		sizetreat[i]=0;
	}

	for(i=0; i<lookorder; i++){
		//control:
		for(j=0; j<samplesize1; j++){
			if(ctime21[j*lookorder+i]!=-1)
				sizecontrol[i]=sizecontrol[i]+1;
		}
		//treat
		for(j=0; j<samplesize2; j++){
			if(ctime22[j*lookorder+i]!=-1)
				sizetreat[i]=sizetreat[i]+1;
		}
	}
	
//	
//	double *normaluhat11, *normaluhat12;	//end 1 (normal data)
	// we can define similarky normaluhat11 & normaluhat12

//	normaluhat11=new double[samplesize1*lookorder];
//	normaluhat12=new double[samplesize2*lookorder];
//


	// the organized normal data.
	// the original data is in normalcontrol & normaltreat
	double *control_org, *treat_org;
	control_org=new double[samplesize1*lookorder];
	treat_org=new double[samplesize2*lookorder];

	for(i=0; i<samplesize1*lookorder; i++)
		control_org[i]=0;
	for(i=0; i<samplesize2*lookorder; i++)
		treat_org[i]=0;

	for(i=0; i<lookorder; i++){
		for(j=0; j<sizecontrol[i]; j++)
			control_org[j*lookorder+i]=normalcontrol[ID21[j*lookorder+i]*MAXLOOK1+i];
		for(j=0; j<sizetreat[i]; j++)
			treat_org[j*lookorder+i]=normaltreat[ID22[j*lookorder+i]*MAXLOOK1+i];
	}


	double *meancontrol, *meantreat;
	meancontrol=new double[lookorder];
	meantreat=new double[lookorder];

	for(i=0; i<lookorder; i++){
		meancontrol[i]=0;
		meantreat[i]=0;
	}

	for(i=0; i<lookorder; i++){
		for(j=0; j<sizecontrol[i]; j++){
			meancontrol[i]=meancontrol[i]+control_org[j*lookorder+i];
		}
		meancontrol[i]=meancontrol[i]/sizecontrol[i];

		for(j=0; j<sizetreat[i]; j++){
			meantreat[i]=meantreat[i]+treat_org[j*lookorder+i];
		}
		meantreat[i]=meantreat[i]/sizetreat[i];
	}


	double *uhat11, *uhat12;
	uhat11=new double[samplesize1*lookorder];
	uhat12=new double[samplesize2*lookorder];

	for(i=0; i<samplesize1*lookorder; i++)
		uhat11[i]=0;
	for(i=0; i<samplesize2*lookorder; i++)
		uhat12[i]=0;

	for(i=0; i<lookorder; i++){
		for(j=0; j<sizecontrol[i]; j++){
			uhat11[j*lookorder+i]=control_org[j*lookorder+i]-meancontrol[i];
		}

		for(j=0; j<sizetreat[i]; j++){
			uhat12[j*lookorder+i]=treat_org[j*lookorder+i]-meantreat[i];
		}
	}


	// calculation of the omega hat:
	double *omegahat;
	int j1, j2, i1, i2;
	double temp1, temp2;
	omegahat=new double[2*lookorder*2*lookorder];
	double *omegacheck;
	omegacheck=new double[2*lookorder*2*lookorder];

	// separate into 4 blocks:

	// block 1:
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			temp1=0;
			temp2=0;
			for(i1=0; i1<samplesize1; i1++){
				temp1=temp1+uhat11[i1*lookorder+j1]*uhat11[i1*lookorder+j2];
			}
			for(i2=0; i2<samplesize2; i2++){
				temp2=temp2+uhat12[i2*lookorder+j1]*uhat12[i2*lookorder+j2];
			}
			omegahat[j1*2*lookorder+j2]=(temp1+temp2)/(samplesize1+samplesize2);
		}
	}


	// block 2:
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			temp1=0;
			temp2=0;
			for(i1=0; i1<samplesize1; i1++){
				temp1=temp1+uhat11[i1*lookorder+j1]*uhat21[i1*lookorder+j2];
			}
			for(i2=0; i2<samplesize2; i2++){
				temp2=temp2+uhat12[i2*lookorder+j1]*uhat22[i2*lookorder+j2];
			}
			omegahat[j1*2*lookorder+j2+lookorder]=(temp1+temp2)/(samplesize1+samplesize2);
		}
	}

	// block 3:
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			temp1=0;
			temp2=0;
			for(i1=0; i1<samplesize1; i1++){
				temp1=temp1+uhat21[i1*lookorder+j1]*uhat11[i1*lookorder+j2];
			}
			for(i2=0; i2<samplesize2; i2++){
				temp2=temp2+uhat22[i2*lookorder+j1]*uhat12[i2*lookorder+j2];
			}
			omegahat[(j1+lookorder)*2*lookorder+j2]=(temp1+temp2)/(samplesize1+samplesize2);
		}
	}

	// block 4:
	for(j1=0; j1<lookorder; j1++){
		for(j2=0; j2<lookorder; j2++){
			temp1=0;
			temp2=0;
			for(i1=0; i1<samplesize1; i1++){
				temp1=temp1+uhat21[i1*lookorder+j1]*uhat21[i1*lookorder+j2];
			}
			for(i2=0; i2<samplesize2; i2++){
				temp2=temp2+uhat22[i2*lookorder+j1]*uhat22[i2*lookorder+j2];
			}
			omegahat[(j1+lookorder)*2*lookorder+j2+lookorder]=(temp1+temp2)/(samplesize1+samplesize2);
		}
	}


	for(i=0; i<2*lookorder; i++)
		for(j=0; j<2*lookorder; j++)
			omegacheck[i*2*lookorder+j]=omegahat[i*2*lookorder+j]/sqrt(omegahat[i*2*lookorder+i]*omegahat[j*2*lookorder+j]);


	double *sqrtomega;
	sqrtomega=new double[2*lookorder*2*lookorder];
	sqrtomega=sqrt_matrix(2*lookorder, omegacheck);

	
//
//	the correlation has been found above. August 19th 8:00PM (checked)
//

//	the following is copied from the code of two survival.


	double *overCov;
	overCov=new double[2*lookorder*2*lookorder];

	for(i=0; i<2*lookorder*2*lookorder; i++)
		overCov[i]=omegahat[i];

	double * overCovA;
	overCovA=new double[2*lookorder*2*lookorder];

	for(i=0; i<lookorder; i++){ 
		for(j=0; j<lookorder; j++){  
			overCovA[i*2*lookorder+j]=overCov[i*2*lookorder+j]/sqrt(overCov[i*2*lookorder+i]*overCov[j*2*lookorder+j]);
			overCovA[(i+lookorder)*2*lookorder+j]=overCov[(i+lookorder)*2*lookorder+j]/sqrt(overCov[j*2*lookorder+j]*overCov[(i+lookorder)*2*lookorder+lookorder+i]);
			overCovA[i*2*lookorder+j+lookorder]=overCov[i*2*lookorder+j+lookorder]/sqrt(overCov[i*2*lookorder+i]*overCov[(j+lookorder)*2*lookorder+lookorder+j]);
			overCovA[(i+lookorder)*2*lookorder+j+lookorder]=overCov[(i+lookorder)*2*lookorder+j+lookorder]/sqrt(overCov[(i+lookorder)*2*lookorder+i+lookorder]*overCov[(j+lookorder)*2*lookorder+lookorder+j]);
		}
	}

	double *tempAA;
	tempAA=new double[2*lookorder*2*lookorder];
	tempAA=sqrt_matrix(2*lookorder, overCovA);


	double *overArray;
	overArray=new double[2*lookorder*looksimul];
	
	double *meanA1, *varA1;
	meanA1=new double[2*lookorder];
	varA1=new double[2*lookorder];

	for(i=0; i<2*lookorder; i++){
		meanA1[i]=0;
		varA1[i]=overCovA[i*2*lookorder+i];
	}

	overArray=UNNormalSimul(2*lookorder, looksimul, meanA1, varA1, overCovA);
	
	// the check procedure of overArray.
	double *checkstructure1;
	int sizec1=2*lookorder;
	int sizec2=looksimul;
	checkstructure1=new double[sizec1*(2+sizec1)];
	checkstructure1=NormalCheck(sizec1, sizec2, overArray);

	double *meanend1, *meanend2;
	meanend1=new double[lookorder];
	meanend2=new double[lookorder];


	double *llength1, *llength2;
	llength1=new double[lookorder];
	llength2=new double[lookorder];
	for(i=0; i<lookorder; i++){
		llength1[i]=0;
		llength2[i]=0;
		for(j=0; j<samplesize1; j++){
			for(k=0; k<=i; k++){
				if(ctime21[j*lookorder+k]>0){
					//enrolled
					llength1[i]=llength1[i]+1;
				}
			}
		}

		for(j=0; j<samplesize2; j++){
			for(k=0; k<=i; k++){
				if(ctime22[j*lookorder+k]>0){
					//enrolled
					llength2[i]=llength2[i]+1;
				}
			}
		}
	}
	//need to calculate the mean for each end at each look.
	for(i=0; i<lookorder; i++){
		con1=0;
		for(j=0; j<=i; j++)
			con1=con1+sizetreat[j];
		meanend1[i]=(NormalEnd1->meanAlter*llength2[i]-NormalEnd1->meanNull*llength1[i])/sqrt(llength1[i]+llength2[i]);

		meanend2[i]=(sqrt(samplesize1+samplesize2))*absd(log(SurvivalEnd2->lambdaAlter/SurvivalEnd2->lambdaNull))*sqrt(overCov[(i+lookorder)*2*lookorder+i+lookorder]);
	}


	// Separate nend11, nend12, nend21, nend22:
	double *nend11, *nend12, *nend21, *nend22;
	nend11=new double[looksimul*lookorder];
	nend12=new double[looksimul*lookorder];
	nend21=new double[looksimul*lookorder];
	nend22=new double[looksimul*lookorder];

	for(i=0; i<looksimul; i++){
		for(j=0; j<lookorder; j++){
			nend11[i*lookorder+j]=overArray[i*2*lookorder+j];	//end 1 control
			nend12[i*lookorder+j]=overArray[i*2*lookorder+j]+meanend1[j];	//end1 treat
			nend21[i*lookorder+j]=overArray[i*2*lookorder+lookorder+j];		//end2 control
			nend22[i*lookorder+j]=overArray[i*2*lookorder+lookorder+j]+meanend2[j];	//end2 treat
		}
	}



	// check of nend11, nend12, nend21, nend22:
	double *nendcheck;
	nendcheck=new double[lookorder*(2+lookorder)];

	// calculation of mariginal critical boundary:
	double *boundary1, *boundary2;
	boundary1=new double[2*lookorder];
	boundary2=new double[2*lookorder];


	// create two quasi TrialEndNormal Type for the calculation of UNBound:
	TrialEndNormal *Tend1, *Tend2;
	Tend1=new TrialEndNormal;
	Tend2=new TrialEndNormal;


	Tend1->order=1;
	Tend1->num_look=num_look;
	Tend1->look_order=lookorder;
	Tend1->looksimul=looksimul;
	Tend1->sample_size=samplesize1+samplesize2;
	Tend1->spending_number=NormalEnd1->spending_number;
	Tend1->meanNull=0;
	Tend1->meanAlter=NormalEnd1->meanAlter;
	Tend1->Bi_Alpha=NormalEnd1->Bi_Alpha;
	Tend1->Bi_Beta=NormalEnd1->Bi_Beta;
	Tend1->overall_alpha=NormalEnd1->overall_alpha;
	Tend1->overall_beta=NormalEnd1->overall_beta;
	
	Tend2->order=2;
	Tend2->num_look=num_look;
	Tend2->look_order=lookorder;
	Tend2->looksimul=looksimul;
	Tend2->sample_size=samplesize1+samplesize2;
	Tend2->spending_number=SurvivalEnd2->alphaSpend;
	Tend2->meanNull=0;
	Tend2->meanAlter=absd(log(SurvivalEnd2->lambdaAlter/SurvivalEnd2->lambdaNull));
	Tend2->Bi_Alpha=SurvivalEnd2->global_alpha;
	Tend2->Bi_Beta=SurvivalEnd2->global_beta;
	Tend2->overall_alpha=SurvivalEnd2->alpha;
	Tend2->overall_beta=SurvivalEnd2->beta;
	

	for(i=0; i<num_look; i++){
		Tend1->inform_time[i]=NormalEnd1->inform_time[i];
		Tend2->inform_time[i]=SurvivalEnd2->inform_time[i];

		Tend1->alpha[i]=NormalEnd1->alpha[i];
		Tend1->beta[i]=NormalEnd1->beta[i];
		Tend2->alpha[i]=SurvivalEnd2->alpha_spending[i];
		Tend2->beta[i]=SurvivalEnd2->beta_spending[i];

	}


//	OutNormal(Tend1);
//	OutNormal(Tend2);


	boundary1=UNBound(lookorder, nend11, nend12, Tend1);
	boundary2=UNBound(lookorder, nend21, nend22, Tend2);
	

	// check of boundary 1 and boundary2:
/*	cout<<"Boundary for end 1:"<<endl;
	for(i=0; i<2*lookorder; i++)
		cout<<boundary1[i]<<"\t";
	cout<<endl;
	cout<<"Boundary for end 2:"<<endl;
	for(i=0; i<2*lookorder; i++)
		cout<<boundary2[i]<<"\t";
	cout<<endl;

*/
	//so far, it seems the numerical results are OK.  8:51PM 8/19/2002

//	cout<<"start the search for constant C"<<endl;

	// the following code is mainly copied from the calculation for two Normal Case.
	// neccessary definition needed


	int decisiontype;		//hard versus soft.
	decisiontype=NormalEnd1->rule_decision;
//	cout<<"decision"<<"\t"<<decisiontype<<endl;



	double *BiAlpha;
	BiAlpha=new double[SurvivalEnd2->num_look];
	for(i=0; i<SurvivalEnd2->num_look; i++)
		BiAlpha[i]=SurvivalEnd2->BiAlphaSpending[i];

	double *work1, *work2;
	work1=new double[looksimul];
	work2=new double[looksimul];

	// since only alpha is invloved, we only need the distribution under the Null,
	// however, since we may need to report the beta spending eventually, we also
	// get the Alternative distribution for future use.

	int search_length=1000;

	double *c_search;
	c_search=new double[search_length];

	double c_lower=0.01;
	double c_upper=10.0;
	double c_mid;
	double c_range=c_upper-c_lower;
	double alphawork=0;
	double countt=0;	
	double minalphawork=1.0;

	int nn;
	int lengthlook;
	int indi;
	
	
	double *upper1, *lower1, *upper2, *lower2;
	double *adjustupper1, *adjustlower1, *adjustupper2, *adjustlower2;
	
	upper1=new double[lookorder];
	lower1=new double[lookorder];
	upper2=new double[lookorder];
	lower2=new double[lookorder];
	adjustupper1=new double[lookorder];
	adjustlower1=new double[lookorder];
	adjustupper2=new double[lookorder];
	adjustlower2=new double[lookorder];

	for(i=0; i<lookorder; i++){
		lower1[i]=boundary1[2*i];
		upper1[i]=boundary1[2*i+1];
		lower2[i]=boundary2[2*i];
		upper2[i]=boundary2[2*i+1];
	}

	//repair the boundary:
	i=0;
	while(upper1[i]>lower1[i])
		i=i+1;
	lower1[i]=upper1[i];
	for(j=i; j<lookorder; j++){
		upper1[j]=upper1[i];
		lower1[j]=lower1[i];
	}

	i=0;
	while(upper2[i]>lower2[i])
		i=i+1;
	lower2[i]=upper2[i];
	for(j=i; j<lookorder; j++){
		upper2[j]=upper2[i];
		lower2[j]=lower2[i];
	}

	// the search for constant c:
	//mainly copy from the Normal case.		7/6/2002 3:22PM.

	// in case of hard decision:

	// initialize work:


	// ATT: Sep 9th 9:55AM
	for(i=0; i<looksimul; i++){
		// below is copied from NormalSurvival
		// now we just need to interchange the order
		work2[i]=absd(nend11[i*lookorder+0]);
		work1[i]=absd(nend21[i*lookorder|0]);
	}

	if(decisiontype==1) {
		for(n=0; n<search_length; n++){	
			// Initialize c_search:
			c_search[n]=c_lower+n*c_range/search_length;

			countt=0;
			adjustupper1[0]=upper1[0]*c_search[n];
			adjustlower1[0]=lower1[0]*c_search[n];
			adjustupper2[0]=upper2[0]*c_search[n];
			adjustlower2[0]=lower2[0]*c_search[n];

			for(m=0; m<looksimul; m++){
				if( (work1[m]>adjustupper1[0]) && (work2[m]>adjustupper2[0]) )
					countt=countt+1;	// H++ H+- H-+ H--
				else if( (work1[m]>adjustupper1[0]) && (work2[m]<adjustlower2[0]) )
					countt=countt+1;	// H+0 H-0
				else if( (work1[m]<adjustlower1[0]) && (work2[m]>adjustupper2[0]) )
					countt=countt+1;	// H0+ H0-
			}

			alphawork=countt/looksimul;

			if( minalphawork > absd(alphawork-BiAlpha[0]) ){
				c_mid=c_search[n];
				minalphawork=absd(alphawork-BiAlpha[0]);
			}
		}
	
		adjustupper1[0]=upper1[0]*c_mid;
		adjustlower1[0]=lower1[0]*c_mid;
		adjustupper2[0]=upper2[0]*c_mid;
		adjustlower2[0]=lower2[0]*c_mid;
	
//		cout<<"search of c for the first look:"<<"\t"<<c_mid<<"\t";
//		cout<<"minalphawork"<<"\t"<<minalphawork<<endl;


		// now we search the const c for the rest of looks:
		for(i=1; i<lookorder; i++){
			minalphawork=1;
			lengthlook=0;
			for(j=0; j<looksimul; j++){
				indi=0;
			
				for(m=0; m<i; m++){
					if( indi!=1) {
						if( absd(nend11[j*lookorder+m])>adjustupper1[m] && absd(nend21[j*lookorder+m])>adjustupper2[m])
							indi=1;		
						else if( absd(nend11[j*lookorder+m])>adjustupper1[m] && absd(nend21[j*lookorder+m])<adjustlower2[m])
							indi=1;
						else if( absd(nend11[j*lookorder+m])<adjustlower1[m] && absd(nend21[j*lookorder+m])>adjustupper2[m])
							indi=1;
					}
				}

				if(indi==0){
					work1[lengthlook]=absd(nend11[j*lookorder+i]);
					work2[lengthlook]=absd(nend21[j*lookorder+i]);
					lengthlook=lengthlook+1;
				}
			}

			for(n=0; n<search_length; n++){	
			// Initialize c_search:
				c_search[n]=c_lower+n*c_range/search_length;

				countt=0;
				adjustupper1[i]=upper1[i]*c_search[n];
				adjustlower1[i]=lower1[i]*c_search[n];
				adjustupper2[i]=upper2[i]*c_search[n];
				adjustlower2[i]=lower2[i]*c_search[n];
		
				for(nn=0; nn<lengthlook; nn++){
					if( (work1[nn]>adjustupper1[i]) && (work2[nn]>adjustupper2[i]) )
						countt=countt+1;
					else if( (work1[nn]<adjustlower1[i]) && (work2[nn]>adjustupper2[i]) )
						countt=countt+1;
					else if( (work1[nn]>adjustupper1[i]) && (work2[nn]<adjustlower2[i]) )
						countt=countt+1;
				}

				alphawork=countt/lengthlook;

				if( minalphawork > absd(alphawork-BiAlpha[i]) ){
					c_mid=c_search[n];
					minalphawork=absd(alphawork-BiAlpha[i]);
				}
			}

//			cout<<"search of c end for look"<<"\t"<<i<<"\t";
//			cout<<"minalphawork"<<"\t"<<minalphawork<<"\t"<<"const c"<<"\t"<<c_mid<<endl;
			adjustupper1[i]=upper1[i]*c_mid;
			adjustlower1[i]=lower1[i]*c_mid;
			adjustupper2[i]=upper2[i]*c_mid;
			adjustlower2[i]=lower2[i]*c_mid;
		}

		for(i=0; i<lookorder; i++){
			NormalEnd1->UpperAdjust[i]=adjustupper1[i];
			NormalEnd1->LowerAdjust[i]=adjustlower1[i];
			SurvivalEnd2->UpperAdjust[i]=adjustupper2[i];
			SurvivalEnd2->LowerAdjust[i]=adjustlower2[i];
		}
	
/*		cout<<"The finalized boundary"<<endl;
		for(i=0; i<lookorder; i++){
			cout<<adjustupper1[i]<<"\t";
		}
		cout<<endl;
		for(i=0; i<lookorder; i++){
			cout<<adjustlower1[i]<<"\t";
		}
		cout<<endl;
		for(i=0; i<lookorder; i++){
			cout<<adjustupper2[i]<<"\t";
		}
		cout<<endl;
		for(i=0; i<lookorder; i++){
			cout<<adjustlower2[i]<<"\t";
		}
		cout<<endl;*/
	}


	// in case of soft decision:
	//mainly copy from the above calculation:
	// work can not be used DIRECTLY.

	else if(decisiontype==0){	
		for(n=0; n<search_length; n++){	
			// Initialize c_search:
			c_search[n]=c_lower+n*c_range/search_length;

			countt=0;
			adjustupper1[0]=upper1[0]*c_search[n];
			adjustlower1[0]=lower1[0]*c_search[n];
			adjustupper2[0]=upper2[0]*c_search[n];
			adjustlower2[0]=lower2[0]*c_search[n];
		
			//initialize work:
			for(m=0; m<looksimul; m++){
				work1[m]=nend11[m*lookorder+0];
				work2[m]=nend21[m*lookorder+0];
			}

			for(m=0; m<looksimul; m++){
				if( absd(work1[m])>adjustupper1[0] )	
					countt=countt+1;		// H-* & H+*
				else if( (absd(work1[m])<adjustlower1[0]) && (absd(work2[m])>adjustupper2[0]) )
					countt=countt+1;		//H0+ & H0-
				else if( (work1[m]<-adjustlower1[0]) && (work1[m]>-adjustupper1[0]) && (work2[m]<-adjustupper2[0]) )
					countt=countt+1;		// H(-)-
			}

			alphawork=countt/looksimul;

			if( minalphawork > absd(alphawork-BiAlpha[0]) ){
				c_mid=c_search[n];
				minalphawork=absd(alphawork-BiAlpha[0]);
			}
		}
	
		adjustupper1[0]=upper1[0]*c_mid;
		adjustlower1[0]=lower1[0]*c_mid;
		adjustupper2[0]=upper2[0]*c_mid;
		adjustlower2[0]=lower2[0]*c_mid;
	
//		cout<<"search of c for the first look [SOFT DECISION, Survival]:"<<"\t"<<c_mid<<"\t";
//		cout<<"minalphawork"<<"\t"<<minalphawork<<endl;


		// now we search the const c for the rest of looks:
		for(i=1; i<lookorder; i++){
			minalphawork=1;
			lengthlook=0;

			for(j=0; j<looksimul; j++){
				indi=0;

				for(m=0; m<i; m++){
					if( indi!=1) {
						if( absd(nend11[j*lookorder+m])>adjustupper1[m] )
							indi=1;		// H-*  H+*
						else if( absd(nend11[j*lookorder+m])<adjustlower1[m] && absd(nend21[j*lookorder+m])>adjustupper2[m])
							indi=1;		// H0- & H0+
						else if( (nend11[j*lookorder+m]<-adjustlower1[m]) && (nend11[j*lookorder+m]>-adjustupper1[m]) && (nend21[j*lookorder+m]<-adjustupper2[m]) )
							indi=1;		// H(-)-
					}
				}

				if(indi==0){
					work1[lengthlook]=nend11[j*lookorder+i];
					work2[lengthlook]=nend21[j*lookorder+i];
					lengthlook=lengthlook+1;
				}
			}

			for(n=0; n<search_length; n++){	
			// Initialize c_search:
				c_search[n]=c_lower+n*c_range/search_length;

				countt=0;
				adjustupper1[i]=upper1[i]*c_search[n];
				adjustlower1[i]=lower1[i]*c_search[n];
				adjustupper2[i]=upper2[i]*c_search[n];
				adjustlower2[i]=lower2[i]*c_search[n];
		
				for(nn=0; nn<lengthlook; nn++){		// make mistake in this look:
				//	if( (work1[nn]>adjustupper1[i]) || (work2[nn]>adjustupper2[i]) )
				//		countt=countt+1;
					if( absd(work1[nn])>adjustupper1[i] )					
						countt=countt+1;	// H-* H+*
					else if( (absd(work1[nn])<adjustlower1[i]) && (absd(work2[nn])>adjustupper2[i]))
						countt=countt+1;	// H0- H0+
					else if( (work1[nn]<-adjustlower1[i]) && (work1[nn]>-adjustupper1[i]) && (work2[nn]<-adjustupper2[i]) )
						countt=countt+1;
				}


				alphawork=countt/lengthlook;

				if( minalphawork > absd(alphawork-BiAlpha[i]) ){
					c_mid=c_search[n];
					minalphawork=absd(alphawork-BiAlpha[i]);
				}
			}

//			cout<<"search of c end for look"<<"\t"<<i<<"\t";
//			cout<<"minalphawork"<<"\t"<<minalphawork<<"\t"<<"const c"<<"\t"<<c_mid<<endl;
			adjustupper1[i]=upper1[i]*c_mid;
			adjustlower1[i]=lower1[i]*c_mid;
			adjustupper2[i]=upper2[i]*c_mid;
			adjustlower2[i]=lower2[i]*c_mid;
		}

		for(i=0; i<lookorder; i++){
			NormalEnd1->UpperAdjust[i]=adjustupper1[i];
			NormalEnd1->LowerAdjust[i]=adjustlower1[i];
			SurvivalEnd2->UpperAdjust[i]=adjustupper2[i];
			SurvivalEnd2->LowerAdjust[i]=adjustlower2[i];
		}
	}


	//now the left is the calculation of the test statistic:
	double *teststatistic;
	teststatistic=new double[2*lookorder];
	double *teststat1, *teststat2;
	teststat1=new double[lookorder];
	teststat2=new double[lookorder];
	double t1=0, t2=0;

	for(i=0; i<lookorder; i++){
		teststat1[i]=0;
		teststat2[i]=0;
	}
	
	// normal data is in the following two array:
//.	normalcontrol=new double[MAXLOOK*samplesize1];	// normal data control
//	normaltreat=new double[MAXLOOK*samplesize2];	// normal data treatment

	double *lengthc1, *lengthc2;
	lengthc1=new double[lookorder];
	lengthc2=new double[lookorder];

	for(i=0; i<lookorder; i++){
		lengthc1[i]=0;
		lengthc2[i]=0;
		t1=0;
		t2=0;
		for(j=0; j<samplesize1; j++){
			for(k=0; k<=i; k++){
				if(ctime21[j*lookorder+k]>0){
					//enrolled
					lengthc1[i]=lengthc1[i]+1;
					t1=t1+control_org[j*lookorder+k];
				}
			}
		}

		for(j=0; j<samplesize2; j++){
			for(k=0; k<=i; k++){
				if(ctime22[j*lookorder+k]>0){
					//enrolled
					lengthc2[i]=lengthc2[i]+1;
					t2=t2+treat_org[j*lookorder+k];
				}
			}
		}
		teststat1[i]=(t2-t1)/sqrt((lengthc1[i]+lengthc2[i])*1.0);
	}


	double *temp_stat2;
	double *temp_send11;
	double *temp_send12;
	temp_stat2=new double[2*lookorder];
	temp_send11=new double[column*(samplesize1+samplesize2)];
	temp_send12=new double[column*(samplesize1+samplesize2)];

	for(i=0; i<column*(samplesize1+samplesize2); i++){
		temp_send11[i]=send21[i];
		temp_send12[i]=send22[i];
	}
	
	temp_stat2=LogRank3(lookorder, num_look, samplesize1, samplesize2, column, temp_send11, temp_send12, send21, send22, looktime);
	
	for(i=0; i<lookorder; i++){
		NormalEnd1->testZ[i]=teststat1[i];
		SurvivalEnd2->testZ[i]=temp_stat2[i];
	}

    SurvivalEnd1= SurvivalEnd2;
	NormalEnd2 = NormalEnd1;
}






















//
//	Ancillary functions:
//

//	Alpha & Beta Spending function:
double* alpha_beta1(double totalAlphaBeta, double *inform_time, int num_look)
{
	double *information3;
	information3=new double[num_look];

	int i;
	for(i=0; i<num_look; i++)
		information3[i]=inform_time[i];

	double *alphareturn;
	double *alphatemp;
	alphareturn=new double[num_look];
	alphatemp=new double[num_look];

	for(i=0; i< num_look; i ++){
		alphareturn[i]=totalAlphaBeta*(1-exp(4*information3[i]))/(1-exp(4));
	}

	alphatemp[0]=alphareturn[0];
	for(i=1; i<num_look; i++)
		alphatemp[i]=alphareturn[i]-alphareturn[i-1];

	return alphatemp;
}


double * alpha_beta2(double totalAlphaBeta, double *inform_time, int num_look)
{
	double *alphareturn;
	double *alphatemp;
	alphareturn=new double[num_look];
	alphatemp=new double[num_look];
	int i;

	for(i=0; i<num_look; i++) {
		alphareturn[i]=totalAlphaBeta*inform_time[i];
	}

	alphatemp[0]=alphareturn[0];
	for(i=1; i<num_look; i++)
		alphatemp[i]=alphareturn[i]-alphareturn[i-1];

	return alphatemp;

}


double *alpha_beta3(double totalAlphaBeta, double *inform_time, int num_look)
{
	double *alphareturn;
	double *alphatemp;
	alphareturn=new double[num_look];
	alphatemp=new double[num_look];

	int i;

	for(i=0; i< num_look; i++) {
		alphareturn[i]=totalAlphaBeta*inform_time[i]*inform_time[i];
	}
	alphatemp[0]=alphareturn[0];
	for(i=1; i<num_look; i++)
		alphatemp[i]=alphareturn[i]-alphareturn[i-1];

	return alphatemp;

}



double Sample_Quan(int size, double *array1, double percentage)
{
  double *p;
  int flag=1; // if flag=1, need to do more work
  double tmp, score;
  int count=0, position;
  p=new double[size];  

  p=array1;

  while (flag!=0)
    {
      flag=0;
      for(int i=0; i<size-1-count; i++){
		if(p[i]>p[i+1]){
		tmp=p[i];
		p[i]=p[i+1];
		p[i+1]=tmp;
		flag=1;
		}
      }
      count++;
    }
	
  position=(int) (percentage*(size-1) );

  score=array1[position];
	
  int i;

  return score;           
}



double absd(double a)
{
	return a>0? a: -a;
}

int minInt(int x, int y)
{
	return x<y? x:y;
}



double *sqrt_matrix(int size, double *A)  // Transpose(B)*(B) = A , B is an upper triangular matrix,
{
	double *B = new double[size*size];
	int i=0, j=0;

	for(i=0; i<size; i++){			//initialize
		for(j=0; j<size; j++){
			B[i*size+j] = 0;
		}
	}
	double temp_Bii2=0, temp_Bij=0;

	int p=0, q=0;
	for(i=0; i<size; i++){
		temp_Bii2 = A[i*size+i];
		for(p=0; p<i; p++){
			temp_Bii2 -= pow(B[p*size+i],2);
		}
		B[i*size+i] = pow(temp_Bii2, 0.5);

		for(j=i+1; j<size; j++){
			temp_Bij = A[i*size+j];
			for(q=0; q<i; q++){
				temp_Bij -= B[q*size+i]*B[q*size+j];
			}
			B[i*size+j]=temp_Bij/B[i*size+i];
		}
	}

	return B;
}


double* Stand_Normal(int i)   
{
  double *p, *workarray;
  double r, theta;
  double mean=0.0;
  double var=0.0;

  int j;
  int n=0; 
  p=new double[i];
  workarray= new double[i];

//  srand ((unsigned)time(NULL));
//  int seed=(int) (-117197)*( (double) ( rand() % 2000) ) / 2000.0;
  int seed=(int) (-117197)*SEEDD[ICOUNT];
  long *idum=new long(seed);
//  cout<<"seed in stand_normal"<<"\t"<<seed;
  ICOUNT=ICOUNT+1;	

  while(n<i){
	workarray[n]=ran1(idum)  ; 
	workarray[n+1]=ran1(idum)  ; 
    
	if(workarray[n]>0){
		r=sqrt(-2*log(workarray[n]));
		theta=2*Pi*workarray[n+1];
		p[n]=r*cos(theta);
		p[n+1]=r*sin(theta);
		n=n+2;
		}  
	} 

  for(j=0; j<i; j++)
	  mean=mean+p[j];
  mean=mean/i;
  for(j=0; j<i; j++){
	  p[j]=p[j]-mean;
	  var=var+p[j]*p[j];
  }
  var=var/i;
  for(j=0; j<i; j++)
	  p[j]=p[j]/sqrt(var);

  return p;
}


float ran1(long *idum)
{
	int j;
	long k;
	static long iy=0;
	static long iv[NTAB];
	float temp;

	if(*idum<=0 || !iy){			//initialize
		if(-(*idum)<1) *idum=1;		//be sure to prevent idum=0.
		else *idum=-(*idum);
		for( j=NTAB+7; j>=0; j--){	//load the shuffle table(after 8 warm-ups)
			k=(*idum)/IQ;
			*idum=IA*(*idum-k*IQ)-IR*k;
			if(*idum<0) *idum+=IM;
			if(j<NTAB) iv[j]=*idum;
		}
		iy=iv[0];
	}
	k=(*idum)/IQ;
	*idum=IA*(*idum-k*IQ)-IR*k;
	if(*idum<0) *idum+=IM;
	j=iy/NDIV;
	iy=iv[j];
	iv[j]=*idum;
	if((temp=AM*iy)>RNMX) return RNMX;
	else return temp;
}


double *NormalCheck(int size1, int size2, double * checkarray)
{
	double *structure;
	double *meanA1, *varA1, *corrA1;
	structure=new double[2*size1+size1*size1];
	meanA1=new double[size1];
	varA1=new double[size1];
	corrA1=new double[size1*size1];

	int i, j, k;
	for(i=0; i<size1; i++){
		meanA1[i]=0;
		for(j=0; j<size2; j++){
			meanA1[i]=meanA1[i]+checkarray[j*size1+i];
		}
		meanA1[i]=meanA1[i]/size2;
	}
	for(i=0; i<size1; i++) {
		varA1[i]=0;
		for(j=0; j<size2; j++) {
			varA1[i]=varA1[i]+(checkarray[j*size1+i]-meanA1[i])*(checkarray[j*size1+i]-meanA1[i]);
		}
		varA1[i]=varA1[i]/size2;
	}
	for(i=0; i<size1; i++){
		for(j=0; j<size1; j++){
			corrA1[i*size1+j]=0;
			for(k=0; k<size2; k++){
				corrA1[i*size1+j]=corrA1[i*size1+j]+(checkarray[k*size1+i]-meanA1[i])*(checkarray[k*size1+j]-meanA1[j]);
			}
			corrA1[i*size1+j]=corrA1[i*size1+j]/size2;
			corrA1[i*size1+j]=corrA1[i*size1+j]/sqrt(varA1[i]*varA1[j]);
		}
	}

	for(i=0; i<size1; i++){
		structure[i]=meanA1[i];
		structure[i+size1]=varA1[i];
	}
	for(i=0; i<size1*size1; i++)
		structure[2*size1+i]=corrA1[i];
	
	return structure;
}



void mySort(double *p, int size)
{
	int flag=1; // if flag=1, need to do more work
	double tmp;
	int count=0;

	while (flag!=0){
		flag=0;
		for(int i=0; i<size-1-count; i++){
			if(p[i]>p[i+1]){
				tmp=p[i];
				p[i]=p[i+1];
				p[i+1]=tmp;
				flag=1;
			}
		}
		count++;
	}
}













